#!/usr/bin/perl

###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# linksadmin.cgi from admin/links                                             #
# v0.9.9.3.4                                                                  #
# CSS style sheet compatibility update by: my2cents (classicchat.net)         #
# Delete Links Count Total on Category Delete by: Aron Shiewitz (2xlnt.com)   #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified: 12 Apr 2006 by my2cents                                           #
# Modified: 12 May, 13 Aug 2006 by Jos                                        #
# Modified: 14 Aug 2006 by Jos for Jack Deth - delete links count fix         #
###############################################################################
###############################################################################

$| = 1;
use CGI::Carp qw(fatalsToBrowser);

$scriptname = "WebAPP";

eval {
	require "../config.pl";
	require "$sourcedir/subs.pl";

	if ($IIS != 2) {
		if ($IIS == 0) {
			if ($ENV{'SERVER_SOFTWARE'} =~ m!IIS!) { $IIS = 1; }
		}
		if (($IIS) && ($0 =~ m!(.*)(\\|\/)!)) { chdir($1); }
		if ($IIS == 1) { print "HTTP/1.0 200 OK\n"; }
	}
};
if ($@) {
	print "Content-type: text/html\n\n";
	print qq~<h1>Software Error:</h1>
Execution of <b>$scriptname</b> has been aborted due to a compilation error:<br>
<pre>$@</pre>
<p>If this problem persists, please contact the webmaster and inform him about date and time you've received this error.</p>
~;
	exit;
}

$anonuser = "Guest";
@months = qw(January February March April May June July August September October November December);
@days = qw(Sunday Monday Tuesday Wednesday Thursday Friday Saturday);

getcgi();
getdate();
loadcookie(); # needs months days
loaduser();
logips();
&ban; # needs username realname anonuser months days first
logvisitors();
&getver;

if ($action eq "addlncat") { addlncat(); }
elsif ($action eq "addlncat2") { addlncat2(); }
elsif ($action eq "editlncat") { editlncat(); }
elsif ($action eq "editlncat2") { editlncat2(); }
elsif ($action eq "deletelncat") { deletelncat(); }
elsif ($action eq "deletelncat2") { deletelncat2(); }
else { viewlist(); }

###############
sub viewlist {
###############
check_access(editlink); if ($access_granted ne "1") { error("$err{'011'}"); }

open (DATABASE,"$linksdir/linkcats.dat");
hold(DATABASE);
@linksdatabase=<DATABASE>;
release(DATABASE);
close (DATABASE);

$navbar = "$btn{'014'} $mnu{'007'} $btn{'014'} $nav{'130'}";
print_top();

print qq~<font face='Arial' size='2'><i>$nav{'130'}</i><br>
<table width='100%' border='1'>
<tr>
<td class="titletext">$msg{'354'}</td>
<td class="titletext">$msg{'366'}</td>
<td class="titletext">$msg{'573'}</td>
<td class="titletext">$msg{'357'}</td>
</tr>
~;

foreach $lnkrec (@linksdatabase){
	chomp($lnkrec);
	($link,$file,$desc)=split(/\|/,$lnkrec);
	print qq~<tr>
<td><font size="2"><a href="$pageurl/admin/linksadmin.cgi?action=editlncat&amp;file=$file">$nav{'096'}</a> - <a href="$pageurl/admin/linksadmin.cgi?action=deletelncat&amp;file=$file">$nav{'097'}</a></font></td>
<td><font size="2">$link</font></td>
<td><font size="2">$file</font></td>
<td><font size="2">$desc</font></td>
</tr>
~;
}

print qq~</table>
<p><a href="$pageurl/admin/linksadmin.cgi?action=addlncat">$nav{'128'}</a></p>
</font>~;

print_bottom();
exit;
}

#################
sub addlncat {
#################
check_access(editlink); if ($access_granted ne "1") { error("$err{'011'}"); }

$navbar = "$btn{'014'} $mnu{'007'} $btn{'014'} $nav{'128'}";
print_top();

print qq~<font face='Arial'>
<i>$nav{'128'}</i><br>
<form action='$pageurl/admin/linksadmin.cgi?action=addlncat2' method='post'>
<table border='1'>
<tr>
<td><font size='2'>$msg{'366'} ($msg{'574'})</font></td>
<td><input type="text" class="textinput" name="ncatname"></td>
</tr>
<tr>
<td><font size='2'>$msg{'573'}</font></td>
<td><input type="text" class="textinput" name="ncatfile"></td>
</tr>
<tr>
<td><font size='2'>$msg{'357'}</font></td>
<td><input type="text" class="textinput" name="ncatdesc"></td>
</tr>
</table>
<input type="submit" class="button" value="$btn{'035'}">
</form>
</font>~;

print_bottom();
exit;
}

#################
sub addlncat2 {
#################
check_access(editlink); if ($access_granted ne "1") { error("$err{'011'}"); }
if ($input{'ncatfile'} =~ /(\$+|\?+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<+|\%)/) { error("$err{'006'}") }
if ($input{'ncatname'} eq "") {error("$err{'034'}");}
if ($input{'ncatfile'} eq "") {error("$err{'035'}");}
if ($input{'ncatdesc'} eq "") {error("$err{'036'}");}

$ncatfile = $input{'ncatfile'};
$ncatfile =~ s/^\s+//;
$ncatfile =~ s/\s+$//;
$ncatfile =~ tr/ /_/;
$ncatfile = lc($ncatfile);

open (DATABASE,"$linksdir/linkcats.dat");
hold(DATABASE);
chomp(@checklinksdatabase=<DATABASE>);
release(DATABASE);
close (DATABASE);

				foreach $findlnkrec (@checklinksdatabase){
				@lncatitem = split(/\|/, $findlnkrec);
				if ($ncatfile eq $lncatitem[1]) { error("$err{'037'}"); }
				}

open (DATABASE,"$linksdir/linkcats.dat");
hold(DATABASE);
@linksdatabase=<DATABASE>;
release(DATABASE);
close (DATABASE);

				open (LINKS,"$linksdir/linkcats.dat");
				hold(LINKS);
				chomp(@checklinksdatabase = <LINKS>);
				release(LINKS);
				close (LINKS);
				
				foreach $checklnkrec (@checklinksdatabase){
				@lncatitem = split(/\|/, $checklnkrec);
				if ($input{'ncatfile'} eq $lncatitem[1]) { error("$err{'037'}");}
				}

open (NEWDATABASE,">$linksdir/linkcats.dat");
hold(NEWDATABASE);
print NEWDATABASE "$input{'ncatname'}|$input{'ncatfile'}|$input{'ncatdesc'}\n"; 
print NEWDATABASE @linksdatabase;
release(NEWDATABASE);
close (NEWDATABASE);

print "Location: $pageurl/admin/linksadmin.cgi\n\n"; 
exit;

}

#################
sub editlncat {
#################
check_access(editlink); if ($access_granted ne "1") { error("$err{'011'}"); }

open (DATABASE,"$linksdir/linkcats.dat");
hold(DATABASE);
chomp(@linksdatabase=<DATABASE>);
release(DATABASE);
close (DATABASE);

				foreach $findlnkrec (@linksdatabase){
				@lncatitem = split(/\|/, $findlnkrec);
				if ($info{'file'} eq $lncatitem[1]) { $ecatname = $lncatitem[0] ; $ecatfile = $lncatitem[1] ; $ecatdesc = $lncatitem[2]; }
				}

$navbar = "$btn{'014'} $mnu{'007'} $btn{'014'} $nav{'129'} $btn{'014'} $ecatname";
print_top();

print qq~<font face='Arial'>
<i>$nav{'129'}</i><br>
<form action="$pageurl/admin/linksadmin.cgi?action=editlncat2" method="post">
<table border='1'>
<tr>
<td><font size='2'>$msg{'366'}</font></td>
<td><input type="text" class="textinput" name="ncatname" value="$ecatname"></td>
</tr>
<tr>
<td><font size='2'>$msg{'573'}</font></td>
<td><input type='hidden' name='ncatfile' value="$ecatfile">$ecatfile</td>
</tr>
<tr>
<td><font size='2'>$msg{'357'}</font></td>
<td><input type="text" class="textinput" name="ncatdesc" value="$ecatdesc"></td>
</tr>
</table>
<input type="submit" class="button" value="$btn{'036'}">
</form>
</font>~;

print_bottom();
exit;
}

#################
sub editlncat2 {
#################
check_access(editlink); if ($access_granted ne "1") { error("$err{'011'}"); }
if ($input{'ncatname'} eq "") {error("$err{'034'}");}
if ($input{'ncatfile'} eq "") {error("$err{'035'}");}
if ($input{'ncatdesc'} eq "") {error("$err{'036'}");}

open (DATABASE,"$linksdir/linkcats.dat");
hold(DATABASE);
@linksdatabase=<DATABASE>;
release(DATABASE);
close (DATABASE);

open (EDITDATABASE,">$linksdir/linkcats.dat");
hold(EDITDATABASE);
		for ($a = 0; $a < @linksdatabase; $a++) {
			($ocatname, $ocatfile, $ocatdesc) = split(/\|/,$linksdatabase[$a]);
			if ($ocatfile eq $input{'ncatfile'}) { print EDITDATABASE "$input{'ncatname'}|$input{'ncatfile'}|$input{'ncatdesc'}\n"; }
			else { print EDITDATABASE "$linksdatabase[$a]"; }
		}
release(EDITDATABASE);
close (EDITDATABASE);

print "Location: $pageurl/admin/linksadmin.cgi\n\n"; 
exit;
}

#################
sub deletelncat {
#################
check_access(editlink); if ($access_granted ne "1") { error("$err{'011'}"); }

open (DATABASE,"$linksdir/linkcats.dat");
hold(DATABASE);
chomp(@linksdatabase=<DATABASE>);
release(DATABASE);
close (DATABASE);

				foreach $findlnkrec (@linksdatabase){
				@lncatitem = split(/\|/, $findlnkrec);
				if ($info{'file'} eq $lncatitem[1]) { $dcatname = $lncatitem[0]; $dcatfile = $lncatitem[1]; }
				}

	$navbar = "$btn{'014'} $btn{'011'} $dcatname";
	print_top();
	
	print qq~<b>$btn{'011'} $dcatname?</b><br>
	<a href="$pageurl/admin/linksadmin.cgi?action=deletelncat2&amp;file=$dcatfile">$nav{'047'}</a> - <a href="$pageurl/admin/linksadmin.cgi">$nav{'048'}</a>~;
	
	print_bottom();
	exit;
}

##################
sub deletelncat2 {
##################

	check_access(editlink); if ($access_granted ne "1") { error("$err{'011'}"); }

	@linksdatabase = read_database("$linksdir/linkcats.dat");

	open (DELETEDATABASE,">$linksdir/linkcats.dat");
	hold(DELETEDATABASE);
	for ($a = 0; $a < @linksdatabase; $a++) {
		my ($ocatfile) = (split(/\|/,$linksdatabase[$a]))[1];
		if ($ocatfile ne $info{'file'}) { print DELETEDATABASE "$linksdatabase[$a]"; }
	}
	close(DELETEDATABASE);

	### code to delete the links from the count when deleting a category - originally by Aron Shiewitz - Jack Deth
	my $catscount = chomp_datatext("$linksdir/$info{'file'}.cnt");
	my $linkcatscount = chomp_datatext("$linksdir/linkcats.cnt");

	$linkcatscount -= $catscount;

	open(LCNT, ">$linksdir/linkcats.cnt") or error("$err{'016'} linkcats.cnt"); 
	hold(LCNT); 
	print LCNT "$linkcatscount"; 
	close(LCNT);
	### End code

	unlink("$linksdir/$info{'file'}.dat"); 
	unlink("$linksdir/$info{'file'}.cnt");

	print "Location: $pageurl/admin/linksadmin.cgi\n\n"; 
	exit;

}

1;