###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# ads.pl                                                                      #
# v0.9.9.3.4                                                                  #
#                                                                             # 
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
###############################################################################
###############################################################################

################
sub OutputJava {
################

	my $adfile = "$datadir/banners/data.txt";

	my @rotation_info = &chomp_database("$adfile");

	if (@rotation_info) {
		srand(time|$$);

		$banner_info = int(rand(@rotation_info)); # number

		my ($iban,$iw,$ih,$alt) = (split(/\|/, $rotation_info[$banner_info]))[1..4];

		print qq~$banner{'001'}<br><a
 href="$pageurl/$cgi?action=bannerredirect&amp;banner=$banner_info"
 target="_blank"><img src="$iban" width="$iw" height="$ih"
 alt="$alt" border="0"></a><br><a
 href="$pageurl/$cgi?action=bannerfarm" class="bannerlink">$banner{'016'}</a>~;

	}

}

####################
sub bannerredirect {
####################
	
	my $adfile = "$datadir/banners/data.txt";

	if (defined $info{'banner'}) {
		my @datas = &chomp_database("$adfile");

		open(FILE, ">$adfile");
		hold(FILE);

		for ($k=0; $k < @datas; $k++) {
			if ($k eq $info{'banner'}) { # number
				($banurl,$iban,$iw,$ih,$alt,$banhits) = split(/\|/, $datas[$k]);
				$myurl = $banurl;
				$banhits_temp = $banhits + 1;
				print FILE "$banurl|$iban|$iw|$ih|$alt|$banhits_temp\n";
			} else {
				print FILE "$datas[$k]\n";
			}
		}

		release(FILE);
		close(FILE);

		print "Location: $myurl\n\n";
	} else {

		error("$err{'006'}");
	}

}

################
sub bannerfarm {
################

	my $adfile = "$datadir/banners/data.txt";

	my @banfarmdata = &chomp_database("$adfile");

	$navbar = "$btn{'014'} $banner{'016'}";
	print_top();

	print qq~<table align="center">~;

	$k = 0;
	for ($k=0; $k < @banfarmdata; $k++) {

		($banfarmurl,$ibanfarm,$baniw,$banih,$banalt,$banfarmhits) = split(/\|/, $banfarmdata[$k]);

		print qq~<tr><td align="center"><a
 href="$pageurl/$cgi?action=bannerredirect&amp;banner=$k"
 target="_blank" class="bannerlink"><img
 src="$ibanfarm" width="$baniw" height="$banih" alt="$banalt"
 border="0"><br>$banalt</a> &nbsp; <small>($banfarmhits $banner{'017'})</small><br><br></td>
</tr>
~;
	}

	print qq~</table>~;

	print_bottom();
	exit;

}

if (-e "$user_lib/ads.pl") {require "$user_lib/ads.pl"}

1;