###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# archive.pl                                                                  #
# v0.9.9.3.4                                                                  #
# Original by Carter for WebAPP v0.9.9.3                                      #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
###############################################################################

##################
sub archiveindex {
##################

	my $spacer = 1; # This will allow for spaces inbetween categories. 0 for no spacer, and 1 to put IN the spacer - Carter

	$navbar = "$btn{'014'} $nav{'165'}";
	print_top();

	print qq~<div class="forumtext" style="margin:5px"><img src="$imagesurl/forum/open.gif"
 width="16" height="16" border="0" alt="*">&nbsp; $nav{'165'}</div>
<table width="100%" border="0" cellspacing="1" cellpadding="2" class="forumtitlebackcolor">
<tr>
<td width="16" class="boardtitle columnheader">&nbsp;</td>
<td nowrap align="left" class="boardtitle columnheader">$msg{'095'}</td>
<td nowrap align="center" class="boardtitle columnheader">$msg{'096'}</td>
<td nowrap align="center" class="boardtitle columnheader">$msg{'097'}</td>
<td nowrap align="center" class="boardtitle columnheader">$msg{'098'}</td>
</tr>
~;

	if (! $userrank) { $userrank = "none"; }
	if (! $userstatus) { $userstatus = "none"; } # these for multiple status on board

# Get the Categories
	opendir (DIR, "$boardsdir/archive") || error("No Archive Directory Found");
	@files = readdir(DIR);
	closedir (DIR);
	@files = grep(/\.cat/,@files);
	@categories = sort(@files);

	my $colspan = "5";
	my $colspan2 = 4;

	my $toprow = 0;

# Now Get the Boards in Each Category
	foreach $curcat (@categories) {
		$curcat =~ s/[\n\r]//g;

		my @catinfo = chomp_database("$boardsdir/archive/$curcat");

		$catinfo[1] =~ s/[\n\r]//g;
		if ($catinfo[1]) {
			if (($catinfo[1] !~ /\b$userrank\b|\b$userstatus\b/i) && ($userrank ne "$root")) {
				next;
			}  # for multiple status on board
		}

		my $curcatname = "$catinfo[0]";

# This will put a space in between the Categories, to look like OTHER web forums.
# Comment out to make plain

		if ($spacer eq "1") { # spacer between categories
			if ($toprow) { # no spacer before first category
				print qq~<tr>
<td colspan="$colspan">&nbsp;</td>
</tr>
~;
			}
			$toprow = 1;
		}

		print qq~<tr>
<td valign="top" class="boardtitle">&nbsp;</td>
<td colspan="$colspan2" class="boardtitle">$curcatname</td>
~;

		print qq~</tr>
~;

		foreach $curboard (@catinfo) {
			if ($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
				$curboard =~ s/[\n\r]//g;

				my @boardinfo = chomp_database("$boardsdir/archive/$curboard.dat");

				my $curboardname = "$boardinfo[0]";
				my $descr = "$boardinfo[1]";

				my @messages = chomp_database("$boardsdir/archive/$curboard.txt");

				if (@messages > 1) {

					my @allmessages = ();
					my @data =();

					for (0..$#messages) {
						my @fields = split(/\|/, $messages[$_]);
						my $saveddate = $fields[5];
						my ($chkmonth, $chkday, $chkyear, $chkhour, $chkmin, $chksec) = split(/\/| - |\:/, $saveddate);
						$chkyear = (2000+$chkyear);
						my $sortdate = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";
						unshift (@fields, $sortdate);
						for $i (0..$#fields) {
							$data[$_][$i] = $fields[$i];
						}
					}
					my @sorted = sort { $b->[0] <=> $a->[0] } @data;

					for (@sorted) {
						shift (@$_);
						push (@allmessages, join ("\|", @$_) . "\n");
					}

					@messages = @allmessages;
				}

				my $tm = @messages;
				my $messagecount = 0;
				my $new = "off";
				my $postdate = "";

				if (($tm > 0) && ($messages[0] !~ /^$/)) {
					(undef, undef, undef, undef, undef, $postdate, undef, undef, $poster, undef, undef) = split(/\|/, $messages[0]);

					for ($a = 0; $a < @messages; $a++) {
						(undef, undef, undef, undef, undef, undef, $mreplies, undef, undef, undef, undef) = split(/\|/, $messages[$a]);
						$messagecount++;
						$messagecount = $messagecount+$mreplies;
					}

					display_date($postdate); $postdate = $user_display_date;
				} else { # if no messages in the board
					$tm = 0;
					$postdate="???";
					$poster = "???";
				}
				$new = "locked";

				print qq~<tr>
<td valign="top" class="forumwindow2"><img
 src="$imagesurl/forum/$new.gif" width="16" height="15" alt="*"></td>
<td valign="top" class="forumwindow2"><a
 href="$pageurl/$cgi?action=viewarchive&amp;board=$curboard"
 class="forumlink">$curboardname</a><br>
$descr</td>
<td valign="top" align="center" class="forumwindow2">$tm</td>
<td valign="top" align="center" class="forumwindow2">$messagecount</td>
<td valign="top" align="center" class="forumwindow2"
 style="white-space: nowrap">$postdate<br>$msg{'042'} $poster</td>
</tr>
~;
			}
		}
	}

	print qq~</table>
~;

	print_bottom();
	exit;

}

#########################
sub archivemessageindex {
#########################

	if ($currentboard =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top(); print "What are you doing Stan?"; print_bottom(); exit; }

	if (! $userrank) { $userrank = "none"; }
	if (! $userstatus) { $userstatus = "none"; } # these for multiple status on board

	if ($userrank ne "$root") {
		opendir (DIR, "$boardsdir/archive") || error("No Archive Directory Found");
		@files = readdir(DIR);
		closedir (DIR);
		@files = grep(/\.cat/,@files);
		@categories = sort(@files);

		foreach $curcat (@categories) {
			$curcat =~ s/[\n\r]//g;

			@catinfo = read_database("$boardsdir/archive/$curcat");

			$catinfo[1] =~ s/[\n\r]//g;

			if ($catinfo[1] ne "") {
				foreach $searchcat (@catinfo) {
					$searchcat =~ s/[\n\r]//g;

						if (($currentboard eq "$searchcat") && ($catinfo[1] !~ /\b$userrank\b|\b$userstatus\b/i)) { # for multiple status on board
							print_top();  print "What are you doing Stan?"; print_bottom(); exit;
						}
				}
			}
		}
	}

	@boardinfo = chomp_database("$boardsdir/archive/$currentboard.dat");

	$boardname = "$boardinfo[0]";

	$boardinfo[2] =~ s/[\n\r]//g;

	$navbar = "$btn{'014'} $nav{'165'} $btn{'014'} $boardname";
	print_top();

# condition around navigation tree - show only if no breadcrumbs in place:

	if (!$breadcrumb) {
		print qq~<div class="forumtext" style="margin: 3px"><img
 src="$imagesurl/forum/open.gif" width="16" height="16" border="0"
 alt="">&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=viewarchive" class="forumnav">$nav{'165'}</a>
<br>
<img src="$imagesurl/forum/tline.gif" width="12" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="16" height="16" border="0"
 alt="">&nbsp;&nbsp;$boardname</div>~;
	}

# carry on from up above:
	$boardinfo[2] =~ s/[\n\r]//g;

# here's where it gets the list
	$moderators = $boardinfo[2];

# split above list on space:
	foreach $curuser (split(/ /, $moderators)) {
		if ($username eq "$curuser") { $thisboardmod = $username; }
		else { $thisboardmod = ""; }
	}

	print qq~<table width="100%" class="forumtitlebackcolor" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<table width="100%" border="0" cellspacing="1" cellpadding="2">
<tr>
<td class="boardtitle" width="16">&nbsp;</td>
<td class="boardtitle" width="15">&nbsp;</td>
<td class="boardtitle" width="40%"><b>$msg{'037'}</b></td>
<td class="boardtitle" width="20%"><b>$msg{'101'}</b></td>
<td class="boardtitle" width="10%" align="center"><b>$msg{'102'}</b></td>
<td class="boardtitle" width="10%" align="center"><b>$msg{'157'}</b></td>
<td class="boardtitle" width="20%" align="center"><b>$msg{'103'}</b></td>
~;

	if (!defined $info{'view'}) { $info{'view'} = ""; }

	if (!defined $info{'start'}) { $start = 0; }
	else { $start = "$info{'start'}"; }

	@messages = chomp_database("$boardsdir/archive/$currentboard.txt");

	@allmessages = ();
	@data =();

	for (0..$#messages) {
		@fields = split(/\|/, $messages[$_]);
		$saveddate = $fields[5];
		($chkmonth, $chkday, $chkyear, $chkhour, $chkmin, $chksec) = split(/\/| - |\:/, $saveddate);
		$chkyear = (2000+$chkyear);
		$sortdate = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";
		unshift (@fields, $sortdate);
		for $i (0..$#fields) {
			$data[$_][$i] = $fields[$i];
		}
	}
	@sorted = sort { $b->[0] <=> $a->[0] } @data;

	for (@sorted) {
		shift (@$_);
		push (@allmessages, join ("\|", @$_) . "\n");
	}

	@messages = @allmessages;

	$messagecount = 0;

	for ($a = 0; $a < @messages; $a++) {
		($mnum[$a], $msub[$a], $mname[$a], $musername[$a], $memail[$a], $mdate[$a], $mreplies[$a], $mviews[$a], $mlpname[$a], $micon[$a], $mstate[$a]) = split(/\|/, $messages[$a]);
		$messagecount++;

	}

	($chkmonth, $chkday, $chkyear, $chkhour, $chkmin, $chksec) = split(/\/| - |\:/, $mdate[0]);	
	$chkyear = (2000+$chkyear);
	$sortdate = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";
	$writedate = "$mdate[0]";
	writelog("archive$currentboard");

	$numshown = 0;

	$second="forumwindow3";
	for ($b = $start; $b < @messages; $b++) {
		if ($second eq "forumwindow2") { $second="forumwindow3"; }
		else { $second="forumwindow2"; }
		$numshown++;

		$new = "";

		if ($musername[$b] ne "$anonuser") { }

		$msub[$b] = censor_it($msub[$b]);

		$type = "locked"; $typealt = "$msg{'494'}";

		if ($mdate[$b] eq "") {
			$mdate[$b] = "???";
		}

		$nummessages = $mreplies[$b]+1;
		$c = 0;
		$pages = "";
		if ($nummessages > $maxmessagedisplay) {
			while (($c*$maxmessagedisplay) < $nummessages) {
				$viewc = $c+1;
				$strt = $c*$maxmessagedisplay;
				$pages = qq~$pages<a href="$forum&amp;op=archivedisplay&amp;num=$mnum[$b]&amp;start=$strt" class="forumlink">$viewc</a> ~;
				$c++;
			}
			$pages =~ s/\n$//g;
			$pages = qq~( <img src="$imagesurl/forum/multipage.gif" alt=""> $pages )~;
		}

		symbol_alt($micon[$b]);

		display_date($mdate[$b]); $mdate[$b] = $user_display_date;

		print qq~<tr>
<td width="16" class="$second"><img src="$imagesurl/forum/$type.gif" alt="$typealt"></td>
<td width="15" class="$second"><img src="$imagesurl/forum/$micon[$b].gif" alt="$symbolalt" border="0" align="middle"></td>
<td width="40%" class="$second"><a href="$forum&amp;op=archivedisplay&amp;num=$mnum[$b]" class="forumlink"><b>$msub[$b]</b></a> $new $pages</td>
<td width="20%" class="$second">$mname[$b]</td>
<td width="10%" align="center" class="$second">$mreplies[$b]</td>
<td width="10%" align="center" class="$second">$mviews[$b]</td>
<td width="20%" align="center" class="$second" nowrap>$mdate[$b]<br>$msg{'042'} $mlpname[$b]</td>
</tr>
~;

		$lastposter = "";
		if ($numshown >= $maxdisplay && $info{'view'} ne 'all') { $b = @messages; }
	}
	print qq~</table>
</td>
</tr>
</table>
<table border="0" width="100%">
<tr>
<td valign="top" class="forumtext">
<img src="$imagesurl/forum/tline.gif" width="12" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="16" height="16" border="0"
 alt="">&nbsp;&nbsp;$boardname
<br>
<img src="$imagesurl/forum/open.gif" width="16" height="16" border="0"
 alt="">&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=viewarchive" class="forumnav">$nav{'165'}</a></td>
<td align="right" valign="top">&nbsp;</td>
</tr>
<tr>
<td valign="top" class="forumtext"><b>$msg{'039'}</b> ~;

	$nummessages = @messages;
	$c = 0;
	while (($c*$maxdisplay) < $nummessages) {
		$viewc = $c+1;
		$strt = ($c*$maxdisplay);
		if ($start == $strt) { print "[$viewc] "; }
		else { print qq~<a href="$forum&amp;start=$strt" class="forumnav">$viewc</a> ~; }
		++$c;
	}

	jumpto();

	print qq~</td>
~;

	print qq~<td align="right" valign="top" class="forumtext"><form
 action="$pageurl/$cgi" method="get">$msg{'104'} <input
 type="hidden" name="action" value="forum">
<select name="board">
$selecthtml
</select>
<input type="submit" class="button" value="$btn{'014'}">
</form>~;

	if (-e "$boardsdir/$currentboard.dat") { # link back to forum same board
		print qq~<br><span class="forumtext"><a
 href="$pageurl/$cgi?action=forum&board=$currentboard"
 class="forumnav">$nav{'003'}</a></span>~;
	}

	print qq~</td>
</tr>
</table>
~;

	print_bottom();
	exit;

}

####################
sub archivedisplay {
####################

	if ($currentboard =~ /[\$\|\(\)\[\]\{\}\^\*\.<]+/) { &data_error; }
	if ($info{'num'} !~ /^[0-9]+$/) { &data_error; }
	if ((!defined $info{'start'}) || ($info{'start'} eq "")) { $info{'start'} = 0; }
	if ($info{'start'} =~ /\D/) { &data_error; } # for Shaka_Flex's trick

 	logread(); # refresh bug fix by Carter

	if (! $userrank) { $userrank = "none"; }
	if (! $userstatus) { $userstatus = "none"; } # these for multiple status on board

	$viewnum = $info{'num'};

	if ($userrank ne "$root") {
		opendir (DIR, "$boardsdir/archive") || error("No Archive Directory Found");
		@files = readdir(DIR);
		closedir (DIR);
		@files = grep(/\.cat/,@files);
		@categories = sort(@files);

		foreach $curcat (@categories) {
			$curcat =~ s/[\n\r]//g;

			@catinfo = read_database("$boardsdir/archive/$curcat");

			$catinfo[1] =~ s/[\n\r]//g;
			if ($catinfo[1] ne "") {
				foreach $searchcat(@catinfo) {
					$searchcat =~ s/[\n\r]//g;
					if (($currentboard eq "$searchcat") && ($catinfo[1] !~ /\b$userrank\b|\b$userstatus\b/i)) { #  multiple status on board
						print_top();  print "$msg{'630'}"; print_bottom(); exit; # prints Stan message
					}
				}
			}
		}
	}

	my @tthreads = read_database("$boardsdir/archive/$currentboard.txt");

	$found_thread = "";

	for ($i = 0; $i < @tthreads; $i++) {
		($mnum, $msub, $mname, $musername, $memail, $mdate, $mreplies, $mviews, $mlpname, $micon, $mstate) = split(/\|/, $tthreads[$i]);
		if ($viewnum eq $mnum) {
			$mviews++;
			$tthreads[$i] = "$mnum|$msub|$mname|$musername|$memail|$mdate|$mreplies|$mviews|$mlpname|$micon|$mstate";
			$type = "thread"; $typealt = "$msg{'490'}";
			if ($mstate == 1) { $type = "locked"; $typealt = "$msg{'494'}"; }
			$found_thread = "1"; #abywn - masked board fix
			last;
		}
	}

	if ($found_thread eq "1") {
		open(FILE, ">$boardsdir/archive/$currentboard.txt") || &error("$err{'016'} $boardsdir/archive/$currentboard.txt");
		hold(FILE);
		print FILE @tthreads;
		close(FILE);
	} else {
# find board when thread has been moved
		opendir (DIR, "$boardsdir/archive") || error("No Archive Directory Found");
		@files = readdir(DIR);
		closedir (DIR);
		@files = grep(/\.cat/,@files);
		@categories = sort(@files);

		for ($c=0; $c<@categories; $c++) {
			$curcat = $categories[$c];
			$curcat =~ s/[\n\r]//g;

			@catinfo = read_database("$boardsdir/archive/$curcat");

			for ($i=2; $i<@catinfo; $i++) {
				$thisboard = $catinfo[$i];
				$thisboard =~ s/[\n\r]//g;

				@curboardinfo = chomp_database("$boardsdir/archive/$thisboard.txt");

				foreach $postline (@curboardinfo) {
					($mnum) = (split(/\|/, $postline))[0];
					if ($viewnum eq $mnum) {
						$currentboard = $thisboard;
						$i = @catinfo;
						$c = @categories;
						last;
					}
				}
			}

			$catinfo[1] =~ s/[\n\r]//g;
			foreach $searchcat (@catinfo) {
				$searchcat =~ s/[\n\r]//g;
				if ($currentboard eq "$searchcat") {
					if ($catinfo[1] ne "") {
						if (($userrank ne $root) && ($catinfo[1] !~ /\b$userrank\b|\b$userstatus\b/i)) { #  multiple status on board
							error("$err{'042'}");
						}
					}
					$forum = qq~$pageurl/$cgi?action=viewarchive&board=$currentboard~;
					$type = "move";
					$typealt = qq~&gt;~;
					last;
				}
			}
		}
	}

	@tthreads = ();

	open(FILE, "$memberdir/membergroups.dat");
	hold(FILE);
	chomp(@membergroups = <FILE>);
	close(FILE);

# begin hack for admin remove missing threads
	if ($userrank eq $root) {
		unless (-e "$messagedir/$viewnum.txt") {
			error("No $viewnum.txt. Would you like to <a href=\"$pageurl/$cgi?action=viewarchive&board=$currentboard&op=removethread&thread=$viewnum\">delete this thread?</a>")
		}
	}
# end hack

	@messages = chomp_database("$messagedir/$viewnum.txt");

	if ($info{'start'} > @messages) { &data_error; } # for Shaka_Flex's trick

	($msub, $mname, $memail, $mdate, $musername, $micon, $mip, $mmessage) = split(/\|/, $messages[@messages-1]);
	($msub[0], $mname[0], $memail[0], $mdate[0], $musername[0], $micon[0], $mip[0], $mmessage[0]) = split(/\|/, $messages[0]);
	$msub[0] = censor_it($msub[0]);

	$writedate = "$date";
	writelog("archive$viewnum");

	@boardinfo = chomp_database("$boardsdir/archive/$currentboard.dat");

	$boardname = "$boardinfo[0]";

	$boardinfo[2] =~ s/[\n\r]//g;
	$boardinfo[2] =~ /^\|(.*?)\|$/;
	$moderators = $boardinfo[2];
	$moderators =~ s/\|(\S?)/,$1/g;
	foreach $curuser (split(/ /, $moderators)) {
		if ($username eq "$curuser") {
			$thisboardmod = $username;
		} else { $thisboardmod = ""; }
	}

	jumpto();

	if ($info{'start'} ne "") { $start = "$info{'start'}"; }
	else { $start = 0; }

	if (!defined $msub[0]) { $msub[0] = ""; } # moved up Oct 28 2005

	$navbar = "$btn{'014'} $nav{'165'} $btn{'014'} $boardname";
	print_top();

# Start pages at top hack

	my $pages = qq~<span class="forumtext"><b>$msg{'039'}</b> </span>~;
	$nummessages = @messages;
	$c = 0;
	while (($c*$maxmessagedisplay) < $nummessages) {
		$viewc = $c+1;
		$strt = ($c*$maxmessagedisplay);

		if ($start == $strt) { $pages .= "[$viewc] "; }
		else { $pages .= qq~<a
 href="$forum&amp;op=archivedisplay&amp;num=$viewnum&amp;start=$strt">$viewc</a> ~;
		}

		$c++;
	}

# End pages at top hack ($pages used below twice)

	print qq~<table width="100%" border="0" cellspacing="1" cellpadding="2">
<tr>
<td valign="top" class="forumtext">$pages<br clear="all">~;

# condition around navigation tree - show only if no breadcrumbs in place:

	if (!$breadcrumb) {
		print qq~<img
 src="$imagesurl/forum/open.gif" width="16" height="16" border="0"
 alt="">&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=viewarchive">$nav{'165'}</a>
<br>
<img src="$imagesurl/forum/tline.gif" width="12" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="17" height="15" border="0" alt="">&nbsp;&nbsp;<a
 href="$forum" class="forumnav">$boardname</a>
<br>
<img src="$imagesurl/forum/tline2.gif" width="24" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="17" height="15" border="0"
 alt="">&nbsp;&nbsp;$msub[0]~;
	}

	print qq~</td>
<td align="right" valign="bottom"><a
 href="$forum&amp;op=printpage&amp;num=$viewnum" target="_blank"><img
 src="$imagesurl/forum/print.gif" vspace="5" alt="$msg{'106'}" border="0"></a><br>~;

	print qq~</td>
</tr>
</table>
<table width="100%" class="forumtitlebackcolor" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<table width="100%" border="0" cellspacing="1" cellpadding="2">
<tr>
<td class="boardtitle">
<table width="100%" border="0" cellspacing="0" cellpadding="0">
<tr>
<td><img src="$imagesurl/forum/$type.gif" alt="$typealt"></td>
<td>&nbsp;<b>$msg{'049'}</b></td>
</tr>
</table>
</td>
<td class="boardtitle"><b>$msg{'064'} $msub[0]</b></td>
</tr>
~;

	$second = "forumwindow3";
	for ($a = $start; $a < @messages; $a++) {

		if ($second eq "forumwindow2") { $second="forumwindow3"; }
		else { $second="forumwindow2"; }
		$numshown++;
		($msub[$a], $mname[$a], $memail[$a], $mdate[$a], $musername[$a], $micon[$a], $mip[$a], $mmessage[$a]) = split(/\|/, $messages[$a]);

		$subject = "$msub[$a]";
		if ($subject eq "") { $subject="---"; }
		$mmessage[$a] =~ s/\n//g;
		$message = "$mmessage[$a]";
		$name = "$mname[$a]";
		$messagedate = "$mdate[$a]";
		display_date($messagedate); $messagedate = $user_display_date;

		if ($userrank eq "$root") { $ip = qq~<a href="$pageurl/$cgi?action=findip&ip=$mip[$a]">$mip[$a]</a>~; } # Carter
		else { $ip = "$msg{'108'}"; }

		$removed = 0;
		if (!(-e("$memberdir/$musername[$a].dat"))) { $removed = 1; }
		$postinfo = "";
		$signature = "";
		$viewd = "";
		$icq = "";
		$sendm = "";
		$memberpic ="";
		if ($musername[$a] ne "$anonuser" && $removed == 0) {
			if ($username ne "$anonuser") {
				$sendm = qq~&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=imsend&amp;to=$musername[$a]"><img
 src="$imagesurl/forum/message.gif" alt="$msg{'109'} $mname[$a]" border="0"></a>~;
 			}

			open(FILE, "$memberdir/$musername[$a].dat");
			hold(FILE);
			chomp(@memset = <FILE>);
			release(FILE);
			close(FILE);

			# add memset presets
			if (!defined $memset[7]) { $memset[7] = ""; }
			if (!defined $memset[8]) { $memset[8] = ""; }

			$ranking = $memset[6]+$memset[11]+$memset[12];

			($joindate, undef) = split(/-/,$memset[10]); # Carter

			$postinfo = qq~$msg{'688'}&nbsp;$joindate<br>
$msg{'021'}&nbsp;$memset[6]<br>~;

			if ($username ne "$anonuser") {
				$viewd = qq~&nbsp;&nbsp;<a href="$pageurl/$cgi?action=viewprofile&amp;username=$musername[$a]"><img src="$imagesurl/forum/profile.gif" alt="$msg{'051'} $mname[$a]" border="0"></a>~;
			}
			$memberinfo = "$membergroups[2]";
			if ($ranking > 25) {
				$memberinfo = "$membergroups[3]";
			}
			if ($ranking > 100) {
				$memberinfo = "$membergroups[4]";
			}

			if ($ranking > 250) {
				$memberinfo = "$membergroups[5]";
			}
			if ($ranking > 500) {
				$memberinfo = "$membergroups[6]";
			}
			if ($ranking > 1000) {
				$memberinfo = "$membergroups[7]";
			}
			if ($ranking > 1500) {
				$memberinfo = "$membergroups[8]";
			}

			if ($boardmoderator eq "$musername[$a]") { $memberinfo = "$membergroups[1]"; }
			if ($memset[7] ne "") { $memberinfo = "$memset[7]"; }
			if ($memberinfo eq "$root") { $memberinfo = "$membergroups[0]"; }
			$signature = "$memset[5]";
			$signature =~ s/&&/\n/g;
			$signature = htmlescape($signature);
			if ($signature ne "") {
				$signature = qq~<br><br><br>
<hr noshade="noshade" size="1">
$signature
~;
			}

			if (!($memset[8] =~ /\D/) && $memset[8] ne "") {
				$icq = qq~&nbsp;&nbsp;<a
 href="http://www.icq.com/$memset[8]" target="_blank"><img
 src="http://wwp.icq.com/scripts/online.dll?icq=$memset[8]&amp;img=5"
 alt="$msg{'052'} $memset[8]" border="0"></a>~;
			}
		} else {
			$memberinfo = "$anonuser";
		}

		$message = "$message\n$signature";
		$memberpic ="";

		if ($musername[$a] ne "$anonuser"  && $removed == 0) {
			if ($memset[9] eq "") { $memset[9] = "_nopic.gif"; }
			if ($memset[9] =~ /^http:\/\// ) {
				if ($memberpic_width ne 0) { $tmp_width = qq~width="$memberpic_width"~; }
				else { $tmp_width = ""; }
				if ($memberpic_height ne 0) { $tmp_height = qq~height="$memberpic_height"~; }
				else { $tmp_height = ""; }
				$memberpic = qq~<img src="$memset[9]" $tmp_width $tmp_height border="0" alt="$name">~;
			} else {
				$memberpic = qq~<img src="$imagesurl/avatars/$memset[9]" border="0" alt="">~;
			}
		}

		if ($enable_ubbc) { doubbc(); }
		if ($enable_smile) { dosmilies(); }

		$url = "";
		if (($memset[4]) && ($musername[$a] ne "$anonuser")) {
			$url = qq~<a href="$memset[4]" target="_blank"><img
 src="$imagesurl/forum/www.gif" alt="$msg{'053'} $mname[$a]"
 border="0"></a>&nbsp;&nbsp;~;
		}

		$message = censor_it($message);
		$subject = censor_it($subject);

		if ($userrank ne "$root") { $ip = "$msg{'108'}"; }
		symbol_alt($micon[$a]);
		$sname = showhtml($name);

		print qq~<tr>
<td class="$second" width="140" valign="top">
<b>$sname</b><br>
$memberpic<br><br>
<span class="textsmall">$memberinfo<br>
$postinfo</span>
</td>
<td class="$second" valign="top">
<table border="0" cellspacing="0" cellpadding="0" width="100%">
<tr>
<td><img src="$imagesurl/forum/$micon[$a].gif" alt="$symbolalt"></td>
<td width="100%">&nbsp;<a name="$a"><b>$subject</b></a></td>
<td align="right" nowrap>&nbsp;<b>$msg{'110'}</b> $messagedate</td>
</tr>
</table>
<hr noshade="noshade" size="1">
$message<br>
</td>
</tr>
<tr class="$second">
<td><img src="$imagesurl/forum/ip.gif" alt="$msg{'111'}" align="top"> $ip</td>
<td>
<table border="0" cellspacing="0" cellpadding="0" width="100%">
<tr>
<td>$url~;

		if ($username ne $anonuser) { # avoid not authorized message
			if ($hidemail eq "1" && $musername[$a] ne "$anonuser") {
				print qq~<a href="$pageurl/$cgi?action=anonemail&sendto=$musername[$a]">~;
			} else {
				print qq~<a href="mailto:$memail[$a]">~;
			}

			print qq~<img src="$imagesurl/forum/email.gif" alt="$msg{'055'} $mname[$a]"
 border="0"></a>$viewd$sendm$icq~;
		}

		print qq~&nbsp;</td>
<td align="center"><a
 href="$pageurl/$cgi?action=viewarchive&amp;board=$currentboard&amp;op=archivedisplay&amp;num=$info{'num'}&amp;start=$info{'start'}#$a"><img
 src="$imagesurl/forum/link.gif" alt="$msg{'694'}" border="0"></a></td>
<td align="right">&nbsp;~; # link to post

		print qq~</td>
</tr>
</table>
</td>
</tr>
~;
		if ($numshown >= $maxmessagedisplay) { $a = @messages; }
	}

	if (!defined $msub[0]) { $msub[0] = ""; }

	print qq~</table>
</td>
</tr>
</table>
<table border="0" width="100%" cellspacing="1" cellpadding="2">
<tr>
<td valign="bottom" class="forumtext"><img
 src="$imagesurl/forum/tline2.gif" width="24" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="17" height="15" border="0" alt="">&nbsp;&nbsp;$msub[0]
<br>
<img src="$imagesurl/forum/tline.gif" width="12" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="17" height="15" border="0" alt="">&nbsp;&nbsp;<a
 href="$forum" class="forumnav" class="forumnav">$boardname</a>
<br>
<img src="$imagesurl/forum/open.gif" width="17" height="15" border="0" alt="">&nbsp;&nbsp;
<a href="$pageurl/$cgi?action=viewarchive">$nav{'165'}</a></td>
<td align="left" valign="top">&nbsp;</td>
<td align="right" valign="top">&nbsp;</td>
</tr>
<tr>
<td valign="top" class="forumtext">$pages</td>
<td align="right" colspan="2" class="forumtext"><form action="$pageurl/$cgi" method="get">
$msg{'104'} <select name="board">$selecthtml</select> <input type="submit" class="button" value="$btn{'014'}">
<input type="hidden" name="action" value="forum"></form></td>
</tr>
</table>
~;

	print_bottom();
	exit;

}

if (-e "$user_lib/archive.pl") {require "$user_lib/archive.pl"}

1; # return true