###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# block.pl                                                                    #
# v0.9.9.3.4                                                                  #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
###############################################################################
###############################################################################

################
sub block_left {
################

	@blockl = chomp_database("$datadir/blocks/blockleft.dat");

	foreach $line (@blockl) {
		@item = split(/\|/, $line);

		if (($item[2] == 1) && ((!$item[4]) || ($item[4] eq "1" && $username ne "$anonuser"))) {
	   	$cont = showblockhtml($item[3]);
			boxhead_div("$item[1]");
			print qq~$cont~;
			&boxfoot_div;
		}
	}

}

#################
sub block_right {
#################

	@blockr = chomp_database("$datadir/blocks/blockright.dat");

	foreach $line (@blockr) {
		@item = split(/\|/, $line);

		if (($item[2] == 1) && ((!$item[4]) || ($item[4] eq "1" && $username ne "$anonuser"))) {
   		$cont = showblockhtml($item[3]);
			boxhead_div("$item[1]");
			print qq~$cont~;
			&boxfoot_div;
		}
	}

}

###############
sub block_top {
###############
# Guest Only option by Jos
# needs note in admin panel: "2" equals guest only

	open(FILE, "$datadir/blocks/blocktop.dat");
	hold(FILE);
	chomp(@blockt = <FILE>);
	release(FILE);
	close(FILE);

	foreach $line (@blockt) {
		@item = split(/\|/, $line);
		if (($item[2] == 1)
		&& (((!$item[4]) || ($item[4] eq "1" && $username ne "$anonuser"))
		|| ($item[4] eq '2' && $username eq "$anonuser"))) {
			$cont = showblockhtml($item[3]);
			cboxheader("$item[1]");
			print qq~$cont~;
			&cboxfooter;
		}
	}

}

##################
sub block_bottom {
##################

	open(FILE, "$datadir/blocks/blockbottom.dat");
	hold(FILE);
	chomp(@blockbtm = <FILE>);
	release(FILE);
	close(FILE);

	foreach $line (@blockbtm) {
		@item = split(/\|/, $line);
		if (($item[2] == 1) && ((!$item[4]) || ($item[4] eq "1" && $username ne "$anonuser"))) {
	    		$cont = showblockhtml($item[3]);
			cboxheader("$item[1]");
			print qq~$cont~;
			&cboxfooter;
		}
	}

}

###################
sub showblockhtml {
###################

	my $text = shift;

	if ($allow_html == 1) {
		$text =~ s/&amp;/&/g;
		$text =~ s/&quot;/"/g;
		$text =~ s/&lt;/</g;
		$text =~ s/&gt;/>/g;
		$text =~ s/\n/<br>/g;
		$text =~ s/&&/\n/g; # inverse of block admin regex to save line breaks inside tags
		$text =~ s/<pipe>/&#124;/g;
	}

	return $text;

}

if (-e "$user_lib/block.pl") {require "$user_lib/block.pl"}

1;