###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# captcha.pl                                                                  #
# v0.9.9.3.4                                                                  #
# for CAPTCHAs                                                                #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
###############################################################################
###############################################################################

# 
# Need a folder of images called "letters" in webapp image DIR A to Z .jpg format 
# Need to move the rand_key.pl with formated keys in the cgi-lib CHMOD 644! 
# Make a file in db called captcha.log CHMOD 644. 
# 
# To get Images, Form & HTML use: 
#        require "$sourcedir/captcha.pl"; 
#        $Imagehtml = get_image(); 
# 
# This must be added/printed to the Guest form & HTML to print: 
# $Imagehtml 
# 
# To check Auth use: 
# require "$sourcedir/captcha.pl"; 
# my $secret_images = get_image(1, $input{'security_key'}, $input{'date_captcha'}); 
# if (!$secret_images) { error($err{'011'}); } 
# 

#################
sub print_image { 
#################
# Captcha Image Printer 
# 
# Made by: S_Flex 
# Date: 12-12-2005 
# For Help: www.shakaflex.com 
# 
# Code: Captcha 1-2 
# Edit at your own Risk 

use CGI qw(:standard); 

# works with getcgi $info{'i'} 
# Better check - 3! 

	if ($info{'i'} !~ /^[0-9]+$/ || $info{'i'} > 994) { 
		print "Content-type: text/html\n\n"; 
		exit 0; 
	} 

	require "$sourcedir/rand_key.pl"; 

	my $secret_letter     = $rand_key[$info{'i'}]; 
	my $secret_image_path = "$imagesdir/letters/$secret_letter.jpg"; 

	print "Content-type: image/jpg\n\n"; 
	open (PIC,$secret_image_path); 
	binmode(PIC); 
	local $/=undef; 
	my $picture=<PIC>; 
	print $picture; 
	close(PIC); 

	exit 0; 

} 

############### 
sub get_image { 
############### 
# Captcha Auth & Get Image 
# 
# Made by: S_Flex 
# Date: 02-23-2006 
# For Help: www.shakaflex.com 
# 
# 02-23-2006 - Babel Enabled version, the 5555555 is salt. 
#              Check Library Path, Should be ok as it is. 
#              SHA1 encoding is commented. 
# 
# 12-12-2005 - Released 
# 
# Code: Captcha 2-2 

# CHECK THIS PATH!!!! 
# Library Path 

# use lib '../'; 
use Babel; 
$y = new Babel;

# Edit at your own Risk 

       my ($in_action, $seckey, $date_ch) = @_; 

       if (!$in_action) { 
               require "$sourcedir/rand_key.pl"; 

               my $secret_word; 
               my $secret_images; 
               for my $i (1..6) { 
                       my $letter_index = int(rand 994); 
                       $secret_images .= qq~<img src="$pageurl/captcha.cgi?i=$letter_index">~; 
                       my $secret_letter = $rand_key[$letter_index]; 
                       $secret_word .= $secret_letter; 
               } 
               # SHA1 encoding 
               #use Digest::SHA1 qw(sha1_hex); 
               #my $security_key2=sha1_hex($secret_word); 

               # Babel encoding 
               use Babel; 
               $y = new Babel; 
               my $security_key2 = $y->encode($secret_word, '5555555'); 

               open (LOG,">>$datadir/captcha.log"); 
               print LOG "$date|$ENV{'REMOTE_ADDR'}|$security_key2\n"; 
               close(LOG); 

               my $set = qq~<b>$cha{'002'}</b><br>$secret_images<br><small>$cha{'003'}</small><br> 
<input type="text" name="security_key" value=""> 
<input type="hidden" name="date_captcha" value="$date"><br>~; 

               return $set; 
       } else { 

               # warning fix 
               if(!$seckey || !$date_ch) { return 0; } 

               my @captchas = chomp_database("$datadir/captcha.log"); 

               # Start of Small/?Fast version. 
               if (!@captchas) { return 0; } 

               my $return1 = 0; 
               $seckey = uc($seckey); 

               # SHA1 encoding 
               #use Digest::SHA1 qw(sha1_hex); 
               #$seckey = sha1_hex($seckey); 

               # Babel encoding 
               $seckey = $y->encode($seckey, '5555555'); 

               open(DATA, ">$datadir/captcha.log"); 
               hold(DATA); 
               foreach my $captcha (@captchas) { 
                       my ($c_date, $c_ip, $s_key) = split(/\|/, $captcha); 
                       if ($date_ch eq $c_date 
                               && $ENV{'REMOTE_ADDR'} eq $c_ip 
                               && $seckey eq $s_key) { 
                                       $return1 = 1; 
                       } 
                       elsif ($c_date) { 
                                       print DATA "$captcha\n"; 
                       } 
               } 
          release(DATA); 
          close(DATA); 

          return $return1; 
       } 

}

###################
sub captcha_admin {
###################

	check_access("editip");
	if ($access_granted ne "1") { error("$err{'011'}"); }

	$navbar = "$btn{'014'} $mnu{'059'}";
	print_top();

	my @captcha;

	if (open(CAPTCHA, "$datadir/conf/captcha.cfg")) {
		holdr(CAPTCHA);
		chomp(@captcha = <CAPTCHA>);
		close(CAPTCHA);
	}

	my $ablevisual = $captcha[0] || "yes";
	my $allownorefer = $captcha[1] || "no";
	my $allowgrec = $captcha[2] || "yes";

	my $vno = "";
	my $rno = "";
	my $gno = "";
	if ($ablevisual ne "yes") {$vno = " selected"}
	if ($allownorefer ne "yes") {$rno = " selected"}
	if ($allowgrec ne "yes") {$gno = " selected"}

	print qq~<br>
<b><i>$mnu{'059'}</i></b><br>
<br>
<form action="$pageurl/$cgi?action=admin&op=captchaadmin2" method="post" name="creator"> 
<table border="0" cellpadding="1" cellspacing="1" class="titlebg">
<tr>
<td class="windowbg">$cha{'004'}</td>
<td class="windowbg"><select name="ablevisuals">
<option value="yes">$nav{'047'}</option>
<option value="no"$vno>$nav{'048'}</option>
</select></td>
</tr>
<tr>
<td class="windowbg">$cha{'005'}</td>
<td class="windowbg"> <select name="allownorefers">
<option value="yes">$nav{'047'}</option>
<option value="no"$rno>$nav{'048'}</option>
</select></td>
</tr>
<tr>
<td class="windowbg">$cha{'006'}</td>
<td class="windowbg"> <select name="allowgrec">
<option value="yes">$nav{'047'}</option>
<option value="no"$gno>$nav{'048'}</option>
</select></td>
</tr>
</table>
<br>
<input type="submit" class="button" value="$btn{'015'}"><br>
<br>
</form>
<br>
~;

	print_bottom();
	exit;

}

####################
sub captcha_admin2 {
####################

	check_access("editip");
	if ($access_granted ne "1") { error("$err{'011'}"); }

	$input{'ablevisuals'} =~ s/[\n\r]//g;
	$input{'allownorefers'} =~ s/[\n\r]//g;
	$input{'allowgrec'} =~ s/[\n\r]//g;

	open(CAPTCHA, ">$datadir/conf/captcha.cfg");
	hold(CAPTCHA);

	print CAPTCHA "$input{'ablevisuals'}\n";
	print CAPTCHA "$input{'allownorefers'}\n";
	print CAPTCHA "$input{'allowgrec'}\n";

	close(CAPTCHA);
 
	print "Location: $pageurl/$cgi?action=admin&op=captchaadmin\n\n";
	exit;

}

if (-e "$user_lib/captcha.pl") {require "$user_lib/captcha.pl"}

1;