###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# downloads.pl                                                                #
# v0.9.9.3.4                                                                  #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
###############################################################################
###############################################################################

my (@id, @name); # prevents interference with the same arrays in poll.pl - Lander

###############
sub downloads {
###############

	if (!$info{'cat'}) {

		my @cats = read_database("$downloadsdir/downloadcats.dat");

		my $catscount = chomp_datatext("$downloadsdir/downloadcats.cnt");

		$navbar = "$btn{'014'} $nav{'056'}";
		print_top();

		print qq~<table align="center" border="0" cellpadding="3" cellspacing="10">
<tr>
~;
		my $count = 0;
		my $c = 0;

		foreach my $category (@cats) {
			my @fields = split (/\|/, $category);
			if (-e "$downloadsdir/$fields[1].dat") {
				my $cnt = chomp_datatext("$downloadsdir/$fields[1].cnt");

##STEVE##IVE ADDED FOLDER ICONS THAT GREY OUT IN HERE

				print qq~<td valign="top" width="50%"><table border="0">
<tr>
<td width="20" valign="top"><img src="$imagesurl/dir.gif" border="0" alt="*"></td>
<td><b><a
 href="$pageurl/$cgi?action=downloads&amp;cat=$fields[1]">$fields[0]</a></b> <i>($cnt)</i></td>
</tr>
<tr>
<td>&nbsp;</td>
<td>$fields[2]</td>
</tr>
</table>
</td>
~;
			} else {
				print qq~<td valign="top" width="50%"><table border="0">
<tr>
<td width="20" valign="top"><img src="$imagesurl/dirempty.gif" border="0" alt="*"></td>
<td><font color="#888888"><b>$fields[0]</b> <i>(0)</i></font></td>
</tr>
<tr>
<td>&nbsp;</td>
<td><font color="#888888">$fields[2]</font></td>
</tr>
</table>
</td>
~;
			}

			$c++;
			$count++;
			if (($count == 2) && ($c < @cats)) { # avoid empty row - Jos
				print qq~</tr>
<tr>
~;
				$count = 0;
			}
		}

# fill table with remaining cells where required - Jos
		while (($count > 0) && ($count < 2)) {
			print qq~<td>&nbsp;</td>~;
			$count++;
		}

		if ($catscount == 1) { $downloadscount = "$msg{'084'} <b>1</b> $msg{'169'}"; }
		else { $downloadscount = "$msg{'086'} <b>$catscount</b> $msg{'170'}"; }

		print qq~</tr>
</table>
<hr>
<br>
<table align="center" border="0" cellpadding="3" cellspacing="0">
<tr>
<td align="center">$downloadscount</td>
</tr>
~;
		if ($adminonlyd eq "1") {
			check_access("editdown");
			if ($access_granted eq "1") {
				print qq~<tr>
<td align="center"><a href="$pageurl/$cgi?action=adddownload">$nav{'058'}</a></td>
</tr>
~;
			}
		}

		if ($adminonlyd ne "1") {
			if ($username ne "$anonuser") {
				print qq~<tr>
<td align="center"><a href="$pageurl/$cgi?action=adddownload">$nav{'058'}</a></td>
</tr>
~;
			}
		}
		print qq~</table>
~;

		show_latestdownloads(); # a table

		print qq~<br>~;

		downloads_search(); # a table

		print qq~<br>~;

		print_bottom();
		exit;

	} else { # to view downloads list

		my @catsname = read_database("$downloadsdir/downloadcats.dat");

		for ($a = 0; $a < @catsname; $a++) {
			($dlname[$a], $dlfolder[$a], undef) = split(/\|/, $catsname[$a]);
			if ($info{'cat'} eq $dlfolder[$a]) {
				$dnlcatsname = $dlname[$a];
			}
		}

		$navbar = "$btn{'014'} $nav{'056'} $btn{'014'} $dnlcatsname";
		print_top();

		if ($info{'cat'} =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

		my @dnlcats = read_database("$downloadsdir/$info{'cat'}.dat");

		for ($a = 0; $a < @dnlcats; $a++) {
			($id[$a], $name[$a], $url[$a], $desc[$a], $date[$a], $downloadposter[$a], $hits[$a], $votes[$a], $score[$a]) = split(/\|/, $dnlcats[$a]);
		}
		if (!defined $info{'start'}) { $info{'start'} = "0"; }
		if ($info{'start'} eq "") { $start = 0; }
		else { $start = "$info{'start'}"; }

		$numshown = 0;

		print qq~<table border="0" cellpadding="1" cellspacing="0" width="100%">
~;
		for ($b = $start; $b < @dnlcats; $b++) {
			++$numshown;
			display_date($date[$b]); $date[$b] = $user_display_date;
			$message = $desc[$b];

			if (length($message) > 100) {
				$tmpmessage = substr($message, 0, 100);
				$tmpmessage =~ s/(.*)\s.*/$1/;
				$oneliner = "$tmpmessage...";
			} else {
				$oneliner = $message;
			}
			if ($votes[$b] eq "") { $votes[$b] = "0"; }
			if ($score[$b] eq "") { $score[$b] = "0"; }

			$averagescore = "0";
			if ($votes[$b] > 0) { # STOPS DIVISION BY ZERO!
				$averagescore = "0";
				$averagescore = int(($score[$b] * 10) / $votes[$b]);
			}

##STEVE##27-03-02## MODS HERE!
			print qq~<tr>
<td><img src="$imagesurl/search/dnld.gif" border="0" alt="">&nbsp;&nbsp;<b><a
 href="$pageurl/$cgi?action=downloadinfo&amp;cat=$info{'cat'}&amp;id=$id[$b]">$name[$b]</a></b></td>
</tr>
<tr>
<td>$oneliner</td>
</tr>
<tr>
<td><small>$msg{'089'} $date[$b] $nav{'134'} $hits[$b] $msg{'065'} $votes[$b] $msg{'447'} $score[$b] $msg{'448'} $averagescore%</small></td>
</tr>
<tr>
<td><small>~;

#THIS WORKS QUICKER COS ITS JUST 100PIXELS = 100PERCENT SO NO NEED FOR ANY DAFT LOOPS SO LONG AS BAR IS 100PX WIDE JUST DIVIDE B4HAND IF YOU JUST WANT 50PX OR WHATEVER :)
			if ($averagescore > 0) {
				$greycells = 100 - $averagescore;
				print qq~0%&nbsp;<img
 src="$imagesurl/rategreen.gif" height="8" width="$averagescore" border="0" alt=""><img
 src="$imagesurl/rategrey.gif" height="8" width="$greycells" border="0"
 alt="">&nbsp;100%&nbsp;&nbsp;~;
			} else {
				print qq~0%&nbsp;<img
 src="$imagesurl/rategrey.gif" height="8" width="100" border="0"
 alt="">&nbsp;100%&nbsp;&nbsp;~;
			}
 			print qq~<br><a
 href="$pageurl/$cgi?action=redirectd&amp;cat=$info{'cat'}&amp;id=$id[$b]"
 target="_blank">$msg{'646'}</a>~;

			if ($username ne $anonuser) {
				if ($username ne $downloadposter[$b]) {
					print qq~ &#124; <a
 href="$pageurl/$cgi?action=ratedownloads&amp;cat=$info{'cat'}&amp;id=$id[$b]">$nav{'059'}</a>~;
				}

				print qq~ &#124; <a  href="$pageurl/$cgi?action=imsend&amp;to=admin&complaindownload=$info{'cat'}&amp;id=$id[$b]">$nav{'060'}</a>~;
			}

			check_access("editdown");
			if ($access_granted eq "1") {
				print qq~ &#124; <a
 href="$pageurl/$cgi?action=editdownloads&amp;cat=$info{'cat'}&amp;id=$id[$b]">$nav{'131'}</a> &#124; <a
 href="$pageurl/$cgi?action=deletedownload&amp;cat=$info{'cat'}&amp;id=$id[$b]">$nav{'132'}</a> &#124; <a
 href="$pageurl/$cgi?action=movedownload&amp;cat=$info{'cat'}&amp;id=$id[$b]">$nav{'133'}</a></small><br>
<br></td>
</tr>
~;
			} else {
				print qq~</small><br><br></td>
</tr>
~;
			}
			if ($numshown >= $maxlinks) { $b = @dnlcats; }
		}
		print qq~<tr>
<td>~;

		if ($numshown >= $maxlinks) {
			print qq~<hr noshade="noshade" size="1">
$msg{'039'}~;
			$numlinks = @dnlcats;
			$c = 0;
			while (($c*$maxlinks) < $numlinks) {
				$viewc = $c+1;
				$strt = ($c*$maxlinks);
				if ($start == $strt) { print "$viewc "; }
				elsif ($strt == 0) {
					print qq~<a href="$pageurl/$cgi?action=downloads&amp;cat=$info{'cat'}">$viewc</a> ~;
				} else {
					print qq~<a
 href="$pageurl/$cgi?action=downloads&amp;cat=$info{'cat'}&amp;start=$strt">$viewc</a> ~;
				}
				++$c;
			}
		}
		print qq~</td>
</tr>
</table>
<br>
<table align="center" border="0" cellpadding="3" cellspacing="0">
~;
		if ($adminonlyd eq "1") {
			check_access("editdown");
			if ($access_granted eq "1") {
				print qq~<tr>
<td align="center"><a href="$pageurl/$cgi?action=downloads">$nav{'056'} $nav{'033'}</a> &#124; <a
 href="$pageurl/$cgi?action=adddownload">$nav{'058'}</a></td>
</tr>
~;
			}
		}
		if($username ne "$anonuser") {
			if ($adminonlyd ne "1") {
				print qq~<tr>
<td align="center"><a href="$pageurl/$cgi?action=downloads">$nav{'056'} $nav{'033'}</a> &#124; <a
 href="$pageurl/$cgi?action=adddownload">$nav{'058'}</a></td>
</tr>
~;
			}
		} else {
			print qq~<tr>
<td align="center"><a href="$pageurl/$cgi?action=downloads">$nav{'056'} $nav{'033'}</a></td>
</tr>
~;
		}
		print qq~</table>
</div>
~;

		print_bottom();
		exit;

	}

}

###################
sub download_info {
###################

	if ((!defined $info{'cat'}) || ($info{'cat'} =~ /[\$?|()[\]{}\^*.<%]/)) { &data_error; }

	my @dnlcats = read_database("$downloadsdir/$info{'cat'}.dat");

	my @allcats = read_database("$downloadsdir/downloadcats.dat");

	my $thiscat = "";
	foreach my $allcategory (@allcats) {
		my @allfields = split (/\|/, $allcategory);
		if ($info{'cat'} eq $allfields[1]) { $thiscat = "$allfields[0]"; }
	}

	for ($a = 0; $a < @dnlcats; $a++) {
		($id[$a], $name[$a], $url[$a], $desc[$a], $date[$a], $downloadposter[$a], $hits[$a], $votes[$a], $score[$a]) = split(/\|/, $dnlcats[$a]);
		if ($info{'id'} eq $id[$a]) {
			display_date($date[$a]); $date[$a] = $user_display_date;

			if ($votes[$a] eq "") { $votes[$a] = "0"; }
			if ($score[$a] eq "") { $score[$a] = "0"; }

			$navbar = "$btn{'014'} $nav{'056'} $btn{'014'} $thiscat $btn{'014'} $name[$a]";
			print_top();

			print qq~<div id="linkinfo">
<table align="center" width="100%" cellpadding="3" cellspacing="0" border="0">
~;

# condition around navigation tree - show only if no breadcrumbs in place:
	if (!$breadcrumb) { 
		print qq~<tr>
<td>&nbsp;<img src="$imagesurl/forum/open.gif" width="17" height="15" border="0" alt="">&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=downloads">$nav{'056'}</a>
<br>
<img src="$imagesurl/forum/tline.gif" width="12" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="17" height="15" border="0" alt="">&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=downloads&amp;cat=$info{'cat'}">$thiscat</a></td>
</tr>
~;
	}

	print qq~<tr>
<td class="forumwindow3">&nbsp;<img
 src="$imagesurl/search/dnld.gif" border="0" alt="">&nbsp; <b>$name[$a]</b>
<br>
<small>&nbsp;$msg{'089'} $date[$a] $nav{'134'} $hits[$a] $msg{'065'} $votes[$a] $msg{'447'} $score[$a]</small></td>
</tr>
<tr>
<td class="forumwindow1 text">$desc[$a]</td>
</tr>
<tr>
<td class="forumwindow1 text" align="right"><a
 href="$pageurl/$cgi?action=redirectd&amp;cat=$info{'cat'}&amp;id=$id[$a]"
 class="polllink" target="_blank">$msg{'646'}</a>&nbsp;</td>
</tr>
~;
			if ($votes[$a] > 0) { # STOPS DIVISION BY ZERO!
				$averagescore = "0";
				$averagescore = int(($score[$a] * 10) / $votes[$a]);
			}
			print qq~<tr>
<td class="forumwindow3" align="center"><small>~;

			if ($votes[$a] > 0) {
				$greycells = 100 - $averagescore;
				print qq~0%&nbsp;<img
 src="$imagesurl/rategreen.gif" height="8" width="$averagescore" border="0"
 alt="$averagescore%"><img
 src="$imagesurl/rategrey.gif" height="8" width="$greycells" border="0"
 alt="">&nbsp;100%&nbsp;&nbsp;<br>
~;
			} else {
				print qq~0%&nbsp;<img
 src="$imagesurl/rategrey.gif" height="8" width="100" border="0"
 alt="0%">&nbsp;100%&nbsp;&nbsp;<br>
~;
			}
			if ($username ne $anonuser) {
				if ($username ne $downloadposter[$a]) {
					print qq~<a
 href="$pageurl/$cgi?action=ratedownloads&amp;cat=$info{'cat'}&amp;id=$id[$a]">$nav{'059'}</a> &#124; ~;
				}
				print qq~ &#124; <a  href="$pageurl/$cgi?action=imsend&amp;to=admin&complaindownload=$info{'cat'}&amp;id=$id[$b]">$nav{'060'}</a>~;
			}

			check_access("editdown");
			if ($access_granted eq "1") {
				print qq~ &#124; <a
 href="$pageurl/$cgi?action=editdownloads&amp;cat=$info{'cat'}&amp;id=$id[$a]">$nav{'131'}</a> &#124; <a
 href="$pageurl/$cgi?action=deletedownload&amp;cat=$info{'cat'}&amp;id=$id[$a]">$nav{'132'}</a> &#124; <a
 href="$pageurl/$cgi?action=movedownload&amp;cat=$info{'cat'}&amp;id=$id[$a]">$nav{'133'}</a>~;
			}
			print qq~</small></td>
</tr>
</table>
<br>
</div>
~;

			print_bottom();
			exit;
		}
	}

}

#################
sub adddownload {
#################

	if ($username eq "$anonuser" && $adminonlyd ne "1") { error("noguests"); }

	if ($adminonlyd eq "1") {
			check_access("editdown");
		if ($access_granted ne "1") { error("$err{'011'}"); }
	}

	@cats = read_database("$downloadsdir/downloadcats.dat");

	$navbar = "$btn{'014'} $nav{'056'} $btn{'014'} $nav{'058'}";
	print_top();

	print qq~<form method="post" action="$pageurl/$cgi?action=adddownload2" onSubmit="oneclick(this)">
<table border="0" cellpadding="5" cellspacing="0">
<tr>
<td><b>$msg{'167'}</b></td>
<td><input type="text" class="textinput" name="title" size="40" maxlength="100"></td>
</tr>
<tr>
<td><b>$msg{'168'}</b></td>
<td><input type="text" class="textinput" name="url" size="40" maxlength="150" value="http://"></td>
</tr>
<tr>
<td><b>$msg{'092'}</b></td>
<td><select name="cat">~;

	foreach $category (@cats) {
		@fields = split (/\|/, $category);

		print qq~<option
 value="$fields[1]">$fields[0]~;
	}
	print qq~</select><td>
</tr>
<tr>
<td valign="top"><b>$msg{'093'}</b></td>
<td><textarea name="desc" cols="40" rows="5" maxlength="1500"></textarea>
<br>
$msg{'645'}</td>
</tr>
<tr>
<td colspan="2"><input type="submit" class="button" value="$btn{'018'}"></td>
</tr>
</table>
</form>
~;

	print_bottom();
	exit;

}

##################
sub adddownload2 {
##################

	if ($adminonlyd eq "1") {
		check_access("editdown");
		if ($access_granted ne "1") { error("$err{'011'}"); }
	}
	error("$err{'031'}") unless ($input{'cat'});
	error("$err{'021'}") unless ($input{'title'});
	error("$err{'022'}") unless ($input{'url'});
	error("$err{'023'}") unless ($input{'desc'});
	if (length($input{'desc'}) > 1500) { $input{'desc'} = substr($input{'desc'},0,1500); }
	if($username eq "$anonuser") { error("$err{'011'}"); }

	if (open(DATA,"<$downloadsdir/$input{'cat'}.dat")) {
		hold(DATA);
		@datas=<DATA>;
		release(DATA);
		close(DATA);

		foreach $line (@datas) {
			$thisid = (split(/\|/, $line))[0];
			push (@allids, $thisid);
		}
		@allids = sort { $b <=> $a } @allids;
		$id = $allids[0] +1;
	} else {
		$id = 1;
	}

	chomp($input{'desc'});
	chomp($input{'title'});
	chomp($input{'url'});

	$title = htmlescape($input{'title'});
	$desc = htmlescape($input{'desc'});

	open(DATABASE,">$downloadsdir/$input{'cat'}.dat");
	hold(DATABASE);
	print DATABASE "$id|$title|$input{'url'}|$desc|$date|$username|0|0|0\n";
	print DATABASE @datas;
	release(DATABASE);
	close(DATABASE);

	if (open(CNT,"<$downloadsdir/$input{'cat'}.cnt")) {
		hold(CNT);
		$catscount = <CNT>;
		release(CNT);
		close(CNT);
	} else {
		$catscount = 0;
	}
	open(DCNT, "$downloadsdir/downloadcats.cnt");
	hold(DCNT);
	$downloadcatscount = <DCNT>;
	release(DCNT);
	close(DCNT);

	$catscount++;
	$downloadcatscount++;

	open(CNT, ">$downloadsdir/$input{'cat'}.cnt");
	hold(CNT);
	print CNT "$catscount";
	release(CNT);
	close(CNT);

	open(DCNT, ">$downloadsdir/downloadcats.cnt");
	hold(DCNT);
	print DCNT "$downloadcatscount";
	release(DCNT);
	close(DCNT);

	success();

}

#############
sub success {
#############

	$navbar = "$btn{'014'} $msg{'599'}";
	print_top();

	print qq~<b>$msg{'599'}</b><br>
$inf{'019'}~;

	print_bottom();
	exit;

}

##############
sub redirect {
##############

	if ($username eq "$anonuser" ) {
		if ($antileech eq "1") { error( "$err{'026'}" ); }
	}
	if ($info{'cat'} =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

	$filetoopen = "$info{'cat'}.dat";
	@datas = read_database("$downloadsdir/$filetoopen");

	$count = @datas;
	$i = 0;

	open(DATA,">$downloadsdir/$filetoopen") or error("$err{'016'} $filetoopen");
	hold(DATA);
	while ($i < $count) {
		($id_temp, $name, $url, $desc, $addate, $downloadposter, $hits_temp, $votes, $score) = split(/\|/, $datas[$i]);

		if ($id_temp eq $info{'id'}) {
			$theurl = $url;
			$hits = $hits_temp +1;

			print DATA "$id_temp|$name|$url|$desc|$addate|$downloadposter|$hits|$votes|$score";
		} else {
			print DATA "$id_temp|$name|$url|$desc|$addate|$downloadposter|$hits_temp|$votes|$score";
		}
		$i++;
	}
	release(DATA);
	close(DATA);

	print "Location: $theurl\n\n";

}

###################
sub editdownloads {
###################

	check_access("editdown");
	if ($access_granted ne "1") { error("$err{'011'}"); }

	$filetoopen = "$info{'cat'}.dat";
	@datas = read_database("$downloadsdir/$filetoopen");

	foreach $line(@datas) {
	chomp($line);
		if ($info{'id'} == (split(/\|/, $line))[0]) {
			($idtemp, $linkname, $theurl, $desc, $thedate, $downloadposter, $nhits, $votes, $score) = split(/\|/, $line);
			last;
		}
	}

	$linkname = htmltotext($linkname);
	$desc = htmltotext($desc);

	$navbar = "$btn{'014'} $nav{'056'} $btn{'014'} $msg{'385'}";
	print_top();

	print qq~<form action="$pageurl/$cgi?action=editdownloads2&cat=$info{'cat'}&id=$info{'id'}"
 method="post" onSubmit="oneclick(this)">
<table border="0" width="100%" cellpadding="0" cellspacing="0">
<tr>
<td colspan="2"><b>$msg{'385'}</b></td>
</tr>
<tr>
<td>$msg{'386'}</td>
<td><input type="hidden" name="newtemp" value="$idtemp" size="3">$idtemp</td>
</tr>
<tr>
<td>$msg{'387'}</td>
<td><input type="text" class="textinput" name="nlinkname" value="$linkname" size="30"></td>
</tr>
<tr>
<td>$msg{'388'}</td>
<td><input type="text" class="textinput" name="ntheurl" value="$theurl" size="30"></td>
</tr>
<tr>
<td>$msg{'389'}</td>
<td><textarea name="ndesc" cols="40" rows="5" maxlength="1500">$desc</textarea></td>
</tr>
<tr>
<td>$msg{'390'}</td>
<td><input type="text" class="textinput" name="nthedate" value="$thedate" size="30"></td>
</tr>
<tr>
<td>$msg{'391'}</td>
<td><input type="text" class="textinput" name="ndownloadposter" value="$downloadposter" size="10"></td>
</tr>
<tr>
<td>$msg{'626'}</td>
<td><input type="text" class="textinput" name="nhits" value="$nhits" size="3"></td>
</tr>
<tr>
<td>$msg{'627'}</td>
<td><input type="hidden" name="nvotes" value="$votes" size="3">$votes</td>
</tr>
<tr>
<td>$msg{'628'}</td>
<td><input type="hidden" name="nscore" value="$score" size="3">$score</td>
</tr>
<tr>
<td colspan="2"><hr></td>
</tr>
<tr>
<td align="center" colspan="2"><input type="submit" class="button" value="$btn{'022'}"></td>
</tr>
</td>
</tr>
</table>
</form>
~;

	print_bottom();
	exit;

}

####################
sub editdownloads2 {
####################

	check_access("editdown");
	if ($access_granted ne "1") { error("$err{'011'}"); }
	error("$err{'021'}") unless ($input{'nlinkname'});
	error("$err{'022'}") unless ($input{'ntheurl'});
	error("$err{'023'}") unless ($input{'ndesc'});
	error("$err{'006'}") unless ($input{'ndownloadposter'});
	error("$err{'006'}") unless ($input{'nthedate'});
	if ($input{'nhits'} eq "") { error("$err{'006'}"); }
	if (length($input{'ndesc'}) > 1500) { $input{'ndesc'} = substr($input{'ndesc'},0,1500); }

	$input{'ndesc'} = htmlescape($input{'ndesc'});
	$input{'nlinkname'} = htmlescape($input{'nlinkname'});

	if ($input{'nvotes'} eq "") {$input{'nvotes'} = "0";}
	if ($input{'nscore'} eq "") {$input{'nscore'} = "0";}

	$filetoopen = "$info{'cat'}.dat";
	@datas = read_database("$downloadsdir/$filetoopen");

	open(EDITDATA,">$downloadsdir/$filetoopen") or error("$err{'016'} $filetoopen");
	hold(EDITDATA);
	for ($a = 0; $a < @datas; $a++) {
		($idtemp, undef, undef, undef, undef, undef, undef, undef, undef) = split(/\|/, $datas[$a]);
		if ($idtemp eq $info{'id'}) {
			print EDITDATA "$input{'newtemp'}|$input{'nlinkname'}|$input{'ntheurl'}|$input{'ndesc'}|$input{'nthedate'}|$input{'ndownloadposter'}|$input{'nhits'}|$input{'nvotes'}|$input{'nscore'}\n";
		}	else { print EDITDATA "$datas[$a]"; }
	}
	release(EDITDATA);
	close(EDITDATA);

	print "Location: $pageurl/$cgi?action=downloads\n\n";
	exit;

}

####################
sub deletedownload {
####################

	check_access("editdown");
	if ($access_granted ne "1") { error("$err{'011'}"); }

	$filetoopen = "$info{'cat'}.dat";
	@datas = read_database("$downloadsdir/$filetoopen");

	foreach $line(@datas) {
	chomp($line);
		if ($info{'id'} == (split(/\|/, $line))[0]) {
			($idtemp, $linkname, $theurl, $desc, $thedate, $downloadposter, $nhits, $votes, $score) = split(/\|/, $line);
			last;
		}
	}

	$navbar = "$btn{'014'} $nav{'056'} $btn{'014'} $nav{'132'}";
	print_top();

	print qq~<form action="$pageurl/$cgi?action=deletedownload2&cat=$info{'cat'}&id=$info{'id'}"
 method="post" onSubmit="oneclick(this)">
<table border="0" width="100%" cellpadding="0" cellspacing="0">
<tr>
<td colspan="2"><b>$nav{'132'}:</b></td>
</tr>
<tr>
<td>$msg{'386'}</td>
<td>$idtemp</td>
</tr>
<tr>
<td>$msg{'387'}</td>
<td>$linkname</td>
</tr>
<tr>
<td>$msg{'388'}</td>
<td>$theurl</td>
</tr>
<tr>
<td>$msg{'389'}</td>
<td>$desc</td>
</tr>
<tr>
<td>$msg{'390'}</td>
<td>$thedate</td>
</tr>
<tr>
<td>$msg{'391'}</td>
<td>$downloadposter</td>
</tr>
<tr>
<td>$msg{'392'}</td>
<td>$nhits</td>
<input type="hidden" name="score" value="$score">
<input type="hidden" name="votes" value="$votes">
</tr>
<tr>
<td colspan="2">
<hr>
</td>
</tr>
<tr>
<td align="center" colspan="2"><input type="submit" class="button" value="$btn{'011'}"></td>
</tr>
</table>
</form>
~;

	print_bottom();
	exit;

}

################
sub deletedownload2 {
################

	check_access("editdown");
	if ($access_granted ne "1") { error("$err{'011'}"); }

	$filetoopen = "$info{'cat'}.dat";
	@datas = read_database("$downloadsdir/$filetoopen");

	open(DATA,">$downloadsdir/$filetoopen") or error("$err{'016'} $filetoopen");
	hold(DATA);
	foreach $datas (@datas) {
		chomp($datas);
		($idtemp, $linkname, $theurl, $desc, $thedate, $linkposter, $nhits, $votes, $score) = split(/\|/, $datas);

		if ($idtemp ne $info{'id'}) {
			print DATA "$idtemp|$linkname|$theurl|$desc|$thedate|$linkposter|$nhits|$votes|$score\n";
		}
	}
	release(DATA);
	close(DATA);

	$lines = 0;
	open(DATA,"<$downloadsdir/$filetoopen") or error("$err{'001'} $filetoopen");
	hold(DATA);
	while (sysread DATA, $buffer, 4096) {
        	$lines += ($buffer =~ tr/\n//);
	}
	release(DATA);
	close(DATA);

	if ($lines == 0) { # NOTE - this not to other method yet
		unlink "$downloadsdir/$info{'cat'}.dat";
		unlink "$downloadsdir/$info{'cat'}.cnt";
	} else {
		open(CNT, "$downloadsdir/$info{'cat'}.cnt") or error("$err{'001'} $info{'cat'}.cnt");
		hold(CNT);
		$catscount = <CNT>;
		release(CNT);
		close(CNT);

		$catscount--;

		open(CNT, ">$downloadsdir/$info{'cat'}.cnt") or error("$err{'016'} $info{'cat'}.cnt");
		hold(CNT);
		print CNT "$catscount";
		release(CNT);
		close(CNT);
	}

	open(LCNT, "$downloadsdir/downloadcats.cnt") or error("$err{'001'} downloadcats.cnt");
	hold(LCNT);
	$linkcatscount = <LCNT>;
	release(LCNT);
	close(LCNT);

	$linkcatscount--;

	open(LCNT, ">$downloadsdir/downloadcats.cnt") or error("$err{'016'} downloadcats.cnt");
	hold(LCNT);
	print LCNT "$linkcatscount";
	release(LCNT);
	close(LCNT);

	print "Location: $pageurl/$cgi?action=downloads\n\n";
	exit;

}

##################
sub movedownload {
##################

	check_access("editdown");
	if ($access_granted ne "1") { error("$err{'011'}"); }

	$filetoopen = "$info{'cat'}.dat";
	@datas = read_database("$downloadsdir/$filetoopen");

	@cats2 = read_database("$downloadsdir/downloadcats.dat");

	foreach $line(@datas) {
	chomp($line);
		if ($info{'id'} == (split(/\|/, $line))[0]) {
			($idtemp, $linkname, $theurl, $desc, $thedate, $linkposter, $hits, $votes, $score) = split(/\|/, $line);
			last;
		}
	}

	$navbar = "$btn{'014'} $nav{'056'} $btn{'014'} $nav{'133'}";
	print_top();

	print qq~<form action="$pageurl/$cgi?action=movedownload2&cat=$info{'cat'}&id=$info{'id'}"
 method="post" onSubmit="oneclick(this)">
<table border="0" width="100%" cellpadding="0" cellspacing="0">
<tr>
<td colspan="2"><b>$nav{'133'}</b></td>
</tr>
<tr>
<td>$msg{'386'}</td>
<td><input type="hidden" name="idtemp" value="$idtemp" size="3">$idtemp</td>
</tr>
<tr>
<td>$msg{'387'}</td>
<td><input type="hidden" name="mlinkname" value="$linkname" size="30">$linkname</td>
</tr>
<tr>
<td>$msg{'388'}</td>
<td><input type="hidden" name="mtheurl" value="$theurl" size="30">$theurl</td>
</tr>
<tr>
<td>$msg{'389'}</td>
<td><input type="hidden" name="mdesc" value="$desc" size="50">$desc</td>
</tr>
<tr>
<td>$msg{'390'}</td>
<td><input type="hidden" name="mthedate" value="$thedate" size="30">$thedate</td>
</tr>
<tr>
<td>$msg{'391'}</td>
<td><input type="hidden" name="mlinkposter" value="$linkposter" size="10">$linkposter</td>
</tr>
<tr>
<td>$msg{'392'}</td>
<td><input type="hidden" name="mhits" value="$hits" size="3">$hits</td>
<input type="hidden" name="mvotes" value="$votes">
<input type="hidden" name="mscore" value="$score">
</tr>
<tr>
<td><b>$msg{'393'} $msg{'092'}</b></td>
<td><select name="cat2">
~;
	foreach $category (@cats2) {
		@fields = split (/\|/, $category);
		if ($fields[1] ne $info{'cat'}) { print qq~<option value="$fields[1]">$fields[0]~; }
	}
	print qq~</select><td>
</tr>
<tr>
<td colspan="2">
<hr>
</td>
</tr>
<tr>
<td align="center" colspan="2"><input type="submit" class="button" value="$btn{'029'}"></td>
</tr>
</table>
</form>
~;

	print_bottom();
	exit;

}

###################
sub movedownload2 {
###################

	check_access("editdown");
	if ($access_granted ne "1") { error("$err{'011'}"); }

	if ($input{'cat2'} eq '') { $input{'cat2'} = $info{'cat'}; }

	my $filetoopen = "$info{'cat'}.dat";
	my @datas = read_database("$downloadsdir/$filetoopen");

# print "from" cat without the line
	open(DATA,">$downloadsdir/$filetoopen") or error("$err{'016'} $filetoopen");
	hold(DATA);
	foreach my $datas(@datas) {
		my ($idtemp) = (split(/\|/, $datas))[0];

		if ($idtemp ne $info{'id'}) {
			print DATA $datas;
		}
	}
#	release(DATA);
	close(DATA);

# added to keep downloads from duplicating - Jos
# get new id number:
	my $idnew = 1; # for empty file
	my @datas2 = ();
	if (open(DATA,"<$downloadsdir/$input{'cat2'}.dat")) { 
		holdr(DATA); 
		@datas2 = <DATA>; 
		close(DATA); 
		my $thisid; 
		my @allids = (); 
		foreach my $line(@datas2) { 
			$thisid = (split(/\|/, $line))[0]; 
			push (@allids, $thisid); 
		} 
		@allids = sort { $b <=> $a } @allids; 
		$idnew = $allids[0] +1;
	}

# print the new line to the "to" cat:
	my $filetomove2 = "$input{'cat2'}.dat";
	open(DATA2,">$downloadsdir/$filetomove2") or error("$err{'016'} $filetomove2");
	hold(DATA2);
	print DATA2 "$idnew\|$input{'mlinkname'}\|$input{'mtheurl'}\|$input{'mdesc'}\|$input{'mthedate'}\|$input{'mlinkposter'}\|$input{'mhits'}\|$input{'mvotes'}\|$input{'mscore'}\n";
	print DATA2 @datas2;
#	release(DATA2);
	close(DATA2);

	my $lines = @datas - 1;

	if ($lines == 0) {
		unlink "$downloadsdir/$info{'cat'}.dat";
		unlink "$downloadsdir/$info{'cat'}.cnt";
	} else {
		open(CNT, ">$downloadsdir/$info{'cat'}.cnt");
		hold(CNT);
		print CNT "$lines";
		close(CNT);
	}

	$catscount = @datas2 + 1;

	open(CNT, ">$downloadsdir/$input{'cat2'}.cnt");
	hold(CNT);
	print CNT "$catscount";
	release(CNT);
	close(CNT);

	print "Location: $pageurl/$cgi?action=downloads\n\n";
	exit;

}

###################
sub ratedownloads {
###################

	if ($username eq "$anonuser") { error("noguests"); }

	$filetoopen = "$info{'cat'}.dat";
	@datas = read_database("$downloadsdir/$filetoopen");

	foreach $line(@datas) {
		if ($info{'id'} == (split(/\|/, $line))[0]) {
			($idtemp, $downloadname, $theurl, $desc, $thedate, $downloadposter, $nhits, $votes, $score) = split(/\|/, $line);
			last;
		}
	}

	if ($username eq "$downloadposter") { error("$err{'033'}"); }

	$navbar = "$btn{'014'} $nav{'056'} $btn{'014'} $nav{'059'}";
	print_top();

	print qq~<form action="$pageurl/$cgi?action=ratedownloads2&cat=$info{'cat'}&id=$info{'id'}"
 method="post" onSubmit="oneclick(this)">
<table align="center" width="100%" cellpadding="0" cellspacing="2" "border="0">
<tr>
<td colspan="2" valign="top"><b>$msg{'619'}:</b></td>
</tr>
<tr>
<td valign="top">$msg{'620'}</td>
<td valign="top">$idtemp</td>
</tr>
<tr>
<td valign="top">$msg{'621'}</td>
<td valign="top">$downloadname</td>
</tr>
<tr>
<td valign="top">$msg{'623'}</td>
<td valign="top">$desc</td>
</tr>
<tr>
<td valign="top">$msg{'624'}</td>
<td valign="top">$thedate</td>
</tr>
<tr>
<td valign="top">$msg{'625'}</td>
<td valign="top">$downloadposter</td>
</tr>
<tr>
<td valign="top">$msg{'626'}</td>
<td valign="top">$nhits</td>
</tr>
<tr>
<td valign="top">$msg{'627'}</td>
<td valign="top">$votes</td>
</tr>
<tr>
<td valign="top">$msg{'628'}</td>
<td valign="top">$score</td>
</tr>
<tr>
<td style="white-space: nowrap"><b>$msg{'629'}</b></td>
<td><select name="rateval">
<option value="1">1
<option value="2">2
<option value="3">3
<option value="4">4
<option value="5">5
<option value="6">6
<option value="7">7
<option value="8">8
<option value="9">9
<option value="10">10
</select><td>
</tr>
<tr>
<td align="center" colspan="2"><hr>
<input type="submit" value="$btn{'040'}" class="button"></td>
</tr>
</table>
</form>
~;

	print_bottom();
	exit;

}

####################
sub ratedownloads2 {
####################

	if ($username eq "$anonuser") { error("noguests"); }

	$filetoopen = "$info{'cat'}.dat";
	@datas = read_database("$downloadsdir/$filetoopen");

	$count = @datas;
	$i = 0;

	open(DATA,">$downloadsdir/$filetoopen") or error("$err{'016'} $filetoopen");
	hold(DATA);
	while ($i < $count) {
		($idtemp, $downloadname, $theurl, $desc, $thedate, $downloadposter, $nhits, $votes, $score) = split(/\|/, $datas[$i]);

		if ($idtemp eq $info{'id'}) {
			if ($username eq "$downloadposter") { error("$err{'033'}"); }
			chomp($score);

			$votes++;
			$score = $score + $input{'rateval'};
			print DATA "$idtemp|$downloadname|$theurl|$desc|$thedate|$downloadposter|$nhits|$votes|$score\n";
		} else {
			print DATA "$idtemp|$downloadname|$theurl|$desc|$thedate|$downloadposter|$nhits|$votes|$score";
		}
		$i++;
	}
	release(DATA);
	close(DATA);

	print "Location: $pageurl/$cgi?action=downloadinfo&cat=$info{'cat'}&id=$info{'id'}\n\n";
	exit;

}

########################
sub downloads_search {
########################

	print qq~<table align="center" width="80%" cellpadding="0" cellspacing="0" border="0">
<tr>
<td align="center" class="forumwindow3 titlebar"><b>$nav{'039'} $nav{'056'}</b></td>
</tr>
<tr>
<td align="center"><form method="POST" action="$pageurl/$cgi?action=search">
<input type="hidden" name="action" value="search">
<input type="hidden" name="type" value="advanced">
<input type="text" name="pattern_phrase" size="30" class="textinput">&nbsp;<input type="submit" class="button" value="$btn{'001'}">
<input type="hidden" name="articleson" value="off">
<input type="hidden" name="forumson" value="off">
<input type="hidden" name="linkson" value="off">
<input type="hidden" name="downloadson" value="on">
</form></td>
</tr>
</table>
~;

}

##########################
sub show_latestdownloads {
##########################

	if ($showlatestdownloads eq "") {
		$showlatestdownloads = "1";
	}
	if ($showlatestdownloads eq "1") {
		latestdownloads();

		print qq~<br>
<table align="center" width="100%" cellpadding="2" cellspacing="1"
 border="0" class="tableback" summary="latest downloads">
<tr>
<td align="center" class="forumwindow3 titlebar" colspan="3"><b>$msg{'673'}</b></td>
</tr>
<tr>
<td align="left" class="forumwindow1 columnheader"><b>$msg{'167'}</b></td>
<td align="left" class="forumwindow1 columnheader"><b>$msg{'088'}</b></td>
<td align="left" class="forumwindow1 columnheader"><b>$msg{'110'}</b></td>
</tr>
~;
		if (@_dtlinks) {
			$timenow = time + 3600*$timeoffset;
			$c = 0;
			for ($c = 0; $c < @_dtlinks && $c < 5; $c++) {
				($_dlcat, $_dlid, $_dlname, $_dltime, $_dldate, $_dlcount, $_ddescription) = split(/\|/, $_dtlinks[$c]);
				$_dldiff = ($timenow - $_dltime) / 86400;
				display_date($_dldate); $_dldate = $user_display_date;
				$message = $_ddescription;
				$_dlname = htmltotext($_dlname);
				$message = htmltotext($message);

				if (length($message) > 70) {
					$tmpmessage = substr($message, 0, 70);
					$tmpmessage =~ s/(.*)\s.*/$1/;
					$_ltdoneliner = "$tmpmessage...";
				} else {
					$_ltdoneliner = $message;
				}
				print qq~<tr>
<td align="left" class="tabletext"><a
 href="$scripturl/$cgi?action=downloadinfo&amp;cat=$_dlcat&amp;id=$_dlid"
 class="whomenu">$_dlname</a>~;

				if ($_dlcount eq "0" && $_dldiff < 5) {
					print qq~&nbsp;<img src="$imagesurl/forum/new.gif" border="0" alt="">~;
				}

				print qq~</td>
<td align="left" class="tabletext"> <small>$_ltdoneliner</small></td>
<td align="left" class="tabletext"><small>$_dldate</small></td>
</tr>
~;
			}
		} else {
			print qq~<tr>
<td align="left" colspan="3" class="tabletext">$msg{'677'}</td>
</tr>
~;
		}
		print qq~</table>~;
	}

}

#####################
sub latestdownloads {
#####################
# Jos reworked this sub for 0.9.9.3

	@_dlcats = read_database("$downloadsdir/downloadcats.dat");

	foreach (@_dlcats) {
		@_dlitem = split(/\|/, $_);
		$_dlcat = $_dlitem[1];
		if (-e("$downloadsdir/$_dlcat.dat")) {
			@_dlcontent = read_database("$downloadsdir/$_dlcat.dat");
			$c = 0;
			for ($c = 0; $c < @_dlcontent; $c++) {
				($_dlid, $_dlname, undef, $_ddescription, $_dldate, undef, $_dlcount, undef, undef) = split(/\|/, $_dlcontent[$c]);
				@_dlsort = split(/[\/:]| \- /, $_dldate);
				$_dltime = "$_dlsort[2]$_dlsort[0]$_dlsort[1]$_dlsort[3]$_dlsort[4]$_dlsort[5]";
				push (@_dtlcats, join ("\|", $_dlcat, $_dlid, $_dlname, $_dltime, $_dldate, $_dlcount, $_ddescription));
			}
		}
	}
	$c = 0;
	for (0..$#_dtlcats) {
		@_dtlfields = split(/\|/, $_dtlcats[$_]);
		for $c (0..$#_dtlfields) {
			$_dtldata[$_][$c] = $_dtlfields[$c];
		}
	}
	@_dtldata = sort { $b->[3] <=> $a->[3] } @_dtldata;
	for (@_dtldata) {
		push (@_dtlinks, join ("\|", @$_));
	}

}

if (-e "$user_lib/downloads.pl") {require "$user_lib/downloads.pl"}

1; # return true