###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# emailer.pl                                           	                      #
# v0.9.9.3.4                                                                  #
# Original by Shawn Raloff for WebAPP                                         #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified: 13 Apr 2006 by my2cents                                           #
# Modified: 17 May 2006 by Jos                                                #
###############################################################################
###############################################################################

############
sub sendto {
############

	$guestapproval = "0";
	$approvedemail = "0";

	if ($info{'sendto'} eq "CompanyEmail") { $guestapproval = "1"; $approvedemail = "1"; }
	if ($info{'sendto'} eq "WebmasterEmail") { $guestapproval = "1"; $approvedemail = "2"; }

	if ($username eq "$anonuser" && $guestapproval eq "0") { error("$err{'011'}"); }
	if ($username ne "$anonuser") { $guestapproval = "0"; }
	if ($approvedemail eq "0") { $approvedemail = "$info{'sendto'}"; }

	$navbar = "$btn{'014'} $msg{'394'}";
	print_top();
	
	print qq~<form action="$pageurl/$cgi?action=sendto2" method="post">
<table border="0" width="100%" cellpadding="1" cellspacing="3">
<tr>
<td>~;
	
	if ($guestapproval eq "1") {
		print qq~<b>$msg{'007'}</b><br>~;
		if ($approvedemail eq "1") { print qq~$compname~; }
		if ($approvedemail eq "2") { print qq~$pagename $root~; }
		print qq~<input type="hidden" name="recipemail" value="$approvedemail">~;
	} else {
		print qq~<b>$msg{'007'}</b><br>~;
		if ($approvedemail eq "0") { print qq~$info{'sendto'}~; }
		if ($approvedemail eq "1") { print qq~$compname~; }
		if ($approvedemail eq "2") { print qq~$pagename $root~; }
		print qq~<input type="hidden" name="recipemail" value="$approvedemail">~;
	}
	
	print qq~</td>
</tr>
<tr>
<td>~;

	if ($guestapproval eq "1") {
		print qq~<b>$msg{'182'}</b><br><input type="text" class="textinput" name="senderemail" size="40">~;
	} else {
		print qq~<b>$msg{'182'}</b><br>$username<input
 type="hidden" name="senderemail" value="$username">~;
	}	

	if (!defined $subject) { $subject = ""; }
	if (!defined $message) { $message = ""; }

	print qq~</td>
</tr>
<tr>
<td><b>$msg{'395'}</b><br>
<input type="text" class="textinput" name="subject" value="$subject" size="40"></td>
</tr>
<tr>
<td><b>$msg{'396'}</b><br>
<textarea name="message" cols="40" rows="10">$message</textarea></td>
</tr>
<tr>
<td><input type="submit" class="button" value="$btn{'005'}">&nbsp;&nbsp;<input
 type="reset" class="button" value="$btn{'009'}"></td>
</tr>
</table>
</form>
~;

	print_bottom();
	exit;

}

#############
sub sendto2 {
#############

	if (!defined $guestapproval) { $guestapproval = ""; }

	if ($username eq "$anonuser" && $guestapproval eq "0")  { error("$err{'011'}"); }
	error("$err{'014'}") unless ($input{'subject'});
	error("$err{'015'}") unless ($input{'message'});
	
	if ($guestapproval eq "1") {
		error("$err{'005'}") unless ($input{'senderemail'});
	}

	chomp($input{'subject'});
	chomp($input{'message'});

	$foot = "\n\nThis E-mail was sent via $baseurl";

	$mailsubject = convert_newsletter($input{'subject'});
	$mailmessage = convert_newsletter($input{'message'}).$foot;

	# Getting the Senders E-mail Address
	$emailersender = "";
	$emailerrecip = "";
	
	if ($input{'recipemail'} eq "1") {
		$emailerrecip = $compemail;
	}
	
	if ($input{'recipemail'} eq "2") {
	$emailerrecip = $webmaster_email; }
	
	if ($emailerrecip eq "") {
			
		my @sendingto = chomp_database("$memberdir/$input{'recipemail'}.dat");
		
		$emailerrecip = $sendingto[2];
	}						
		
	if ($input{'senderemail'} eq "$username") {
			 
		my @usermail = chomp_database("$memberdir/$username.dat");
	
		$emailersender = $usermail[2];
	} else {
		$emailersender = $input{'senderemail'};
	}
		
	sendemail($emailerrecip, $mailsubject, $mailmessage, $emailersender);

	$navbar = "$btn{'014'} $msg{'394'}";
	print_top();

	print qq~<br>$msg{'166'}. $msg{'398'}<br>
<br>
<a href="$pageurl/$cgi" class="link">$nav{'002'}</a><br>
<br>
~;

	print_bottom();
	exit;

}

#########################
sub convert_newsletter {
#########################

my $text = shift;

	$text =~ s/<pipe>/\|/g;
	$text =~ s/<br>/\n/g;
	$text =~ s/&lt;/</g;
	$text =~ s/&gt;/>/g;
	$text =~ s/ \&nbsp;/  /g;
	$text =~ s/&amp;/&/g;
	$text =~ s/&quot;/"/g;

return $text;

}

if (-e "$user_lib/emailer.pl") {require "$user_lib/emailer.pl"} 

1;