###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# extras.pl                                                                   #
# v0.9.9.3.4                                                                  #
# latest x number of latest posts, also latest comments                       #
# use shownum=nn in the query string to set how many shown                    #
# Original by Jos Brown (www.bantychick.com) 22 May 2006                      #
# from Mod as in use at WebAPP site and elsewhere, written by Jos Brown       #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified 2006: 29 May, 6 Aug, 13 Aug, 20 Aug 2006 by Jos                    #
###############################################################################
###############################################################################

###############
sub fpcatchup {
###############
# catches up on latest posts back to whatever number you set in the url string
# (&shownumber=nnn)

	if ($username eq $anonuser) { error("noguests"); }

	my $shownum = $info{'shownum'} || 50;

	$navbar = " $btn{'014'} $nav{'166'}"; 
	&print_top;

	print qq~<ol>
~;

	if (! $userrank) { $userrank = "none"; }
	if (! $userstatus) { $userstatus = "none"; } # for multiple status on board

	my (@allthreads, @sortvals) = ();

	my @fcats = chomp_database("$boardsdir/cats.txt");
	foreach my $fcat(@fcats) {
		my @fcatinfo = read_database("$boardsdir/$fcat.cat");
		chomp($fcatinfo[1]);
		if ($fcatinfo[1]) {
			if (($fcatinfo[1] !~ /\b$userrank\b|\b$userstatus\b/i) && ($userrank ne "$root")) { # for multiple status on board
				next;
			}
		}
		my @allmessages = (); # part of test
		foreach my $selboard(@fcatinfo[2 .. $#fcatinfo]) {
			chomp($selboard);

			my @postdata = ();
			my @stickyposts = chomp_database("$boardsdir/$selboard.sticky");

			my $issticky = 1;
			for (0..$#stickyposts) {
				my @fields = split(/\|/, $stickyposts[$_]);
				my $saveddate = $fields[5];
				my ($chkmonth, $chkday, $chkyear, $chkhour, $chkmin, $chksec) = split(/\/| - |\:/, $saveddate);
				$chkyear = (2000+$chkyear);
				my $sortdate = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";
				push (@postdata, join ("\|", @fields, $selboard, $issticky, $sortdate . "\n"));
			}

			$issticky = 0;
			my @posts = chomp_database("$boardsdir/$selboard.txt");
			for (0..$#posts) {
				my @fields = split(/\|/, $posts[$_]);
				my $saveddate = $fields[5];
				my ($chkmonth, $chkday, $chkyear, $chkhour, $chkmin, $chksec) = split(/\/| - |\:/, $saveddate);
				$chkyear = (2000+$chkyear);
				my $sortdate = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";
				push (@postdata, join ("\|", @fields, $selboard, $issticky, $sortdate . "\n"));
			}
			push (@allmessages, @postdata);
		}
		push @allthreads, @allmessages;
	} # now should have all threads off all boards from all categories, with board name and sort date

	for (0..$#allthreads) {
		chomp($allthreads[$_]);
		my @fields = split(/\|/, $allthreads[$_]);
		for my $c (0..$#fields) {
			$sortvals[$_][$c] = $fields[$c];
		}
	}
	@allthreads = sort { $b->[13] <=> $a->[13] } @sortvals;

	my @fposts = ();
	for (@allthreads) {
		pop (@$_); # removes sort date
		push (@fposts, join ("\|", @$_) . "\n");
	}

			$myforumlink = "";
 			for ($f = 0; $f < @fposts && $f < $shownum; $f++) { # variable show number or 100
				my ($fpnum, $fptitle, $fpdate, $fpreplys, $fptposter, $selboard, $sticker) = (split(/\|/, $fposts[$f]))[0,1,5,6,8,11,12];

				my @fptposts;

 				if (-e "$messagedir/$fpnum.txt") {
 					@fptposts = read_database("$messagedir/$fpnum.txt");
 				} else {
 					next;
 				}

 				if (!@fptposts) { next; }

				chomp($sticker);
				if ($sticker) { $displayop = 'displaysticky'; }
				else { $displayop = 'display'; }

				my $fpnummessages = @fptposts;
				my $c = 0;
				my $strt;
				my $fppages = '';
				if ($fpnummessages > $maxmessagedisplay) {
					while (($c*$maxmessagedisplay) < $fpnummessages) {
						my $viewc = $c+1;
						$strt = ($c*$maxmessagedisplay);
						$fppages = qq~$fppages <a
 href="$pageurl/$cgi?action=forum&amp;board=$selboard&amp;op=$displayop&amp;num=$fpnum&amp;start=$strt"
 class="forumlink">$viewc</a> ~;
						$c++;
					}
					$fppages =~ s/\n$//g;
					$fppages = qq~( <img
 src="$imagesurl/forum/multipage.gif" alt=""> $fppages )~;
				} else {
					$strt = 0;
				}

 				$fpmessage = (split(/\|/, $fptposts[$#fptposts]))[7];

 				$fpmessage = htmltotext($fpmessage); # strip tags in highlight
 				$fpmessage = censor_it($fpmessage); # censor mouseovers
 				$fpmessage =~ s/\[[^\]]+\]//g; # trim ubbc tags

 				if (length($fpmessage) > 100) {
 					$fpmessage = substr($fpmessage, 0, 100);
 					$fpmessage =~ s/(.*)\s.*/$1/s; # trim to last whole word
 					$fpmessage .= "...";
 				}

 				$fptitle = censor_it($fptitle);

 				display_date($fpdate); $rjtdate = $user_display_date;

 				print qq~<li style="padding-bottom: 3px"><a
  href="$pageurl/$cgi?action=forum&amp;board=$selboard&amp;op=$displayop&num=$fpnum&amp;start=$strt#$#fptposts"
  class="forumlink" title="$fpmessage">$fptitle</a> - ($rjtdate) $msg{'042'} $fptposter $fppages</li>
~;
			}

	print qq~</ol>
~;

	print_bottom();
	exit;
	
}

####################
sub latestcomments {
####################
# shows latest article comments back to whatever number you set in the url string
# (&shownumber=nnn)

	if ($username eq $anonuser) { error("noguests"); }

	my $shownum = $info{'shownum'} || 25;
	my @catlinks = ();
	my @cats = ();
	my %data = ();

	$navbar = " $btn{'014'} $nav{'167'}";
	print_top();

	open(CATS, "<$topicsdir/cats.dat");
	holdr(CATS);
	while(<CATS>) {
		chomp;
		my $catlink = (split(/\|/, $_))[1];
		push(@catlinks, $catlink);
	}
	close(CATS);

	foreach my $curcat (@catlinks) {
		if (-e "$topicsdir/$curcat.cat") {
			my @articles = chomp_database("$topicsdir/$curcat.cat");

			for ($a = 0; $a < @articles; $a++) {

				my ($id, $subject) = (split(/\|/, $articles[$a]))[0,1];

				my @datas = chomp_database("$topicsdir/articles/$id.txt");
				if (@datas > 1) {
					for ($c=1; $c<@datas; $c++) {
						my @item = split (/\|/, $datas[$c]);
						if (@item) {
							my $postdate = $item[4];
							display_date($item[4]); $item[4] = $user_display_date;

							my $message = $item[5];
							$message = htmltotext($message); # strip tags in highlight
							$message = censor_it($message); # censor mouseovers
							$message =~ s/\[[^\]]+\]//g; # trim ubbc tags
							if (length($message) > 100) {
								$message = substr($message, 0, 100);
								$message =~ s/(.*)\s.*/$1/s; # trim to last whole word
								$message .= "..."; # add ellipsis
							}

							$item[0] = censor_it($item[0]);
							$subject = censor_it($subject);

							my $comment = qq~$subject - <a
 href="$pageurl/$cgi?action=viewnews&amp;id=$id#topcomment"
 title="$message">$item[0]</a><br>$msg{'054'} $item[4] $msg{'042'} ~;
								
							if ($item[1] eq "" ) {
								$comment .= qq~$msg{'183'}~;
							} else {
								$comment .= qq~<a
 href="$pageurl/$cgi?action=viewprofile&amp;username=$item[2]" class="smallnewslink">$item[1]</a>~;
							}

							my ($chkmonth, $chkday, $chkyear, $chkhour, $chkmin, $chksec) = split(/\/| - |\:/, $postdate);
							$chkyear = (2000+$chkyear);

							my $sortedentry = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";
							$data{$sortedentry} = $comment;
						}
					}
				}
			}
		}
	}

	print "<ul>";

	my @num = sort {$b <=> $a} keys %data;
	my $j = 0;
	
	while ($j < $shownum && $j < @num) {
		print "<li style=\"padding-bottom: 5px\">$data{$num[$j]}</li>";
		$j++;
	}

	print "</ul>";

	print_bottom();
	exit;

}

if (-e "$user_lib/extras.pl") {require "$user_lib/extras.pl"} 

1;