###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# forum.pl                                                                    #
# v0.9.9.3.4                                                                  #
# Date Formatting and Timezones by: Floyd for WebAPP v0.9.8                   #
# Access Settings by User Status by: Carter for WebAPP v0.9.9.2               #
# Multiple Status Access by: Jos                                              #
# Moderator/Admin Only Moderators Column by: Jos Brown - www.bantychick.com   #
# Access Setting by Minimum Number of Posts by: Jos                           #
# Category Display of Access Groups by: Jos                                   #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified: 2005 by Jos Brown ("bantychick")                            #
# Modified: 17 May, 19 May, 1 Aug, 11 Aug, 18 Aug 2006 by Jos                 #
###############################################################################
###############################################################################

################
sub boardindex {
################

	my $showmoderators = 1; # set to 1 for yes, 0 for no
	my $spacer = 1; # This will allow for spaces inbetween categories. 0 for no spacer, and 1 to put IN the spacer - Carter

	if (($userrank ne $root) && ($userrank ne $boardmoderator)) { $showmoderators = 0; }

	$navbar = "$btn{'014'} $nav{'003'}";
	print_top();

	# condition around navigation tree - show only if no breadcrumbs in place:
	if (!$breadcrumb) {
		print qq~<div class="forumtext" style="margin:5px"><img src="$imagesurl/forum/open.gif"
 width="16" height="16" border="0" alt="*">&nbsp; $nav{'003'}</div>
~;
	}

	print qq~<table width="100%" border="0" cellspacing="1" cellpadding="2" class="forumtitlebackcolor">
<tr>
<td width="16" class="boardtitle columnheader">&nbsp;</td>
<td nowrap align="left" class="boardtitle columnheader">$msg{'095'}</td>
<td nowrap align="center" class="boardtitle columnheader">$msg{'096'}</td>
<td nowrap align="center" class="boardtitle columnheader">$msg{'097'}</td>
<td nowrap align="center" class="boardtitle columnheader">$msg{'098'}</td>~;

	if ($showmoderators == 1) { # show moderators column to moderators and admins
		print qq~<td align="center" class="boardtitle columnheader">$msg{'099'}</td>
~;
	}

	print qq~</tr>
~;

	if (! $userrank) { $userrank = "none"; }
	if (! $userstatus) { $userstatus = "none"; } # these for multiple status on board

	# Get the Categories
	my @categories = chomp_database("$boardsdir/cats.txt");

	my $colspan = "";
	if ($showmoderators == 0) {		
		$colspan = 5;
		$colspan2 = 4;
	} else {
		$colspan = 6;
		$colspan2 = 5;
	}

	my $toprow = 0; # Starting row for first category

	# Now Get the Boards in Each Category
	foreach $curcat (@categories) {
		$curcat =~ s/[\n\r]//g;

		my @catinfo = chomp_database("$boardsdir/$curcat.cat");

		# category access list
		my $accesslist = '';

		$catinfo[1] =~ s/[\n\r]//g;
		if ($catinfo[1]) {

			# access setting according to number of forum posts:
			my $postlevelaccess = 0;
			if (($catinfo[1] =~ /\b(\d+)\b/) && ($settings[6] > $1)) { $postlevelaccess = 1; }
			if (($catinfo[1] !~ /\b$userrank\b|\b$userstatus\b/i) && ($userrank ne "$root") && (!$postlevelaccess)) {
				next;
			} # for multiple status on board
			else {

				$accesslist = $catinfo[1];
				$accesslist =~ s/\W+/, /g;
				$accesslist =~ s/\w+/ucfirst $&/eg;
				$accesslist =~ s/\b(\d+)\b/$1\+ posts/g;

				$accesslist = qq~<tr>
<td class="text textsmall">&nbsp;</td>
<td colspan="~ . ($colspan-1) . qq~" class="text textsmall">$accesslist &nbsp;</td>
</tr>~ . "\n";
			}

		}

		my $curcatname = "$catinfo[0]";

		# This will put a space in between the Categories, to look like OTHER web forums.
		# Comment out to make plain

		# border hiding style rule, set top row for no space
		if ($spacer eq "1") { # spacer between categories
			if ($toprow) { # no spacer before the first category
				print qq~<tr>
<td colspan="$colspan" class="text spacer">&nbsp;</td>
</tr>
~;
			}
			$toprow = 1;
		}

		print qq~<tr>
<td valign="top" class="boardtitle">&nbsp;</td>
<td colspan="$colspan2" class="boardtitle">$curcatname</td>
</tr>
$accesslist~; # category access list

		foreach $curboard (@catinfo) {
			if ($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
				$curboard =~ s/[\n\r]//g;

				my @boardinfo = chomp_database("$boardsdir/$curboard.dat");

				my $curboardname = "$boardinfo[0]";
				my $descr = "$boardinfo[1]";

				my @messages = chomp_database("$boardsdir/$curboard.txt");

				# abywn: added to include stickies
				my @messagessticky = chomp_database("$boardsdir/$curboard.sticky");
				@messages = (@messages, @messagessticky);
				# abywn: end of added code

				if (@messages > 1) {

					# sort so older posts do not display on board index when moved:
					my @allmessages = ();
					my @data =();

					for (0..$#messages) {
						my @fields = split(/\|/, $messages[$_]);
						my $saveddate = $fields[5];
						my ($chkmonth, $chkday, $chkyear, $chkhour, $chkmin, $chksec) = split(/\/| - |\:/, $saveddate);
						$chkyear = (2000+$chkyear);
						my $sortdate = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";
						unshift (@fields, $sortdate);
						for $i (0..$#fields) {
							$data[$_][$i] = $fields[$i];
						}
					}
					my @sorted = sort { $b->[0] <=> $a->[0] } @data;

					for (@sorted) {
						shift (@$_);
						push (@allmessages, join ("\|", @$_) . "\n");
					}

					@messages = @allmessages;
					# end sort
				}

				my $tm = @messages;
				my $messagecount = 0;
				my $new = "off";
				my $postdate = "";

				if (($tm > 0) && ($messages[0] !~ /^$/)) {
					(undef, undef, undef, undef, undef, $postdate, undef, undef, $poster, undef, undef) = split(/\|/, $messages[0]);

					for ($a = 0; $a < @messages; $a++) {
						(undef, undef, undef, undef, undef, undef, $mreplies, undef, undef, undef, undef) = split(/\|/, $messages[$a]);
						$messagecount++;
						$messagecount = $messagecount+$mreplies;
					}

					my ($tdate) = (split(/ - /, $date))[0];
					my ($tmonth, $tday, $tyear) = split(/\//, $tdate);
					my $todaysdate = ($tyear*365)+($tmonth*30)+$tday;
					my ($pdates) = (split(/ /, $postdate))[0];
					my ($pmonth, $pday, $pyear) = split(/\//, $pdates);
					my $pnumber = ($pyear*365)+($pmonth*30)+$pday; # postdate
					my $difference = $todaysdate - $pnumber;
					my $dlp = readlog("$curboard");
					if ($dlp ne "$postdate" && $difference <= "$max_log_days_old") { # allow new or old icon for guests
						$new = "on";
					}

					display_date($postdate); $postdate = $user_display_date;
					if ($showmoderators == 1) {						
						$postdate =~ s/ at / at<br>/; # narrow the formatting
					}
				} else { # if no messages in the board
					$new = "off";
					$tm = 0;
					$postdate="???";
					$poster = "???";
				}

				print qq~<tr>
<td valign="top" class="forumwindow2"><img
 src="$imagesurl/forum/$new.gif" width="16" height="15" alt="*"></td>
<td valign="top" class="forumwindow2"><a
 href="$pageurl/$cgi?action=forum&amp;board=$curboard"
 class="forumlink">$curboardname</a><br>
$descr</td>
<td valign="top" align="center" class="forumwindow2">$tm</td>
<td valign="top" align="center" class="forumwindow2">$messagecount</td>
<td valign="top" align="center" class="forumwindow2"
 style="white-space: nowrap">$postdate<br>$msg{'042'} $poster</td>
~;

				# to show moderators column:
				if ($showmoderators == 1) {
					$boardinfo[2] =~ s/[\n\r]//g;
					print qq~<td valign="top" align="center" class="forumwindow2">~;

					my $howmany = 0;
					$boardinfo[2] =~ /^\|(.*?)\|$/;
					my $moderators = $boardinfo[2];
					$moderators =~ s/\|(\S?)/,$1/g;
					foreach my $curuser (split(/ /, $moderators)) {
						$howmany++;				

						open(FILE, "$memberdir/$curuser.dat");
						hold(FILE);
						chomp(my @modprop = <FILE>);
						release(FILE);
						close(FILE);

						$thisboardmod = qq~<a href="$pageurl/$cgi?action=viewprofile&amp;username=$curuser">$modprop[1]</a>~;
					
						if ($howmany > 1) { print ", "; }			
		
						print "$thisboardmod";

					}
					print qq~</td>
~;
				}
				# end show moderators column

				print qq~</tr>
~;
			}
		}
	}

	print qq~</table>
~;
# end board index

	getTimezones($timezone);

	print qq~<table width="100%">
<tr>
<td align="left" class="forumtext">$msg{'564'} $hour:$min $displaytimezone</td>
<td align="right" class="forumtext">~;

	if ($username ne "$anonuser") {
		print qq~<a href="$pageurl/$cgi?action=markasread" class="forumnav">$msg{'565'}</a>~;
	}

	print qq~</td>
</tr>
<tr>
<td align="center" colspan="2" class="forumtext"><img src="$imagesurl/forum/on.gif"
 alt="New">&nbsp;$msg{'566'}&nbsp;&nbsp;<img
 src="$imagesurl/forum/off.gif" alt="No new">&nbsp;$msg{'567'}</td>
</tr>
</table>
~;

	print_bottom();
	exit;

}

##################
sub messageindex {
##################

	if ($currentboard =~ /[\$|()[\]{}\^\*.<]/) { error("$msg{'630'}"); }

	my $start = $info{'start'} || 0;

	if (! $userrank) { $userrank = "none"; }
	if (! $userstatus) { $userstatus = "none"; } # these for multiple status on board

	my (@categories, $curcat, @catinfo, $searchcat, $postlevelaccess, $curuser);
	my ($stickydate, $sortdate, $numshown, $second, $nummessages, $c, $new);
	if ($userrank ne "$root") {
		@categories = read_database("$boardsdir/cats.txt");

		foreach $curcat (@categories) {
			$curcat =~ s/[\n\r]//g;

			@catinfo = read_database("$boardsdir/$curcat.cat");

			$catinfo[1] =~ s/[\n\r]//g;

			if ($catinfo[1]) {

				# access setting according to number of forum posts:
				my $postlevelaccess = 0;
				if (($catinfo[1] =~ /\b(\d+)\b/) && ($settings[6] > $1)) { $postlevelaccess = 1; }
					foreach $searchcat (@catinfo) {
					$searchcat =~ s/[\n\r]//g;

					if (($currentboard eq "$searchcat") && ($catinfo[1] !~ /\b$userrank\b|\b$userstatus\b/i) && (!$postlevelaccess)) {
						error("$msg{'630'}");
					}
				}
			}
		}
	}

	my @boardinfo = chomp_database("$boardsdir/$currentboard.dat");

	my $boardname = $boardinfo[0];

	$boardinfo[2] =~ s/[\n\r]//g;

	$navbar = "$btn{'014'} $nav{'003'} $btn{'014'} $boardname";
	print_top();

	print qq~<table width="100%" border="0" cellspacing="1" cellpadding="2">
<tr>
<td valign="top" class="forumtext">~;

	# condition around navigation tree - show only if no breadcrumbs in place:
	if (!$breadcrumb) {
		print qq~<img
 src="$imagesurl/forum/open.gif" width="16" height="16" border="0"
 alt="">&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=forum" class="forumnav">$nav{'003'}</a>
<br>
<img src="$imagesurl/forum/tline.gif" width="12" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="16" height="16" border="0"
 alt="">&nbsp;&nbsp;$boardname~;
	}

	print qq~&nbsp;</td>
<td align="right" valign="bottom">&nbsp;~;

	if (($username ne $anonuser) || ($enable_guestposting == 1)) {
		print qq~<a
 href="$forum&amp;op=post&amp;title=start+new+thread"><img
 src="$imagesurl/$langgfx/new_thread.gif" alt="$msg{'100'}" border="0"></a>~;
	} # new topic button members only unless guest posting allowed

	# carry on from up above:
	$boardinfo[2] =~ s/[\n\r]//g;

	# here's where it gets the list
	my $moderators = $boardinfo[2];

	# split above list on space:
	foreach $curuser(split(/ /, $moderators)) {
		if ($username eq "$curuser") { $thisboardmod = $username; }
		else { $thisboardmod = ""; }
	}

	if ($userrank eq "$root" || $username eq "$thisboardmod") {
		print qq~&nbsp;&nbsp;<a
 href="$forum&amp;op=poststicky&amp;title=start+new+sticky"><img
 src="$imagesurl/$langgfx/sticky.gif" alt="$msg{'461'}" border="0"></a>~; # weston
	}
	print qq~</td>
</tr>
</table>
<table width="100%" class="forumtitlebackcolor" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<table width="100%" border="0" cellspacing="1" cellpadding="2">
<tr>
<td class="boardtitle" width="3%">&nbsp;</td>
<td class="boardtitle" width="3%">&nbsp;</td>
<td class="boardtitle" width="43%"><div><b>$msg{'037'}</b></div></td>
<td class="boardtitle" width="10%"><b>$msg{'101'}</b></td>
<td class="boardtitle" align="center" width="8%"><b>$msg{'102'}</b></td>
<td class="boardtitle" align="center" width="8%"><b>$msg{'157'}</b></td>
<td class="boardtitle" align="center" width="25%"><b>$msg{'103'}</b></td>
</tr>
~;

	my @messages = chomp_database("$boardsdir/$currentboard.sticky");

	if (@messages) {
		for ($a = 0; $a < @messages; $a++) {
			($mnum[$a], $msub[$a], $mname[$a], $musername[$a], $memail[$a], $mdate[$a], $mreplies[$a], $stickyviews[$a], $mlpname[$a], $micon[$a], $mstate[$a]) = split(/\|/, $messages[$a]);
		}

		$stickydate = $mdate[0] || "";

		if (!defined $info{'view'}) { $info{'view'} = ""; } # for undocumented &view=all option

		$numshown = 0;
		$second = "forumwindow3";
		for ($b = $start; $b < @messages; $b++) {
			if ($second eq "forumwindow3") { $second="forumwindow2"; }
			else { $second="forumwindow3"; }
			$numshown++;

			$new = "";
			if ($username ne "$anonuser") {
				$date1 = readlog("$mnum[$b]");
				$date2 = $mdate[$b];
				$new = checkfornew($date1, $date2);
				if ($new) {
					$new = qq~<img src="$imagesurl/forum/new.gif" alt="">~;
				}
			}

			$msub[$b] = censor_it($msub[$b]);

			my $type;

			if (!defined $mstate[$b]) { $mstate[$b] = 0; }

			if ($mstate[$b] == 0) { $type = "stickythread"; $typealt = "$msg{'493'}"; }
			elsif ($mstate[$b] == 1) { $type = "stickylocked"; $typealt = "$msg{'497'}" }
			elsif ($mreplies[$b] >= 50 || $stickyviews[$b] >= 1000) { $type = "stickyveryhotthread"; $typealt = "$msg{'496'}" }
			elsif ($mreplies[$b] >= 25 || $stickyviews[$b] >= 500) { $type = "stickyhotthread"; $typealt = "$msg{'495'}"; }

			my $pages = '';
			$nummessages = $mreplies[$b]+1;
			if ($nummessages > $maxmessagedisplay) {
				$c = 0;
				my ($viewc, $strt);
				while (($c*$maxmessagedisplay) < $nummessages) {
					$viewc = $c+1;
					$strt = ($c*$maxmessagedisplay);
					$pages .= qq~<a href="$forum&amp;op=displaysticky&amp;num=$mnum[$b]&amp;start=$strt">$viewc</a>~;
					$c++;
				}
				$pages = qq~( <img src="$imagesurl/forum/multipage.gif" alt=""> $pages )~;
			}

			symbol_alt($micon[$b]);

			display_date($mdate[$b]); $mdate[$b] = $user_display_date;

			print qq~<tr>
<td class="forumwindow1"><img src="$imagesurl/forum/$type.gif" alt="$typealt"></td>
<td class="forumwindow1"><img src="$imagesurl/forum/$micon[$b].gif" alt="$symbolalt" border="0" align="middle"></td>
<td class="forumwindow1"><a href="$forum&amp;op=displaysticky&amp;num=$mnum[$b]" class="forumlink"><b>$msub[$b]</b></a> $new $pages</td>
<td class="forumwindow1">$mname[$b]</td>
<td align="center" class="forumwindow1">$mreplies[$b]</td>
<td align="center" class="forumwindow1">$stickyviews[$b]</td>
<td align="center" class="forumwindow1" style="white-space: nowrap">$mdate[$b]<br>$msg{'042'} $mlpname[$b]</td>
</tr>
~;
			if ($numshown >= $maxdisplay && $info{'view'} ne 'all') {
				$b = @messages;
			}
		}
	}

	@messages = chomp_database("$boardsdir/$currentboard.txt");

	if (@messages) {
		# sort so older posts do not display on board index when moved
		my @allmessages = ();
		my @data =();

		for (0..$#messages) {
			my @fields = split(/\|/, $messages[$_]);
			my $saveddate = $fields[5];
			my ($chkmonth, $chkday, $chkyear, $chkhour, $chkmin, $chksec) = split(/\/| - |\:/, $saveddate);
			$chkyear = (2000+$chkyear);
			$sortdate = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";
			unshift (@fields, $sortdate);
			for my $i (0..$#fields) {
				$data[$_][$i] = $fields[$i];
			}
		}
		my @sorted = sort { $b->[0] <=> $a->[0] } @data;

		for (@sorted) {
			shift (@$_);
			push (@allmessages, join ("\|", @$_) . "\n");
		}
		@messages = @allmessages;
		# end sort

		for ($a = 0; $a < @messages; $a++) {
			($mnum[$a], $msub[$a], $mname[$a], $musername[$a], $memail[$a], $mdate[$a], $mreplies[$a], $mviews[$a], $mlpname[$a], $micon[$a], $mstate[$a]) = split(/\|/, $messages[$a]);
		}

		my ($chkmonth, $chkday, $chkyear, $chkhour, $chkmin, $chksec) = split(/\/| - |\:/, $mdate[0]);
		$chkyear = (2000+$chkyear);
		$sortdate = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";
	} else { $sortdate = 0; }
	
	my $sortsticky;
	if ($stickydate) {
		my ($chkmonth, $chkday, $chkyear, $chkhour, $chkmin, $chksec) = split(/\/| - |\:/, $stickydate);	
		$chkyear = (2000+$chkyear);
		$sortsticky = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";
	} else { $sortsticky = 0; }
	if ($sortdate > $sortsticky) { # if newest thread is newer than newest sticky
		$writedate = "$mdate[0]";
	} else {
		$writedate = "$stickydate";
	}
	writelog("$currentboard");

	$numshown = 0;
	$second = "forumwindow3";
	for ($b = $start; $b < @messages; $b++) {
		if ($second eq "forumwindow2") { $second="forumwindow3"; }
		else { $second="forumwindow2"; }
		$numshown++;

		$new = "";
		if ($username ne "$anonuser") {
			$date1 = readlog("$mnum[$b]");
			$date2 = $mdate[$b];
			$new = checkfornew($date1, $date2);
			if ($new) {
				$new = qq~<img src="$imagesurl/forum/new.gif" alt="">~;
			}
		}

		$msub[$b] = censor_it($msub[$b]);

		if (!defined $mstate[$b]) { $mstate[$b] = 0; }

		if ($mstate[$b] == 0) { $type = "thread"; $typealt = "$msg{'490'}"; }
		elsif ($mstate[$b] == 1) { $type = "locked"; $typealt = "$msg{'494'}"; }
		elsif ($mreplies[$b] >= 50 || $mviews[$b] >= 1000) { $type = "veryhotthread"; $typealt = "$msg{'492'}"; }
		elsif ($mreplies[$b] >= 25 || $mviews[$b] >= 500) { $type = "hotthread"; $typealt = "$msg{'491'}"; }

		my ($tmonth, $tday, $tyear) = (split(/[\/:]| - /, $date))[0,1,2];
		my $todaysdate = ($tyear*365)+($tmonth*30)+$tday;
		my ($pmonth, $pday, $pyear) = (split(/[\/:]| - /, $mdate[$b]))[0,1,2];
		my $pnumber = ($pyear*365)+($pmonth*30)+$pday;
		my $difference = $todaysdate - $pnumber;

		if ($mdate[$b] eq "") {
			$mdate[$b] = "???";
		}

		if ($username eq "$anonuser") {
			unless ($mdate[$b] ne "???" && $difference <= "$max_log_days_old") { # default 21 days
				$type = "off";
			}
		} else {
			unless ($date1 ne "$mdate[$b]" && $mdate[$b] ne "???" && $difference <= "$max_log_days_old") {
				$type = "off";
			}
		}

		my $pages = '';
		$nummessages = $mreplies[$b]+1;
		if ($nummessages > $maxmessagedisplay) {
			$c = 0;
			my ($viewc, $strt);
			while (($c*$maxmessagedisplay) < $nummessages) {
				$viewc = $c+1;
				$strt = $c*$maxmessagedisplay;
				$pages .= qq~<a href="$forum&amp;op=display&amp;num=$mnum[$b]&amp;start=$strt" class="forumlink">$viewc</a> ~;
				$c++;
			}
			$pages = qq~( <img src="$imagesurl/forum/multipage.gif" alt=""> $pages )~;
		}

		symbol_alt($micon[$b]);

		display_date($mdate[$b]); $mdate[$b] = $user_display_date;

		print qq~<tr>
<td class="$second"><img src="$imagesurl/forum/$type.gif" alt="$typealt"></td>
<td class="$second"><img src="$imagesurl/forum/$micon[$b].gif" alt="$symbolalt" border="0" align="middle"></td>
<td class="$second"><a href="$forum&amp;op=display&amp;num=$mnum[$b]" class="forumlink"><b>$msub[$b]</b></a> $new $pages</td>
<td class="$second">$mname[$b]</td>
<td align="center" class="$second">$mreplies[$b]</td>
<td align="center" class="$second">$mviews[$b]</td>
<td align="center" class="$second" style="white-space: nowrap">$mdate[$b]<br>$msg{'042'} $mlpname[$b]</td>
</tr>
~;
		if ($numshown >= $maxdisplay && $info{'view'} ne 'all') {
			$b = @messages;
		}
	}
	print qq~</table>
</td>
</tr>
</table>
<table border="0" width="100%">
<tr>
<td valign="top" class="forumtext">
<img src="$imagesurl/forum/tline.gif" width="12" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="16" height="16" border="0"
 alt="">&nbsp;&nbsp;$boardname
<br>
<img src="$imagesurl/forum/open.gif" width="16" height="16" border="0"
 alt="">&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=forum" class="forumnav">$nav{'003'}</a></td>
<td align="right" valign="top">&nbsp;~;

	if (($username ne $anonuser) || ($enable_guestposting == 1)) {
		print qq~<a
 href="$forum&amp;op=post&amp;title=start+new+thread"><img
 src="$imagesurl/$langgfx/new_thread.gif" alt="$msg{'100'}" border="0"></a>~;
	} # new topic button members only unless guest posting allowed

	if ($userrank eq "$root" || $username eq "$thisboardmod") {
		print qq~&nbsp;&nbsp;<a
 href="$forum&amp;op=poststicky&amp;title=start+new+sticky"><img
 src="$imagesurl/$langgfx/sticky.gif" alt="$msg{'461'}" border="0"></a>~;
	}

	print qq~</td>
</tr>
<tr>
<td valign="top" class="forumtext"><b>$msg{'039'}</b> ~;

	$nummessages = @messages;
	$c = 0;
	while (($c*$maxdisplay) < $nummessages) {
		my $viewc = $c+1;
		my $strt = ($c*$maxdisplay);
		if ($start == $strt) { print "[$viewc] "; }
		else { print qq~<a href="$forum&amp;start=$strt" class="forumnav">$viewc</a> ~; }
		++$c;
	}

	jumpto();

	print qq~</td>
~;

	print qq~<td align="right" valign="top" class="forumtext"><form
 action="$pageurl/$cgi" method="get">$msg{'104'} <input
 type="hidden" name="action" value="forum">
<select name="board">
$selecthtml
</select>
<input type="submit" class="button" value="$btn{'014'}">
</form></td>
</tr>
~;

# check for archives
	my $archivelink = "";
	if (-e "$boardsdir/archive/$currentboard.dat") {
		$archivelink = qq~<a
 href="$pageurl/$cgi?action=viewarchive&board=$currentboard"
 class="forumnav">$nav{'165'}</a>~;
	}

	if (($username ne "$anonuser") || ($archivelink)) {
		print qq~<tr>
<td align="left" class="forumtext">~;

		if ($username ne "$anonuser") {
			print qq~<a
 href="$pageurl/$cgi?action=markpostsread&board=$currentboard"
 class="forumnav">$msg{'686'}</a>~; # weston
		}

		print qq~&nbsp;</td>
<td align="right" class="forumtext">$archivelink &nbsp;</td></tr>
~;
	}

	print qq~</table>
~;

	print_bottom();
	exit;

}

if (-e "$user_lib/forum.pl") {require "$user_lib/forum.pl"}

1; # return true