###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# forum_display.pl    	                                                      #
# v0.9.9.3.4                                                                  #
# Printer Friendly Page Security Update by: Abywn (abywn.net)                 #
# Forum Overload Fix by: Anton                                                #
# Find Board When Moved function, Anchor Links,                               #
# and Status Display by: Jos Brown (www.bantychick.com)                       #
# Display Update by: my2cents (classicchat.net)                               #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #	
# File: Modified: 2005 for WebAPP v0.9.9.3 by Jos Brown ("bantychick")        #
# Modified: 17 May, 19 May, 20 May 2006 by Jos                                #
# Modified: 28 June 2006 by my2cents                                          #
# Modified: 5 Aug 2006 by sburg                                               #
# Modified: 8 Aug 2006 by Jos - sebb's user display date fix                  #
###############################################################################
###############################################################################

###################
sub displaysticky {
###################

	$viewnum = $info{'num'};
	if ($viewnum !~ /^[0-9]+$/) { error("$err{'006'}" ); }

	if (! $userrank) { $userrank = "none"; }
	if (! $userstatus) { $userstatus = "none"; } # for multiple status on board

	if ($userrank ne "$root") {
		@categories = read_database("$boardsdir/cats.txt");
		
		foreach $curcat (@categories) {
			$curcat =~ s/[\n\r]//g;

			@catinfo = read_database("$boardsdir/$curcat.cat");
   			
			$catinfo[1] =~ s/[\n\r]//g;

			if ($catinfo[1]) {

# access setting according to number of forum posts - Jos:
				my $postlevelaccess = 0;
				if (($catinfo[1] =~ /\b(\d+)\b/) && ($settings[6] > $1)) { $postlevelaccess = 1; }

				foreach $searchcat (@catinfo) {
					$searchcat =~ s/[\n\r]//g;

					if (($currentboard eq "$searchcat") && ($catinfo[1] !~ /\b$userrank\b|\b$userstatus\b/i) && (!$postlevelaccess)) {
						print_top();  print "What are you doing Stan?"; print_bottom(); exit;
					}
				}
			}
		}
	}

	open(FILE, "$memberdir/membergroups.dat");
	hold(FILE);
	chomp(@membergroups = <FILE>);
	release(FILE);
	close(FILE);

	@messages = chomp_database("$messagedir/$viewnum.txt"); 

	($msub, $mname, $memail, $mdate, $musername, $micon, $mip, $mmessage) = split(/\|/, $messages[@messages-1]);
	$writedate = "$date";
	writelog("$viewnum");

   if ($currentboard =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }
	if ($info{'num'} =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

	@boardinfo = chomp_database("$boardsdir/$currentboard.dat"); 
	
	$boardname = "$boardinfo[0]";

	if ($currentboard =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }
	if ($info{'num'} =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

 	logread(); # refresh bug fix by carter
 	$i = 0;

# begin anton's forum overload bug fix
	my @tthreads = &read_database("$boardsdir/$currentboard.sticky");

	if ($currentboard =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "$msg{'630'}"; print_bottom(); exit; }
	if ($info{'num'} =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "$msg{'630'}"; print_bottom(); exit; }

	for ($i = 0; $i < @tthreads; $i++) {
		($mnum, $msub, $mname, $musername, $memail, $mdate, $mreplies, $mviews, $mlpname, $micon, $mstate) = split(/\|/, $tthreads[$i]);
		if ($viewnum eq $mnum) {
			$mviews++;
			$tthreads[$i] = "$mnum|$msub|$mname|$musername|$memail|$mdate|$mreplies|$mviews|$mlpname|$micon|$mstate";
			last;
		}
	}

	open(FILE, ">$boardsdir/$currentboard.sticky") || &error("$err{'016'} $boardsdir/$currentboard.sticky");
	hold(FILE);
	print FILE @tthreads;
	release(FILE);
	close(FILE);

	@tthreads = ();
# end anton's forum overload bug fix

	if ($currentboard =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }
	if ($info{'num'} =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

	@threads = chomp_database("$boardsdir/$currentboard.sticky"); 
	
	$found_thread = "";

	for ($x = 0; $x < @threads; $x++) {
		($mnum, $msub, $mname, $musername, $memail, $mdate, $mreplies, $stickyviews, $mlpname, $micon, $mstate) = split(/\|/, $threads[$x]);
		if ($viewnum eq $mnum) {
			if ($mstate == 0) { $type = "stickythread"; $typealt = "$msg{'493'}"; }
			if ($mreplies >= 50 || $stickyviews >= 200) { $type = "stickyhotthread"; $typealt = "$msg{'495'}"; }
			if ($mreplies >= 100 || $stickyviews >= 300) { $type = "stickyveryhotthread"; $typealt = "$msg{'496'}"; }
			if ($mstate == 1) { $type = "stickylocked"; $typealt = "$msg{'497'}"; }
			$found_thread = "1";
			last;
		}
	}

	if ($found_thread ne "1") { error("$err{'042'}"); } 

	($msub[0], $mname[0], $memail[0], $mdate[0], $musername[0], $micon[0], $mip[0], $mmessage[0]) = split(/\|/, $messages[0]);
	$title = "$msub[0]";

	$msub[0] = censor_it($msub[0]);

	if ($enable_notification && $username ne $anonuser) {
		$notification = qq~&nbsp;<a href="$forum&amp;op=notify&amp;thread=$viewnum"><img
 src="$imagesurl/$langgfx/notify.gif" alt="$msg{'105'}" border="0"></a> ~;
	}

	jumpto();

	if ($info{'start'} ne "") { $start = "$info{'start'}"; }
	else { $start = 0; }

	if (!defined $msub[0]) { $msub[0] = ""; }

	$navbar = "$btn{'014'} $nav{'003'} $btn{'014'} $boardname";
	print_top();

# Start pages at top - SimonJ and Jos:
	my $pages = qq~<span class="forumtext"><b>$msg{'039'}</b> </span>~;
	$nummessages = @messages;
	$c = 0;
	while (($c*$maxmessagedisplay) < $nummessages) {
		$viewc = $c+1;
		$strt = ($c*$maxmessagedisplay);

		if ($start == $strt) { $pages .= "[$viewc] "; }
		else { $pages .= qq~<a
 href="$forum&amp;op=displaysticky&amp;num=$viewnum&amp;start=$strt">$viewc</a> ~;
		}

		$c++;
	}
# End pages at top ($pages used below twice)

	print qq~<table width="100%" border="0" cellspacing="1" cellpadding="2">
<tr>
<td valign="top" class="forumtext">$pages<br clear="all">~;

# condition around navigation tree - show only if no breadcrumbs in place:
	if (!$breadcrumb) { 
		print qq~<img
 src="$imagesurl/forum/open.gif" width="17" height="15" border="0"
 alt="">&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=forum" class="forumnav">$nav{'003'}</a>
<br>
<img src="$imagesurl/forum/tline.gif" width="12" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="17" height="15" border="0" alt="">&nbsp;&nbsp;<a
 href="$forum" class="forumnav">$boardname</a>
<br>
<img src="$imagesurl/forum/tline2.gif" width="24" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="17" height="15" border="0"
 alt="">&nbsp;&nbsp;$msub[0]~;
	}

	print qq~</td>
<td align="right" valign="bottom"><a
 href="$forum&amp;op=printpage&amp;num=$viewnum" target="_blank"><img
 src="$imagesurl/forum/print.gif" alt="$msg{'106'}" border=0></a><br>
<a href="$forum&amp;op=poststicky&amp;num=$viewnum&amp;title=post+reply&amp;start=$start" class="forumnav"><img
 src="$imagesurl/$langgfx/reply.gif" alt="$msg{'107'}" border="0"></a>$notification</td>
</tr>
</table>
<table width="100%" class="forumtitlebackcolor" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<table width="100%" border="0" cellspacing="1" cellpadding="2">
<tr>
<td class="forumwindow3"><img src="$imagesurl/forum/$type.gif"
 alt="$typealt">&nbsp; <b>$msg{'049'}</b></td>
<td class="forumwindow3"><b>$msg{'064'} $msub[0]</b></td>
</tr>
~;

	$second = "forumwindow3";
	for ($a = $start; $a < @messages; $a++) {

		if ($second eq "forumwindow2") { $second="forumwindow3"; }
		else { $second="forumwindow2"; }
		$numshown++;
		($msub[$a], $mname[$a], $memail[$a], $mdate[$a], $musername[$a], $micon[$a], $mip[$a], $mmessage[$a]) = split(/\|/, $messages[$a]);
		$subject = "$msub[$a]";
		if ($subject eq "") { $subject="---"; }
		$mmessage[$a] =~ s/\n//g;
		$message = "$mmessage[$a]";
		$name = "$mname[$a]";
		$messagedate = "$mdate[$a]";
		display_date($messagedate); $messagedate = $user_display_date;

		if ($userrank eq "$root") { $ip = qq~<a href="$pageurl/$cgi?action=findip&amp;ip=$mip[$a]">$mip[$a]</a>~;  }
		else { $ip = "$msg{'108'}"; }

		$removed = 0;
		if (!(-e("$memberdir/$musername[$a].dat"))) { $removed = 1; }
		$postinfo = "";
		$signature = "";
		$viewd = "";
		$icq = "";
		$sendm = "";
		$memberpic = "";
		$statusdisplay = '';
		if ($musername[$a] ne "$anonuser" && $removed == 0) {
			if ($username ne "$anonuser") {
				$sendm = qq~&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=imsend&amp;to=$musername[$a]"><img
 src="$imagesurl/forum/message.gif" alt="$msg{'109'} $mname[$a]" border="0"></a>~;
			}

			open(FILE, "$memberdir/$musername[$a].dat");
			hold(FILE);
			chomp(@memset = <FILE>);
			release(FILE);
			close(FILE);

			if ($memset[4] eq "") { $memset[4] = "$pageurl/$cgi"; }
			if ($memset[4] eq "http://") { $memset[4] = "$pageurl/$cgi"; }

			$ranking = $memset[6]+$memset[11]+$memset[12];

			if($memset[10] ne "forever") { 
				$joindate = user_date($memset[10]);
				$joindate = (split(/ - /, $joindate))[0];
			} else {
				$joindate = 'forever';
			}

			$postinfo = qq~$msg{'688'} $joindate<br>
$msg{'021'} $memset[6]<br>
~;

			if ($username ne "$anonuser") {
				$viewd = qq~&nbsp;&nbsp;<a href="$pageurl/$cgi?action=viewprofile&amp;username=$musername[$a]"><img src="$imagesurl/forum/profile.gif" alt="$msg{'051'} $mname[$a]" border="0"></a>~;
			}
			$memberinfo = "$membergroups[2]";
			if ($ranking > 25) {
				$memberinfo = "$membergroups[3]";
			}
			if ($ranking > 100) {
				$memberinfo = "$membergroups[4]";
			}
			if ($ranking > 250) {
				$memberinfo = "$membergroups[5]";
			}
			if ($ranking > 500) {
				$memberinfo = "$membergroups[6]";
			}
			if ($ranking > 1000) {
				$memberinfo = "$membergroups[7]";
			}
			if ($ranking > 1500) {
				$memberinfo = "$membergroups[8]";
			}

			if ($boardmoderator eq "$musername[$a]") { $memberinfo = "$membergroups[1]"; }
			if ($memset[7] ne "") { $memberinfo = "$memset[7]"; }
			if ($memberinfo eq "$root") { $memberinfo = "$membergroups[0]"; }

			$signature = "$memset[5]";
			$signature =~ s/\&\&/<br>/g;
			if ($signature ne "") {
				$signature = qq~<table width="100%" border="0" align="bottom"><tr valign="bottom"><td valign="bottom"><br><br><br><br><hr noshade="noshade" size="1">$signature</td></tr></table>~; # Carter
			}

			if (!($memset[8] =~ /\D/) && $memset[8] ne "") {
				$icq = qq~&nbsp;&nbsp;<a
 href="http://www.icq.com/$memset[8]" target="_blank"><img
 src="http://wwp.icq.com/scripts/online.dll?icq=$memset[8]&amp;img=5"
 alt="$msg{'052'} $memset[8]" border="0"></a>~;
			}
		} else {
			$memberinfo = "$anonuser";
		}

		$message = "$message\n$signature";
		$memberpic ="";

		if ($musername[$a] ne "$anonuser"  && $removed == 0) {
			if ($memset[9] =~ /^http:\/\// ) {
				if ($memberpic_width ne 0) { $tmp_width = qq~width="$memberpic_width"~; }
				else { $tmp_width = ""; }
				if ($memberpic_height ne 0) { $tmp_height = qq~height="$memberpic_height"~; }
				else { $tmp_height = ""; }
				$memberpic = qq~<img src="$memset[9]" $tmp_width $tmp_height border="0" alt="$info{'username'}"></a>~;
			} else {
				if ($memset[9] eq "") { $memset[9] = "_nopic.gif"; }
				$memberpic = qq~<img src="$imagesurl/avatars/$memset[9]" border="0" alt=""></a>~;
			}
		}

		if ($enable_ubbc) { doubbc(); }
		if ($enable_smile) { dosmilies(); }

		$url = "";
		if ($memset[3] ne "" && $musername[$a] ne "$anonuser") {
			$url = qq~<a href="$memset[4]" target="_blank"><img
 src="$imagesurl/forum/www.gif" alt="$msg{'053'} $mname[$a]" border="0"></a>&nbsp;&nbsp;~;
		}

		$message = censor_it($message);
		$subject = censor_it($subject);

		if ($userrank ne "$root") { $ip = "$msg{'108'}"; }

		symbol_alt($micon[$a]);

		$sname = showhtml($name);
		$spostinfo = showhtml($postinfo);

		print qq~<tr>
<td class="$second" width="140" valign="top">
<a name="$a"></a>
<b>$sname</b><br>
$memberpic<br>
$memberinfo<br>
$spostinfo<br>
</td>
<td class="$second" valign="top">
<table border="0" cellspacing="0" cellpadding="0" width="100%">
<tr>
<td><img src="$imagesurl/forum/$micon[$a].gif" alt="$symbolalt"></td>
<td width="100%">&nbsp;<b>$subject</b><br>&nbsp;<b>$msg{'110'}</b> $messagedate</td>
</tr>
</table>
<hr noshade="noshade" size="1">
$message<br>
</td>
</tr>
<tr class="$second">
<td><img src="$imagesurl/forum/ip.gif" alt="$msg{'111'}" align="top"> $ip</td>
<td>
<table border="0" cellspacing="0" cellpadding="0" width="100%" maxwidth="80">
<tr>
<td>$url~;

		if ($hidemail eq "1" && $musername[$a] ne "$anonuser") {
			print qq~<a href="$pageurl/$cgi?action=anonemail&amp;sendto=$musername[$a]" class="forumnav">~;
		} else {
			print qq~<a href="mailto:$memail[$a]">~; } print qq~<img src="$imagesurl/forum/email.gif" alt="$msg{'055'} $mname[$a]" border="0"></a>$viewd$sendm$icq</td>
<td align="right"><a
 href="$forum&amp;op=poststicky&amp;num=$viewnum&amp;quote=$a&amp;title=post+reply&amp;start=$start"><img
 src="$imagesurl/forum/quote.gif" alt="$msg{'056'}" border="0"></a>~;
 			if ($username ne $anonuser) {
 				print qq~&nbsp;&nbsp;<a
 href="$forum&amp;op=modifysticky&amp;message=$a&amp;thread=$viewnum"><img
 src="$imagesurl/forum/modify.gif" alt="$msg{'112'}" border="0"></a>&nbsp;&nbsp;<a
 href="$forum&amp;op=modifysticky2&amp;thread=$viewnum&amp;id=$a&amp;d=1"><img
 src="$imagesurl/forum/delete.gif" alt="$msg{'058'}" border="0"></a>~;
 			}

 		print qq~</td>
</tr>
</table></td>
</tr>
~;

		if ($numshown >= $maxmessagedisplay) { $a = @messages; }

	}

	print qq~</table>
</td>
</tr>
</table>
<table border="0" width="100%" cellspacing="1" cellpadding="2">
<tr>
<td valign="bottom" class="forumtext"><img
 src="$imagesurl/forum/tline2.gif" width="24" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="17" height="15" border="0" alt="">&nbsp;&nbsp;$msub[0]
<br>
<img src="$imagesurl/forum/tline.gif" width="12" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="17" height="15" border="0" alt="">&nbsp;&nbsp;<a
 href="$forum" class="forumnav">$boardname</a>
<br>
<img src="$imagesurl/forum/open.gif" width="17" height="15" border="0" alt="">&nbsp;&nbsp;
<a href="$pageurl/$cgi?action=forum" class="forumnav">$nav{'003'}</a></td>
<td align="left" valign="top">~;

	if ($currentboard =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }
	if ($info{'num'} =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

	open(FILE, "$boardsdir/$currentboard.dat");
	hold(FILE);
	chomp(@boardinfo = <FILE>);
	release(FILE);
	close(FILE);
	
	$boardinfo[2] =~ s/[\n\r]//g;
	$boardinfo[2] =~ /^\|(.*?)\|$/;
	$moderators = $boardinfo[2];
	$moderators =~ s/\|(\S?)/,$1/g;

	my $thisboardmod = "";
	foreach $curuser (split(/ /, $moderators)) {
		if ($username eq "$curuser") { $thisboardmod = $username; }
	}

	if ($username eq "$thisboardmod" || $userrank eq "$root") {
		$adminfunction = qq~<a href="$forum&amp;op=movestickythread&amp;thread=$viewnum"><img
 src="$imagesurl/forum/move.gif" alt="$msg{'113'}" border="0"></a>&nbsp;<a
 href="$forum&amp;op=unmakesticky&amp;thread=$viewnum"><img
 src="$imagesurl/forum/thread.gif" alt="$msg{'691'}" border="0"></a>&nbsp;<a
 href="$forum&amp;op=removestickythread&amp;thread=$viewnum"><img
 src="$imagesurl/forum/remove.gif" alt="$msg{'114'}" border="0"></a>&nbsp;<a
 href="$forum&amp;op=lockstickythread&amp;thread=$viewnum"><img
 src="$imagesurl/forum/lock.gif" alt="$msg{'115'}" border="0"></a>~;
	}

	print qq~$adminfunction</td>
<td align="right" valign="top"><a href="$forum&amp;op=poststicky&amp;num=$viewnum&amp;title=post+reply&amp;start=$start"><img
 src="$imagesurl/$langgfx/reply.gif" alt="$msg{'107'}" border="0"></a>$notification</td>
</tr>
<tr>
<td valign="top" class="forumtext">~; 



	print qq~$pages</td>
<td colspan="2" align="right" valign="top" class="forumtext"><form
 action="$pageurl/$cgi" method="get">$msg{'104'} <select
 name="board">$selecthtml</select> <input
 type="submit" class="button" value="$btn{'014'}"><input
 type="hidden" name="action" value="forum"></form></td>
</tr>
</table>
~;

	print_bottom();
	exit;

}

#############
sub display {
#############

	if ((!defined $info{'start'}) || ($info{'start'} eq "")) { $info{'start'} = 0; } 
	if (($currentboard =~ /[\$\|\(\)\[\]\{\}\^\*\.<]+/)
	|| ($info{'num'} !~ /^[0-9]+$/)
	|| ($info{'start'} !~ /^\d*#?\d*$/)) { &data_error; }

 	logread(); # refresh bug fix by Carter

	if (! $userrank) { $userrank = "none"; }
	if (! $userstatus) { $userstatus = "none"; } # for multiple status on board

	my $viewnum = $info{'num'};

	my @categories; # Jan 13 2006

# check for access for non-admins:
	if ($userrank ne "$root") {
		@categories = read_database("$boardsdir/cats.txt");
  		
		foreach $curcat (@categories) {
			$curcat =~ s/[\n\r]//g;

			@catinfo = read_database("$boardsdir/$curcat.cat");
			
			$catinfo[1] =~ s/[\n\r]//g;

			if ($catinfo[1]) {

# access setting according to number of forum posts - Jos:
				my $postlevelaccess = 0;
				if (($catinfo[1] =~ /\b(\d+)\b/) && ($settings[6] > $1)) { $postlevelaccess = 1; }
				foreach $searchcat(@catinfo) {
					$searchcat =~ s/[\n\r]//g;
					if (($currentboard eq "$searchcat") && ($catinfo[1] !~ /\b$userrank\b|\b$userstatus\b/i) && (!$postlevelaccess)) {
						print_top();  print "$msg{'630'}"; print_bottom(); exit; # prints Stan message
					}
				}
			}
		}
	}

# begin anton's forum overload bug fix
	my @tthreads = &read_database("$boardsdir/$currentboard.txt");

	my $found_thread = 0; #abywn - masked board fix

	for ($i = 0; $i < @tthreads; $i++) {
		($mnum, $msub, $mname, $musername, $memail, $mdate, $mreplies, $mviews, $mlpname, $micon, $mstate) = split(/\|/, $tthreads[$i]);
		if ($viewnum eq $mnum) {
			$mviews++;
			$tthreads[$i] = "$mnum|$msub|$mname|$musername|$memail|$mdate|$mreplies|$mviews|$mlpname|$micon|$mstate";
			if ($mstate == 0) { $type = "thread"; $typealt = "$msg{'490'}"; }
			if ($mreplies >= 50 || $mviews >= 200) { $type = "hotthread"; $typealt = "$msg{'491'}"; } # Carter
			if ($mreplies >= 100 || $mviews >= 300) { $type = "veryhotthread"; $typealt = "$msg{'492'}"; } # Carter
			if ($mstate == 1) { $type = "locked"; $typealt = "$msg{'494'}"; }
			$found_thread = "1"; #abywn - masked board fix
			last;
		}
	}

# print the number of reads on the thread:
	if ($found_thread) {
		open(FILE, ">$boardsdir/$currentboard.txt") || &error("$err{'016'} $boardsdir/$currentboard.txt");
		hold(FILE);
		print FILE @tthreads;
		close(FILE);
	} else {
### FIND BOARD WHEN THREAD HAS BEEN MOVED ###

		@categories = read_database("$boardsdir/cats.txt");
		
		for ($c=0; $c<@categories; $c++) {
			$curcat = $categories[$c];
			$curcat =~ s/[\n\r]//g;

			@catinfo = read_database("$boardsdir/$curcat.cat");
			
			for ($i=2; $i<@catinfo; $i++) {
				$thisboard = $catinfo[$i];
				$thisboard =~ s/[\n\r]//g;

				@curboardinfo = chomp_database("$boardsdir/$thisboard.txt");
			
				foreach $postline (@curboardinfo) {
					($mnum) = (split(/\|/, $postline))[0];
					if ($viewnum eq $mnum) {
						$currentboard = $thisboard;
						$i = @catinfo;
						$c = @categories;
						last;
					}
				}
			}

			$catinfo[1] =~ s/[\n\r]//g;
			foreach $searchcat (@catinfo) {
				$searchcat =~ s/[\n\r]//g;
				if ($currentboard eq "$searchcat") {
					if ($catinfo[1] ne "") {
						if (($userrank ne $root) && ($catinfo[1] !~ /\b$userrank\b|\b$userstatus\b/i)) { # multiple status on board
							error("$err{'042'}");
						}
					}
					$forum = qq~$pageurl/$cgi?action=forum&amp;board=$currentboard~;
					$type = "move";
					$typealt = qq~&gt;~;
					last;
				}
			}
		}
	}
### END FIND BOARD WHEN MOVED ###

	@tthreads = ();

	open(FILE, "$memberdir/membergroups.dat");
	hold(FILE);
	chomp(@membergroups = <FILE>);
	close(FILE);

# admin remove missing threads - Jos:
	if ($userrank eq $root) {
		unless (-e "$messagedir/$viewnum.txt") {
			error("No $viewnum.txt. Would you like to <a href=\"$pageurl/$cgi?action=forum&amp;board=$currentboard&amp;op=removethread&amp;thread=$viewnum\">delete this thread?</a>")
		}
	}

	@messages = chomp_database("$messagedir/$viewnum.txt"); 
	
	if ($info{'start'} > @messages) { &data_error; } # by Jos - fix for Shaka_Flex's trick

	($msub, $mname, $memail, $mdate, $musername, $micon, $mip, $mmessage) = split(/\|/, $messages[@messages-1]);
	($msub[0], $mname[0], $memail[0], $mdate[0], $musername[0], $micon[0], $mip[0], $mmessage[0]) = split(/\|/, $messages[0]);
	$msub[0] = censor_it($msub[0]);

	$writedate = "$date";
	writelog("$viewnum");

	@boardinfo = chomp_database("$boardsdir/$currentboard.dat"); 
	
	$boardname = "$boardinfo[0]";

	$boardinfo[2] =~ s/[\n\r]//g;
	$boardinfo[2] =~ /^\|(.*?)\|$/;
	$moderators = $boardinfo[2];
	$moderators =~ s/\|(\S?)/,$1/g;

	my $thisboardmod = "";
	foreach $curuser (split(/ /, $moderators)) {
		if ($username eq "$curuser") { $thisboardmod = $username; }
	}

	if ($enable_notification && $username ne $anonuser) {
		$notification = qq~&nbsp;<a href="$forum&amp;op=notify&amp;thread=$viewnum"><img
 src="$imagesurl/$langgfx/notify.gif" alt="$msg{'105'}" border="0"></a> ~;
	} else {
		$notification = "";
	}

	jumpto();

	if ($info{'start'} ne "") { $start = "$info{'start'}"; }
	else { $start = 0; }

	if (!defined $msub[0]) { $msub[0] = ""; } 

	$navbar = "$btn{'014'} $nav{'003'} $btn{'014'} $boardname";
	print_top();

# Start pages at top - SimonJ and Jos
	my $pages = qq~<span class="forumtext"><b>$msg{'039'}</b> </span>~;
	$nummessages = @messages;
	$c = 0;
	while (($c*$maxmessagedisplay) < $nummessages) {
		$viewc = $c+1;
		$strt = ($c*$maxmessagedisplay);

		if ($start == $strt) { $pages .= "[$viewc] "; }
		else { $pages .= qq~<a
 href="$forum&amp;op=display&amp;num=$viewnum&amp;start=$strt">$viewc</a> ~;
		}

		$c++;
	}
# End pages at top ($pages used below twice)

	print qq~<table width="100%" border="0" cellspacing="1" cellpadding="2">
<tr>
<td valign="top" class="forumtext">$pages<br clear="all">~;

# condition around navigation tree - show only if no breadcrumbs in place:

	if (!$breadcrumb) { 
		print qq~<img
 src="$imagesurl/forum/open.gif" width="16" height="16" border="0"
 alt="">&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=forum">$nav{'003'}</a>
<br>
<img src="$imagesurl/forum/tline.gif" width="12" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="17" height="15" border="0" alt="">&nbsp;&nbsp;<a
 href="$forum" class="forumnav">$boardname</a>
<br>
<img src="$imagesurl/forum/tline2.gif" width="24" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="17" height="15" border="0"
 alt="">&nbsp;&nbsp;$msub[0]~;
	}

	print qq~</td>
<td align="right" valign="bottom"><a
 href="$forum&amp;op=printpage&amp;num=$viewnum" target="_blank"><img
 src="$imagesurl/forum/print.gif" vspace="5" alt="$msg{'106'}" border="0"></a><br>~;

	if (($username ne $anonuser) || ($enable_guestposting == 1)) {
		print qq~<a href="$forum&amp;op=post&amp;num=$viewnum&amp;title=post+reply&amp;start=$start"><img
 src="$imagesurl/$langgfx/reply.gif" alt="$msg{'107'}" border="0"></a>$notification~;
	} # reply button members only unless guest posting allowed - Jos

	print qq~</td>
</tr>
</table>
<table width="100%" class="forumtitlebackcolor" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<table width="100%" border="0" cellspacing="1" cellpadding="2">
<tr>
<td class="boardtitle"><img src="$imagesurl/forum/$type.gif"
 alt="$typealt">&nbsp; <b>$msg{'049'}</b></td>
<td class="boardtitle"><b>$msg{'064'} $msub[0]</b></td>
</tr>
~;

	$second = "forumwindow3";
	for ($a = $start; $a < @messages; $a++) {

		if ($second eq "forumwindow2") { $second="forumwindow3"; }
		else { $second="forumwindow2"; }
		$numshown++;
		($msub[$a], $mname[$a], $memail[$a], $mdate[$a], $musername[$a], $micon[$a], $mip[$a], $mmessage[$a]) = split(/\|/, $messages[$a]);

		$subject = "$msub[$a]";
		if ($subject eq "") { $subject="---"; }
		$mmessage[$a] =~ s/\n//g;
		$message = "$mmessage[$a]";
		$name = "$mname[$a]";
		$messagedate = "$mdate[$a]";
		display_date($messagedate); $messagedate = $user_display_date;

		if ($userrank eq "$root") { $ip = qq~<a href="$pageurl/$cgi?action=findip&amp;ip=$mip[$a]">$mip[$a]</a>~; } # Carter
		else { $ip = "$msg{'108'}"; }

		$removed = 0;
		if (!(-e("$memberdir/$musername[$a].dat"))) { $removed = 1; }
		$postinfo = "";
		$signature = "";
		$viewd = "";
		$icq = "";
		$sendm = "";
		$memberpic = "";
		$statusdisplay = '';
		if ($musername[$a] ne "$anonuser" && $removed == 0) {
			if ($username ne "$anonuser") {
				$sendm = qq~&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=imsend&amp;to=$musername[$a]"><img
 src="$imagesurl/forum/message.gif" alt="$msg{'109'} $mname[$a]" border="0"></a>~;
 			}

			open(FILE, "$memberdir/$musername[$a].dat");
			hold(FILE);
			chomp(@memset = <FILE>);
			release(FILE);
			close(FILE);
			
			# add memset presets
			if (!defined $memset[7]) { $memset[7] = ""; }
			if (!defined $memset[8]) { $memset[8] = ""; }

			$ranking = $memset[6]+$memset[11]+$memset[12];

			if ($memset[14]) {
				$statusdisplay = "<br>" . ucfirst($memset[14]);
			} else {
				$statusdisplay = '';	
			}
			if($memset[10] ne 'forever') { 
				$joindate = user_date($memset[10]);
				$joindate = (split(/ - /, $joindate))[0];
			} else {
				$joindate = 'forever';
			}

			$postinfo = qq~$msg{'688'}&nbsp;$joindate<br>
$msg{'021'}&nbsp;$memset[6]<br>~;

			if ($username ne "$anonuser") {
				$viewd = qq~&nbsp;&nbsp;<a href="$pageurl/$cgi?action=viewprofile&amp;username=$musername[$a]"><img src="$imagesurl/forum/profile.gif" alt="$msg{'051'} $mname[$a]" border="0"></a>~;
			}
			$memberinfo = "$membergroups[2]";
			if ($ranking > 25) {
				$memberinfo = "$membergroups[3]";
			}
			if ($ranking > 100) {
				$memberinfo = "$membergroups[4]";
			}

			if ($ranking > 250) {
				$memberinfo = "$membergroups[5]";
			}
			if ($ranking > 500) {
				$memberinfo = "$membergroups[6]";
			}
			if ($ranking > 1000) {
				$memberinfo = "$membergroups[7]";
			}
			if ($ranking > 1500) {
				$memberinfo = "$membergroups[8]";
			}

			if ($boardmoderator eq "$musername[$a]") { $memberinfo = "$membergroups[1]"; }
			if ($memset[7] ne "") { $memberinfo = "$memset[7]"; }
			if ($memberinfo eq "$root") { $memberinfo = "$membergroups[0]"; }
			$signature = "$memset[5]";
			$signature =~ s/&&/\n/g;
			$signature = htmlescape($signature); 

			if ($imageicons eq "1") { # allow full size images in sigs
				$signature =~ s~(\[img\])(.*?)(view-source:|script:|mocha:|mailto:|about:|shell:)(.*?)(\[\/img\])~\[<font color=red>$err{'043'}<\/font>\]~isg; #anton
				$signature =~ s~\[img\](.+?)\[\/img\]~<img src="$1" alt="" border="0">~isg;
			}

			if ($signature ne "") {
				$signature = qq~<br><br><br>
<hr noshade="noshade" size="1">
$signature
~;
			}

			if (!($memset[8] =~ /\D/) && $memset[8] ne "") {
				$icq = qq~&nbsp;&nbsp;<a
 href="http://www.icq.com/$memset[8]" target="_blank"><img
 src="http://wwp.icq.com/scripts/online.dll?icq=$memset[8]&amp;img=5"
 alt="$msg{'052'} $memset[8]" border="0"></a>~;
			}
		} else {
			$memberinfo = "$anonuser";
		}

		$message = "$message\n$signature";
		$memberpic ="";

		if ($musername[$a] ne "$anonuser"  && $removed == 0) {
			if ($memset[9] eq "") { $memset[9] = "_nopic.gif"; }
			if ($memset[9] =~ /^http:\/\// ) {
				if ($memberpic_width ne 0) { $tmp_width = qq~width="$memberpic_width"~; }
				else { $tmp_width = ""; }
				if ($memberpic_height ne 0) { $tmp_height = qq~height="$memberpic_height"~; }
				else { $tmp_height = ""; }
				$memberpic = qq~<img src="$memset[9]" hspace="5" vspace="5" $tmp_width $tmp_height border="0" alt="$name">~;
			} else {
				$memberpic = qq~<img src="$imagesurl/avatars/$memset[9]" hspace="5" vspace="5" border="0" alt="">~;
			}
		}

		if ($enable_ubbc) { doubbc(); }
		if ($enable_smile) { dosmilies(); }

		$url = "";

		if (($memset[4]) && ($musername[$a] ne "$anonuser")) { # fix for previous poster's home page URL showing on guest poster's post - Jos
			$url = qq~<a href="$memset[4]" target="_blank"><img
 src="$imagesurl/forum/www.gif" alt="$msg{'053'} $mname[$a]"
 border="0"></a>&nbsp;&nbsp;~;
		} else {
			$url = "";
		}

		$message = censor_it($message);
		$subject = censor_it($subject);

		if ($userrank ne "$root") { $ip = "$msg{'108'}"; }
		symbol_alt($micon[$a]);
		$sname = showhtml($name);

		print qq~<tr>
<td class="$second" width="140" valign="top">
<b>$sname</b><br>
$memberpic<br>
<span class="textsmall">$memberinfo
$statusdisplay<br>
$postinfo</span>
</td>
<td class="$second" valign="top">
<table border="0" cellspacing="0" cellpadding="0" width="100%">
<tr>
<td><img src="$imagesurl/forum/$micon[$a].gif" alt="$symbolalt"></td>
<td width="100%">&nbsp;<a name="$a"><b>$subject</b></a><br>&nbsp;<b>$msg{'110'}</b> $messagedate</td>
</tr>
</table>
<hr noshade="noshade" size="1">
$message
</td>
</tr>
<tr class="$second">
<td><img src="$imagesurl/forum/ip.gif" alt="$msg{'111'}" align="top"> $ip</td>
<td>
<table border="0" cellspacing="0" cellpadding="0" width="100%">
<tr>
<td>$url~;

		if ($username ne $anonuser) { # avoid not authorized message
			if ($hidemail eq "1" && $musername[$a] ne "$anonuser") {
				print qq~<a href="$pageurl/$cgi?action=anonemail&amp;sendto=$musername[$a]">~;
			} else {
				print qq~<a href="mailto:$memail[$a]">~;
			}

			print qq~<img src="$imagesurl/forum/email.gif" alt="$msg{'055'} $mname[$a]"
 border="0"></a>$viewd$sendm$icq~;
		}

		print qq~&nbsp;</td>
<td align="center"><a
 href="$pageurl/$cgi?action=forum&amp;board=$currentboard&amp;op=display&amp;num=$info{'num'}&amp;start=$info{'start'}#$a"><img
 src="$imagesurl/forum/link.gif" alt="$msg{'694'}" border="0"></a></td>
<td align="right">&nbsp;~; # link to post

		if ($username ne $anonuser) { # quote button only works for members
			print qq~<a href="$forum&amp;op=post&amp;num=$viewnum&amp;quote=$a"><img
 src="$imagesurl/forum/quote.gif" alt="$msg{'056'}" border="0"></a>~;
		}

		if (($userrank eq $root) || ($username eq $thisboardmod) || ($username eq $musername[$a] && $username ne $anonuser)) {

			print qq~&nbsp;&nbsp;<a
 href="$forum&amp;op=modify&amp;message=$a&amp;thread=$viewnum&amp;start=$start"><img
 src="$imagesurl/forum/modify.gif" alt="$msg{'112'}" border="0"></a>~;
		}

		if (($userrank eq $root) || ($username eq $thisboardmod)) {
			print qq~&nbsp;&nbsp;<a
 href="$forum&amp;op=modify2&amp;thread=$viewnum&amp;id=$a&amp;d=1"><img
 src="$imagesurl/forum/delete.gif" alt="$msg{'058'}" border="0"></a>~;
		}

		print qq~</td>
</tr>
</table>
</td>
</tr>
~;
		if ($numshown >= $maxmessagedisplay) { $a = @messages; }
	}

	if (!defined $msub[0]) { $msub[0] = ""; }

	print qq~</table>
</td>
</tr>
</table>
<table border="0" width="100%" cellspacing="1" cellpadding="2">
<tr>
<td valign="bottom" class="forumtext"><img
 src="$imagesurl/forum/tline2.gif" width="24" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="17" height="15" border="0" alt="">&nbsp;&nbsp;$msub[0]
<br>
<img src="$imagesurl/forum/tline.gif" width="12" height="12" border="0" alt=""><img
 src="$imagesurl/forum/open.gif" width="17" height="15" border="0" alt="">&nbsp;&nbsp;<a
 href="$forum" class="forumnav">$boardname</a>
<br>
<img src="$imagesurl/forum/open.gif" width="17" height="15" border="0" alt="">&nbsp;&nbsp;
<a href="$pageurl/$cgi?action=forum">$nav{'003'}</a></td>
<td align="left" valign="top">&nbsp;~;

	if ($username eq "$thisboardmod" || $userrank eq "$root") {
		$adminfunction = qq~<a href="$forum&amp;op=movethread&amp;thread=$viewnum"><img
 src="$imagesurl/forum/move.gif" alt="$msg{'113'}" border="0"></a>&nbsp;<a
 href="$forum&amp;op=makesticky&amp;thread=$viewnum"><img
 src="$imagesurl/forum/stickythread.gif" alt="$msg{'689'}" border="0"></a>&nbsp;<a
 href="$forum&amp;op=removethread&amp;thread=$viewnum"><img
 src="$imagesurl/forum/remove.gif" alt="$msg{'114'}" border="0"></a>&nbsp;<a
 href="$forum&amp;op=lockthread&amp;thread=$viewnum"><img
 src="$imagesurl/forum/lock.gif" alt="$msg{'115'}" border="0"></a>~;
	} else {
		$adminfunction = "";
	}

	print qq~$adminfunction</td>
<td align="right" valign="top">&nbsp;~;

	if (($username ne $anonuser) || ($enable_guestposting == 1)) {
		print qq~<a href="$forum&amp;op=post&amp;num=$viewnum"><img
 src="$imagesurl/$langgfx/reply.gif" alt="$msg{'107'}" border="0"></a>$notification~;
	} # reply button members only unless guest posting allowed

	print qq~</td>
</tr>
<tr>
<td valign="top" class="forumtext">~; 


	print qq~$pages</td>
<td align="right" colspan="2" class="forumtext"><form action="$pageurl/$cgi" method="get">
$msg{'104'} <select name="board">$selecthtml</select> <input type="submit" class="button" value="$btn{'014'}">
<input type="hidden" name="action" value="forum"></form></td>
</tr>
</table>
~;

	print_bottom();
	exit;

}

###############
sub printpage {
###############

	if ($info{'num'} =~ /\W/) { error($msg{'630'}); }

### FIX FOR VIEWING PRIVATE THREADS VIA PRINT PAGE ###
	if (! $userrank) { $userrank = "none"; }
	if (! $userstatus) { $userstatus = "none"; } # for multiple status on board

	if ($userrank ne "$root") {
		@categories = read_database("$boardsdir/cats.txt");
		
		foreach $curcat (@categories) {
			$curcat =~ s/[\n\r]//g;

			@catinfo = read_database("$boardsdir/$curcat.cat");
			
			$catinfo[1] =~ s/[\n\r]//g;

			if ($catinfo[1]) {
				# access setting according to number of forum posts:
				my $postlevelaccess = 0;
				if (($catinfo[1] =~ /\b(\d+)\b/) && ($settings[6] > $1)) { $postlevelaccess = 1; }

				foreach $searchcat (@catinfo) {
					$searchcat =~ s/[\n\r]//g;

					if (($currentboard eq "$searchcat") && ($catinfo[1] !~ /\b$userrank\b|\b$userstatus\b/i) && (!$postlevelaccess)) {
						print_top();  print "What are you doing Stan?"; print_bottom(); exit;
					}
				}
			}
		}
	}
### END FIX FOR VIEWING PRIVATE THREADS VIA PRINT PAGE ###

	print "Content-type: text/html\n\n";
	print qq~<html>
<head>
<title>$pagename</title>
<meta http-equiv="expires" content="0">
<meta name="Generator" content="$scriptname $scriptver">
<meta http-equiv="Content-Type" content="text/html; charset=$charset{'001'}">
<meta http-equiv="Content-Language" content="$charset{'002'}">
<META HTTP-EQUIV="imagetoolbar" CONTENT="no">
<META NAME="ROBOTS" CONTENT="NOARCHIVE">
<META NAME="GOOGLEBOT" CONTENT="NOSNIPPET">
</head>
<body>
~;

	if ($currentboard =~ /\W/) { error($msg{'630'}); }
	if ($info{'num'} =~ /\W/) { error($msg{'630'}); }

	@threads = chomp_database("$boardsdir/$currentboard.txt");
	@stickythreads = chomp_database("$boardsdir/$currentboard.sticky");

	@threads = (@threads, @stickythreads );

	$found_thread="";
	foreach (@threads) {
		($mnum, undef) = split(/\|/, $_);
		if ($info{'num'} eq $mnum) {
			$found_thread="1";
			last;
		}
	}

	if ($found_thread ne "1") { error("$err{'042'}"); } 

	@messages = chomp_database("$messagedir/$info{'num'}.txt");
	$numshown = @messages;

	@item = split (/\|/, $messages[0]);

	$message = $item[7];
	if ($enable_ubbc) { doubbctopic(); }
	if ($enable_smile) { dosmilies(); }
	display_date($item[3]); $item[3] = "$msg{'054'} $user_display_date";
	if ($item[1] eq "") { $item[1] = "$msg{'183'}"; }

	print qq~<table border="0" cellpadding="3" cellspacing="3" width="100%">
<tr>
<td><img src="$imagesurl/forum/$item[5].gif" alt=""><font
 face="arial" size="4" color="#003399">&nbsp;<b>$item[0]</b></font></td>
</tr>
<tr>
<td><font face="arial" size="-3" color="#000000"> $item[3] $msg{'042'} <b>$item[1]</b></font></td>
</tr>
<tr>
<td valign="top"> <font face="arial" size="-1" color="#000000">$message</font></td>
</tr>
~;

	if ($numshown > 1) {
		print qq~<tr>
<td><hr align="left" width="200"><font
 face="arial" size="3" color="#003399"><b>$msg{'585'}</b></font></td>
</tr>
<tr>
<td>&nbsp;</td>
</tr>
~;

		for ($a = 1; $a < $numshown; $a++) {
			@item = split (/\|/, $messages[$a]);

			$message = $item[7];
			if ($enable_ubbc) { doubbctopic(); }
			if ($enable_smile) { dosmilies(); }

			display_date($item[3]); $item[3] = "$msg{'054'} $user_display_date";
			if ($item[1] eq "") { $item[1] = "$msg{'183'}"; }

			if ($item[5] ne "") {
				print qq~<tr>
<td><font face="arial" size="2" color="#003399"><img src="$imagesurl/forum/$item[5].gif" alt="">&nbsp;<b>$item[0]</b></font></td>
</tr>
<tr>
<td><font face="arial" size="-3" color="#000000">$item[3] $msg{'042'} <b>$item[1]</b></font>
</td>
</tr>
<tr>
<td valign="top"><font face="arial" size="-1" color="#000000">$message</font></td>
</tr>
~;

				if ($a < ($numshown-1)) {
					print qq~<tr>
<td><hr align="left" width="200"></td>
</tr>
~;
				}
			}
		}
	}

			print qq~<tr>
<td><hr><center><small>$msg{'534'} <b>$pagename</b><br>$msg{'159'}<br></small></center></td>
</tr>
</table>
</body>
</html>
~;

	exit;
}

if (-e "$user_lib/forum_display.pl") {require "$user_lib/forum_display.pl"}

1; # return true