###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# forum_mark.pl	                                                              #
# v0.9.9.3.4                                                                  #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified: 2005 by Jos Brown ("bantychick")                            #
# Modified: 25 May 2006 by Jos                                                #
###############################################################################
###############################################################################

##################
sub mark_as_read {
##################

	if (!$info{'board'}) {

		@categories = read_database("$boardsdir/cats.txt");

		my $prtline = "";
		my @allboards = ();

		foreach $curcat (@categories) {
			$curcat =~ s/[\n\r]//g;

			@catinfo = chomp_database("$boardsdir/$curcat.cat");

			$catinfo[1] =~ s/[\n\r]//g;
			if ($catinfo[1] ne "") {
				if ($userrank ne "$root" && $userrank ne "$catinfo[1]") { next; }
			}

			foreach $curboard (@catinfo) {
				if ($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
					$curboard =~ s/[\n\r]//g;

					@messages = chomp_database("$boardsdir/$curboard.txt");

					@messagessticky = chomp_database("$boardsdir/$curboard.sticky");

					@messages = (@messages, @messagessticky);

					# find newest of latest message or latest sticky - Jos
					my @dates = ();
					my @data =();

					for (0..$#messages) {
						my $saveddate = (split(/\|/, $messages[$_]))[5];
						my ($chkmonth, $chkday, $chkyear, $chkhour, $chkmin, $chksec) = split(/\/| - |\:/, $saveddate);
						$chkyear = (2000+$chkyear);
						my $sortdate = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";
						my @fields = ($sortdate, $saveddate);
						for $i (0..$#fields) {
							$data[$_][$i] = $fields[$i];
						}
					}
					my @sorted = sort { $b->[0] <=> $a->[0] } @data;

					for (@sorted) {
						shift (@$_);
						push (@dates, @$_);
					}

					$postdate = $dates[0];
					$prtline .= "$curboard\|$postdate\n";
					push (@allboards, $curboard);
				}
			}
		}

		if ($username ne "$anonuser") {
			@entries = read_database("$memberdir/$username.log");

			open(LOG, ">$memberdir/$username.log");
			hold(LOG);
			print LOG "$prtline";
			foreach $curentry (@entries) {
				$curentry =~ s/[\n\r]//g;
				($name, $value) = split(/\|/, $curentry);
				$date1 = "$value";
				$date2 = "$date";
				calcdifference();
				if (grep(/\b$name\b/, @allboards) == 0 && $result <= $max_log_days_old) {
					print LOG "$curentry\n";
				}
			}
			release(LOG);
			close(LOG);
		}
	} else {
		$writedate = "$date";
		writelog("$currentboard");
	}

	print "Location: $pageurl/$cgi?action=forum\n\n";

}

#####################
sub mark_posts_read {
#####################

	$currentboard = $info{'board'};

	if ($currentboard ne "") {
		@messages = chomp_database("$boardsdir/$currentboard.txt");
				
		@messagessticky = chomp_database("$boardsdir/$currentboard.sticky");

		@messages = (@messages, @messagessticky);

		my $prtline = "";
		my @allthreads = ();

		for ($a = 0; $a < @messages; $a++) {
			($mnum[$a], $mdate[$a]) = (split(/\|/, $messages[$a]))[0,5];

			$prtline .= "$mnum[$a]|$mdate[$a]\n";
			push (@allthreads, $mnum[$a]);
		}

		if ($username ne "$anonuser") {
			@entries = read_database("$memberdir/$username.log");

			open(LOG, ">$memberdir/$username.log");
			hold(LOG);
			print LOG "$prtline";
			foreach $curentry (@entries) {
				$curentry =~ s/[\n\r]//g;
				($name, $value) = split(/\|/, $curentry);
				$date1 = "$value";
				$date2 = "$date";
				calcdifference();
				if (grep(/\b$name\b/, @allthreads) == 0 && $result <= $max_log_days_old) {
					print LOG "$curentry\n";
				}
			}
			release(LOG);
			close(LOG);
		}
	}

	print "Location: $pageurl/$cgi?action=forum&board=$currentboard\n\n"; 

}

if (-e "$user_lib/forum_mark.pl") { require "$user_lib/forum_mark.pl" } 

1; # return true