###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# forum_post.pl                                                               #
# v0.9.9.3.4                                                                  #
# Error Message Update by: Floyd for WebAPP v0.9.8                            #
# Forum Overload Fix by: Anton                                                #
# Post Page Hole Fix by: Jos Brown (www.bantychick.com)                       #
# Reply redirect back to post by: Jos                                         #
# Censoring of Past Posts List by: Jos                                        #
# Captcha human visual verification by Shaka_Flex Integration by: Mossad      #
# CSS Update by my2cents (classicchat.net)                                    #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified by Jos Brown - web nick "bantychick" 2005 for v0.9.9.3       #
# File: Modified 26 Dec 2005 by Mossad                                        #
# Modified: 13 Apr 2006 by my2cents                                           #
# Modified: 18 May 2006, 19 May 2006, 12 Aug, 18 Aug 2006 by Jos              #
###############################################################################
###############################################################################

################
sub poststicky {
################

	if ($username eq $anonuser && $enable_guestposting == 0) { error("noguests"); }

	if (!defined $info{'num'}) { $info{'num'} = ""; }

	if ($currentboard =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "$msg{'630'}"; print_bottom(); exit; }
	if ($info{'num'} =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "$msg{'630'}"; print_bottom(); exit; }

	open(FILE, "$boardsdir/$currentboard.dat");
	hold(FILE);
	chomp(@boardinfo = <FILE>);
	release(FILE);
	close(FILE);

	$boardinfo[2] =~ s/[\n\r]//g;
	$boardinfo[2] =~ /^\|(.*?)\|$/;
	$moderators = $boardinfo[2];
	$moderators =~ s/\|(\S?)/,$1/g;

	foreach $curuser (split(/ /, $moderators)) {
		if ($username eq "$curuser") { $thisboardmod = $username; }
		else { $thisboardmod = ""; }
	}

	if ($userrank ne "$root" && $username ne "$thisboardmod") { error("$err{'011'}"); }

	my @threads = chomp_database("$boardsdir/$currentboard.sticky");

	for ($x = 0; $x < @threads; $x++) {
		($mnum, $msub, $mname, $musername, $memail, $mdate, $mreplies, $stickyviews, $mlpname, $micon, $mstate) = split(/\|/, $threads[$x]);
		if ($info{'num'} eq $mnum && $mstate == 1) {
			error("$err{'024'}");
			$x = @threads;
		}
	}

	if ($enable_notification && $username ne $anonuser) {
		$notification = qq~<tr>
<td><b>$msg{'105'}</b></td>
<td><input type="checkbox" name="notify" value="x"></td>
</tr>
~;
	} else {
		 $notification = '';
	}

	if ($realname ne "") {
		$name_field = qq~$realname<input type="hidden" name="name" value="$realname">~;
	} else {
		$name_field = qq~<input type="text" class="textinput" name="name" size="50">~;
	}
	if ($realemail ne "") {
		$email_field = qq~$realemail<input type="hidden" name="email" value="$realemail">~;
	} else {
		$email_field = qq~<input type="text" class="textinput" name="email" size="50">~;
	}

	if ($info{'num'} ne "") {
		
		@messages = chomp_database("$messagedir/$info{'num'}.txt");

		($msubject, $mname, $memail, $mdate, $musername, $micon, $mip, $mmessage) = split(/\|/, $messages[0]);
		$msubject =~ s/Re: //g;
		$form_subject = "Re: $msubject";

		if (!defined $info{'quote'}) { $info{'quote'} = ""; }
		if ($info{'quote'} ne "") {
			($msubject, $mname, $memail, $mdate, $musername, $micon, $mip, $mmessage) = split(/\|/, $messages[$info{'quote'}]);
			$form_message = "$mmessage";
			$form_message =~ s/\[quote\]\[b\]$mname $msg{'685'}\[\/b\]\n(\S+?)\[\/quote\]//isg;
			$form_message =~ s/\[(\S+?)\]//isg;
			$form_message = "\n\n\[quote\]\[b\]$mname $msg{'685'}\[\/b\]\n$form_message\[/quote\]";
			$form_message = htmltotext($form_message);
			$msubject =~ s/Re: //g;
			$form_subject = "Re: $msubject";
		}
	}

	$navbar = "$btn{'014'} $nav{'036'} ";
	print_top();

	if (!defined $info{'start'}) { $info{'start'} = 0; }
	if (!defined $info{'num'}) { $info{'num'} = 0; }
	if (!defined $form_subject) { $form_subject = ""; }
	if (!defined $form_message) { $form_message = ""; }

	# oneclick doesn't work here
	print qq~<table width="100%" border="0" cellspacing="0" cellpadding="1">
	<tr>
<td><form action="$forum&amp;op=poststicky2&amp;start=$info{'start'}"
 method="post" name="creator">
<input type="hidden" name="followto" value="$info{'num'}">
<table border="0">
<tr>
<td class="formstextnormal">$msg{'013'}</td>
<td>$name_field</td>
</tr>
<tr>
<td class="formstextnormal">$msg{'007'}</td>
<td>$email_field</td>
</tr>
<tr>
<td class="formstextnormal">$msg{'037'}</td>
<td><input type="text" class="textinput" name="subject" value="$form_subject" size="40" maxlength="50"></td>
</tr>
<tr>
<td class="formstextnormal">$msg{'116'}</td>
<td><script language="javascript" type="text/javascript">
<!--
function showImage() {
document.images.icons.src="$imagesurl/forum/"+document.creator.icon.options[document.creator.icon.selectedIndex].value+".gif";
}
// -->
</script>
<select name="icon" onChange="showImage()">
<option value="xx">$msg{'143'}</option>
<option value="thumbup">$msg{'144'}</option>
<option value="thumbdown">$msg{'145'}</option>
<option value="exclamation">$msg{'146'}</option>
<option value="question">$msg{'147'}</option>
<option value="lamp">$msg{'148'}</option>
</select>
<img src="$imagesurl/forum/xx.gif" name="icons" width="15"
 height="15" border="0" hspace="15" alt=""></td>
</tr>
<tr>
<td class="formstextnormal">$msg{'038'}</td>
<td>
<script language="javascript" type="text/javascript">
<!--
function addCode(anystr) {
document.creator.message.value+=anystr;
}
function showColor(color) {
document.creator.message.value+="[color="+color+"][/color]";
}
function upload() {
window.open("$pageurl/$cgi?action=uploadpicture","","width=300,height=150,scrollbars")
}
// -->
</script>
<textarea name="message" rows="10" cols="40">$form_message</textarea></td>
</tr>
~;

	if ($username eq "admin" || $forumimgupld eq "1" && $username ne "$anonuser") {
		print qq~<tr>
<td>&nbsp;</td>
<td class="formstextnormal" valign="top"><a
 href="javascript:upload()">$msg{'598'}</a></td>
</tr>
~;
	}

	if ($enable_ubbc eq "1") {
		print qq~<tr>
<td class="formstextnormal" valign="middle">$msg{'156'}</td>
<td><a href="javascript:addCode('[b][/b]')"><img src="$imagesurl/forum/buttons/bold.gif" align="bottom" width="23" height="22" title="$msg{'117'}" alt="$msg{'117'}" border="0"></a>
<a href="javascript:addCode('[i][/i]')"><img src="$imagesurl/forum/buttons/italicize.gif" align="bottom" width="23" height="22" title="$msg{'118'}" alt="$msg{'118'}" border="0"></a>
<a href="javascript:addCode('[u][/u]')"><img src="$imagesurl/forum/buttons/underline.gif" align="bottom" width="23" height="22" title="$msg{'119'}" alt="$msg{'119'}" border="0"></a>
<a href="javascript:addCode('[small][/small]')"><img src="$imagesurl/forum/buttons/small.gif" align="bottom" width="23" height="22" title="$msg{'729'}" alt="$msg{'729'}" border="0"></a>
<a href="javascript:addCode('[big][/big]')"><img src="$imagesurl/forum/buttons/big.gif" align="bottom" width="23" height="22" title="$msg{'730'}" alt="$msg{'730'}" border="0"></a>
<a href="javascript:addCode('[sub][/sub]')"><img src="$imagesurl/forum/buttons/sub.gif" align="bottom" width="23" height="22" title="$msg{'544'}" alt="$msg{'544'}" border="0"></a>
<a href="javascript:addCode('[sup][/sup]')"><img src="$imagesurl/forum/buttons/sup.gif" align="bottom" width="23" height="22" title="$msg{'545'}" alt="$msg{'545'}" border="0"></a>
<a href="javascript:addCode('[strike][/strike]')"><img src="$imagesurl/forum/buttons/strike.gif" align="bottom" width="23" height="22" title="$msg{'546'}" alt="$msg{'546'}" border="0"></a>
<a href="javascript:addCode('[pre][/pre]')"><img src="$imagesurl/forum/buttons/pre.gif" align="bottom" width="23" height="22" title="$msg{'547'}" alt="$msg{'547'}" border="0"></a><br>
<a href="javascript:addCode('[left][/left]')"><img src="$imagesurl/forum/buttons/left.gif" align="bottom" width="23" height="22" title="$msg{'548'}" alt="$msg{'548'}" border="0"></a>
<a href="javascript:addCode('[center][/center]')"><img src="$imagesurl/forum/buttons/center.gif" align="bottom" width="23" height="22" title="$msg{'120'}" alt="$msg{'120'}" border="0"></a>
<a href="javascript:addCode('[right][/right]')"><img src="$imagesurl/forum/buttons/right.gif" align="bottom" width="23" height="22" title="$msg{'549'}" alt="$msg{'549'}" border="0"></a>
<a href="javascript:addCode('[list][*][*][*][/list]')"><img src="$imagesurl/forum/buttons/list.gif" align="bottom" width="23" height="22" title="$msg{'125'}" alt="$msg{'125'}" border="0"></a>
<a href="javascript:addCode('[email][/email]')"><img src="$imagesurl/forum/buttons/email2.gif" align="bottom" width="23" height="22" title="$msg{'122'}" alt="$msg{'122'}" border="0"></a>
<a href="javascript:addCode('[img][/img]')"><img src="$imagesurl/forum/buttons/img.gif" align="bottom" width="23" height="22" title="$msg{'171'}" alt="$msg{'171'}" border="0"></a>
<a href="javascript:addCode('[url][/url]')"><img src="$imagesurl/forum/buttons/url.gif" align="bottom" width="23" height="22" title="$msg{'121'}" alt="$msg{'121'}" border="0"></a>
<a href="javascript:addCode('[quote][/quote]')"><img src="$imagesurl/forum/buttons/quote2.gif" align="bottom" width="23" height="22" title="$msg{'124'}" alt="$msg{'124'}" border="0"></a>
<a href="javascript:addCode('[code][/code]')"><img src="$imagesurl/forum/buttons/code.gif" align="bottom" width="23" height="22" title="$msg{'123'}" alt="$msg{'123'}" border="0"></a></td>
</tr>
<tr>
<td>&nbsp;</td>
<td><select name="color" onChange="showColor(this.options[this.selectedIndex].value)">
<option value="Black" selected>$msg{'127'}</option>
<option value="Red">$msg{'128'}</option>
<option value="Yellow">$msg{'129'}</option>
<option value="Pink">$msg{'130'}</option>
<option value="Green">$msg{'131'}</option>
<option value="Orange">$msg{'132'}</option>
<option value="Purple">$msg{'133'}</option>
<option value="Blue">$msg{'134'}</option>
<option value="Beige">$msg{'135'}</option>
<option value="Brown">$msg{'136'}</option>
<option value="Teal">$msg{'137'}</option>
<option value="Navy">$msg{'138'}</option>
<option value="Maroon">$msg{'139'}</option>
<option value="LimeGreen">$msg{'140'}</option>
</select>
</td>
</tr>
~;
	}

	smilieblock();

	print qq~$notification
<tr>
<td><br><br></td>
<td><input type="submit" class="button" name="moda" value="$btn{'044'}">&nbsp;<input
 type="submit" class="button" value="$btn{'008'}">&nbsp;<input
 type="reset" class="button" value="$btn{'009'}"></td>
</tr>
~;

	show_legend();

	print qq~</table>
</form>
</td>
</tr>
~;

	print qq~</table>
~;

	if (@messages) {
		print qq~<table width="100%" cellspacing="0" cellpadding="0" border="0">
<tr>
<td><b>$msg{'141'}</b></td>
</tr>
<tr>
<td><table width="100%" class="forumtitlebackcolor tableback" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<table width="100%" border="0" cellspacing="1" cellpadding="2">
~;

		foreach $line (@messages) {
			(undef, $tempname, undef, $tempdate, undef, undef, undef, $temppost) = split(/\|/, $line);
			$message = "$temppost";
			if ($enable_ubbc) { doubbc(); }
			if ($enable_smile) { dosmilies(); }
			print qq~<tr>
<td class="forumwindow3">$msg{'047'} $tempname ($tempdate)</td>
</tr>
<tr>
<td class="forumwindow2">$message</td>
</tr>
~;
		}
		print qq~</table>
</td>
</tr>
</table>
<br>~;

		print qq~</td></tr></table>~;

 	} else {
 		print "<!--no summary-->";
 	}

	print_bottom();
	exit;

}

#################
sub poststicky2 {
#################

	open(FILE, "$boardsdir/$currentboard.dat");
	hold(FILE);
	chomp(@boardinfo = <FILE>);
	release(FILE);
	close(FILE);
	$boardinfo[2] =~ s/[\n\r]//g;

	$boardinfo[2] =~ /^\|(.*?)\|$/;

	$moderators = $boardinfo[2];
	$moderators =~ s/\|(\S?)/,$1/g;

	foreach $curuser (split(/ /, $moderators)) {

			if ($username eq "$curuser") { $boardmoderator = $username; }

	}

	if ($userrank ne "$root" && $username ne "$boardmoderator") { error("$err{'011'}"); }

	if ($input{'moda'} eq "$btn{'011'}")  { print "Location: $pageurl/$cgi?action=forum&board=$currentboard\n\n"; }
	elsif ($input{'moda'} eq "$btn{'044'}") {

# Put the preview code here....
#######################################################################################

	$navbar = "$btn{'014'} $nav{'159'}";
	print_top();

	error("$err{'013'}") unless($input{'name'});
	error("$err{'005'}") unless($input{'email'});
	error("$err{'014'}") unless($input{'subject'});
	error("$err{'015'}") unless($input{'message'});

	if ($username ne "$anonuser") {

		open(FILE, "$memberdir/$username.dat");
		hold(FILE);
		@settings = <FILE>;
		release(FILE);
		close(FILE);

		for( $i = 0; $i < @settings; $i++ ) {
			$settings[$i] =~ s~[\n\r]~~g;
		}
	}

	$nsubject = previewstrip($input{'subject'});
	$nmessage = previewstrip($input{'message'});

	# oneclick doesn't work here
	print qq~<table width="100%" border="0" cellspacing="0" cellpadding="1">
<tr>
<td><form action="$forum&amp;op=poststicky2&amp;start=$info{'start'}"
 method="post" name="creator">
<input type="hidden" name="num" value="$info{'num'}">
<input type="hidden" name="followto" value="$input{'followto'}">
<input type="hidden" name="name" value="$input{'name'}">
<input type="hidden" name="email" value="$input{'email'}">
<input type="hidden" name="subject" value="$nsubject">
<input type="hidden" name="message" value="$nmessage">
<input type="hidden" name="icon" value="$input{'icon'}">
</td></tr>
</table>
~;


	$name = htmlescape($input{'name'});
	$email = htmlescape($input{'email'});
	$subject = htmlescape($input{'subject'});
	$message = htmlescape($input{'message'});
	$icon = "$input{'icon'}";

	$sig = "$settings[5]";
	$sig =~ s/\&\&/<br>/g;
	if ($sig ne "") {
		$sig = qq~<br><br><br>
-----------------<br>
$sig
~;

	}

	if ($enable_ubbc) { doubbc(); }
	if ($enable_smile) { dosmilies(); }

	print qq~<table width="100%" class="forumtitlebackcolor" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<table width="100%" border="0" cellspacing="1" cellpadding="2">
<tr>
<td class="forumwindow3">
<table width="100%" border="0" cellspacing="0" cellpadding="0">
<tr>
<td><img src="$imagesurl/forum/stickythread.gif" alt="$msg{'493'}"></td>
<td class="forumtext">&nbsp;<b>$msg{'049'}</b></td>
</tr>
</table>
</td>
<td class="forumwindow3"><b>$msg{'064'} $subject</b></td>
</tr>~;

	if ($username ne "$anonuser") {
		print qq~<tr>
<td class="forumwindow2" width="140" valign="top"><b>$name</b><br>~;

		if ($settings[9] eq "") { $settings[9] = "_nopic.gif"; }

		if ($settings[9] =~ /^http:\/\// ) {
			if ($memberpic_width ne 0) { $tmp_width = qq~width="$memberpic_width"~; }
			else { $tmp_width = ""; }
			if ($memberpic_height ne 0) { $tmp_height = qq~height="$memberpic_height"~; }
			else { $tmp_height = ""; }
			$memberpic = qq~<img src="$settings[9]" $tmp_width $tmp_height border="0" alt="$info{'username'}"></a>~;
		} else {
			 $memberpic = qq~<img src="$imagesurl/avatars/$settings[9]" border="0" alt=""></a>~;
		}

		print qq~
$memberpic
<br>
$userrank<br>
<br>
Forumposts: $settings[6]<br><br>$msg{'022'} $settings[11]<br><br>$msg{'023'} $settings[12]<br><br><br>
</td>
<td class="forumwindow2" valign="top">
<table border="0" cellspacing="0" cellpadding="0" width="100%">
<tr>
<td><img src="$imagesurl/forum/$icon.gif" alt="$msg{'517'}"></td>
<td width="100%">&nbsp;<b>$subject</b></td>
<td align="right" nowrap>&nbsp;<b>$msg{'110'}</b> $date</td>
</tr>
</table>
<hr noshade="noshade" size="1">
$message
$sig
<br>
</td>
</tr>
<tr class="forumwindow2">
<td><img src="$imagesurl/forum/ip.gif" alt="$msg{'111'}" align="top">$ENV{'REMOTE_ADDR'}</td>
<td>
<table border="0" cellspacing="0" cellpadding="0" width="100%" maxwidth="80">
<tr>
<td><a href="$settings[4]" target="_blank"><img src="$imagesurl/forum/www.gif" alt="$msg{'053'} $name" border="0"></a>&nbsp;&nbsp;<a href="$pageurl/$cgi?action=anonemail&sendto=$username" class="forumnav"><img src="$imagesurl/forum/email.gif" alt="$msg{'055'} $name" border="0"></a>&nbsp;&nbsp;<a href="$pageurl/$cgi?action=viewprofile&amp;username=$username"><img src="$imagesurl/forum/profile.gif" alt="$msg{'051'} $name" border="0"></a>&nbsp;&nbsp;<a href="$pageurl/$cgi?action=imsend&amp;to=$username"><img src="$imagesurl/forum/message.gif" alt="$msg{'109'} $name" border="0"></a></td>
<td align="right"><td>
</tr>
</table>
</td>
</tr>
<tr class="forumwindow2">
<td align="center" colspan="2">
<input type="button" class="button" value="$btn{'030'}" onClick="history.back()"><!-- edit -->
<input type="submit" class="button" value="$btn{'043'}"><!-- Post Message -->
<input type="submit" class="button" name="moda" value="$btn{'011'}"><!-- Delete --></td>
</tr>
</form>
</table>
~;
		}

		print_bottom();

		exit;
	}
#########################################################################################

	else {

		logpost();

		error("$err{'013'}") unless($input{'name'});
		error("$err{'005'}") unless($input{'email'});
		error("$err{'014'}") unless($input{'subject'});
		error("$err{'015'}") unless($input{'message'});

		$name = htmlescape($input{'name'});
		$email = htmlescape($input{'email'});
		$subject = htmlescape($input{'subject'});
		$message = htmlescape($input{'message'});
		$icon = "$input{'icon'}";

		if ($username ne "$anonuser") {
			$name = "$settings[1]";
			$email = "$settings[2]";
		}
		else {
			open(FILE, "$memberdir/memberlist.dat");
			hold(FILE);
			chomp(@memberlist = <FILE>);
			release(FILE);
			close(FILE);

			if (exists $memberlist{$name}) { error("$err{'007'}"); }
			for ($a = 0; $a < @memberlist; $a++) {
				open(FILE, "$memberdir/$memberlist[$a].dat");
				hold(FILE);
				chomp(@check_settings = <FILE>);
				release(FILE);
				close(FILE);

				if ($check_settings[1] eq $name) { error("$err{'007'}"); }
			}
		}
		if (length($subject) > 50) { $subject = substr($subject,0,50); }

		if ($input{'followto'} eq "") {
			opendir (DIR, "$messagedir");
			@files = readdir(DIR);
			closedir (DIR);
			@files = grep(/txt/,@files);

			for ($c = 0; $c < @files; $c++) {
				$files[$c] =~ s/\.txt//;
			}
			@files = reverse(sort { $a <=> $b } @files);
			$postnum = $files[0];
			$postnum++;
		}

      if ($currentboard =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "$msg{'630'}"; print_bottom(); exit; }

		my @messages = read_database("$boardsdir/$currentboard.sticky");
		
      if ($currentboard =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "$msg{'630'}"; print_bottom(); exit; }

		# begin anton's forum overload bug fix
		$followto = $input{'followto'};

		if (!$followto) {
			unshift @messages, "$postnum|$subject|$name|$username|$email|$date|0|0|$name|$icon\|0\n";
		} else {
			for ($a = 0; $a < @messages; $a++) {
				($mnum, $msub, $mname, $musername, $memail, $mdate, $mreplies, $stickyviews, $mlpname, $micon, $mstate) = split(/\|/, $messages[$a]);
				if($mnum eq $followto) {
					$mreplies++;
					unshift @messages, "$mnum|$msub|$mname|$musername|$memail|$date|$mreplies|$stickyviews|$name|$micon|$mstate";
					splice @messages, $a+1, 1;
					last;
				}
			}
		}

		open (FILE, ">$boardsdir/$currentboard.sticky") || &error("$err{'016'} $boardsdir/$currentboard.sticky");
		&hold(FILE);
		print FILE @messages;
		&release(FILE);
		close(FILE);
		# end anton's forum overload bug fix

		if ($input{'followto'} ne "") {
			open(FILE, ">>$messagedir/$followto.txt") || error("$err{'001'} $messagedir/$followto.txt");
		} else {
			open(FILE, ">$messagedir/$postnum.txt") || error("$err{'016'} $messagedir/$postnum.txt");
		}
		hold(FILE);
		print FILE "$subject|$name|$email|$date|$username|$icon|$ENV{REMOTE_ADDR}|$message\n";
		release(FILE);
		close (FILE);

		if ($input{'followto'} ne "") { $thread = "$followto"; }
		else { $thread = "$postnum"; }


		if (-e("$messagedir/$thread.mail")) { require "$sourcedir/notify.pl"; notify_users(); }
		$writedate = "$date";
		writelog("$currentboard");

		if ($username ne "$anonuser") {
			$settings[6]++;

			open(FILE, ">$memberdir/$username.dat") || error("$err{'016'} $memberdir/$username.dat");
			hold(FILE);
			for ($i = 0; $i < @settings; $i++) {
					print FILE "$settings[$i]\n";
			}
			release(FILE);
			close(FILE);
		}

		if ($input{'notify'}) {
			print "Location: $cgi\?action=forum\&board=$currentboard\&op=notify2\&thread=$thread\n\n";
		}
		else { print "Location: $cgi\?action=forum\&board=$currentboard\&op=displaysticky\&num=$thread\&start=$info{'start'}\n\n"; }
		exit;
	}
}

##########
sub post {
##########

	if ($username eq $anonuser && $enable_guestposting == 0) { error("noguests"); }

	if (!defined $info{'num'}) { $info{'num'} = ""; }
	if ($currentboard =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top(); print "$msg{'630'}"; print_bottom(); exit;	}
	if ($info{'num'} =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top(); print "$msg{'630'}"; print_bottom(); exit; }

	# begin fix for viewing private threads via post page
	if (! $userrank) { $userrank = "none"; }
	if (! $userstatus) { $userstatus = "none"; } # for multiple status on board

	if ($userrank ne "$root") {
		my @categories = read_database("$boardsdir/cats.txt");
		
		foreach $curcat (@categories) {
			$curcat =~ s/[\n\r]//g;
			
			my @catinfo = read_database("$boardsdir/$curcat.cat");
			
			$catinfo[1] =~ s/[\n\r]//g;

			if ($catinfo[1]) {

				# access setting according to number of forum posts - Jos:
				my $postlevelaccess = 0;
				if (($catinfo[1] =~ /\b(\d+)\b/) && ($settings[6] > $1)) { $postlevelaccess = 1; }

				foreach $searchcat (@catinfo) {
					$searchcat =~ s/[\n\r]//g;

					if (($currentboard eq "$searchcat") && ($catinfo[1] !~ /\b$userrank\b|\b$userstatus\b/i) && (!$postlevelaccess)) {
						print_top();  print "$msg{'630'}"; print_bottom(); exit;
					}
				}
			}
		}
	}
	# end fix for viewing private threads via post page

	my @threads = chomp_database("$boardsdir/$currentboard.txt");
	
	for ($x = 0; $x < @threads; $x++) {
		($mnum, $msub, $mname, $musername, $memail, $mdate, $mreplies, $mviews, $mlpname, $micon, $mstate) = split(/\|/, $threads[$x]);

		if ($info{'num'} eq $mnum && $mstate == 1) {
			error("$err{'024'}");
			$x = @threads;
		}
	}

	if ($enable_notification && $username ne $anonuser) {
		$notification = qq~<tr>
<td><b>$msg{'105'}</b></td>
<td><input type="checkbox" name="notify" value="x"></td>
</tr>
~;
	} else { $notification = ''; }

	if ($realname ne "") {
		$name_field = qq~$realname<input
 type="hidden" name="name" maxlength="20" value="$realname">~;
	} else {
		$name_field = qq~<input
 type="text" class="textinput" name="name" size="50" maxlength="20">~;
	}

	if ($realemail ne "") {
		$email_field = qq~$realemail<input
 type="hidden" name="email" maxlength="35" value="$realemail">~;
	} else {
		$email_field = qq~<input
 type="text" class="textinput" name="email" size="50" maxlength="35">~;
	}

	if ($info{'num'} ne "") {
		
		@messages = chomp_database("$messagedir/$info{'num'}.txt");
		
		($msubject, $mname, $memail, $mdate, $musername, $micon, $mip, $mmessage) = split(/\|/, $messages[0]);
		$msubject =~ s/Re: //g;
		$form_subject = "Re: $msubject";

		if (!defined $info{'quote'}) { $info{'quote'} = ""; }
		if ($info{'quote'} ne "") {
			($msubject, $mname, $memail, $mdate, $musername, $micon, $mip, $mmessage) = split(/\|/, $messages[$info{'quote'}]);
			$form_message = "$mmessage";
			$form_message =~ s/\[quote\]\[b\]$mname $msg{'685'}\[\/b\]\n(\S+?)\[\/quote\]//isg;
			$form_message =~ s/\[(\S+?)\]//isg;
			$form_message = "\n\n\[quote\]\[b\]$mname $msg{'685'}\[\/b\]\n$form_message\[/quote\]";
			$form_message = htmltotext($form_message);
		}

		my $lastpost = $#messages;
		$lastpost++;
		my $strtpg = (int(@messages/$maxmessagedisplay))*$maxmessagedisplay;
		$info{'start'} = $strtpg . "\#" . $lastpost; # to redirect back to last post after reply from any page
	}

	$navbar = "$btn{'014'} $nav{'003'} $btn{'014'} $nav{'036'} ";
	print_top();

	if (!defined $info{'start'}) { $info{'start'} = 0; }
	if (!defined $info{'num'}) { $info{'num'} = 0; }
	if (!defined $form_subject) { $form_subject = ""; }
	if (!defined $form_message) { $form_message = ""; }

	# oneclick doesn't work here
	print qq~<table width="100%" cellspacing="0" cellpadding="1" border="0">
<tr>
<td><form action="$forum&amp;op=post2&amp;start=$info{'start'}"
 method="post" name="creator"><input
 type="hidden" name="followto" value="$info{'num'}">
<table border="0">
<tr>
<td><b>$msg{'013'}</b></td>
<td>$name_field</td>
</tr>
<tr>
<td><b>$msg{'007'}</b></td>
<td>$email_field</td>
</tr>
<tr>
<td><b>$msg{'037'}</b></td>
<td><input type="text" class="textinput" name="subject" value="$form_subject" size="40" maxlength="50"></td>
</tr>
<tr>
<td><b>$msg{'116'}</b></td>
<td><script language="javascript" type="text/javascript">
<!--
function showImage() {
document.images.icons.src="$imagesurl/forum/"+document.creator.icon.options[document.creator.icon.selectedIndex].value+".gif";
}
// -->
</script>
<select name="icon" onChange="showImage()">
<option value="xx">$msg{'143'}</option>
<option value="thumbup">$msg{'144'}</option>
<option value="thumbdown">$msg{'145'}</option>
<option value="exclamation">$msg{'146'}</option>
<option value="question">$msg{'147'}</option>
<option value="lamp">$msg{'148'}</option>
</select>
<img src="$imagesurl/forum/xx.gif" name="icons" width="15"
 height="15" border="0" hspace="15" alt=""></td>
</tr>
<tr>
<td valign=top><b>$msg{'038'}</b></td>
<td>
<script language="javascript" type="text/javascript">
<!--
function addCode(anystr) {
document.creator.message.value+=anystr;
}
function showColor(color) {
document.creator.message.value+="[color="+color+"][/color]";
}
function upload() {
window.open("$pageurl/$cgi?action=uploadpicture","","width=300,height=150,scrollbars")
}
// -->
</script>
<textarea name="message" rows="10" cols="40">$form_message</textarea></td>
</tr>
~;

	if ($username eq "admin" || $forumimgupld eq "1" && $username ne "$anonuser") {
		print qq~<tr>
<td>&nbsp;</td>
<td class="formstextnormal" valign="top"><a
 href="javascript:upload()">$msg{'598'}</a></td>
</tr>
~;
	}

	if ($enable_ubbc eq "1") {
		print qq~<tr>
<td class="formstextnormal" valign="middle">$msg{'156'}</td>
<td><a href="javascript:addCode('[b][/b]')"><img src="$imagesurl/forum/buttons/bold.gif" align="bottom" width="23" height="22" title="$msg{'117'}" alt="$msg{'117'}" border="0"></a>
<a href="javascript:addCode('[i][/i]')"><img src="$imagesurl/forum/buttons/italicize.gif" align="bottom" width="23" height="22" title="$msg{'118'}" alt="$msg{'118'}" border="0"></a>
<a href="javascript:addCode('[u][/u]')"><img src="$imagesurl/forum/buttons/underline.gif" align="bottom" width="23" height="22" title="$msg{'119'}" alt="$msg{'119'}" border="0"></a>
<a href="javascript:addCode('[small][/small]')"><img src="$imagesurl/forum/buttons/small.gif" align="bottom" width="23" height="22" title="$msg{'729'}" alt="$msg{'729'}" border="0"></a>
<a href="javascript:addCode('[big][/big]')"><img src="$imagesurl/forum/buttons/big.gif" align="bottom" width="23" height="22" title="$msg{'730'}" alt="$msg{'730'}" border="0"></a>
<a href="javascript:addCode('[sub][/sub]')"><img src="$imagesurl/forum/buttons/sub.gif" align="bottom" width="23" height="22" title="$msg{'544'}" alt="$msg{'544'}" border="0"></a>
<a href="javascript:addCode('[sup][/sup]')"><img src="$imagesurl/forum/buttons/sup.gif" align="bottom" width="23" height="22" title="$msg{'545'}" alt="$msg{'545'}" border="0"></a>
<a href="javascript:addCode('[strike][/strike]')"><img src="$imagesurl/forum/buttons/strike.gif" align="bottom" width="23" height="22" title="$msg{'546'}" alt="$msg{'546'}" border="0"></a>
<a href="javascript:addCode('[pre][/pre]')"><img src="$imagesurl/forum/buttons/pre.gif" align="bottom" width="23" height="22" title="$msg{'547'}" alt="$msg{'547'}" border="0"></a><br>
<a href="javascript:addCode('[left][/left]')"><img src="$imagesurl/forum/buttons/left.gif" align="bottom" width="23" height="22" title="$msg{'548'}" alt="$msg{'548'}" border="0"></a>
<a href="javascript:addCode('[center][/center]')"><img src="$imagesurl/forum/buttons/center.gif" align="bottom" width="23" height="22" title="$msg{'120'}" alt="$msg{'120'}" border="0"></a>
<a href="javascript:addCode('[right][/right]')"><img src="$imagesurl/forum/buttons/right.gif" align="bottom" width="23" height="22" title="$msg{'549'}" alt="$msg{'549'}" border="0"></a>
<a href="javascript:addCode('[list][*][*][*][/list]')"><img src="$imagesurl/forum/buttons/list.gif" align="bottom" width="23" height="22" title="$msg{'125'}" alt="$msg{'125'}" border="0"></a>
<a href="javascript:addCode('[email][/email]')"><img src="$imagesurl/forum/buttons/email2.gif" align="bottom" width="23" height="22" title="$msg{'122'}" alt="$msg{'122'}" border="0"></a>
<a href="javascript:addCode('[img][/img]')"><img src="$imagesurl/forum/buttons/img.gif" align="bottom" width="23" height="22" title="$msg{'171'}" alt="$msg{'171'}" border="0"></a>
<a href="javascript:addCode('[url][/url]')"><img src="$imagesurl/forum/buttons/url.gif" align="bottom" width="23" height="22" title="$msg{'121'}" alt="$msg{'121'}" border="0"></a>
<a href="javascript:addCode('[quote][/quote]')"><img src="$imagesurl/forum/buttons/quote2.gif" align="bottom" width="23" height="22" title="$msg{'124'}" alt="$msg{'124'}" border="0"></a>
<a href="javascript:addCode('[code][/code]')"><img src="$imagesurl/forum/buttons/code.gif" align="bottom" width="23" height="22" title="$msg{'123'}" alt="$msg{'123'}" border="0"></a></td>
</tr>
<tr>
<td>&nbsp;</td>
<td><select name="color" onChange="showColor(this.options[this.selectedIndex].value)">
<option value="Black" selected>$msg{'127'}</option>
<option value="Red">$msg{'128'}</option>
<option value="Yellow">$msg{'129'}</option>
<option value="Pink">$msg{'130'}</option>
<option value="Green">$msg{'131'}</option>
<option value="Orange">$msg{'132'}</option>
<option value="Purple">$msg{'133'}</option>
<option value="Blue">$msg{'134'}</option>
<option value="Beige">$msg{'135'}</option>
<option value="Brown">$msg{'136'}</option>
<option value="Teal">$msg{'137'}</option>
<option value="Navy">$msg{'138'}</option>
<option value="Maroon">$msg{'139'}</option>
<option value="LimeGreen">$msg{'140'}</option>
</select>
</td>
</tr>
~;
	}

	smilieblock();

	### CAPTCHA ###
	if ($username eq "$anonuser") {
		my @captcha;
		if (open(CAPTCHA, "$datadir/conf/captcha.cfg")) {
			holdr(CAPTCHA);
			chomp(@captcha = <CAPTCHA>);
			close(CAPTCHA);
		}
		my $ablevisual = $captcha[0] || "yes";

		if ($ablevisual eq "yes") {
			require "$sourcedir/captcha.pl"; 
			$Imagehtml = get_image();
			print qq~<tr>
<td align="center" colspan="2">$Imagehtml</td>
</tr>
~; 
		}
	}
	###

	print qq~$notification
<tr>
<td><br><br></td>
<td><input type="submit" class="button" name="moda" value="$btn{'044'}">&nbsp;<input
 type="submit" class="button" value="$btn{'008'}">&nbsp;<input
 type="reset" class="button" value="$btn{'009'}"></td>
</tr>
~;

	show_legend();

	print qq~</table>
</form>
</td>
</tr>
~;

	print qq~</table>
~;

	if (@messages) {
		print qq~<b>$msg{'141'}</b><br>
<table width="100%" cellpadding="0" cellspacing="0" border="0" class="boardtitle">
<tr>
<td>
<table width="100%" cellpadding="2" cellspacing="1" border="0" class="tableback">
~;

		foreach $line (@messages) {
			(undef, $tempname, undef, $tempdate, undef, undef, undef, $temppost) = split(/\|/, $line);
			$message = "$temppost";

			$message = censor_it($message);

			if ($enable_ubbc) { doubbc(); }
			if ($enable_smile) { dosmilies(); }

			print qq~<tr>
<td class="forumwindow3">$msg{'047'} $tempname ($tempdate)</td>
</tr>
<tr>
<td class="forumwindow2">$message</td>
</tr>
~;
		}
		print qq~</table></td>
</tr>
</table>
<br>~;

	} else {
		print "<!--no summary-->";
	}

	print_bottom();
	exit;

}

###########
sub post2 {
###########

	if ($username eq "$anonuser" && $enable_guestposting == 0) { error("noguests"); }

	if ($input{'moda'}) {
		if ($input{'moda'} eq "$btn{'011'}")  { print "Location: $cgi\?action=forum\&board=$currentboard\n\n"; }
		elsif ($input{'moda'} eq "$btn{'044'}") {

# Put the preview code here....
#######################################################################################

			$navbar = "$btn{'014'} $nav{'159'}";
			print_top();

			error("$err{'013'}") unless($input{'name'});
			error("$err{'005'}") unless($input{'email'});
			error("$err{'014'}") unless($input{'subject'});
			error("$err{'015'}") unless($input{'message'});

			$nsubject = previewstrip($input{'subject'});
			$nmessage = previewstrip($input{'message'});
			$name = htmlescape($input{'name'});
			$email = htmlescape($input{'email'});
			$subject = htmlescape($input{'subject'});
			$message = htmlescape($input{'message'});
			$icon = "$input{'icon'}";

			$sig = "$settings[5]";
			$sig =~ s/\&\&/<br>/g;
			if ($sig ne "") {
				$sig = qq~<br><br><br>
	-----------------<br>
	$sig
	~;
			}
			$message = "$message\n$sig";

			if ($enable_ubbc) { doubbc(); }
			if ($enable_smile) { dosmilies(); }

			if (!defined $info{'start'}) { $info{'start'} = ""; }
			if (!defined $info{'num'}) { $info{'num'} = ""; }
			if (!defined $input{'security_key'}) { $input{'security_key'} = ""; }
			if (!defined $input{'date_captcha'}) { $input{'date_captcha'} = ""; }

			print qq~<form action="$forum&amp;op=post2&amp;start=$info{'start'}"
 method="post" name="creator"><input
 type="hidden" name="num" value="$info{'num'}"><input
 type="hidden" name="followto" value="$input{'followto'}"><input
 type="hidden" name="name" value="$input{'name'}"><input
 type="hidden" name="email" value="$input{'email'}"><input
 type="hidden" name="subject" value="$nsubject"><input
 type="hidden" name="message" value="$nmessage"><input
 type="hidden" name="icon" value="$input{'icon'}"><input
 type="hidden" name="security_key" value="$input{'security_key'}"><input
 type="hidden" name="date_captcha" value="$input{'date_captcha'}">
<table width="100%" class="forumtitlebackcolor" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<table width="100%" border="0" cellspacing="1" cellpadding="2">
<tr>
<td class="boardtitle"><img src="$imagesurl/forum/thread.gif"
 alt="$msg{'490'}">&nbsp; <b>$msg{'049'}</b></td>
<td class="boardtitle"><b>$msg{'064'} $subject</b></td>
</tr>
~;

			if ($username ne "$anonuser") {
				print qq~<tr>
<td class="forumwindow2" width="140" valign="top"><b>$name</b><br>
~;

				if ($settings[9] eq "") { $settings[9] = "_nopic.gif"; }
				if ($settings[9] =~ /^http:\/\// ) {
					if ($memberpic_width ne 0) { $tmp_width = qq~width="$memberpic_width"~; }
					else { $tmp_width = ""; }
					if ($memberpic_height ne 0) { $tmp_height = qq~height="$memberpic_height"~; }
					else { $tmp_height = ""; }
					$memberpic = qq~<img src="$settings[9]" $tmp_width $tmp_height border="0" alt="$name"></a>~;
				} else {
					$memberpic = qq~<img src="$imagesurl/avatars/$settings[9]" border="0" alt=""></a>~;
				}

				display_date($date); $messagedate = $user_display_date;
				($joindate, undef) = split(/-/,$settings[10]);
				print qq~$memberpic<br><br>
<span class="textsmall">$userrank<br>
$msg{'688'}&nbsp;$joindate<br>
$msg{'021'}&nbsp;$settings[6]<br></span></td>
<td class="forumwindow2" valign="top">
<table border="0" cellspacing="0" cellpadding="0" width="100%">
<tr>
<td><img src="$imagesurl/forum/$icon.gif" alt="$msg{'517'}"></td>
<td width="100%">&nbsp;<b>$subject</b></td>
<td align="right" nowrap>&nbsp;<b>$msg{'110'}</b> $messagedate</td>
</tr>
</table>
<hr noshade="noshade" size="1">
$message<br>
</td>
</tr>
<tr class="forumwindow2">
<td><img src="$imagesurl/forum/ip.gif" alt="$msg{'111'}" align="top">$ENV{'REMOTE_ADDR'}</td>
<td>
<table border="0" cellspacing="0" cellpadding="0" width="100%" maxwidth="80">
<tr>
<td><a href="$settings[4]" target="_blank"><img src="$imagesurl/forum/www.gif" alt="$msg{'053'} $name" border="0"></a>&nbsp;&nbsp;<a href="$pageurl/$cgi?action=anonemail&sendto=$username" class="forumnav"><img src="$imagesurl/forum/email.gif" alt="$msg{'055'} $name" border="0"></a>&nbsp;&nbsp;<a href="$pageurl/$cgi?action=viewprofile&amp;username=$username"><img src="$imagesurl/forum/profile.gif" alt="$msg{'051'} $name" border="0"></a>&nbsp;&nbsp;<a href="$pageurl/$cgi?action=imsend&amp;to=$username"><img src="$imagesurl/forum/message.gif" alt="$msg{'109'} $name" border="0"></a></td>
<td align="right"><td>
</tr>
</table>
</td>
</tr>
<tr class="forumwindow2">
<td align="center" colspan="2">
<input type="button" class="button" value="$btn{'030'}" onClick="history.back()"><!-- edit -->
<input type="submit" class="button" value="$btn{'043'}"><!-- Post Message -->
<input type="submit" class="button" name="moda" value="$btn{'011'}"><!-- Delete --></td>
</tr>
~;
			} else {

				print qq~<tr>
<td class="forumwindow2" width="140" valign="top"><b>$name</b><br>
<br>
<br><br><br>
</td>
<td class="forumwindow2" valign="top">
<table border="0" cellspacing="0" cellpadding="0" width="100%">
<tr>
<td><img src="$imagesurl/forum/$icon.gif" alt="$msg{'517'}"></td>
<td width="100%">&nbsp;<b>$subject</b></td>
<td align="right" nowrap>&nbsp;<b>$msg{'110'}</b> $date</td>
</tr>
</table>
<hr noshade="noshade" size="1">
$message
<br><br><br>
</td>
</tr>
<tr class="forumwindow2">
<td><img src="$imagesurl/forum/ip.gif" alt="$msg{'111'}" align="top">$ENV{'REMOTE_ADDR'}</td>
<td>&nbsp;</td>
</tr>
<tr class="forumwindow2">
<td align="center" colspan="2">
<INPUT type="button" class="button" value="$btn{'030'}" onClick="history.back()">
<input type="submit" class="button" value="$btn{'043'}">
<input type="submit" class="button" name="moda" value="$btn{'011'}"></td>
</tr>
~;

			}

			print qq~</table></td></tr></table></form>~;

			print_bottom();
			exit;
		}
	}
#########################################################################################

	else {

		### CAPTCHA ###
		if ($username eq "$anonuser") {
			my @captcha;
			if (open(CAPTCHA, "$datadir/conf/captcha.cfg")) {
				holdr(CAPTCHA);
				chomp(@captcha = <CAPTCHA>);
				close(CAPTCHA);
			}
			my $ablevisual = $captcha[0] || "yes";

			if ($ablevisual eq "yes") {
				require "$sourcedir/captcha.pl"; 
				my $secret_images = get_image(1, $input{'security_key'}, $input{'date_captcha'}); 
				if (!$secret_images) { error("$cha{'001'}"); }
			}
		}
		###

		logpost();

		if ($username ne $anonuser) {
			error("$err{'003'}") unless($input{'name'});
			error("$err{'005'}") unless($input{'email'});
		}

		error("$err{'014'}") unless($input{'subject'});
		error("$err{'015'}") unless($input{'message'});

		if ($username eq $anonuser && $enable_guestposting == 1) {
			error("$err{'005'}") unless($input{'email'});
			error("$err{'003'}") unless($input{'name'});
		}


		$name = htmlescape($input{'name'});
		$email = htmlescape($input{'email'});
		$subject = htmlescape($input{'subject'});
		$message = htmlescape($input{'message'});
		$icon = "$input{'icon'}";

		if ($username ne "$anonuser") {
			$name = "$settings[1]";
			$email = "$settings[2]";
		} else {
			open(FILE, "$memberdir/memberlist.dat");
			hold(FILE);
			chomp(@memberlist = <FILE>);
			release(FILE);
			close(FILE);

			if (exists $memberlist{$name}) { error("$err{'007'}"); }
			for ($a = 0; $a < @memberlist; $a++) {
				open(FILE, "$memberdir/$memberlist[$a].dat");
				hold(FILE);
				chomp(@check_settings = <FILE>);
				release(FILE);
				close(FILE);

				if ($check_settings[1] eq $name) { error("$err{'007'}"); }
			}
		}
		if (length($subject) > 50) { $subject = substr($subject,0,50); }
		if ($input{'followto'} eq "") {
			opendir (DIR, "$messagedir");
			@files = readdir(DIR);
			closedir (DIR);
			@files = grep(/txt/,@files);
			for ($c = 0; $c < @files; $c++) {
				$files[$c] =~ s/\.txt//;
			}
			@files = reverse(sort { $a <=> $b } @files);
			$postnum = $files[0];
			$postnum++;
		}

      if ($currentboard =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "$msg{'630'}"; print_bottom(); exit; }

		my @messages = read_database("$boardsdir/$currentboard.txt");
			
		# anton's forum overload bug fix:
		$followto = $input{'followto'};

		if (!$followto) {
			unshift @messages, "$postnum|$subject|$name|$username|$email|$date|0|0|$name|$icon\|0\n";
		} else {
			for ($a = 0; $a < @messages; $a++) {
				($mnum, $msub, $mname, $musername, $memail, $mdate, $mreplies, $mviews, $mlpname, $micon, $mstate) = split(/\|/, $messages[$a]);
				if($mnum eq $followto) {
					$mreplies++;
					unshift @messages, "$mnum|$msub|$mname|$musername|$memail|$date|$mreplies|$mviews|$name|$micon|$mstate";
					splice @messages, $a+1, 1;
					last;
				}
			}
		}

		open (FILE, ">$boardsdir/$currentboard.txt") || &error("$err{'016'} $boardsdir/$currentboard.txt");
		&hold(FILE);
		print FILE @messages;
		&release(FILE);
		close(FILE);
		# end anton's forum overload bug fix

		if ($input{'followto'} ne "") {
			$thread = "$followto";
			open(FILE, ">>$messagedir/$followto.txt") || error("$err{'016'} $messagedir/$followto.txt");
		}
		else {
			$thread = "$postnum";
			open(FILE, ">$messagedir/$postnum.txt") || error("$err{'016'} $messagedir/$postnum.txt");
		}
		hold(FILE);
		print FILE "$subject|$name|$email|$date|$username|$icon|$ENV{REMOTE_ADDR}|$message\n";
		release(FILE);
		close (FILE);

		if (-e("$messagedir/$thread.mail")) { require "$sourcedir/notify.pl"; notify_users(); }
		$writedate = "$date";
		writelog("$currentboard");

		if ($username ne "$anonuser") {
			$settings[6]++;

			open(FILE, ">$memberdir/$username.dat") || error("$err{'016'} $memberdir/$username.dat");
			hold(FILE);
			for ($i = 0; $i < @settings; $i++) {
					print FILE "$settings[$i]\n";
			}
			release(FILE);
			close(FILE);
		}

		if ($input{'notify'}) {
			print "Location: $cgi\?action=forum\&board=$currentboard\&op=notify2\&thread=$thread\n\n";
		} else {
			print "Location: $cgi\?action=forum\&board=$currentboard\&op=display\&num=$thread\&start=$info{'start'}\n\n";
		}

		exit;
	}

}

#############
sub logpost {
#############

	# Time allowed between posts
	my $tbp = 15;
	my $currenttime = time();

	# Check the log
	open(LOG, "$datadir/forum/postlog.log") || open(LOG, ">$datadir/forum/postlog.log");
	hold(LOG);
	chomp(my @data = <LOG>);
	release(LOG);
	close(LOG);

	foreach my $data(@data) {
		$data =~ s/[\n\r]//g;
		my ($yourip, $loggedtime) = split(/\|/, $data);

		# if your IP is logged then we will check the time it was logged
		if ($ENV{REMOTE_ADDR} eq "$yourip") {
			my $checktime = $currenttime - $loggedtime;

			#if your ip was logged less the $tbp seconds ago cut it out
			if ($checktime < "$tbp") {
				$navbar = "$btn{'014'} $err{'041'} ";
				print_top();

				print qq~$err{'038'} $tbp $err{'040'}...  $err{'041'}...~; # Too many posts in a $tbp second period... Slow down Simba...
				print_bottom();
				exit;
			} else {
				# if your ip was more then $tbp seconds, you maybe messed up, we'll fix it.

				# removing your IP from the log
				open(FILE, ">$datadir/forum/postlog.log");
				hold(FILE);

				foreach $data(@data) {
					$data =~ s/[\n\r]//g;
					my ($yourip, $loggedtime) = split(/\|/, $data);
					if ($ENV{REMOTE_ADDR} ne "$yourip" && $checktime < "$tbp") {
						print FILE "$data\n";
					}
				}
				print FILE "$ENV{REMOTE_ADDR}|$currenttime\n";

				release(FILE);
				close(FILE);
			}
		}
	}
}

if (-e "$user_lib/forum_post.pl") {require "$user_lib/forum_post.pl"}

1; # return true