###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# mmedit.pl                                                                   #
# v0.9.9.3.4                                                                  #
# For Users to Edit Their Menus                                               #
# Based on the WebApp Menu Manager Mod written by Ted Loomos in 2002          #
# Core Code Introduction by: Aron Shiewitz (www.2xlnt.com) for v0.9.9.3       #
# File: Original by: Jos Brown (www.bantychick.com),                          #
# for final integration with WebAPP core code                                 #
# CSS Update by: my2cents (classicchat.net)                                   #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified: 13 Apr 2006 by my2cents                                           #
# Modified: 16 May 2006 by Jos                                                #
###############################################################################
###############################################################################

##############
sub viewmenu {
##############

	if (-e "$langdir/menu/$userlang") {require "$langdir/menu/$userlang";}
	elsif (-e "$langdir/menu/$language") {require "$langdir/menu/$language";}
	else {require "$langdir/menu/english.lng";}

	$navbar = "$btn{'014'} $mmm{'001'}";
	print_top();

	my @menuitems;

	if (-e "$datadir/menuman/$username.dat") {
		@menuitems = chomp_database("$datadir/menuman/$username.dat");
	}

	print qq~<font face="Arial" size="2"><i>$mmm{'023'}: $username</i></font><br>
<table border="1">
<tr>
<td class="titletext">$msg{'354'}</td>
<td class="titletext">$msg{'207'}</td>
<td class="titletext">$mmm{'003'}</td>
</tr>
~;

	foreach my $rec (@menuitems){
		my ($mmid, $url, $title, $access, $target, $icon) = split(/\|/,$rec);

		if ($title =~ m/^\$/) {
			$title = "$title (". (eval "$title") .")"
		}

		print qq~<tr>
<td width="80"><font size="2"><a
 href="$pageurl/$cgi?action=menu&id=$mmid&op=Edit"><img
 src="$imagesurl/menuman/edit.gif" border="0" alt="$btn{'030'}" title="$btn{'030'}"></a>&nbsp;<a
 href="$pageurl/$cgi?action=menu&id=$mmid&op=Up"><img
 src="$imagesurl/menuman/move_up.gif" border="0" alt="$mmm{'005'}" title="$mmm{'005'}"></a>&nbsp;<a
 href="$pageurl/$cgi?action=menu&id=$mmid&op=Down"><img
 src="$imagesurl/menuman/move_down.gif" border="0" alt="$mmm{'006'}" title="$mmm{'006'}"></a>&nbsp;<a
 href="$pageurl/$cgi?action=menu&id=$mmid&op=Delete"><img
 src="$imagesurl/menuman/delete.gif" border="0" alt="$btn{'011'}" title="$btn{'011'}"></a></font></td>
<td><font size="2">$title</font></td>
<td><font size="2">$url</font></td>
</tr>
~;
	}

	print qq~</table>
<p><font face="Arial" size="2"><a
 href="$pageurl/$cgi?action=menu&op=Add">$mmm{'007'}</a></font></p>
		
~;

	print_bottom();
	exit;

}

##################
sub editmenuitem {
##################

	if (-e "$langdir/menu/$userlang") {require "$langdir/menu/$userlang";}
	elsif (-e "$langdir/menu/$language") {require "$langdir/menu/$language";}
	else {require "$langdir/menu/english.lng";}

	my (@menuitems, $mmid, $url, $title, $access, $target, $icon);

	my $actionphrase = '';
	if ($op eq "Edit") {
		$actionphrase = $mmm{'008'};
		@menuitems = chomp_database("$datadir/menuman/$username.dat");

		MENUITEM: foreach $rec (@menuitems){
			($mmid, $url, $title, $access, $target, $icon) = split(/\|/,$rec);
			if ($mmid == $info{id}) {
				last MENUITEM;
			}
		}
	} else {
		$actionphrase = $mmm{'007'};
		$mmid = "";
		$url = "";
		$title = "";
		$target = "";
		$icon = "\$themesurl/\$usertheme/images/dot.gif";
	}

	$navbar = "$btn{'014'} <a href=\"$pageurl/$cgi?action=menu\">$mmm{'001'}</a> $btn{'014'} $actionphrase";
	print_top();

	my $targetSelections = "<option value=''>$mmm{'016'}</option>";
	if ($target eq "_blank") {$sel="selected"} else {$sel=""}
	$targetSelections .= "<option value='_blank' $sel>$mmm{'017'}</option>";

	print qq~<table cellspacing="0" cellpadding="3" border="0">
<tr>
<td valign=top width="100%"><font face="Arial"><i>$actionphrase</i><br></font>
<form action="$pageurl/$cgi?action=menu&op=EditSave" method=POST>
<input type="hidden" name="todo" value="$op">
<input type="hidden" name="id" value="$mmid">
~;

	if ($userrank ne $root) {
		print qq~<input type="hidden" name="icon" value="$icon">
~;
	}

	print qq~<table border="1">
<tr>
<td><font size="2">$msg{'207'}</font></td>
<td><input type="text" class="textinput" name="title" value="$title" size="20"></td>
~;

	if ($userrank eq $root) {
		print qq~<td><font size="2">$mmm{'009'}</font></td>
~;
	}

	print qq~</tr>
<tr>
<td><font size="2">$mmm{'003'}</font></td>
<td><input type="text" class="textinput" name="url" value="$url" size="40"></td>
~;

	if ($userrank eq $root) {
		print qq~<td><font size="2">$mmm{'010'}</font></td>
~;
	}

	print qq~</tr>
<tr>
<td><font size="2">$mmm{'012'}</font></td>
<td><select name="target">$targetSelections</select></td>
~;

	if ($userrank eq $root) {
		print qq~<td><font size="2">$mmm{'013'}</font></td>
~;
	}

	print qq~</tr>
~;

	if ($userrank eq $root) {
		print qq~<tr>
<td><font size="2">$mmm{'014'}</font></td>
<td><input type="text" class="textinput" name="icon" value="$icon" size="40"></td>
<td><font size="2">$mmm{'015'}</font></td>
</tr>
~;
	}

	print qq~</table>
<input type=submit value="$actionphrase" class="button">
</form>
</td>
</tr>
</table>
~;

	print_bottom();
	exit;

}

##################
sub savemenuitem {
##################

	if ($input{'todo'}) { $op = $input{'todo'}; }

	my (@menuitems, $mmid);

	if (-e "$datadir/menuman/$username.dat") {
		@menuitems = chomp_database("$datadir/menuman/$username.dat");
	}

	open (MENUFILE,">$datadir/menuman/$username.dat") || error("$err{'016'} $datadir/menuman/$username.dat");
	foreach my $rec (@menuitems) {
		($mmid) = (split(/\|/,$rec))[0];
		if (($op eq "Edit") || ($op eq "Delete")) {
			my $itemtoedit = $input{'id'} || $info{'id'};
			if ($mmid == $itemtoedit) {
				if ($op eq "Edit") {
					print MENUFILE "$mmid|$input{'url'}|$input{'title'}||$input{'target'}|$input{'icon'}\n";
				}
			} else {
				print MENUFILE "$rec\n";
			}
		} else {
			print MENUFILE "$rec\n";
		}
	}
	if ($op eq "Add") {
		$mmid++;
		print MENUFILE "$mmid|$input{url}|$input{title}||$input{target}|$input{icon}\n";
	}
	close (MENUFILE);

	if (($#menuitems == -1) && ($op eq "Add")) {
		chmod 0777, "$datadir/menuman/$username.dat";
	}
	if (($#menuitems == 0) && ($op eq "Delete")) {
		unlink ("$datadir/menuman/$username.dat");
	}

	print "Location: $pageurl/$cgi?action=menu\n\n";

}

#################
sub reordermenu {
#################

	my @menuitems = read_database("$datadir/menuman/$username.dat");

	my ($fid, $ndx, $tondx, $furl, $ftitle, $faccess, $ftarget, $ficon);
	my ($tid, $turl, $ttitle, $taccess, $ttarget, $ticon);

	MENUITEM: for ($ndx=0; $ndx < @menuitems; $ndx++) {
		($fid) = (split(/\|/,$menuitems[$ndx]))[0];
		if ($fid == $info{id}) {
			last MENUITEM;
		}
	}

	my $swap = 0;
	if ($op eq "Up" && $ndx != 0) {
		$tondx = $ndx - 1;
		$swap = 1;

	} elsif ($op eq "Down" && $ndx != $#menuitems) {
		$tondx = $ndx + 1;
		$swap = 1;
	}

	if ($swap) {
		chomp($menuitems[$ndx]);
		chomp($menuitems[$tondx]);
		($fid, $furl, $ftitle, $faccess, $ftarget, $ficon) = split(/\|/,$menuitems[$ndx]);
		($tid, $turl, $ttitle, $taccess, $ttarget, $ticon) = split(/\|/,$menuitems[$tondx]);

		$menuitems[$ndx] = "$fid\|$turl\|$ttitle\|$taccess\|$ttarget\|$ticon\n";
		$menuitems[$tondx] = "$tid\|$furl\|$ftitle\|$faccess\|$ftarget\|$ficon\n";
	}

	open (MENUFILE,">$datadir/menuman/$username.dat") || error("$err{'016'} $datadir/menuman/$username.dat");
	hold(MENUFILE);
	foreach my $rec(@menuitems) {
		print MENUFILE $rec;
	}
	close(MENUFILE);

	print "Location: $pageurl/$cgi?action=menu\n\n";

}

if (-e "$user_lib/mmedit.pl") {require "$user_lib/mmedit.pl"}

1;