###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# notify.pl                                                                   #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified: 25 May 2006 by Jos ("bantychick")                                 #
###############################################################################
###############################################################################

##################
sub notify_users {
##################

	open(FILE, "$messagedir/$thread.mail");
	hold(FILE);
	@mails = <FILE>;
	release(FILE);
	close(FILE);

	foreach $curmail (@mails) {
		$curmail =~ s/[\n\r]//g;
		$notifysubject = "$msg{'683'} $subject";
		$notifymessage = qq~$inf{'016'} $forum&op=display&num=$thread   $xtr{'015'} $forum&op=notify_remove&num=$thread&email=$curmail ~;
		sendemail($curmail, $notifysubject, $notifymessage);
	}

}

############
sub notify {
############

	if ($username eq "$anonuser") { error("$err{'011'}"); }

	if (!defined $boardname) {
		open(FILE, "$boardsdir/$currentboard.dat") || error("$err{'001'} $currentboard.dat");
		hold(FILE);
		chomp(@boardinfo=<FILE>);
		release(FILE);
		close(FILE);

		$boardname = "$boardinfo[0]";
	} # get board name for navbar when using notification checkbox


	$navbar = "$btn{'014'} $nav{'003'} $btn{'014'} $boardname";
	print_top();

	print qq~$msg{'155'}<br>
<b><a href="$pageurl/$cgi?action=forum&amp;board=$currentboard&amp;op=notify2&amp;thread=$info{'thread'}">$nav{'047'}</a> - <a href="$cgi?action=forum&amp;board=$currentboard&amp;op=display&num=$info{'thread'}">$nav{'048'}</a></b>
~;
	print_bottom();
	exit;

}

#############
sub notify2 {
#############

	if ($username eq "$anonuser") { error("$err{'011'}"); }

	if ($info{'thread'} =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

	if ($currentboard =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

	if (open (FILE, "$messagedir/$info{'thread'}.mail")) {
		hold(FILE);
		chomp(@mails = <FILE>);
		release(FILE);
		close(FILE);
	} # if no *.mail yet for the thread

	open (FILE, ">$messagedir/$info{'thread'}.mail") || error("$err{'016'} $thread.mail");
	hold(FILE);
	print FILE "$settings[2]\n";
	foreach $curmail (@mails) {
		if ($settings[2] ne "$curmail") { print FILE "$curmail\n"; }
	}
	release(FILE);
	close(FILE);

	print "Location: $cgi?action=forum\&board=$currentboard\&op=display\&num=$info{'thread'}\n\n";
	exit;

}

###################
sub notify_remove {
###################
	if ($info{'num'} =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

	if ($currentboard =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

	open (FILE, "$messagedir/$info{'num'}.mail");
	hold(FILE);
	chomp(@mails = <FILE>);
	release(FILE);
	close(FILE);

	open (FILE, ">$messagedir/$info{'num'}.mail") || error("$err{'016'} $info{'num'}.mail");
	hold(FILE);

	foreach $curmail (@mails) {
		if($info{'email'} eq "$curmail") { print FILE ""; }
		else { print FILE "$curmail\n"; }
	}
	release(FILE);
	close(FILE);

print "Location: $cgi?action=forum\&board=$currentboard\&op=notify_remove_success\n\n";
	exit;
}

###########################
sub notify_remove_success {
###########################

	print_top();
	$navbar = "$btn{'014'} $nav{'027'}";

	print qq~<br><br>
<center><b>$xtr{'016'}</b></center>
<br><br>
~;

	print_bottom();
	exit;

}

#########################
sub notify_sticky_users {
#########################
	open(FILE, "$messagedir/$thread.mail");
	hold(FILE);
	@mails = <FILE>;
	release(FILE);
	close(FILE);

	foreach $curmail (@mails) {
		$curmail =~ s/[\n\r]//g;
		$notifysubject = "$msg{'683'} $subject";
		$notifymessage = qq~$inf{'016'} $pageurl/$forum$curboard&op=display&num=$thread  To be removed: $pageurl/$forum$curboard&op=notify_remove&num=$thread&email=$curmail ~;
		sendemail($curmail, $notifysubject, $notifymessage);
	}
}

##################
sub notifysticky {
##################
	if ($username eq "$anonuser") { error("$err{'011'}"); }

	$navbar = "$btn{'014'} $nav{'003'} $btn{'014'} $boardname";
	print_top();
	print qq~$msg{'155'}<br>
<b><a href="$cgi?action=forum&amp;board=$currentboard&amp;op=notifysticky2&amp;thread=$info{'thread'}">$nav{'047'}</a> - <a href="$cgi?action=forum&amp;board=$currentboard&amp;op=display&num=$info{'thread'}">$nav{'048'}</a></b>
~;
	print_bottom();
	exit;
}

###################
sub notifysticky2 {
###################

	if ($username eq "$anonuser") { error("$err{'011'}"); }

	if ($info{'thread'} =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

	if ($currentboard =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

	open (FILE, "$messagedir/$info{'thread'}.mail");
	hold(FILE);
	chomp(@mails = <FILE>);
	release(FILE);
	close(FILE);

	open (FILE, ">$messagedir/$info{'thread'}.mail") || error("$err{'016'} $thread.mail");
	hold(FILE);
	print FILE "$settings[2]\n";
	foreach $curmail (@mails) {
		if($settings[2] ne "$curmail") { print FILE "$curmail\n"; }
	}
	release(FILE);
	close(FILE);

	print "Location: $cgi?action=forum\&board=$currentboard\&op=displaysticky\&num=$info{'thread'}\n\n";
	exit;

}

if (-e "$user_lib/notify.pl") {require "$user_lib/notify.pl"}

1; # return true