###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# plugins.pl                                                                  #
# v0.9.9.3.4                                                                  #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified: 25 May 2006 by Jos                                                #
###############################################################################
###############################################################################

###############################################################################
###############################################################################
# About:                                                                      #
# The object of this file is to make the themes upwards compatible.           #
#                                                                             #
# There are Four sections:                                                    #
# left_top_plugins();                                                         #
# left_bottom_plugins();                                                      #
# right_top_plugins();                                                        #
# right_bottom_plugins();                                                     #
#                                                                             #
# This way the programmes can add code here, to add new sections to the themes#
# and not affect the themes themeselves.  Allowing users to keep customized   #
# themes, and keeping us from messing them up.                                #
#                                                                             #
#                                                                             #
# These are currently left blank intentionally...                             #
# Current Date: 07/24/02                                                      #
###############################################################################
###############################################################################

######################
sub left_top_plugins {
######################
# these blocks will be located below the main menu

}

#########################
sub left_bottom_plugins {
#########################
# These blocks will be located above the left blocks

}

#######################
sub right_top_plugins {
#######################
# These blocks are located below the poll

}

##########################
sub right_bottom_plugins {
##########################
# These blocks will be located above the info block

}

if (-e "$user_lib/plugins.pl") {require "$user_lib/plugins.pl"} 

1;