###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# topics.pl            	                                                      #
# v0.9.9.3.4                                                                  #
# Directory Traversal Fix by: Carter                                          #
# Topics Code Optimization for WebAPP v0.9.9.2 by: Anton                      #
# Front Page News as Text File by: Jos Brown (www.bantychick.com)             #
# Admin Edit Article (button on article) by: Jos                              #
# New Articles Subject Fix by: Jos                                            #
# Email Article Upgrade and Verification by: Jos                              #
# Reply Comments (threaded comments) by: Carter                               #
# XSS Security Hole in Comments Patch by: Jos                                 #
# Character Entity Encoding by: Jos                                           #
# CSS Stylesheet compatibility update by: my2cents (classicchat.net)          #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified: 2005 by Jos Brown ("bantychick")                            #
# Modified: Apr, 11 May, 7 Aug 2006 by Jos                                    #
# Modified: 12 June 2006 by my2cents                                          #
###############################################################################
###############################################################################

#############
sub topnews {
#############
# by Jos - to read front page news from a text file
# called from print_top, reads topnews.txt, requires subs_post.pl printnews sub

	$navbar = " ";
	print_top();

	print $welcome;
		
	newsheader();

	@articles = chomp_database("$topicsdir/topnews.txt");

	for ($a = 0; $a < @articles && $a < $maxnews; $a++) {
		($id, $subject, $nick, $poster, $email, $postdate, $message, $curcat, $curcatname, $commentscnt, $morelink) = split(/\|/, $articles[$a]);
				
		display_date($postdate);
		$postdatenew = $user_display_date;
		$postdateold = $postdate;
		read_count($id);

		$postdate = $postdatenew;
		newstop();
		$postdate = $postdateold;

		if ($enable_ubbc) { doubbctopic(); }
		if ($enable_smile) { dosmilies(); }

		$commentscnt =~ s/!!!COMMENT!!!/$msg{'040'}/;
		$commentscnt =~ s/!!!COMMENTS!!!/$msg{'041'}/;
		$morelink =~ s/!!!MORE!!!/$nav{'025'}/;
		$message .= $morelink;

		newsshort();

		print $post;
	}

	print_poll();
	exit;

}

##############
sub postnews {
##############

	if (($username eq $anonuser) || (($enable_userarticles == 0) && ($username ne "admin"))) { error("noguests"); }

	$navbar = "$btn{'014'} $nav{'023'}";
	print_top();

	# oneclick doesn't work here
	print qq~<form action="$pageurl/$cgi?action=postnews2" method="post"
 name="creator">
<table border="0" cellspacing="1">
<tr>
<td class="formstextnormal">$msg{'013'}</td>
<td class="formstext">$realname</td>
</tr>
<tr>
<td class="formstextnormal">$msg{'007'}</td>
<td class="formstext">$realemail</td>
</tr>
<tr>
<td class="formstextnormal">$msg{'034'}</td>
<td><select name="cat">~;

	open(CATS, "<$topicsdir/cats.dat");
	&hold(CATS);
	while(<CATS>){
		chomp;
		my ($name, $id) =split(/\|/);
		print qq~<option value="$id">$name</option>
~;
		}
	&release(CATS);
	close(CATS);

	print qq~</select></td>
</tr>
<tr>
<td class="formstextnormal">$msg{'037'}</td>
<td><input type="text" class="textinput" name="subject" size="40" maxlength="50"></td>
</tr>
<tr>
<td valign="top" class="formstextnormal">$msg{'038'}</td>
<td><script language="javascript" type="text/javascript">
<!--
function addCode(anystr) {
document.creator.message.value+=anystr;
}
function showColor(color) {
document.creator.message.value+="[color="+color+"][/color]";
}
function upload() {
window.open("$pageurl/$cgi?action=uploadpicture","","width=300,height=150,scrollbars")
}
// -->
</script>
<textarea name="message" rows="10" cols="40"></textarea></td>
</tr>
~;

	if ($username eq "admin" || $topicimgupld eq "1" && $username ne "$anonuser") {
		print qq~<tr>
<td>&nbsp;</td>
<td class="formstextnormal" valign="top"><a
 href="javascript:upload()">$msg{'598'}</a></td>
</tr>
~;
	}

	if ($enable_ubbc eq "1") {
		print qq~<tr>
<td class="formstextnormal" valign="top">$msg{'156'}</td>
<td valign="middle"><a href="javascript:addCode('[b][/b]')"><img src="$imagesurl/forum/buttons/bold.gif" align="bottom" width="23" height="22" title="$msg{'117'}" alt="$msg{'117'}" border="0"></a>
<a href="javascript:addCode('[i][/i]')"><img src="$imagesurl/forum/buttons/italicize.gif" align="bottom" width="23" height="22" title="$msg{'118'}" alt="$msg{'118'}" border="0"></a>
<a href="javascript:addCode('[u][/u]')"><img src="$imagesurl/forum/buttons/underline.gif" align="bottom" width="23" height="22" title="$msg{'119'}" alt="$msg{'119'}" border="0"></a>
<a href="javascript:addCode('[small][/small]')"><img src="$imagesurl/forum/buttons/small.gif" align="bottom" width="23" height="22" title="$msg{'729'}" alt="$msg{'729'}" border="0"></a>
<a href="javascript:addCode('[big][/big]')"><img src="$imagesurl/forum/buttons/big.gif" align="bottom" width="23" height="22" title="$msg{'730'}" alt="$msg{'730'}" border="0"></a>
<a href="javascript:addCode('[sub][/sub]')"><img src="$imagesurl/forum/buttons/sub.gif" align="bottom" width="23" height="22" title="$msg{'544'}" alt="$msg{'544'}" border="0"></a>
<a href="javascript:addCode('[sup][/sup]')"><img src="$imagesurl/forum/buttons/sup.gif" align="bottom" width="23" height="22" title="$msg{'545'}" alt="$msg{'545'}" border="0"></a>
<a href="javascript:addCode('[strike][/strike]')"><img src="$imagesurl/forum/buttons/strike.gif" align="bottom" width="23" height="22" title="$msg{'546'}" alt="$msg{'546'}" border="0"></a>
<a href="javascript:addCode('[pre][/pre]')"><img src="$imagesurl/forum/buttons/pre.gif" align="bottom" width="23" height="22" title="$msg{'547'}" alt="$msg{'547'}" border="0"></a><br>
<a href="javascript:addCode('[left][/left]')"><img src="$imagesurl/forum/buttons/left.gif" align="bottom" width="23" height="22" title="$msg{'548'}" alt="$msg{'548'}" border="0"></a>
<a href="javascript:addCode('[center][/center]')"><img src="$imagesurl/forum/buttons/center.gif" align="bottom" width="23" height="22" title="$msg{'120'}" alt="$msg{'120'}" border="0"></a>
<a href="javascript:addCode('[right][/right]')"><img src="$imagesurl/forum/buttons/right.gif" align="bottom" width="23" height="22" title="$msg{'549'}" alt="$msg{'549'}" border="0"></a>
<a href="javascript:addCode('[list][*][*][*][/list]')"><img src="$imagesurl/forum/buttons/list.gif" align="bottom" width="23" height="22" title="$msg{'125'}" alt="$msg{'125'}" border="0"></a>
<a href="javascript:addCode('[email][/email]')"><img src="$imagesurl/forum/buttons/email2.gif" align="bottom" width="23" height="22" title="$msg{'122'}" alt="$msg{'122'}" border="0"></a>
<a href="javascript:addCode('[img][/img]')"><img src="$imagesurl/forum/buttons/img.gif" align="bottom" width="23" height="22" title="$msg{'171'}" alt="$msg{'171'}" border="0"></a>
<a href="javascript:addCode('[url][/url]')"><img src="$imagesurl/forum/buttons/url.gif" align="bottom" width="23" height="22" title="$msg{'121'}" alt="$msg{'121'}" border="0"></a>
<a href="javascript:addCode('[quote][/quote]')"><img src="$imagesurl/forum/buttons/quote2.gif" align="bottom" width="23" height="22" title="$msg{'124'}" alt="$msg{'124'}" border="0"></a>
<a href="javascript:addCode('[code][/code]')"><img src="$imagesurl/forum/buttons/code.gif" align="bottom" width="23" height="22" title="$msg{'123'}" alt="$msg{'123'}" border="0"></a><br>
<select name="color" onChange="showColor(this.options[this.selectedIndex].value)">
<option value="Black" selected>$msg{'127'}</option>
<option value="Red">$msg{'128'}</option>
<option value="Yellow">$msg{'129'}</option>
<option value="Pink">$msg{'130'}</option>
<option value="Green">$msg{'131'}</option>
<option value="Orange">$msg{'132'}</option>
<option value="Purple">$msg{'133'}</option>
<option value="Blue">$msg{'134'}</option>
<option value="Beige">$msg{'135'}</option>
<option value="Brown">$msg{'136'}</option>
<option value="Teal">$msg{'137'}</option>
<option value="Navy">$msg{'138'}</option>
<option value="Maroon">$msg{'139'}</option>
<option value="LimeGreen">$msg{'140'}</option>
</select>
</td>
</tr>
~;
	}

	smilieblock();

	if ($userrank eq "$root") { $approved = "1"; }
	else { $approved = "0"; }

	print qq~<tr>
<td><br><br></td>
<td><input type="hidden" name="approved" value="$approved"><input
 type="submit" class="button" name="moda" value="$btn{'044'}">&nbsp;<input
 type="submit" class="button" value="$btn{'008'}">&nbsp;&nbsp;<input
 type="reset" class="button" value="$btn{'009'}"></td>
</tr>
~;

	topicsshow_legend();

	print qq~</table>
</form>
<br>
~;

	print_bottom();
	exit;

}

###############
sub postnews2 {
###############

	if (($username eq $anonuser) || (($enable_userarticles == 0) && ($username ne "admin"))) { error("noguests"); }
	error("$err{'014'}") unless ($input{'subject'});
	error("$err{'015'}") unless ($input{'message'});

	if ($input{'subject'} =~ /#/) {
		print_top();
		print "\# Signs Are Not Allowed in Subjects...";
		print_bottom();
		exit;
	}

	$input{'cat'} =~ s/\s+$//; # possible fix for space in categories bug

	if ($enable_autopublish eq "") { $enable_autopublish = "0"; }
	if ($enable_autopublish eq "0" && $username ne "admin") { $input{'approved'} = "0"; }
	if ($enable_autopublish eq "1" && $userrank eq "$root") { $input{'approved'} = "1"; }
	if ($username eq "admin") { $input{'approved'} = "1"; }
	if ($username eq $article_imrecip) { $input{'approved'} = "1"; } # admin

	if (!defined $input{'moda'}) { $input{'moda'} = ""; }

	if ($input{'moda'} eq "$btn{'044'}") {

# Put the preview code here....
#######################################################################################
			
		$navbar = "$btn{'014'} $nav{'004'} $btn{'014'} $nav{'155'}";
		print_top();

		$nmessage = previewstrip($input{'message'});
		$message = $input{'message'};
	
		if ($enable_ubbc) { doubbctopic(); }
		if ($enable_smile) { dosmilies(); }
		$message = censor_it($message);

		# oneclick does not work here
		print qq~<form action="$pageurl/$cgi?action=postnews2" method="post"
 name="creator">
<table border="0" cellpadding="3" cellspacing="0" width="100%">
<tr>
<td class="fullnewstitle">$input{'subject'}</td>
</tr>
<tr>
<td class="newstextsmall">$msg{'612'} $date $msg{'042'} $username </td>
</tr>
<tr>
<td>&nbsp;</td>
</tr>
<tr>
<td valign="top"><img src="$imagesurl/topics/$input{'cat'}.gif" border="0"
 align="right" vspace="5" alt="$input{'cat'}"></a> $message</td>
</tr>
<tr>
<td>&nbsp;</td>
</tr>
<tr>
<td align="left" valign="middle">&nbsp;<img src="$imagesurl/print.gif"
 border="0" alt="$msg{'106'} - $input{'subject'}" align="absmiddle">&nbsp;&nbsp;<img
 src="$imagesurl/friend.gif" border="0" alt="$msg{'055'}" align="absmiddle">
&nbsp;&nbsp;&nbsp;$readcount</td>
</tr>
<tr>
<td>&nbsp;</td>
</tr>
<tr>
<td valign="top" align="center"><input
 type="hidden" name="subject" value="$input{'subject'}"><input
 type="hidden" name="message" value="$nmessage"><input
 type="hidden" name="cat" value="$input{'cat'}">
<input type="button" class="button" value="$btn{'030'}" onClick="history.back()"><!-- edit -->
<input type="submit" class="button" value="$btn{'043'}"><!-- Post Message -->
<input type="submit" class="button" name="moda" value="$btn{'011'}"><!-- Delete --></td>
</tr>
</form>
</table>
~;

		print_bottom();

		exit;
	}
#########################################################################################

	elsif ($input{'moda'} eq "$btn{'011'}") {
		print "Location: $pageurl/$cgi\n\n";
	}
	else {
		require "$sourcedir/entities.pl";

		opendir (DIR, "$topicsdir/articles");
		@files = readdir(DIR);
		closedir (DIR);
		@files = grep(/txt/,@files);
		for ($c = 0; $c < @files; $c++) {
			$files[$c] =~ s/\.txt//;
		}
		@files = reverse(sort { $a <=> $b } @files);
		$postnum = $files[0];
		$postnum++;

		chomp($input{'message'});
		chomp($input{'subject'});

		# make entities and waescape - Jos:
		$message = make_entities($input{'message'});
		$message = waescape($message);
		$subject = make_entities($input{'subject'});
		$subject = waescape($subject);

		if ($input{'approved'} eq "1") {
			open (FILE, "$topicsdir/$input{'cat'}.cat");
			hold(FILE);
			@articles = <FILE>;
			release(FILE);
			close (FILE);

			open(FILE, ">$topicsdir/$input{'cat'}.cat");
			hold(FILE);
			print FILE "$postnum|$subject|$realname|$username|$realemail|$date|0\n";
			print FILE @articles;
			release(FILE);
			close(FILE);

			open(FILE, ">$topicsdir/articles/$postnum.txt") || error("$err{'016'} $topicsdir/articles/$postnum.txt");
			hold(FILE);
			print FILE "$subject|$realname|$username|$realemail|$date|$message\n";
			release(FILE);
			close(FILE);
		
			open(CNT, ">$topicsdir/articles/$postnum.cnt");
			hold(CNT);
			print CNT "0";
			release(CNT);
			close(CNT);

			open(FILE, "$memberdir/$username.dat") || error("$err{'010'}");
			hold(FILE);
			chomp(@settings = <FILE>);
			release(FILE);
			close(FILE);

			$settings[11]++;

			open(FILE, ">$memberdir/$username.dat");
			hold(FILE);
			for ($i = 0; $i < @settings; $i++) {
				print FILE "$settings[$i]\n";
			}
			release(FILE);
			close(FILE);
		} else { # if the settings don't permit autopublish of this article
	
			open (FILE, "$topicsdir/newarticles.dat");
			hold(FILE);
			@articles = <FILE>;
			release(FILE);
			close (FILE);

			# new articles subject fix - Jos
			if ($articles[0] !~ /^$/) {
				($num) = (split(/\|/, $articles[0]))[0];
			} else { $num = 0; }
			$num++; 

			open(FILE, ">$topicsdir/newarticles.dat"); 
			hold(FILE);
			print FILE "$num|$input{'cat'}|$subject|$realname|$username|$realemail|$date|$message\n"; 
			print FILE @articles;
			release(FILE);
			close(FILE);

			if ($article_im eq "1") {
				$msgid = time;
				$imsubj = "$msg{'463'} $subject";
				$formatmsg = "$msg{'420'}$realname$msg{'464'} <a href=\"$scripturl/$cgi?action=admin&op=verifynews\" target=\"_blank\">$mnu{'018'}</a>";

				@imessages = read_database("$memberdir/$article_imrecip.msg");

				open (AFILE, ">$memberdir/$article_imrecip.msg") || error("$err{'016'} $memberdir/$article_imrecip.msg");
				hold(AFILE);
				print AFILE "$username|$imsubj|$date|$formatmsg|$msgid\n";
				foreach $curm (@imessages) { print AFILE "$curm"; }
				release(AFILE);
				close(AFILE);
			} 
		}
	}

	&printnews;

	xml();
	success();

}

##############
sub viewnews {
##############

	error("$err{'006'}") unless ($info{'id'}); # Invalid input!
	if ($info{'id'} !~ /^[0-9]+$/) { &data_error; }

	my @catlinks = ();

	open(CATS, "<$topicsdir/cats.dat");
	&hold(CATS);
	while(<CATS>) {
		chomp;
		my ($catlink) = (split(/\|/, $_))[1];
		push(@catlinks, $catlink);
		push(@cats, $_);
	}
	&release(CATS);
	close(CATS); #anton

	CATITEM: foreach $curcat(@catlinks) {

		$curcat =~ s/\s+$//; # possible fix for space in categories bug

		if (-e("$topicsdir/$curcat.cat")) {

			@articles = chomp_database("$topicsdir/$curcat.cat");

			for ($a = 0; $a < @articles; $a++) {

				# reply comments:
				($articleid, $comments) = (split(/\|/, $articles[$a]))[0,6];

				if ($info{'id'} eq $articleid) {
					foreach (@cats) {
						@item = split(/\|/, $_);
						$item[1] =~ s/[\n\r]//g;
						if ($curcat eq "$item[1]") {
							$curcatname = "$item[0]";
							$curcatlink = "$item[1]";
						}
					}
					if ($comments == 1) { $commentscnt = "$comments $msg{'040'}"; }
					else { $commentscnt = "$comments $msg{'041'}"; }
					last CATITEM; # no more parsing after these datas found - Jos
				}
			}
		}
	}

	# opening the datafile and reading for the topic and comments
	@datas = chomp_database("$topicsdir/articles/$info{'id'}.txt");
	$viewid = $info{'id'};
	view_count();
	read_count($viewid);

	$navbar = "$btn{'014'} $nav{'004'} $btn{'014'} $curcatname";
	print_top();

	$numshown = @datas; #anton

	@item = split(/\|/, $datas[0]); #anton

	$message = $item[5];
	# making sure the html and censor is working
	if ($enable_ubbc) { doubbctopic(); }
	if ($enable_smile) { dosmilies(); }
	$message = censor_it($message);
	$item[0] = censor_it($item[0]);

	display_date($item[4]);
	$item[4] = $user_display_date;

	print qq~<table border="0" cellpadding="3" cellspacing="0" width="100%" class="text">
<tr>
<td class="fullnewstitle">$item[0]</td>
</tr>
<tr>
<td class="newstextsmall">$msg{'612'} $item[4] $msg{'042'} ~;

	# If the names left blank.. their an "anonymous coward"
	if ($item[1] eq "") { print qq~$msg{'183'}~; }

	# If the names not blank.. and their a guest... post the name and email
	if ($username ne "$anonuser") {
		if ($item[2] eq "$anonuser") {
			print qq~<a href="mailto:$item[3]" class="smallnewslink">~;
		} else {
			print qq~<a href="$pageurl/$cgi?action=viewprofile&username=$item[2]"
 class="smallnewslink">~;
		}
	}

	print qq~$item[1]~;

	if ($username ne "$anonuser") {
		print qq~</a>~;
	}

	print qq~</td>
</tr>
<tr>
<td>&nbsp;</td>
</tr>
<tr>
<td valign="top" class="newstextnormal"><a
 href="$pageurl/$cgi?action=topics&amp;viewcat=$curcatlink"><img
 src="$imagesurl/topics/$curcatlink.gif" border="0" align="right"
 hspace="5" vspace="5" alt="$curcatname"></a>$message</td>
</tr>
<tr>
<td>&nbsp;</td>
</tr>
<tr>
<td align="left" valign="middle" class="newsfootertable">&nbsp;<a
 href="$pageurl/$cgi?action=printtopic&amp;id=$viewid&amp;curcatname=$curcatname&amp;img=$curcatlink"
 target="_blank"><img src="$imagesurl/print.gif" align="middle" border="0"
 title="$msg{'106'}" alt="$msg{'106'} - $item[0]"></a>&nbsp;&nbsp;~;

	if ($username ne $anonuser) {
		print qq~<a
 href="$pageurl/$cgi?action=emailtopic&amp;id=$viewid&amp;curcatname=$curcatname"><img
 title="$mnu{'041'}" src="$imagesurl/friend.gif" align="middle" border="0"
 alt="$mnu{'041'}"></a>~;

		# admin edit article - Jos
		if ($userrank eq $root) {
			print qq~&nbsp;&nbsp;<a
 href="$scripturl/$cgi?action=admin&amp;op=modifynews2&amp;id=$viewid&amp;cat=$curcatlink"><img
 src="$imagesurl/forum/modify.gif" border="0" title="$help{'013'} - $item[0]" alt="$help{'013'} - $item[0]" align="middle"></a>&nbsp;~;
		}

	} else {
		print qq~<img
 src="$imagesurl/friend.gif" border="0" title="$help{'001'}" alt="$help{'001'}"
 align="middle">~;
	}

	print qq~&nbsp;&nbsp;&nbsp;$readcount</td>
</tr>
<tr>
<td class="newstextsmall" align="center">$msg{'613'} <a
 href="$pageurl/$cgi?action=otherarticles&amp;writer=$item[2]&amp;real=$item[1]"
 class="smallnewslink">$item[1]</a></td>
</tr>
<tr>
<td>&nbsp;</td>
</tr>
<tr>
<td valign="top">&nbsp;&nbsp;$msg{'158'}</td>
</tr>
<tr>
<td class="newstexttitle"><a name="topcomment"></a>&nbsp;$item[0] &#124; $commentscnt ~;

	if ($username eq "$anonuser" && $enable_topicguestposting eq "0") {
		print qq~&#124; <a href="$pageurl/$cgi?action=register"
 class="commentlink">$nav{'011'}</a> ~;
 	} else {
		print qq~&#124; <a href="\#comment" class="commentlink">$btn{'012'}</a>~;
	}

	print qq~</td>
</tr>
</table>
~;

	# if comments
	if ($numshown > 1) {
		print qq~<table border="0" cellpadding="3" cellspacing="0" width="100%" class="text">
<tr>
<td class="newssubtitle" align="center"><br>$msg{'159'}~;

		if ($enable_topicguestposting eq "0" && $username eq "$anonuser") {
			print qq~<br>$msg{'488'}~;
		}
		print qq~</td>
</tr>
<tr>
<td align="right" valign="top">~;

		for ($a = 1; $a < @datas; $a++) {
			@item = split (/\|/, $datas[$a]);
			$item[1] =~ s/[\n\r]//g;

			### make a variable for reply comment for the time since it gets reset ###
			# or does not match if using a different time zone than the server - Jos
			my $commenttime = $item[4];

			display_date($item[4]); $item[4] = $user_display_date;
			$message = $item[5];

			if ($enable_ubbc) { doubbc(); }
			if ($enable_smile) { dosmilies(); }

			$message = censor_it($message);
			$item[0] = censor_it($item[0]);

			if (@item == 0) {
				print qq~&nbsp;~;
			} else {

				# setting the number of ul's and setting the br's
				if (($a > 1) && $item[6]) { # the first comment that could be a reply to comment - Jos
# SAVE for future use:
#					for ($ul = 0; $ul < $item[6]; $ul++) {
#						print qq~<ul>~;
#					}
#					$yestobr = 1; # for the next one
					$width = 100 - $item[6] * 4 . "\%";
				} else {
# SAVE for future use:
#					if (!$yestobr) {
#						print "<br>";
#					}
#					$yestobr = 0;
					$width = "100\%";
				}

				print qq~<br clear="all">
<table width="$width" cellpadding="3" cellspacing="0"
 border="0" class="commentbackcolor">
<tr>
<td align="left" class="commenttitleback">&nbsp;$item[0]</td>
</tr>
<tr>
<td align="left" class="commentsubtitleback">&nbsp;$msg{'054'} $item[4] $msg{'042'} ~;

				if ($item[1] eq "" ) { print qq~$msg{'183'}~; }

				if ($username ne "$anonuser") {
					if ($item[1] ne "" && $item[2] eq "$anonuser") {
						print qq~<a href="mailto:$item[3]" class="smallnewslink">~;
					}

					if ($item[1] ne "" && $item[2] ne "$anonuser") {
						print qq~<a href="$pageurl/$cgi?action=viewprofile&username=$item[2]"
 class="smallnewslink">~;
					}
				}

				print qq~$item[1]~;

				if ($username ne "$anonuser") {
					print qq~</a>~;
				}

				# Printing the comment for all to read
				print qq~</td>
</tr>
<tr>
<td align="left" valign="top">$message</td>
</tr>
~;

# NEW CODE SECTION REPLY COMMENTS:

				if ($item[7]) { # if comment has $parentpost

# Parse out the date and time to carry over and make sure we have the correct comment

					$commenttime =~ s/[-\/: ]//g; # set up above

					if ($enable_topicguestposting eq "1" || $username ne "$anonuser") {
						print qq~<tr>
<td> [ <a href="$scripturl/$cgi?action=replycomment&amp;id=$viewid&amp;cat=$curcatlink&amp;parent=$item[7]&amp;ul=$item[6]&amp;tcomment=$commenttime">$msg{'740'}</a> ]</td>
</tr>
~;
					}
					print qq~</table>
~;

# MY CHANGES BELOW -------------------------------------------------------------------
# SAVE for future use:
#					for ($ul = 0; $ul < $item[6]; $ul++) {
#						print qq~</ul>~;
#					}
				}
				else {
					print qq~</table>
~; # table end on comments made before reply comments was introduced
				}
			}
		}
# SAVE for future use:
		# space at bottom if previous comment is not a reply
#		if (!$yestobr) { print "<br>"; } 
		print qq~<br clear="all">~;

		print qq~</td>
</tr>
</table>
~;
	} else {

		print qq~<table border="0" cellpadding="0" cellspacing="2" width="100%" class="commentbackcolor">
<tr>
<td class="newssubtitle" align="center">$msg{'159'}~;

		if ($enable_topicguestposting eq "0" && $username eq "$anonuser") {
			print qq~<br>$msg{'488'}~;
		}
		print qq~</td>
</tr>
<tr>
<td>&nbsp;</td>
</tr>
<tr>
<td valign="top">$msg{'043'}</td>
</tr>
<tr>
<td>&nbsp;</td>
</tr>
</table>
~;
	}

	if ($enable_topicguestposting eq "1" || $enable_topicguestposting eq "" ) {

		print qq~<table align="center">
<tr>
<td align="center" class="newstexttitle">&nbsp;$msg{'044'}</td>
</tr>
<tr>
<td valign="top" width="100%"><form
 action="$scripturl/$cgi?action=commentnews" method="post" onSubmit="oneclick(this)">
<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
<td colspan="2"><a name="comment"></a>&nbsp;</td>
</tr>
~;

		if ($username ne "$anonuser") {
			print qq~<tr>
<td class="formstextnormal">$msg{'013'}</td>
<td class="formstext">$realname<input type="hidden" name="name"
  value="$realname"><input type="hidden" name="email" value="$realemail"></td>
</tr>
~;
		}

		if ($username eq "$anonuser") {
			print qq~<tr>
<td class="formstextnormal">$msg{'013'}</td>
<td><input type="text" class="textinput" name="name" size="40" maxlength="20" value="$realname"></td>
</tr>
<tr>
<td>&nbsp;</td>
<td>$msg{'180'}</td>
</tr>
<tr>
<td class="formstextnormal">$msg{'007'}</td>
<td><input type="text" class="textinput" name="email" size="40" maxlength="40" value="$realemail"></td>
</tr>
~;
		}

		print qq~<tr>
<td class="formstextnormal">$msg{'037'}&nbsp;&nbsp;</td>
<td><input type="text" class="textinput" name="subject" size="40" maxlength="50"></td>
</tr>
<tr>
<td class="formstextnormal">$msg{'038'}</td>
<td><textarea name="message" rows="10" cols="40"></textarea></td>
</tr>
<tr>
<td>&nbsp;</td>
<td align="center"><input
 type="hidden" value="$info{'id'}" name="id"><input
 type="hidden" value="$curcatlink" name="cat"><input
 type="submit" class="button" value="$btn{'012'}">&nbsp;&nbsp;&nbsp;<input
 type="reset" class="button" value="$btn{'009'}"></td>
</tr>
</table>
</form>
<br></td>
</tr>
</table>
~;

	} else {

		if ($username ne "$anonuser") {

			print qq~<table width="100%"><tr><td align="center"
 class="newstexttitle">&nbsp;$msg{'044'}</td>
</tr>
<tr>
<td valign="top" width="100%" align="center"><form
 action="$scripturl/$cgi?action=commentnews" method="post" onSubmit="oneclick(this)">
<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
<td colspan="2"><a name="comment"></a>&nbsp;</td>
</tr>
<tr>
<td class="formstextnormal">$msg{'013'}</td>
<td class="formstext">$realname<input type="hidden" name="name"
 value="$realname"><input type="hidden" name="email" value="$realemail"></td>
</tr>
<tr>
<td class="formstextnormal">$msg{'037'}&nbsp;&nbsp;</td>
<td><input type="text" class="textinput" name="subject" size="40" maxlength="50"></td>
</tr>
<tr>
<td class="formstextnormal">$msg{'038'}</td>
<td><textarea name="message" rows="10" cols="40"></textarea></td>
</tr>
<tr>
<td>&nbsp;</td>
<td><input type="hidden" value="$info{'id'}" name="id"><input
 type="hidden" value="$curcatlink" name="cat"><input
 type="submit" class="button" value="$btn{'012'}">&nbsp;&nbsp;&nbsp;<input
 type="reset" class="button" value="$btn{'009'}"></td>
</tr>
</table>
</form>
<br></td>
</tr>
</table>
~;
		}
	}

	print qq~<br>
~;

	print_bottom();
	exit;

}

#################
sub commentnews {
#################

	if ($enable_topicguestposting eq "1" || $enable_topicguestposting eq "" ) { }
	else {
		if($username eq "$anonuser") { error("noguests"); }
	}
	error("$err{'014'}") unless ($input{'subject'} && $input{'subject'} !~ /^[\s]+$/); #anton - second part is fix for only a space in subject line
	error("$err{'015'}") unless ($input{'message'} && $input{'message'} !~ /^[\s]+$/); #

	if ($input{'name'}) {
		if ($input{'name'} !~ /^[\w\s\-]+$/) { &error("$err{'006'}"); } # \s to allow for space in real name, \- to allow for dash in username
	} #anton

	$input{'cat'} =~ s/\s+$//; # possible fix for space in categories bug

	@datas = chomp_database("$topicsdir/$input{'cat'}.cat");

	$count = @datas;
	$i = 0;

	# reply comments:
	$uls = 0;
	$parentpost = 0;

	chomp($input{'message'});
	chomp($input{'subject'});

	$subject = htmlescape($input{'subject'});
	$message = htmlescape($input{'message'});

	open(FILE, ">$topicsdir/$input{'cat'}.cat") || error("$err{'016'} $topicsdir/$input{'cat'}.cat");
	hold(FILE);
	while ($i < $count) {
		($id_temp, $subj, $nick, $poster, $email, $postdate, $comments) = split(/\|/, $datas[$i]);

		if ($id_temp eq $input{'id'}) {
			$comments++;
			print FILE "$id_temp|$subj|$nick|$poster|$email|$postdate|$comments\n";
		} else {
			print FILE "$id_temp|$subj|$nick|$poster|$email|$postdate|$comments\n";
		}

		$i++;
	}
	release(FILE);
	close(FILE);

	# This code below will post according to a logged in user or not
	# reply comments:
	@quick = chomp_database("$topicsdir/articles/$input{'id'}.txt");

	($parentpost) = (split(/\|/, $quick[$#quick]))[7];
	
	$parentpost++;

	if ($username ne "$anonuser") {
		open(FILE, ">>$topicsdir/articles/$input{'id'}.txt") || error("$err{'016'} $topicsdir/articles/$input{'id'}.txt");
		hold(FILE);

		# reply comments:
		print FILE "$subject|$realname|$username|$realemail|$date|$message|0|$parentpost\n";

		release(FILE);
		close(FILE);
	}

	if ($username eq "$anonuser") {
		open(FILE, ">>$topicsdir/articles/$input{'id'}.txt") || error("$err{'016'} $topicsdir/articles/$input{'id'}.txt");
		hold(FILE);

		# reply comments:
		print FILE "$subject|$input{'name'}|$username|$input{'email'}|$date|$message|0|$parentpost\n";

		release(FILE);
		close(FILE);
	}

	if ($username ne "$anonuser") {
		open(FILE, "$memberdir/$username.dat") || error("$err{'010'}");
		hold(FILE);
		chomp(@settings = <FILE>);
		release(FILE);
		close(FILE);

		$settings[12]++;

		open(FILE, ">$memberdir/$username.dat");
		hold(FILE);
		for ($i = 0; $i < @settings; $i++) {
			print FILE "$settings[$i]\n";
		}
		release(FILE);
		close(FILE);
	}

	# Send IM to Articles Author and Editor
	open(FILE, "$topicsdir/articles/$input{'id'}.txt") || error("$err{'016'} $topicsdir/articles/$input{'id'}.txt");
	hold(FILE);
	chomp($thecomments = <FILE>);
	release(FILE);
	close(FILE);

	@articledata = split(/\|/, $thecomments);
	$authorssubject = $articledata[0];
	$authorsusername = $articledata[2];

	if ($username eq "$anonuser") {
		$realname = $input{'name'};
	}

	$formatmsg = qq~$realname $msg{'682'} <a href="$scripturl/$cgi?action=viewnews&amp;id=$input{'id'}#topcomment">$authorssubject</a>.~;
	$msgid = time;
	$imsubj = "$msg{'681'}";

	# No Need to IM as Author posting Comment
	if ($username ne $authorsusername) { 
		my @authormessages = read_database("$memberdir/$authorsusername.msg");

		open (BFILE, ">$memberdir/$authorsusername.msg") || error("$err{'016'} $memberdir/$authorsusername.msg");
		hold(BFILE);
		print BFILE "$username|$imsubj|$date|$formatmsg|$msgid\n";
		foreach $curm (@authormessages) { print BFILE "$curm"; }
		release(BFILE);
		close(BFILE);
	}

	# No need to send twice!
	if ($authorsusername ne $article_imrecip) {
		my @editormessages = read_database("$memberdir/$article_imrecip.msg");

		open (AFILE, ">$memberdir/$article_imrecip.msg") || error("$err{'016'} $memberdir/$article_imrecip.msg");
		hold(AFILE);
		print AFILE "$anonuser|$imsubj|$date|$formatmsg|$msgid\n";
		foreach $curm (@editormessages) { print AFILE "$curm"; }
		release(AFILE);
		close(AFILE);
	}

	# Send IM to admin in case articles editor isn't checking their IMs
	# IF author is not admin, author is not articles editor,
	# admin is not articles editor, and isn't admin's own comment
	if (($authorsusername ne "admin")
		&& ($authorsusername ne $article_imrecip) 
		&& ($article_imrecip ne "admin")
		&& ($username ne 'admin')) {

		my @editormessages = read_database("$memberdir/admin.msg");

		open (AFILE, ">$memberdir/admin.msg") || error("$err{'016'} $memberdir/admin.msg");
		hold(AFILE);
		print AFILE "$anonuser|$imsubj|$date|$formatmsg|$msgid\n";
		foreach $curm (@editormessages) { print AFILE "$curm"; }
		release(AFILE);
		close(AFILE);
	}

	&printnews;

	print "Location: $pageurl/$cgi?action=viewnews&id=$input{'id'}\n\n";

}

##################
sub replycomment {
##################

	# Get the parent post information and information from the URL
	$navbar = "$btn{'014'} $nav{'004'} $btn{'014'} $msg{'741'}"; # up here since lower placement causes error 500 on mismatch - Jos
	print_top();

	@quick = chomp_database("$topicsdir/articles/$info{'id'}.txt");

	# Read each comment, and parse it out
	foreach $quickie(@quick[1..$#quick]) { # skip first line, avoid blanks and warnings - Jos
		$quickie =~ s/[\n\r]//g;
		($subj, $nick, $poster, $email, $postdate, $comments, $uls, $parentpost) = split(/\|/, $quickie);
		$mycommenttime = $postdate; # Getting the commenttime
		$mycommenttime =~ s/[-\/: ]//g;

		if (($info{'parent'} eq $parentpost) 
			&& ($info{'ul'} eq "$uls") 
			&& ($info{'tcomment'} eq "$mycommenttime")) {

			# if we allow guest posting then we will allow the replying to comments
			if ($enable_topicguestposting eq "1" || $enable_topicguestposting eq "" ) {
				print qq~<table align="center">
<tr>
<td align="center" class="newstexttitle">&nbsp;$msg{'741'}:</td>
</tr>
<tr>
<td valign="top" width="100%"><form
 action="$scripturl/$cgi?action=replycomment2" method="post" onSubmit="oneclick(this)">
<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
<td colspan="2"><a name="comment"></a>&nbsp;</td>
</tr>
~;

				if ($username ne "$anonuser") {
					print qq~<tr>
<td class="formstextnormal">$msg{'013'}</td>
<td class="formstext">$realname<input type="hidden" name="name"
 value="$realname"><input type="hidden" name="email" value="$realemail"></td>
</tr>
~;
				}

				if ($username eq "$anonuser") {
					print qq~<tr>
<td class="formstextnormal">$msg{'013'}</td>
<td><input type="text" class="textinput" name="name" size="40" maxlength="20" value="$realname"></td>
</tr>
<tr>
<td>&nbsp;</td>
<td>$msg{'180'}</td>
</tr>
<tr>
<td class="formstextnormal">$msg{'007'}</td>
<td><input type="text" class="textinput" name="email" size="40" maxlength="40" value="$realemail"></td>
</tr>
~;
				}

				print qq~<tr>
<td class="formstextnormal">$msg{'037'}&nbsp;&nbsp;</td>
<td><input type="text" class="textinput" name="subject" value="re: $subj" size="40" maxlength="50"></td>
</tr>
<tr>
<td class="formstextnormal">$msg{'038'}</td>
<td><textarea name="message" rows="10" cols="40"></textarea></td>
</tr>
<tr>
<td>&nbsp;</td>
<td align="center"><input
 type="hidden" value="$info{'id'}" name="id"><input
 type="hidden" value="$info{'ul'}" name="ul"><input
 type="hidden" value="$info{'parent'}" name="parent"><input
 type="hidden" value="$info{'tcomment'}" name="tcomment"><input
 type="hidden" value="$info{'cat'}" name="cat"><input
 type="submit" class="button" value="$btn{'012'}">&nbsp;&nbsp;&nbsp;<input
 type="reset" class="button" value="$btn{'009'}"></td>
</tr>
</table>
</form>
<br></td>
</tr>
</table>
~;
			} else {
				if ($username ne "$anonuser") {
					print qq~<table width="100%">
<tr>
<td align="center" class="newstexttitle">&nbsp;$msg{'044'}</td>
</tr>
<tr>
<td valign="top" width="100%" align="center"><form
 action="$scripturl/$cgi?action=replycomment2" method="post" onSubmit="oneclick(this)">
<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
<td colspan="2"><a name="comment"></a>&nbsp;</td>
</tr>
<tr>
<td class="formstextnormal">$msg{'013'}</td>
<td class="formstext">$realname<input type="hidden" name="name"
 value="$realname"><input type="hidden" name="email" value="$realemail"></td>
</tr>
<tr>
<td class="formstextnormal">$msg{'037'}&nbsp;&nbsp;</td>
<td><input type="text" class="textinput" name="subject" value="re: $subj" size="40" maxlength="50"></td>
</tr>
<tr>
<td class="formstextnormal">$msg{'038'}</td>
<td><textarea name="message" rows="10" cols="40"></textarea></td>
</tr>
<tr>
<td>&nbsp;</td>
<td><input type="hidden" value="$info{'id'}" name="id"><input
 type="hidden" value="$info{'ul'}" name="ul"><input
 type="hidden" value="$info{'parent'}" name="parent"><input
 type="hidden" value="$info{'tcomment'}" name="tcomment"><input
 type="hidden" value="$info{'cat'}" name="cat"><input
 type="submit" class="button" value="$btn{'012'}">&nbsp;&nbsp;&nbsp;<input
 type="reset" class="button" value="$btn{'009'}"></td>
</tr>
</table>
</form>
<br></td>
</tr>
</table>
~;
				}
			}
			last; # in case of double entry, was printing double forms
		}
	}

	print_bottom();
	exit;

}

###################
sub replycomment2 {
###################

	if (($username eq "$anonuser") 
		&& ((defined $enable_topicguestposting) && ($enable_topicguestposting ne "1"))) {
		error("noguests");
	}
	error("$err{'014'}") unless ($input{'subject'} && $input{'subject'} !~ /^[\s]+$/);
	error("$err{'015'}") unless ($input{'message'} && $input{'message'} !~ /^[\s]+$/);
	if ($input{'name'}) {
		if ($input{'name'} !~ /^[\w\s\-]+$/) { &error("$err{'006'}"); } 
   }

	$input{'cat'} =~ s/\s+$//; # avoid space or line break after category names

	# Get the parent post information and information from the URL
	# $input{'id'}		TOPIC NUMBER
	# $input{'ul'}		NUMBER OF UL'S TO TAB OVER
	# $input{'parent'}	WHO THE PARENT POST IS
	# $input{'cat'}		CATEGORY WE ARE REPLYING TO
	# $input{'tcomment'}	TIME OF THE COMMENT FOR REPLY VERIFICATION

	@datas = chomp_database("$topicsdir/$input{'cat'}.cat");

	$count = @datas;
	$i = 0;

	chomp($input{'message'});
	chomp($input{'subject'});

	$subject = htmlescape($input{'subject'});
	$message = htmlescape($input{'message'});

	open(FILE, ">$topicsdir/$input{'cat'}.cat") || error("$err{'016'} $topicsdir/$input{'cat'}.cat");
	hold(FILE);
	while ($i < $count) {
		($id_temp, $subj, $nick, $poster, $email, $postdate, $comments) = split(/\|/, $datas[$i]);

		if ($id_temp eq $input{'id'}) {
			$comments++; 
		}
		print FILE "$id_temp|$subj|$nick|$poster|$email|$postdate|$comments\n"; # increments the comments count

		$i++;
	}
	release(FILE);
	close(FILE);

	# reading the txt file and placing the comments
	@quick = chomp_database("$topicsdir/articles/$input{'id'}.txt");

	open(DBFILE, ">$topicsdir/articles/$input{'id'}.txt") || error("$err{'016'} $topicsdir/articles/$input{'id'}.txt");
	hold(DBFILE);

	foreach $quick (@quick) {
		$quick =~ s/[\n\r]//g;
		($subj, $nick, $poster, $email, $postdate, $comments, $uls, $parentpost) = split(/\|/, $quick);

		$timeposted = $postdate;
		$timeposted =~ s/[-\/: ]//g;

		if (!defined $uls) { $uls = ''; }
		if (!defined $parentpost) { $parentpost = ''; }

		if ($input{'parent'} ne $parentpost) {
			print DBFILE "$subj|$nick|$poster|$email|$postdate|$comments|$uls|$parentpost\n";
		}
		if ($input{'parent'} eq $parentpost) { 

			if ($input{'ul'} ne $uls && $input{'tcomment'} ne $timeposted) { print DBFILE "$subj|$nick|$poster|$email|$postdate|$comments|$uls|$parentpost\n"; }
			if ($input{'ul'} eq $uls && $input{'tcomment'} ne $timeposted) { print DBFILE "$subj|$nick|$poster|$email|$postdate|$comments|$uls|$parentpost\n"; }
			if ($input{'ul'} eq $uls && $input{'tcomment'} eq $timeposted) {
				print DBFILE "$subj|$nick|$poster|$email|$postdate|$comments|$uls|$parentpost\n";

				if ($username ne "$anonuser") {
					$uls = $input{'ul'} + 1;
					print DBFILE "$subject|$realname|$username|$realemail|$date|$message|$uls|$input{'parent'}\n";
				}

				if ($username eq "$anonuser") {
					$uls = $input{'ul'} + 1;
					print DBFILE "$subject|$input{'name'}|$username|$input{'email'}|$date|$message|$uls|$input{'parent'}\n";
				}

				if ($username ne "$anonuser") {
					open(FILE, "$memberdir/$username.dat") || error("$err{'010'}");
					hold(FILE);
					chomp(@settings = <FILE>);
					release(FILE);
					close(FILE);

					$settings[12]++;

					open(FILE, ">$memberdir/$username.dat");
					hold(FILE);
					for ($i = 0; $i < @settings; $i++) {
						print FILE "$settings[$i]\n";
					}
					release(FILE);
					close(FILE);
				}
			}
		}
	}

	release(DBFILE);
	close(DBFILE);
	
	&printnews;

	print "Location: $pageurl/$cgi?action=viewnews&id=$input{'id'}\n\n";

}

#############
sub success {
#############
	$navbar = "$btn{'014'} $nav{'004'} $btn{'014'} $nav{'023'} $nav{'027'}";
	print_top();
	print qq~<b>$nav{'027'}</b><br>
	$inf{'009'}
	~;
	print_bottom();
	exit;
}

############
sub topics {
############

	@cats = chomp_database("$topicsdir/cats.dat");

	if (!defined $info{'viewcat'}) { $info{'viewcat'} = ""; }

	# Carter's directory traversal fix
	if ($info{'viewcat'} =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

	if ($info{'viewcat'} eq "") {
		$navbar = "$btn{'014'} $nav{'004'}";
		print_top();

		print qq~<div align="center" class="articlecattitle">$msg{'045'}</div>
<br>
<table border="0" cellpadding="3" cellspacing="0" width="100%">
<tr>
~;

		$count = 0;

		for ($i = 0; $i < @cats; $i++) {
			@item = split (/\|/, $cats[$i]);
			$item[0] =~ s/[\n\r]//g;
			$item[1] =~ s/[\n\r]//g;

			@articles = chomp_database("$topicsdir/$item[1].cat");

			$articlenumber = 0;

			foreach $line (@articles) {
				$line =~ s/[\n\r]//g;
				$articlenumber++;
			}

			if ($articlenumber eq "0") {
				print qq~<td align="center" valign="top" width="33%" class="articlecatnormal"><img
 src="$imagesurl/topics/$item[1].gif" border="0"
 alt="$item[0]"><br>$item[0] ($articlenumber)</td>
~;
			} else {
				print qq~<td align="center" valign="top" width="33%" class="articlecatnormal"><a
 href="$pageurl/$cgi?action=topics&amp;viewcat=$item[1]"><img
 src="$imagesurl/topics/$item[1].gif" border="0"
 alt="$item[0]"></a><br>$item[0] ($articlenumber)</td>
~;
			}

			$count++;
			if (($count == 3) && ($i < $#cats)) {
					print qq~</tr>
<tr>
~;
				$count = 0;
			}
		}

		# fill table with remaining cells where required - Jos
		while (($count > 0) && ($count < 3)) {
			print qq~<td>&nbsp;</td>~;
			$count++;
		}

		print qq~</tr>
</table>
<br>
<table align="center" border="0" cellpadding="3" cellspacing="0">
<tr>
<td align="center"><hr>
~;

		if ($enable_userarticles eq "1" && $username ne "$anonuser") {
			print qq~<a href="$pageurl/$cgi?action=postnews">$nav{'023'}</a></td>
</tr>
~;
		}

		article_search();

		print qq~</table>
~;

		print_bottom();
		exit;
	} else {

   		unless($info{'viewcat'} =~ /^([\w.]+)$/) { error("Are you trying to hack me?"); } # Anton

		for ($i = 0; $i < @cats; $i++) {
			$cats[$i] =~ s/[\n\r]//g;
			@item = split (/\|/, $cats[$i]);
			$item[0] =~ s/[\n\r]//g;
			$item[1] =~ s/[\n\r]//g;
			if ($info{'viewcat'} eq "$item[1]") { $curcatname = "$item[0]"; }
		}

		$navbar = "$btn{'014'} $nav{'004'} $btn{'014'} $curcatname";
		print_top();

		print qq~<div align="center" class="articlecattitle">$msg{'046'} "$curcatname"</div>
<br>
~;

		if (-e("$topicsdir/$info{'viewcat'}.cat")) {

			# Carter's directory traversal fix
			if ($info{'viewcat'} =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

			open (FILE, "<$topicsdir/$info{'viewcat'}.cat");
			hold(FILE);
			chomp(@datas=<FILE>);
			release(FILE);
			close(FILE);

			print qq~<table border="0" cellpadding="1" cellspacing="0" width="100%">~;

			if (!defined $info{'start'}) { $start = 0; }
			else { $start = "$info{'start'}"; }

			$numshown = 0;
			for ($b = $start; $b < @datas; $b++) {
				$numshown++;
				@item = split(/\|/, $datas[$b]);

				if ($numshown > $maxtopics) { $datas[$b] = @datas; }
				if ($numshown <= $maxtopics) {

					if ($item[6] == 1) { $commentscnt = "$item[6] $msg{'040'}"; }
					elsif ($item[6] == -1) { $commentscnt = "0 $msg{'041'}"; }
					else { $commentscnt = "$item[6] $msg{'041'}"; }

					read_count($item[0]);

					open (FILE, "$topicsdir/articles/$item[0].txt");
					hold(FILE);
					chomp($text = <FILE>);
					release(FILE);
					close(FILE);

					@text = split(/\|/, $text);

					$message = htmltotext($text[5]);
					$message = htmlescape($message);
					$message = censor_it($message);
					$item[1] = censor_it($item[1]);
					undosmilies();
					undoubbc();
					display_date($item[5]); $item[5] = $user_display_date;

					if (length($message) > 100) {
						$tmpmessage = substr($message, 0, 100);
						$tmpmessage =~ s/(.*)\s.*/$1/;
						$oneliner = "$tmpmessage...";
					} else {
						$oneliner = $message;
					}

					print qq~<tr>
<td><img src="$imagesurl/search/topic.gif" border="0" alt="" valign="middle">&nbsp;<a
 href="$pageurl/$cgi?action=viewnews&amp;id=$item[0]">$item[1]</a></td>
</tr>
<tr>
<td>$oneliner</td>
</tr>
<tr>
<td>$msg{'047'} $item[2] $msg{'048'} $item[5]</td>
</tr>
<tr>
<td>($commentscnt) $readcount<br>
<br></td>
</tr>
~;
					}
				}
				print qq~<tr>
<td>~;
				if ($numshown >= $maxtopics) {
					print qq~<hr noshade="noshade" size="1">
$msg{'039'} ~;

					$numtopics = @datas;
					$c = 0;
					while (($c*$maxtopics) < $numtopics) {
						$viewc = $c+1;
						$strt = ($c*$maxtopics);

						if ($start == $strt) { print "[$viewc] "; }
						elsif ($strt == 0) { print qq~<a href="$pageurl/$cgi?action=topics&amp;viewcat=$info{'viewcat'}">$viewc</a> ~; }
						else { print qq~<a href="$pageurl/$cgi?action=topics&amp;viewcat=$info{'viewcat'}&amp;start=$strt">$viewc</a> ~; }

						$c++;
					}
				} else {
					if ($numshown < $maxtopics) {
						print qq~<hr noshade="noshade" size="1">
$msg{'039'} ~;

				$numtopics = @datas;
				$c = 0;
				while (($c*$maxtopics) < $numtopics) {
					$viewc = $c+1;
					$strt = ($c*$maxtopics);

					if ($start == $strt) { print "[$viewc] "; }
					elsif ($strt == 0) { print qq~<a href="$pageurl/$cgi?action=topics&amp;viewcat=$info{'viewcat'}">$viewc</a> ~; }
					else { print qq~<a href="$pageurl/$cgi?action=topics&amp;viewcat=$info{'viewcat'}&amp;start=$strt">$viewc</a> ~; }

					$c++;
				}
			}
		}
		print qq~</td>
</tr>
</table>
~;
		}

		print_bottom();
		exit;
	}

}

################
sub printtopic {
################

	if ($info{'id'} =~ /\D/) {
		print_top();
		print "What are you doing Stan?";
		print_bottom();
		exit;
	}

	print "Content-type: text/html\n\n";

	print qq~<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=$charset{'001'}">
<meta http-equiv="Content-Language" content="$charset{'002'}">
<title>$pagename</title>
</head>
<body>
~;

	@datas = chomp_database("$topicsdir/articles/$info{'id'}.txt");

	foreach $line (@datas) { $numshown++; }

	for ($a = 0; $a < 1; $a++) {
		@item = split (/\|/, $datas[$a]);

		$message = $item[5];
		if ($enable_ubbc) { doubbctopic(); }
		if ($enable_smile) { dosmilies(); }
		$message = censor_it($message);
		$item[0] = censor_it($item[0]);
		display_date($item[4]); $item[4] = "$msg{'054'} $user_display_date";
		if ($item[1] eq "") { $item[1] = "$msg{'183'}"; }
	}

	print qq~<table border="0" cellpadding="3" cellspacing="3" width="100%">
<tr>
<td><font face="arial" size="4" color="#003399"><img src="$imagesurl/search/topic.gif" alt="">&nbsp;<b>$item[0]</b></font></td>
</tr>
<tr>
<td><font face="arial" size="-3" color="#000000">$item[4] $msg{'042'} <b>$item[1]</b></td>
</tr>
<tr>
<td valign="top"><img src="$imagesurl/topics/$info{'img'}.gif" border="0"
 align="right" vspace="5" alt="$info{'curcatname'}"><font
 face="arial" size="-1" color="#000000">$message</font></td>
</tr>
~;

	if ($numshown > 1) {
		print qq~<tr>
<td><hr align="left" width="200"><font face="arial" size="3" color="#003399"><b>$msg{'158'}</b></font></td>
</tr>
<tr>
<td>&nbsp;</td>
</tr>
~;

		for ($a = 1; $a < $numshown; $a++) {
			@item = split (/\|/, $datas[$a]);

			$message = $item[5];
			if ($enable_ubbc) { doubbctopic(); }
			if ($enable_smile) { dosmilies(); }
			$message = censor_it($message);
			$item[0] = censor_it($item[0]);
			display_date($item[4]); $item[4] = "$msg{'054'} $user_display_date";
			if ($item[1] eq "") { $item[1] = "$msg{'183'}"; }

			if ($item[5] ne "") {
				print qq~<tr>
<td><font face="arial" size="2" color="#003399"><img
 src="$imagesurl/search/comments.gif" alt="">&nbsp;<b>$item[0]</b></font></td>
</tr>
<tr>
<td><font face="arial" size="-3" color="#000000">$item[4] $msg{'042'} <b>$item[1]</b></td>
</tr>
<tr>
<td valign="top"><font face="arial" size="-1" color="#000000">$message</font></td>
</tr>
~;
				if ($a < ($numshown-1)) {
					print qq~<tr>
<td><hr align="left" width="200"></td>
</tr>
~;
				}
			}
		}
	}

	print qq~<tr>
<td><hr><center><small>$msg{'465'} <b>$pagename</b><br>$msg{'159'}<br></small></center></td>
</tr>
</table>
</body>
</html>
~;

	exit;

}

################
sub emailtopic {
################

	if ((!defined $info{'id'}) || ($info{'id'} =~ /\D/)) { &data_error; }

	if ($username eq "$anonuser") { error("noguests"); }

	@datas = chomp_database("$topicsdir/articles/$info{'id'}.txt");

	my $title = (split(/\|/, $datas[0]))[0];

	$navbar = "$btn{'014'} $mnu{'041'} $btn{'014'} $info{'curcatname'}: $title";
	print_top();
	print qq~<br>
<form action="$pageurl/$cgi?action=emailtopic2&id=$info{'id'}&curcatname=$info{'curcatname'}" method="post">
<table border="0" width="100%" cellpadding="0" cellspacing="0">
<tr>
<td colspan="2" class="formstextnormal" align="center">$msg{'489'}</td>
</tr>
<tr>
<td colspan="2">&nbsp;</td>
</tr>
<tr>
<td width="20%" class="formstextnormal" nowrap>$msg{'182'}</td>
<td width="80%"><input type="text" class="textinput" name="name" value="$realname" size="40"></td>
</tr>
<tr>
<td width="20%" class="formstextnormal" nowrap>From E-Mail:</td>
<td width="80%"><input type="text" class="textinput" name="from" value="$realemail" size="40"></td>
</tr>
<tr>
<td width="20%" class="formstextnormal" nowrap>$msg{'181'}</td>
<td width="80%"><input type="text" class="textinput" name="sendto" size="40"></td>
</tr>
<tr>
<td colspan="2">&nbsp;</td>
</tr>
<tr>
<td colspan="2" align="center"><input
 type="submit" name="sendarticle" value="$btn{'045'}" class="button">&nbsp;<input
 type="submit"name="sendarticle" value="$btn{'046'}" class="button">&nbsp;<input
 type="reset" value="$btn{'009'}" class="button"></td>
</tr>
</table>
</form>
~;

	print_bottom();
	exit;

}

#################
sub emailtopic2 {
#################

	if ((!defined $info{'id'}) || ($info{'id'} =~ /\D/)) { &data_error; }

	if ($username eq "$anonuser")  { error("noguests"); }
	error("$err{'005'}") unless ($input{'sendto'});
	error("$err{'014'}") unless ($input{'from'});

	my @datas = chomp_database("$topicsdir/articles/$info{'id'}.txt");

	my @item = split(/\|/, $datas[0]);

	my $head = "$input{'name'} $msg{'584'} $pagename.\n\n";
	my $foot = "\n\n$msg{'465'} $pagename\n\n$msg{'466'}$input{'name'}.\n\n";
	my $title = " $item[0]";
	my $link = "\n\n$msg{'738'} $pageurl/$cgi?action=viewnews&id=$info{'id'} .";
	
	my ($commentnote, $mailmessage) = ();

	if ($input{'sendarticle'} eq "$btn{'045'}") { # if send whole article
		$message = $item[5];
		$message = censor_it($message);
		$item[0] = censor_it($item[0]);
		doubbc();
		$message = htmltotext($message);
		$message = convert_newsletter($message);

		$commentnote = "\n($msg{'739'} $#datas $msg{'041'}.)";
		$mailmessage = "$head $message $link $commentnote $foot";
	}

	if ($input{'sendarticle'} eq "$btn{'046'}") {
		$mailmessage = "$head $title $link $foot";
	}

	my $mailsubject = $info{'curcatname'} . ":" . $title;
	my $mailto = $input{'sendto'};
	my $mailfrom = $input{'from'};

	sendemail($mailto, $mailsubject, $mailmessage, $mailfrom);

	# record a record and give a verified page that article was sent:
	open(LOG,">>$datadir/sendarticle.log");
	hold(LOG);
  	print LOG "$date|$ENV{'REMOTE_ADDR'}|$input{'name'}|$mailfrom|$info{'id'}|$mailto|$username\n";
 	close(LOG);

	$navbar = "$btn{'014'} $mnu{'041'}"; # E-mail News
	print_top();

	print qq~$msg{'398'}<br>$msg{'320'} $mailto<br>$inf{'014'}~; # Thank you!, Your E-mail has been sent., To:, 

	print_bottom();
	exit;

}

####################
sub topicsshow_legend {
####################

		if ($enable_ubbc eq "1") {

			 if ($username ne "$anonuser") {

			 		open(FILE, "$memberdir/$username.pref") || error("$err{'010'}");
					hold(FILE);
					chomp(@preferences = <FILE>);
					release(FILE);
					close(FILE);

											if ($preferences[7] == 1 || $preferences[7] eq "" ) {topicslegend();
											}
				} else {topicslegend();}
		}

}

##################
sub topicslegend {
##################
# Different than regular sub legend in that sub legend has forum message icons

	print qq~<tr>
<td>&nbsp;</td>
<td valign="top"><br>
<table width="100%" cellpadding="2" cellspacing="0"
 border="0" class="menutable">
<tr>
<td>$msg{'516'}</td>
</tr>
</table>
<table width="100%" align="center" cellpadding="1" cellspacing="0"
 border="0" class="menubordercolor">
<tr>
<td>
<table width="100%" cellpadding="0" cellspacing="3" border="0" class="menubackcolor">
<tr>
<td align="center" colspan="2"><b><u>$msg{'156'}</u></b></td>
</tr>
<tr>
<td valign="top" width="50%">&nbsp;<img src="$imagesurl/forum/buttons/bold.gif" alt="$msg{'117'}" border="0">&nbsp;&nbsp;$msg{'523'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/italicize.gif" alt="$msg{'118'}" border="0">&nbsp;&nbsp;$msg{'524'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/underline.gif" alt="$msg{'119'}" border="0">&nbsp;&nbsp;$msg{'525'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/small.gif" alt="$msg{'729'}" border="0">&nbsp;&nbsp;$msg{'715'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/big.gif" alt="$msg{'730'}" border="0">&nbsp;&nbsp;$msg{'731'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/sub.gif" alt="$msg{'544'}" border="0">&nbsp;&nbsp;$msg{'544'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/sup.gif" alt="$msg{'545'}" border="0">&nbsp;&nbsp;$msg{'545'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/strike.gif" alt="$msg{'546'}" border="0">&nbsp;&nbsp;$msg{'546'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/pre.gif" alt="$msg{'547'}" border="0">&nbsp;&nbsp;$msg{'547'}.</td>
<td valign="top" width="50%">&nbsp;<img src="$imagesurl/forum/buttons/left.gif" alt="$msg{'548'}" border="0">&nbsp;&nbsp;$msg{'548'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/center.gif" alt="$msg{'120'}" border="0">&nbsp;&nbsp;$msg{'526'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/right.gif" alt="$msg{'549'}" border="0">&nbsp;&nbsp;$msg{'549'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/list.gif" alt="$msg{'125'}" border="0">&nbsp;&nbsp;$msg{'532'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/email2.gif" alt="$msg{'122'}" border="0">&nbsp;&nbsp;$msg{'529'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/img.gif" alt="$msg{'171'}" border="0">&nbsp;&nbsp;$msg{'528'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/url.gif" alt="$msg{'121'}" border="0">&nbsp;&nbsp;$msg{'527'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/quote2.gif" alt="$msg{'124'}" border="0">&nbsp;&nbsp;$msg{'531'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/code.gif" alt="$msg{'123'}" border="0">&nbsp;&nbsp;$msg{'530'}.</td>
</tr>
</table></td>
</tr>
</table></td>
</tr>
~;

}

################
sub view_count {
################

	my $viewscount = "0";

	if (open(CNT, "$topicsdir/articles/$viewid.cnt")) {
		hold(CNT);
		$viewscount = <CNT>;
		release(CNT);
		close(CNT);
	}

		$viewscount++;

		open(CNT, ">$topicsdir/articles/$viewid.cnt");
		hold(CNT);
		print CNT "$viewscount";
		release(CNT);
		close(CNT);

}

################
sub read_count {
################

	my ($counter) = @_;

	$readcount = "";
	$viewscount = "0";

	if (open(CNT, "$topicsdir/articles/$counter.cnt")) {
		hold(CNT);
		$viewscount = <CNT>;
		release(CNT);
		close(CNT);
	}

	if ($viewscount eq "") { $readcount = qq~<img src="$imagesurl/forum/new.gif" alt="New">~; }
	if ($viewscount eq "0") { $readcount = qq~<img src="$imagesurl/forum/new.gif" alt="New">~; }
	if ($viewscount eq "1") { $readcount = "($viewscount $nav{'152'})"; }
	if ($viewscount eq "2") { $readcount = "($viewscount $nav{'151'})"; }
	if ($viewscount > "2") { $readcount = "($viewscount $nav{'151'})"; }

}

####################
sub article_search {
####################

	print qq~<tr>
<td><form method="POST" action="$pageurl/$cgi?action=search"><input
 type="hidden" name="action" value="search">
<b>$nav{'039'} $nav{'004'}:</b>&nbsp;&nbsp;<input
 type="text" name="pattern" size="16" class="text">&nbsp;<input
 type="submit" class="button" value="$btn{'001'}"><input
 type="hidden" name="articleson" value="on"><input
 type="hidden" name="forumson" value="off"><input
 type="hidden" name="linkson" value="off"><input
 type="hidden" name="downloadson" value="off"></form><br></td>
</tr>
~;
}

####################
sub other_articles {
####################

	if (!defined $info{'page'}) { $info{'page'} = ""; }
	if (!defined $info{'not'}) { $info{'not'} = ""; }

	if ($info{'page'} eq "") { $pagenum = 1; }  else { $pagenum = $info{'page'}; }
	$numresults = 20;  # Change this # here to specify number of results per page.
	$casesensitive = 1;
	$matchednum = 0;
	@matches = ();
	$pattern = $info{'writer'};
	$ignore = $info{'not'};
	$writername = $info{'real'};

	other_articles2();

	if (@matches) {

		for (0..$#matches) {
			@eachmatch = split(/\|/, $matches[$_]);
			$eachmatch[1] =~ s/\.txt//g;
			for $c (0..$#eachmatch) {
				$eachdata[$_][$c] = $eachmatch[$c];
			}
		}
		@eachdata = sort { $b->[1] <=> $a->[1] } @eachdata;
		for (@eachdata) {
			push (@allmatches, join ("\|", @$_));
		}

		@matches = @allmatches;

		if ($ignore ne "") {
			$othernum = $matchednum-1; $othertext ="$msg{'614'}";
		} else {
			$othernum = $matchednum; $othertext ="$msg{'615'}";
		}
		if ($othernum < 1) { $othernum = 0; }

	}

	$navbar = "$btn{'014'} $othertext $msg{'042'} $writername";
	print_top();
	print qq~<table cellspacing="1" cellpadding="3" border="0" width="100%">
<tr>
<td>$writername $msg{'616'} $othernum $othertext.<br>$msg{'404'} $pagenum</td>
</tr>
<tr><td>&nbsp;</td></tr>
~;

	if (@matches) {

		for ($i = ($pagenum * $numresults) - $numresults ; $i < $pagenum * $numresults && $i < @matches ; $i++) {
			if ($matches[$i] ne "") { # warning Apr 6 2005 - Use of uninitialized value in string ne
				($type) = split (/\|/, $matches[$i]); # no curfle here
				if ($type eq "article") {
					($type, $curfile, $line, $maintitle, $title, $realname, $ausername, $email, $otherdate) = split ( /\|/ , $matches[$i] );
					($id, undef) = split( /\./ , $curfile );

					$text = chomp_datatext("$topicsdir/articles/$id.txt");

					@text = split(/\|/, $text);

					$message = htmltotext($text[5]);
					$message = htmlescape($message);
					undosmilies();
					undoubbc();
					$message = censor_it($message);
					$title = censor_it($title);
					display_date($otherdate); $otherdate = $user_display_date;

					if (length($message) > 100) {
						$tmpmessage = substr($message, 0, 100);
						$tmpmessage =~ s/(.*)\s.*/$1/;
						$oneliner = "$tmpmessage...";
					} else {
						$oneliner = $message;
					}

					if ($id ne $ignore) {
						print qq~<tr>
<td><img src="$imagesurl/search/topic.gif" alt="$nav{'004'}">&nbsp;<a
 href="$scripturl/$cgi?action=viewnews&amp;id=$id">$title</a>
<br>$oneliner<br>$msg{'110'} $otherdate</td>
</tr>
~;
					}
				}
			}
		}

		print qq~<tr>
<td>&nbsp;</td>
</tr>
<tr>
<td><a href="#top">$msg{'406'}</a></td>
</tr>
<tr>
<td>~;

		$numofpages = $matchednum / $numresults;
		if ($numofpages > int ($numofpages)) {
			$numofpages = int ($numofpages) +1;
		} else {
			$numofpages = int ($numofpages);
		}
		if ($numofpages > 1) {
			print qq~<b>$msg{'039'}</b>&nbsp;~;
			for ( $i = 1 ; $i <= $numofpages ; $i++) {
				if ( $i == $pagenum ) {
					print qq~[$i]&nbsp;~ ;
				} else {
					print qq~<a href="$scripturl/$cgi?action=otherarticles&amp;writer=$pattern&amp;real=$writername&amp;not=$ignore&amp;page=$i">$i</a>&nbsp~;
				}
			}
		}
	}

	print qq~</td>
</tr>
</table>
~;

	print_bottom();
	exit;

}

#####################
sub other_articles2 {
#####################

	opendir (DIR, "$topicsdir/articles");
	@files = readdir(DIR);
	closedir (DIR);

	@files = grep (/\.txt/, @files);
	foreach $curfile (@files) {

		my $line = 0; #anton
		open (FILE, "<$topicsdir/articles/$curfile");
		&hold(FILE);
		while (<FILE>) {
			$line++;
			# fix for resetting of $realname - Jos:
			my ($title, $arealname, $ausername, $aemail, $adate, $body) = split ( /\|/, $_);
			$maintitle = $title;
			if ($casesensitive == 0) {
				if ($arealname eq $pattern || $ausername eq $pattern) {
					if ($line == 1) {
						$type = "article"; $matchednum++;
					} else {
						$type = "comment";
					}
					$_ = join '|', $type, $curfile, $line, $maintitle, $title, $arealname, $ausername, $aemail, $adate ;
					push @matches, $_;
				}
			} else {
				if (($arealname =~ /^$pattern$/i) || ($ausername =~ /^$pattern$/i)) {
					if ($line == 1) {
						$type = "article"; $matchednum++;
					} else {
						$type = "comment";
					}
					$_ = join '|', $type, $curfile, $line, $maintitle, $title, $arealname, $ausername, $aemail, $adate ;
					push @matches, $_;
				}
			}
		}
		&release(FILE);
		close(FILE);
	}

}

##############
sub undoubbc {
##############

	$message =~ s~\[\[~\{\{~g;
	$message =~ s~\]\]~\}\}~g;
	$message =~ s~\n\[~\[~g;
	$message =~ s~\]\n~\]~g;
	$message =~ s~\<br\>~ ~g;
	$message =~ s~\<pipe\>~ ~g;
	$message =~ s~\[hr\]\n~ ~g;
	$message =~ s~\[hr\]~ ~g;
	$message =~ s~\[b\]~<b>~isg;
	$message =~ s~\[\/b\]~</b>~isg;
	$message =~ s~\[i\]~<i>~isg;
	$message =~ s~\[\/i\]~</i>~isg;
	$message =~ s~\[u\]~<u>~isg;
	$message =~ s~\[\/u\]~</u>~isg;
	$message =~ s~\[img\](.+?)\[\/img\]~Image~isg;
	$message =~ s~\[color=(\S+?)\]~<font color="$1">~isg;
	$message =~ s~\[\/color\]~</font>~isg;
	$message =~ s~\[quote\]<br>(.+?)<br>\[\/quote\]~<b>$1</b>~isg;
	$message =~ s~\[quote\](.+?)\[\/quote\]~<b>$1</b>~isg;
	$message =~ s~\[fixed\]~ ~isg;
	$message =~ s~\[\/fixed\]~ ~isg;
	$message =~ s~\[sup\]~ ~isg;
	$message =~ s~\[\/sup\]~ ~isg;
	$message =~ s~\[strike\]~ ~isg;
	$message =~ s~\[\/strike\]~ ~isg;
	$message =~ s~\[sub\]~ ~isg;
	$message =~ s~\[\/sub\]~ ~isg;
	$message =~ s~\[left\]~ ~isg;
	$message =~ s~\[\/left\]~ ~isg;
	$message =~ s~\[center\]~ ~isg;
	$message =~ s~\[\/center\]~ ~isg;
	$message =~ s~\[right\]~ ~isg;
	$message =~ s~\[\/right\]~ ~isg;
	$message =~ s~\[list\]~ ~isg;
	$message =~ s~\[\*\]~ ~isg;
	$message =~ s~\[\/list\]~ ~isg;
	$message =~ s~\[pre\]~ ~isg;
	$message =~ s~\[\/pre\]~ ~isg;
	$message =~ s~\[small\]~ ~isg;
	$message =~ s~\[\/small\]~ ~isg;
	$message =~ s~\[big\]~ ~isg;
	$message =~ s~\[\/big\]~ ~isg;
	$message =~ s~\[code\](.+?)\[\/code\]~<b>$1</b>~isg;
	$message =~ s~\[email\](.+?)\[\/email\]~<a href="mailto:$1">$1</a>~isg;
	$message =~ s~\[url\]www\.\s*(.+?)\s*\[/url\]~www.$1~isg;
	$message =~ s~\[url=\s*(\w+\://.+?)\](.+?)\s*\[/url\]~$2~isg;
	$message =~ s~\[url=\s*(.+?)\]\s*(.+?)\s*\[/url\]~$2~isg;
	$message =~ s~\[url\]\s*(.+?)\s*\[/url\]~$1~isg;
	$message =~ s~([^\w\"\=\[\]]|[\n\b]|\A)\\*(\w+://[\w\~\.\;\:\,\$\-\+\!\*\?/\=\&\@\#\%]+[\w\~\.\;\:\$\-\+\!\*\?/\=\&\@\#\%])~$1 $2~isg;
	$message =~ s~([^\"\=\[\]/\:\.]|[\n\b]|\A)\\*(www\.[\w\~\.\;\:\,\$\-\+\!\*\?/\=\&\@\#\%]+[\w\~\.\;\:\$\-\+\!\*\?/\=\&\@\#\%])~$1 $2~isg;
	$message =~ s~\{\{~\[~g;
	$message =~ s~\}\}~\]~g;
}

############
sub undosmilies {
############

		$message =~ s~\[bones\]~ox~g;
		$message =~ s~\[bounce\]~I~g;
		$message =~ s~\:-\?~:-?~g;
		$message =~ s~\[confused\]~:-?~g;
		$message =~ s~\Q8\)~Q8~g;
		$message =~ s~\Q8-\)~Q8~g;
		$message =~ s~\[cool\]~Q8~g;
		$message =~ s~\[cry\]~:'-(~g;
		$message =~ s~\:o~:o~g;
		$message =~ s~\:\-o~:-o~g;
		$message =~ s~\[eek\]~:-o~g;
		$message =~ s~\[evil\]~>;->~g;
		$message =~ s~\:\(~:-(~g;
		$message =~ s~\:-\(~(:-(~g;
		$message =~ s~\[frown\]~(:-(~g;
		$message =~ s~\:D~:D~g;
		$message =~ s~\:-D~:-D~g;
		$message =~ s~\[grin\]~:-D~g;
		$message =~ s~\[lol\]~LoL~g;
		$message =~ s~\:x~:x~g;
		$message =~ s~\:-x~:-x~g;
		$message =~ s~\[mad\]~:-x~g;
		$message =~ s~\[ninja\]~(:)-)~g;
		$message =~ s~\[nonsense\]~:-?~g;
		$message =~ s~\[oops\]~8-)~g;
		$message =~ s~\[razz\]~:PP~g;
		$message =~ s~\[rolleyes\]~oo~g;
		$message =~ s~\:\)~:-)~g;
		$message =~ s~\:-\)~:-)~g;
		$message =~ s~\[smile\]~:-)~g;
		$message =~ s~\:P~:P~g;
		$message =~ s~\:-P~:-P~g;
		$message =~ s~\[tongue\]~:P~g;
		$message =~ s~\;-\)~;-)~g;
		$message =~ s~\[wink\]~;-)~g;
		$message =~ s~\[tarzan\]~Tz~g;

}

if (-e "$user_lib/topics.pl") {require "$user_lib/topics.pl"}

1; # return true