###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# whosonline.pl                                                               #
# v0.9.9.3.4                                                                  #
# Brad's "Cool Hack" added by: Abywn and Ditto                                #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified: 23 Nov 2002 by Brad                                         #
# Modified: 10 Dec 2003 by maddog                                             #
# Modified: ??? by Abywn, Ditto                                               #
# Modified: 19 Aug 2004 by john-gr                                            #
# Modified: 2005, 25 May 2006 by Jos                                          #
###############################################################################
###############################################################################

#############
sub readwho {
#############

	if ($username eq "$anonuser") {error('noguests');}

	$navbar = "$btn{'014'} $msg{'263'}";
	print_top();
	print qq~<table width="100%" cellpadding="2" cellspacing="0" border="0" class="forumtitlebackcolor">
<tr>
<td><table width="100%" cellpadding="2" cellspacing="1" border="0">
<tr>
<td align="center" valign="middle"
 class="boardtitle" nowrap>&nbsp;<b>$xtr{'013'}</b>&nbsp;</td>
<td align="center" valign="middle"
 class="boardtitle"  nowrap>&nbsp;<b>$msg{'013'}</b>&nbsp;</td>
<td align="center" valign="middle"
 class="boardtitle" nowrap>&nbsp;<b>$nav{'100'}:</b>&nbsp;</td>
<td align="center" valign="middle"
 class="boardtitle" nowrap>&nbsp;<b>$xtr{'014'}</b>&nbsp;</td>
<td align="center" valign="middle"
 class="boardtitle">&nbsp;<b>$msg{'656'}:</b>&nbsp;</td>
</tr>
~;

	if (@entries == 0) {
		print qq~<tr>
<td colspan="5" class="forumwindow1">$msg{'268'}</td>
</tr>
~;
	} else {

		my $guests = 0;
		my $howmany = 0;
		my $class = 2;

		open(LOG, "$datadir/log.dat");
		hold(LOG);
		chomp(my @entries = <LOG>);
		release(LOG);
		close(LOG);

		@entries = (sort { lc($a) cmp lc($b) } @entries);

		foreach $curentry (@entries) {
			($name, $loc) = (split(/\|/, $curentry))[0,2];

			if($loc =~/memberlist/i){$uloc = "Member List"}
			elsif($loc =~/links/i){$uloc = "Links Menu"}
			elsif($loc =~/forum[post]/i){$uloc = "Writing Post"}
			elsif($loc =~/calendar/i){$uloc = "Calendar"}
			elsif($loc =~/poll/i){$uloc = "Viewing Poll"}
			elsif($loc =~/logout/i){$uloc = "Logging Out"}
			elsif($loc =~/who/i){$uloc = "Who's Online"}
			elsif($loc =~/login/i){$uloc = "Logging On"}
			elsif($loc =~/imsend/i){$uloc = "Sending IM"}
			elsif($loc =~/im$/i){$uloc = "Reading IM"}
			elsif($loc =~/postnews/i){$uloc = "Posting News"}
			elsif($loc =~/forum/i){$uloc = "Forums"}
			elsif($loc =~/reply/i){$uloc = "Replying"}
			elsif($loc =~/admin/i){$uloc = "Admin Menu"}
			elsif($loc =~/search/i){$uloc = "Search Menu"}
			elsif($loc =~/viewprof/i){$uloc = "Viewing Profile"}
			elsif($loc =~/editprof/i){$uloc = "Editing Profile"}
			elsif($loc =~/(?<!mods)$cgi\?*$/i){$uloc = "Front Page"}
			else {$uloc = "Other"}

			if ($name =~ /\./) { ++$guests }
			else {
				$howmany++;

				open(FILE, "$memberdir/$name.dat");
				hold(FILE);
				chomp(@memsettings = <FILE>);
				release(FILE);
				close(FILE);

	if (!defined $memsettings[1]) { $memsettings[1] = ""; } # real name
	if (!defined $memsettings[2]) { $memsettings[2] = ""; } # email
	if (!defined $memsettings[4]) { $memsettings[4] = ""; } # website URL
	if (!defined $memsettings[7]) { $memsettings[7] = ""; } # rank - set to $userrank in loaduser sub
	if (!defined $memsettings[8]) { $memsettings[8] = ""; } # icq
	if (!defined $memsettings[9]) { $memsettings[9] = ""; } # avatar
	if (!defined $memsettings[16]) { $memsettings[16] = ""; } # about
	if (!defined $memsettings[18]) { $memsettings[18] = ""; } # favorite activities
	# the last line printed for a new member is $memsettings[21]

	$#memsettings = 26; # set length so presets will stick

	if (!defined $memsettings[23]) { $memsettings[23] = ""; } # aim
	if (!defined $memsettings[24]) { $memsettings[24] = ""; } # yahoo

				$email = "";
				$url = "";
				$icq = "";
				$aol = "";
				$yim = "";

				$memshort = $memsettings[1];
				$mememail = $memsettings[2];
            if ($memsettings[9] eq "") { $memavatar = "$imagesurl/forum/Anonymous.gif"; }
            elsif ($memsettings[9] !~ /^http:\/\//) { $memavatar = "$imagesurl/avatars/$memsettings[9]"; }
				else { $memavatar = $memsettings[9]; } # Ditto and jos

     			$namelink = qq~<a href="$pageurl/$cgi?action=viewprofile&username=$name"><img
 src="$memavatar" height="40" border="0" alt="$msg{'051'} $memshort"></a>~;

            if ($hidemail eq "1" || $hidemail eq "") {
					$email = qq~<a href="$pageurl/$cgi?action=anonemail&sendto=$name"><img
 src="$imagesurl/forum/email.gif" alt="$msg{'055'} $memshort" border="0"></a>~;
				} else {
					$email = qq~<a href="mailto:$mememail"><img
 src="$imagesurl/forum/email.gif" alt="$msg{'055'} $memshort" border="0"></a>~;
				}
				$memweb = $memsettings[4];
				if ($memweb ne "") {
					$url = qq~<a href="$memweb" target="_blank"><img
 src="$imagesurl/forum/www.gif" alt="$msg{'053'} $memshort" border="0"></a>~;
				}
				$memicq = $memsettings[8];
				if ($memicq ne "") {
					$icq = qq~<a href="http://www.icq.com/$micq" target="_blank"><img
 src="http://wwp.icq.com/scripts/online.dll?icq=$memicq&amp;img=5"
 alt="$msg{'052'} $memshort" border="0"></a>~;
				}
				$memabout = $memsettings[16];
				$memrank = $memsettings[7]; # Abwyn
				$memfav = $memsettings[18]; # Ditto

				$memaol = $memsettings[23];
				if ($memaol ne "") {
					$aol = qq~<a
 href="aim:goim?screenname=$memaol&amp;message=Hi.+Are+you+there?" target="_blank"><img
 src="$imagesurl/aimyel_im.gif" alt="$msg{'661'} $memshort" border="0"></a>~;
				}
				$memyahoo = $memsettings[24];
				if ($memyahoo ne "") {
					$yim = qq~<a
 href="http://edit.yahoo.com/config/send_webmesg?.target=$memyahoo&.src=pg"
 target="_top"><img border="0" src="http://opi.yahoo.com/online?u=$memyahoo&m=g&t=1"
 alt="$msg{'662'} $memshort"></a>~;
				}
				$memim = qq~<a
 href="$pageurl/$cgi?action=imsend&amp;to=$name"><img
 src="$imagesurl/forum/message.gif" alt="$msg{'109'} $memshort" border="0"></a>~;

				print qq~<tr>
<td align="center" valign="middle" class="forumwindow$class">&nbsp;<b>$namelink</b>&nbsp;</td>
<td align="center" valign="middle"
 class="forumwindow$class" nowrap>&nbsp;$memshort&nbsp;~;

				if ($memrank) {
					print qq~<br><small>&nbsp;($memrank)&nbsp;</small>~;
				}

				print qq~</td>
<td align="center" valign="middle" class="forumwindow$class" nowrap>&nbsp;$memim $email $url $icq $aol $yim&nbsp;</td>
<td align="center" valign="middle" class="forumwindow$class" nowrap>&nbsp;~;

				if ($userrank eq $root) {
					print qq~<a
  href="$loc">$uloc</a>~;
				} else {
					print qq~$uloc~;
				}

				print qq~&nbsp;</td>
 <td valign="middle" class="forumwindow$class">$memfav</td>
 </tr>
~; # location link made admin-only by Jos on request of Abwyn

				$class = 5-$class; #abwyn, john-gr
			}
		}

		print qq~<tr>
<td colspan="5" class="forumwindow1">$msg{'344'} $guests $msg{'346'} $howmany $msg{'347'}</td>
</tr>
</table>
~;
	}

	print qq~</td>
</tr>
</table>
<br>
~;

	print_bottom();
	exit;

}

if (-e "$user_lib/whosonline.pl") { require "$user_lib/whosonline.pl" }

1; # return true