###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
# **************************************************                          #
# Color Me theme - by Jos Brown                                               #
# **************************************************                          #
# header.pl                                                                   #
# Prints the top, left column, and start for center column of each page.      #
# v0.9.9.3.4                                                                  #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified:                                                                   #
###############################################################################
###############################################################################

print "Content-type: text/html\n\n";

print qq~<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd">
<html> 
<head> 
<meta http-equiv="Content-Type" content="text/html; charset=$charset{'001'}"> 
<meta http-equiv="Content-Language" content="$charset{'002'}">
<title>$pagetitle</title> 
<meta name="description" content="My WebAPP Site.">
<meta name="keywords" content="WebAPP, Web, Automated, Perl, portal system">~;

if ($navbar && ($navbar !~ /\S/)) { # print xml alternate front page only ($navbar is space)
	print qq~<link href="$baseurl/webapp.xml" rel="alternate" type="application/rss+xml" title="$pagetitle">
~;
}

print qq~<link rel="stylesheet" href="$themesurl/$usertheme/style.css" type="text/css"> 
<!--[if IE]>
<style type="text/css">
div {
 zoom:1; /* triggers normal css layout in IE */
}
</style>
<![endif]-->
<meta name="Generator" content="$scriptname $scriptver"> 
<script language="javascript" src="$baseurl/webapp.js" type="text/javascript"></script>
</head> 
<body>
<a id="top"></a>
~; 

### Top of page with logo, and search function ### 

&logo_block;

&top_menu;

print qq~<table width="100%" cellpadding="0" cellspacing="9">
<tr>
<td valign="top" width="150"><div style="width: 150px">~;

&main_menu;

&themelangchooser;

&search_block;

&left_top_plugins;

&mysite_block;

&status_block;

&leftblock_block;

&left_bottom_plugins;

print qq~</div></td>
<td valign="top">~;

&nav_bar; # starts welcome message or page content, ended with newsheader or footer.pl

1; # return true