###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
# **************************************************                          #
# Color Me theme - by Jos Brown                                               #
# **************************************************                          #
# theme.pl                                                                    #
# Sub-Routines                                                                #
# v0.9.9.3.4                                                                  #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified:                                                                   #
###############################################################################
###############################################################################

require "$sourcedir/block.pl";
require "$sourcedir/menuman.pl";
if (-e "$langdir/theme/$userlang") {require "$langdir/theme/$userlang";}
elsif (-e "$langdir/theme/$language") {require "$langdir/theme/$language";}
else {require "$langdir/theme/english.lng";}

#############
sub getvars {
#############

	$titlebg = "#396DA6"; # grid behind admin, instantmessage, and memberlist .pl's
	$windowbg = "#33CCFF"; # articles admin, memberlist and instantmessage header rows
	$windowbg2 = "#fefefe"; # articles admin, memberlist rows
	$windowbg3 = "#ffffff"; # articles admin, memberlist alternate rows

}

################
sub logo_block {
################

	print qq~<div class="myheadertable">
<img align="left"
 src="$themesurl/$usertheme/images/$langgfx/logo.jpg"
 width="258" height="87" alt="$pagetitle">~;

	if ($searchmod eq 1) {
		search_module();
	}

	print qq~</div>
~;

}

###################
sub search_module {
###################

	print qq~<form method="POST" action="$pageurl/$cgi?action=search"><input
 type="hidden" name="action" value="search"><input
 type="hidden" name="articleson" value="on"><input
 type="hidden" name="forumson" value="on"><a
 href="$pageurl/$cgi?action=search&amp;type=advanced&amp;articleson=on&amp;forumson=on">$nav{'154'}</a>&nbsp;<br>
<input
 type="text" name="pattern" size="16" class="textinput"><br><input
 type="submit" class="button" value="$btn{'001'}">&nbsp;</form>
~;

}

##############
sub menu_bar {
##############
# for Menu Manager, this is designed to be the bottom menu

	print qq~<table width="100%" cellpadding="0" cellspacing="0" border="0" class="navbar">
<tr>  
<td height="21"><table width="100%" cellpadding="0" cellspacing="0" border="0">
<tr>
~;
	show_menubar("menubar");

	print qq~</tr>
</table></td>
<td align="right" width="75">&nbsp;<a
 href="#" onClick="this.style.behavior='url(#default#homepage)'; this.setHomePage('$scripturl/$cgi');" onmouseout="self.status=''; return true" onmouseover="self.status='$thm{'003'}'; return true"><img
 src="$themesurl/$usertheme/images/home2.gif"
 border="0" alt="$thm{'001'}" title="$thm{'002'}"></a>&nbsp;&nbsp;<a
 href="javascript:window.external.AddFavorite%20('$scripturl/$cgi','$pagename')" onmouseout="self.status=''; return true" onmouseover="self.status='$thm{'006'}'; return true"><img
 src="$themesurl/$usertheme/images/topicsb.gif"
 border="0" alt="$thm{'004'}" title="$thm{'005'}"></a>&nbsp;&nbsp;<a
 href="#top" onmouseout="self.status=''; return true" onmouseover="self.status='$thm{'009'}'; return true"><img
 src="$themesurl/$usertheme/images/icon_go_up.gif" border="0" alt="$thm{'007'}" title="$thm{'008'}"></a>&nbsp;</td> 
</tr> 
</table>
~;

}

##############
sub top_menu {
##############
# for Menu Manager

	print qq~<table border="0" cellpadding="2" cellspacing="0" width="100%" class="topnavbar">
<tr>
~;

	show_topmenu("topmenu");

	print qq~</tr>
</table>
~;

}

####################
sub checkforbanner {
####################
	
	if ($dispfrad ne "0") {
		banner_disp();
	}

}

#################
sub banner_disp {
#################

	if ($dispfrad eq "1" && $username ne "$anonuser") {
		open(FILE, "$memberdir/$username.pref") || error("$err{'010'}");
		hold(FILE);
		chomp(@preferences = <FILE>);
		release(FILE);
		close(FILE);

		if ($preferences[2] eq "1") {
			show_banner();
		}
	}

	if ($dispfrad eq "2" || $username eq "$anonuser") {
		show_banner();
	}

}

#################
sub show_banner {
#################

	print qq~<center><br><div align="center" class="bannertable">~;

	require "$sourcedir/ads.pl";
	OutputJava(); 
 
	print qq~</div></center>
~;

}

###############
sub boxheader {
###############

	my ($title) = @_;
	print qq~<div class="menutable"><h2>$title</h2></div>
<div class="menubackcolor">
<table align="center" width="130" cellpadding="0" cellspacing="0" border="0">
~;

}

###############
sub boxfooter {
###############

	print qq~</table>
</div>
~;

}

############
sub boxtop {
############

	my ($title) = @_;

	print qq~<div class="menutable"><h2>$title:</h2></div>
<div class="menubackcolor">
~;

}

###############
sub boxbottom {
###############

	print qq~</div>
~;

}

################
sub cboxheader {
################
# boxheader for center blocks

	my ($title) = @_;

	print qq~<div class="menutable"> $title</div>
<div class="menubordercolor">
<div class="menubackcolor">
<div class="newstextnormal">~;

}

################
sub cboxfooter {
################
# boxfooter for center blocks

	print qq~</div>
</div>
</div>
~;

}

##############
sub menuitem {
##############
# for member panel and latest posts
# also used in subs.pl sub check_access for 2 admin links

#	my ($url, $title) = @_;

#	print qq~<li><a
# href="$pageurl/$cgi?action=$url" class="menu">$title</a></li>
#~;

#	my ($url, $title, $target, undef) = @_;
	my ($url, $title, $target, $dummy) = @_;

# get rid of the empty target attributes:
	if ($target) { $target = " target=\"$target\""; }

	if ($url) {
		if ($url !~ /^(https?:\/\/|\/)/i) {
			$url = "$pageurl/$cgi\?action=$url";
		}
	} else {
		$url = "$pageurl/$cgi";
	}

	print qq~<li><a href="$url" class="menu"$target>$title</a></li>
~;

}

###############
sub main_menu {
###############

	boxtop("$nav{'038'}");

	print qq~<div class="cat"><ul>~;

	show_menu("mainmenu");

	print qq~</ul></div>
~;

	&boxbottom;

}

##################
sub search_block {
##################

	if ($searchmod eq "2") {
		boxtop("$nav{'039'}");

		print qq~<div style="text-align: center">
<form method="POST" action="$pageurl/$cgi?action=search">
<input type="hidden" name="action" value="search">
<input type="text" name="pattern" size="16" class="textinput"><br>
<input type="hidden" name="articleson" value="on">
<input type="hidden" name="forumson" value="on">
<input type="hidden" name="linkson" value="on">
<input type="hidden" name="downloadson" value="on">
<input type="submit" class="button" value="$btn{'001'}"><br>
<small><a href="$pageurl/$cgi?action=search&amp;type=advanced&amp;page=0&amp;articleson=on&amp;forumson=off&amp;linkson=off&amp;downloadson=off">$nav{'154'}</a></small>
</form>
</div>
~;
		&boxbottom;
	}

}

##################
sub mysite_block {
##################

	if ($username eq "$anonuser") {
		login_panel();
	} else {
		member_panel();
	}

}

#################
sub login_panel {
#################

	$returnpage1 = $info{'action'} || '';
	$returnpage2 = $info{'board'} || '';
	$returnpage3 = $info{'cat'} || '';
	$returnpage4 = $info{'viewcat'} || '';
	$returnpage5 = $info{'num'} || '';
	$returnpage6 = $info{'id'} || '';

	boxtop("$nav{'012'}");

	print qq~<form method="post" action="$pageurl/$cgi?action=login2"><input
 type="hidden" name="returnpage1" value="$returnpage1"><input
 type="hidden" name="returnpage2" value="$returnpage2"><input
 type="hidden" name="returnpage3" value="$returnpage3"><input
 type="hidden" name="returnpage4" value="$returnpage4"><input
 type="hidden" name="returnpage5" value="$returnpage5"><input
 type="hidden" name="returnpage6" value="$returnpage6"><div
 align="center" class="whocat">$msg{'006'}<br><input
 type="text" name="username" size="8" class="textinput"><br> 
$msg{'009'}<br>
<input type="password" name="passwrd" size="8" class="textinput"><br>
<input type="checkbox" name="rememberme" checked>&nbsp;$msg{'410'}<br> 
<input type="submit" class="button" value="$btn{'017'}"><br>
<a href="$pageurl/$cgi?action=reminder">$nav{'014'}</a><br>
$msg{'340'}<a href="$pageurl/$cgi?action=register" class="menu">$msg{'341'}</a>.
</div></form>
~;
	
	&boxbottom;

}

##################
sub member_panel {
##################

	boxtop("$msg{'587'}");

	print qq~<div class="cat"><ul>~;

	show_menu("memberpanel");

	print "</ul></div>";

	&boxbottom;

	if (-e "$datadir/menuman/$username.dat") {
		if ($username eq "admin") {
			boxtop("$thm{'011'}");
		} else {
			boxtop("$thm{'010'}");
		}

		print qq~<div class="cat"><ul>~;

		show_menu("$username");

		print "</ul></div>";

		&boxbottom;
	}

}

##################
sub status_block {
##################

	boxtop("$nav{'040'}");
	&userstatus;
	&boxbottom;

}

#####################
sub leftblock_block {
#####################

	&block_left;

}

#############
sub nav_bar {
#############

	print qq~<div class="menutable">&nbsp;~;

	if ($navbar && ($navbar =~ /\S/)) {
		require "$sourcedir/breadcrumb.pl"; # ADD THIS
		breadcrumb();                       # ADD THIS

		print qq~</div>
<div class="menubackcolor">
<table align="center" width="95%" cellpadding="0" cellspacing="3" border="0">
<tr>
<td valign="top">~;

	} else {
		print qq~$nav{'002'}</div>
<div class="menubackcolor">~;
	}

}

################
sub newsheader {
################

	if ($navbar && ($navbar =~ /\S/)) {
		print qq~</td>
</tr>
</table>
</div>
~;
	} else {
		print qq~</div>
~;
	}

	&block_top;

}

################
sub front_date {
################

	my ($wholetime) = @_; # ($postdate) for viewnews

	my ($twodate, $posttime) = split(/ - /, $wholetime);
	my ($mm, $dd, $yy) = split(/\//, $twodate);
	my @shortmos = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);

	if (!$user_check_date) { $user_check_date = $check_date; } # $check_date defined in config.pl, config.dat - american or european

	getTimezones();
#	my ($newcnvmonth, $newcnvday, $newcnvyear, $newcnvhour, $newcnvmin, undef) = getNewtime($twodate, $posttime);
	my ($newcnvmonth, $newcnvday, $newcnvyear, $newcnvhour, $newcnvmin, $dummy) = getNewtime($twodate, $posttime);
	$newcnvmonth -= 1;
	$newcnvday =~ s/^0//;
	$newcnvyear += 2000;
	$newcnvhour =~ s/^0//;

	if ($user_check_date eq "american") {
		$frontdate = "$shortmos[$newcnvmonth] $newcnvday $newcnvyear";
	}
	if ($user_check_date eq "european") {
		$frontdate = "$newcnvday $shortmos[$newcnvmonth] $newcnvyear";
	}

	$fronttime = "$newcnvhour:$newcnvmin <small>$displaytimezone</small>";

}

#############
sub newstop {
#############
# replaced $postdate with $frontdate $msg{'580'} $fronttime
# before running this sub, topnews routine sets $postdate for news display
# then back again afterwards

	$postdate = $postdateold;
	front_date($postdate);

	$post = qq~<div class="menutable" style="width: 200px"><h3>$subject</h3></div>
<div class="menubackcolor"><span
 class="newssubtitle"> $curcatname: $frontdate $msg{'580'} $fronttime $msg{'042'} <a
 href="$pageurl/$cgi?action=viewprofile&amp;username=$poster"
 class="smallnewslink">$nick</a><br><br></span>~;

}

###############
sub newsshort {
###############
# before running this sub, topnews routine does doubbc and dosmilies and applies
# variables to the message

	$post = qq~$post
$message<br clear="all">
<div class="newsfootertable">
<span>&nbsp;$readcount &nbsp; <a
 href="$pageurl/$cgi?action=viewnews&amp;id=$id"
 class="newslink" title=" &amp; $msg{'106'} - $subject">Permalink</a></span>
<span class="newsfootertext"> [ <a
 href="$pageurl/$cgi?action=viewnews&amp;id=$id#topcomment"
 class="newslink">$commentscnt</a> ]&nbsp;</span>
</div>
</div>
~;

}

##################
# sub newslong {
##################
# from the old front news method, no longer needed
# }

################
sub poll_block {
################

	if ($pollmod eq "" || $pollmod eq "1") {
		boxtop("$nav{'041'}");

		require "$sourcedir/poll.pl";
		&poll;

		&boxbottom;
	}

}

######################
sub rightblock_block {
######################

	&block_right;

}

####################
sub calendar_block {
####################

	if ($modulecal == 1) {
		boxtop("$msg{'284'}");
		require "$scriptdir/mods/calendar/sidebar.cgi";
		&cal_displaySidebarCal;
		boxbottom();
	}

}

#######################
sub newsletter_block {
#######################

	if ($modulenl eq "1") {
		if (($modulenlmem eq "0") || ($modulenlmem eq "1" && $username ne "$anonuser")) { 
			newsletter_display();
		}
	}
	
}

########################
sub newsletter_display {
########################

	boxtop("$mnu{'038'}");

	print qq~<form action="$pageurl/$cgi?action=subscribe" method="POST">
<div align="center">$msg{'487'}<br>
$msg{'007'}<br>
<input type="text" name="joinnl" value="" size="12" class="textinput"><br>
$msg{'176'}<input type="radio" name="action"
 value="subscribe" checked><br>
$msg{'177'}<input type="radio" name="action" value="remove"><br>
<input type="submit" value="$btn{'016'}" class="button" style="margin: 3px"></div>
</form>
~;

boxbottom();

}

################
sub info_block {
################

	if (($infoblockmod eq "2") || (($infoblockmod eq "1") && ($username eq "$anonuser"))) {
		&info_stuff;
	}
	elsif (($infoblockmod eq "1") && ($username ne "$anonuser")) {
		@preferences = chomp_database("$memberdir/$username.pref");
		if (($preferences[1] == 1) || ($preferences[1] eq "")) {
			&info_stuff;
		}
	}
	
}

################
sub info_stuff {
################

	boxtop("$msg{'486'}");

	print qq~<div align="center"><a href="$link1" target="_blank"><img
 src="$image1" vspace="1" alt="button ad" border="0"></a><br clear="all">
<a href="$link2" target="_blank"><img
 src="$image2" vspace="1" alt="button ad" border="0"></a><br clear="all">
<a href="$link3" target="_blank"><img
 src="$image3" vspace="1" alt="button ad" border="0"></a></div>
~;

	&boxbottom;

}

#####################
sub mycontent_block {
#####################

	if (!$shownumber) {
		$shownumber = 5;
	} else {
		$showcon = 1;
	}

	if ($showcon eq "1") {
		latestforumposts();

# extra pagetable div so IE reads the centering
		print qq~<div class="pagetable"><div class="mycontenttable">
<div class="menutable">$nav{'093'}:</div>
<div class="menubackcolor">~;

		if (@myforumnum) { 
			print qq~<div class="cat"><ul class="whocat">~;

			# redo the time
			# substitute $myforumdata{$myforumnum[$myflcounter]} with $formatline
			my @shortmos = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);

			for ($myflcounter = 0; $myflcounter < @myforumnum && $myflcounter < $shownumber; $myflcounter++) {
				# redo the time
				my $formatline = $myforumdata{$myforumnum[$myflcounter]};
				if (!$user_check_date) { $user_check_date = $check_date; }
				if ($user_check_date eq "european") {
					$formatline =~ s/\((\d\d)\/(\d\d)\/(\d\d $msg{'580'} )(\d\d)(:\d\d:\d\d [a-zA-Z]+)\)/int($1).' '.$shortmos[$2-1].' 20'.$3.int($4).$5/e;
				} else {
					$formatline =~ s/\((\d\d)\/(\d\d)\/(\d\d $msg{'580'} )(\d\d)(:\d\d:\d\d [a-zA-Z]+)\)/$shortmos[$1-1].' '.int($2).' 20'.$3.int($4).$5/e;
				}

				print qq~<li>$formatline</li>
~; 
			}
			print "</ul></div>";
		} else { 
			print qq~<div class="menubackcolor">$msg{'179'}</div>~;
		}

		print qq~</div></div></div>~;

	}

}

######################
sub mycontent_block2 {
######################

	if ($showcon2 eq "1") {
		$shownumber = 10;
		mycontent_block;
	}

}

###############
sub about_bar {
###############

	print qq~<div align="right"><div class="helpsnavtable"><a
 href="$pageurl/$cgi?action=about" class="helpsnavlink">$nav{'091'}</a> &#124; <a
 href="$pageurl/$cgi?action=contact" class="helpsnavlink">$nav{'092'}</a> &#124; <a
 href="$pageurl/$cgi?action=help" class="helpsnavlink">$nav{'090'}</a> &#124; <a
 href="$pageurl/$cgi?action=recommend" class="helpsnavlink">$nav{'008'}</a>~;

	show_stats();

	print qq~</div></div>
~;
	
}

##################
sub footercredit {
##################

	print qq~<br>
<div style="padding: 2px; text-align: right; font-size: 9px; color: #000000"> &quot;Color Me&quot; theme by Jos Brown<br>
</div>
~;

}
################
sub show_stats {
################

	if ($dispstat eq "0" && $username eq "admin") {
		print qq~ &#124; <a href="$pageurl/$cgi?action=stats" class="helpsnavlink">$nav{'006'}</a>~; 
	} 
	if ($dispstat eq "1" && $username ne "$anonuser") {
		print qq~ &#124; <a href="$pageurl/$cgi?action=stats" class="helpsnavlink">$nav{'006'}</a>~; 
	} 
	if ($dispstat eq "2") {
		print qq~ &#124; <a href="$pageurl/$cgi?action=stats" class="helpsnavlink">$nav{'006'}</a>~; 
	}

}

################
sub wepapp_bar {
################

	print qq~<br>
<div class="webapptext">
<br>
$msg{'399'}<a
 href="$pageurl/$cgi?action=ver" class="webapplink">$scriptname v$scriptver</a>$msg{'400'}
<br>
$msg{'401'}
</div>
<a href="$baseurl/webapp.xml" target="_blank"><img src="$imagesurl/xmlfeed.gif"
 width="80" height="15" border="0" alt="XML Feed"></a>
~;

}

######################
sub broadcastmessage {
######################

	if ($username ne "$anonuser") { 
		open(FILE, "$memberdir/admin.pref") || error("$err{'010'}"); 
		hold(FILE); 
		chomp(@preferences = <FILE>); 
		release(FILE); 
		close(FILE); 
 
 		if ($preferences[4] == 1) { 
			print qq~<table id="showimage"
 style="position:absolute; width:250px; left:250px; top:250px"
 bgcolor="$bmheadercolor" cellpadding="0" cellspacing="2" border="0"> 
<tr> 
<td width="100%"><table border="0" width="100%" cellspacing="0" cellpadding="0"
 height="36"> 
<tr> 
<td id="dragbar" style="cursor:hand; font-family: Verdana; color: $bmbgcolor"
 width="100%" onMouseover="dragswitch=1;if (ns4) drag_dropns(showimage);"
 onMouseout="dragswitch=0;" onMousedown="initializedrag(event);"
 onselectstart="return false;"><strong><small>Admin Broadcast Message</small></strong></td>
<td><a href="#" onClick="hidebox();return false;"><img
 src="$themesurl/standard/images/close.gif" width="16" height="14"
 border="0" alt="close this window"></a></td> 
</tr> 
<tr> 
<td width="100%" bgcolor="$bmbgcolor" style="padding:4px" colspan="2"> 
 
<!-- PUT YOUR CONTENT BETWEEN HERE --> 
 
$preferences[5]  
 
<!-- END YOUR CONTENT HERE --> 
 
</td> 
</tr> 
</table></td> 
</tr> 
</table> 
~; 
 
		} 

	} 
 
# End broadcast java alert message 

}

1; # return true