#!/usr/bin/perl

###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# blockbottom.cgi - from admin/blocks/bottom                                  #
# v0.9.9.3.4                                                                  #
# Bottom Center Blocks added to WebAPP v0.9.9.3 by: Aron Shiewitz (2xlnt.com) #
# CSS style sheet compatibility update by: my2cents (classicchat.net)         #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified: 2005 by Jos Brown web nick "bantychick" for 0.9.9.3         #
# Modified: 12 May 2006 by Jos for my2cents                                   #
# Modified: 13 Aug 2006 by Jos                                                #
###############################################################################
###############################################################################

$| = 1;

use CGI::Carp qw(fatalsToBrowser);

$scriptname = "WebAPP";

eval {
	require "../config.pl";
	require "$sourcedir/subs.pl";

	if ($IIS != 2) {
		if ($IIS == 0) {
			if ($ENV{'SERVER_SOFTWARE'} =~ m!IIS!) { $IIS = 1; }
		}
		if (($IIS) && ($0 =~ m!(.*)(\\|\/)!)) { chdir($1); }
		if ($IIS == 1) { print "HTTP/1.0 200 OK\n"; }
	}
};
if ($@) {
	print "Content-type: text/html\n\n";
	print qq~<h1>Software Error:</h1>
Execution of <b>$scriptname</b> has been aborted due to a compilation error:<br>
<pre>$@</pre>
<p>If this problem persists, please contact the webmaster and inform him about date and time you've received this error.</p>
~;
	exit;
}

$anonuser = "Guest";
@months = qw(January February March April May June July August September October November December);
@days = qw(Sunday Monday Tuesday Wednesday Thursday Friday Saturday);

getcgi();
getdate();
loadcookie(); # needs months days
loaduser();
logips();
&ban; # needs username realname anonuser months days first
logvisitors();
&getver;

if ( $action eq "addbtmblk" ) { addbtmblk(); }
elsif ( $action eq "addbtmblk2" ) { addbtmblk2(); }
elsif ( $action eq "editbtmblk" ) { editbtmblk(); }
elsif ( $action eq "editbtmblk2" ) { editbtmblk2(); }
elsif ( $action eq "deletebtmblk" ) { deletebtmblk(); }
else { viewbtmblk(); }

##############
sub viewbtmblk {
##############

	check_access("editbtmblk"); if ($access_granted ne "1") { error("$err{'011'}"); }

	$navbar = "$btn{'014'} $nav{'063'} $btn{'014'} $btn{'034'} $btn{'014'} $mnu{'058'}";
	print_top();

	print qq~<i>$btn{'034'}</i>
<table border="1">
<tr>
<td width="400" align="center" class="titletext"><b>$msg{'353'}</b></td>
<td align="center" class="titletext"><b>$help{'012'}</b></td>
</tr>
~;

	open (ORGDB,"<$datadir/blocks/blockbottom.dat");
	hold (ORGDB);
	@ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	foreach $rec (@ODB){
		chomp($rec);
		($block,$title,$stat,$bcont)=split(/\|/,$rec);
		$cont = showhtml($bcont);
		$cont =~ s/&&/\n/g;
		$cont =~ s/&lt;/</ig;

		print qq~<tr>
<td><table width="400">~;

		print qq~<tr>
<td><table border="0" cellpadding="0" cellspacing="0" width="100%" class="menutable">
<tr>
<td>&nbsp;$title</td>
</tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="menubordercolor">
<tr>
<td width="100%"><table border="0" cellpadding="0" cellspacing="3"
 width="100%" class="menubackcolor">
~;

		print qq~<tr>
<td>$cont</td>
</tr>
~;

		print qq~</table></td>
</tr>
</table></td>
</tr>
~;

		print qq~</table></td>
<td align="center"><a
 href="$pageurl/admin/blockbottom.cgi?action=editbtmblk&amp;block=$block&amp;title=$title&amp;stat=$stat">$nav{'096'}</a> - <a
 href="$pageurl/admin/blockbottom.cgi?action=deletebtmblk&amp;block=$block&amp;title=$title&amp;stat=$stat">$nav{'097'}</a></td>
</tr>
~;
	}

	print qq~<tr>
<td align="center" colspan="2"><a
 href="$pageurl/admin/blockbottom.cgi?action=addbtmblk">&nbsp;$nav{'121'}</a></td>
</tr>
</table>
<br>
~;

	print_bottom();
	exit;
}

###############
sub editbtmblk {
###############

	check_access("editbtmblk"); if ($access_granted ne "1") { error("$err{'011'}"); }

	$navbar = "$btn{'014'} $nav{'063'} $btn{'014'} $nav{'096'} $mnu{'058'}";
	print_top();

	open(FILE, "$datadir/blocks/blockbottom.dat" || print "There was an error" );
	hold(FILE);
	chomp(@blocks = <FILE>);
	release(FILE);
	close(FILE);

	for ($a = 0; $a < @blocks; $a++) {
		($ablock, $atitle, $astat, $abcont, $only) = split(/\|/, $blocks[$a]);
		if ($ablock eq $info{'block'} and $atitle eq $info{'title'}) {
			$cont = htmltotext($abcont); # to put to a form for editing
			$cont =~ s/&amp;&amp;/\n/g; # inverse of regex to save line breaks inside tags

			print qq~<font face='Arial'><b><i>$btn{'033'}</i></b></font>
<form action='$pageurl/admin/blockbottom.cgi?action=editbtmblk2' method='post'>
<input type='hidden' name='block' value='$info{'block'}'>
<input type='hidden' name='title' value='$info{'title'}'>
<table border='1'>
<tr>
<td><font size='2'>$msg{'349'}</font></td>
<td><input type="text" class="textinput" name="nblock" value="$info{'block'}"> $msg{'573'}</td>
</tr>
<tr>
<td><font size='2'>$msg{'350'}</font></td>
<td><input type="text" class="textinput" name="ntitle" value="$info{'title'}"> $msg{'574'}</td>
</tr>
<tr>
<td><font size='2'>$msg{'351'}</font></td>
<td><input type="text" class="textinput" name="nstat" value="$info{'stat'}"> $msg{'552'}</td>
</tr>
<tr>
<td><font size='2'>$msg{'587'}</font></td>
<td><input type="text" class="textinput" name="nonly" value="$only"> $msg{'575'}</td>
</tr>
<tr>
<td><font size='2'>$msg{'352'}</font></td>
<td><textarea name='nbcont' rows='20' cols='40' wrap='off'>$cont</textarea></td>
</tr>
</table>
<input type="submit" class="button" value="$btn{'033'}">
</form>
~;

		}
	}

	print_bottom();
	exit;
}

###############
sub editbtmblk2 {
###############

	check_access("editbtmblk"); if ($access_granted ne "1") { error("$err{'011'}"); }

	open (ORGDB,"<$datadir/blocks/blockbottom.dat");
	hold (ORGDB);
	@ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	open (DATABASE,">$datadir/blocks/blockbottom.dat");
	hold (DATABASE);
	foreach $rec (@ODB){
		chomp($rec);
		($block,$title,$stat,$bcont,$only)=split(/\|/,$rec);
		if ($block eq $input{'block'}){
			$input{'nbcont'} =~ s/\n(?=[^<]+>)/&&/gs; # save line breaks inside tags
			$cont = htmlescape($input{'nbcont'});
			$cont =~ s/scrypt/script/g; #
			$cont =~ s/yframe/iframe/g; # allow for javascript and iframe in blocks

			print DATABASE "$input{'nblock'}|$input{'ntitle'}|$input{'nstat'}|$cont|$input{'nonly'}\n";
		} else {
			print DATABASE "$block|$title|$stat|$bcont|$only\n";
		}
	}

	release (DATABASE);
	close (DATABASE);

	print "Location: $pageurl/admin/blockbottom.cgi\n\n";
}

#############
sub addbtmblk {
#############

	check_access("editbtmblk"); if ($access_granted ne "1") { error("$err{'011'}"); }

	$navbar = "$btn{'014'} $nav{'063'} $btn{'014'} $btn{'027'} $mnu{'058'}";
	print_top();

	print qq~<font face='Arial'><b><i>$msg{'348'}</i></b></font>
<form action='$pageurl/admin/blockbottom.cgi?action=addbtmblk2' method='post'>
<table border='1' width='100%'>
<tr>
<td><font size='2'>$msg{'349'}</font></td>
<td><input type="text" class="textinput" name="nblock"> $msg{'573'}</td>
</tr>
<tr>
<td><font size='2'>$msg{'350'}</font></td>
<td><input type="text" class="textinput" name="ntitle"> $msg{'574'}</td>
</tr>
<tr>
<td><font size='2'>$msg{'351'}</font></td>
<td><input type="text" class="textinput" name="nstat" value="1"> $msg{'552'}</td>
</tr>
<tr>
<td><font size='2'>$msg{'587'}</font></td>
<td><input type="text" class="textinput" name="nonly" value="0"> $msg{'575'}</td>
</tr>
<tr>
<td><font size='2'>$msg{'352'}</font></td>
<td><textarea name='nbcont' rows='20' cols='40' wrap='off'></textarea></td>
</tr>
</table>
<input type="submit" class="button" value="$btn{'022'}"></form>
~;

	print_bottom();
	exit;
}

##############
sub addbtmblk2 {
##############

	check_access("editbtmblk"); if ($access_granted ne "1") { error("$err{'011'}"); }

	open (DATABASE1,">>$datadir/blocks/blockbottom.dat");
	hold (DATABASE1);

	$input{'nbcont'} =~ s/\n(?=[^<]+>)/&&/gs; # save line breaks inside tags
	$cont = htmlescape($input{'nbcont'});
	$cont =~ s/scrypt/script/g; #
	$cont =~ s/yframe/iframe/g; # allow for javascript and iframe in blocks

	print DATABASE1 "$input{'nblock'}|$input{'ntitle'}|$input{'nstat'}|$cont|$input{'nonly'}\n";

	release (DATABASE1);
	close (DATABASE1);

	print "Location: $pageurl/admin/blockbottom.cgi\n\n";
}

################
sub deletebtmblk {
################

	check_access("editbtmblk"); if ($access_granted ne "1") { error("$err{'011'}"); }

	open (ORGDB,"<$datadir/blocks/blockbottom.dat");
	hold (ORGDB);
	@ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	open (DATABASE,">$datadir/blocks/blockbottom.dat");
	hold (DATABASE);
	@raw_data=<DATABASE>;

	foreach $rec (@ODB){
		chomp($rec);
		($block,$title,$stat,$bcont,$only)=split(/\|/,$rec);
		if ($block eq $info{'block'}){
 			print DATABASE @raw_data;
		} else {
			print DATABASE "$block|$title|$stat|$bcont|$only\n";
		}
	}

	release (DATABASE);
	close (DATABASE);

	print "Location: $pageurl/admin/blockbottom.cgi\n\n";
}

1;