#!/usr/bin/perl

###############################################################################
###############################################################################
# WebAPP - Automated Perl Portal                                              #
#-----------------------------------------------------------------------------#
# captcha.cgi                                                                 #
# v0.9.9.3                                                                    #
# for separate image print for CAPTCHAs                                       #
# by Jos Brown ("bantychick") for 0.9.9.3                                     #
#                                                                             #
# This program is free software; you can redistribute it and/or               #
# modify it under the terms of the GNU General Public License                 #
# as published by the Free Software Foundation; either version 2              #
# of the License, or (at your option) any later version.                      #
#                                                                             #
# This program is distributed in the hope that it will be useful,             #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License along     #
# with this program; if not, write to the Free Software Foundation, Inc.,     #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Last modified: Dec 2005 by Jos Brown                                  #
###############################################################################
###############################################################################

$| = 1;

use CGI::Carp qw(fatalsToBrowser);

eval {
	require "config.pl";
	require "$sourcedir/subs.pl";
};

if ($@) {
	print "Content-type: text/html\n\n";
	print qq~<h1>Software Error:</h1>
Execution of <b>$scriptname</b> has been aborted due a compilation error:<br>
<pre>$@</pre>
<p>If this problem persists, please contact the webmaster and inform him about date and time you've received this error.</p>
SD: $scriptdir~;
	exit;
}

getcgi();

if ($action && ($action eq "data_error")) {
	$anonuser = "Guest";
	@months = qw(January February March April May June July August September October November December);
	@days = qw(Sunday Monday Tuesday Wednesday Thursday Friday Saturday);

	getcgi();
	getdate();
	loadcookie();
	loaduser();
	logips();
	&ban;
	logvisitors();
	&getver;

	&data_error;
} else {
	require "$sourcedir/captcha.pl"; &print_image;
} 

exit;

1;
