###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# breadcrumb.pl                                                               #
# v0.9.9.3.4                                                                  #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
###############################################################################
###############################################################################
# to use:
# in themes/yourtheme/theme.pl, sub nav_bar,
# break printing and put these 2 lines in place of $nav{'002'} like this:
# ...<td>&nbsp;~; # break printing here
# 
#   $nav{'002'} # remove this 
#   require "$sourcedir/breadcrumb.pl"; # ADD THIS 
#   breadcrumb();                       # ADD THIS 
# 
#   print qq~</td>... # resume printing here for your individual theme
###############################################################################

################
sub breadcrumb {
################

	if (!defined $action) { $action = ""; }
	$breadcrumb = 1;

# if this is not the front page (navbar for front page contains only a space):
	if ($navbar && ($navbar =~ /\S/)) {
		my $count = 0;
		while ($navbar =~ /$btn{'014'}/g) {
			$count++;
		}

# only do the following if there is a trail to link:
# and doesn't already have a navbar:
		if ((($count > 1) || ($action eq "admin")
		|| ($location =~ /\/admin\/|\/mods\/calendar\/|\/modmanager/)) 
		&& ($navbar !~ /<a/)) {
			my $navtrail = "";

# these don't need to read the $navbar:
			if ($action eq "viewnews") {
				$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=topics">$nav{'004'}</a> $btn{'014'} <a
 href="$cgi?action=topics&amp;viewcat=$curcatlink">$curcatname</a>~;
			}
			elsif ($action eq "forum") {
				if (!$op) { $op = ''; }

				if ($op eq "display") {
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=forum">$nav{'003'}</a> $btn{'014'} <a
 href="$pageurl/$cgi?action=forum&amp;board=$currentboard">$boardname</a>~;

				} else {
					if ($currentboard) {
						@boardinfo = chomp_database("$boardsdir/$currentboard.dat");
						$boardname = "$boardinfo[0]";
						if (($op eq "post") || ($op eq "poststicky")) {
							$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=forum">$nav{'003'}</a> $btn{'014'} <a
 href="$pageurl/$cgi?action=forum&amp;board=$currentboard">$boardname</a> $btn{'014'} $nav{'036'}~;
						} else {
							$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=forum">$nav{'003'}</a> $btn{'014'} $boardname~;
						}
					}
				}
			}
			elsif ($action eq "viewarchive") {
				if (!$op) { $op = ''; }

				if ($op eq "archivedisplay") {
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=viewarchive">$nav{'165'}</a> $btn{'014'} <a
 href="$pageurl/$cgi?action=viewarchive&amp;board=$currentboard">$boardname</a>~;
				} else {
					if ($currentboard) {
						my @boardinfo = chomp_database("$boardsdir/archive/$currentboard.dat");
						$boardname = "$boardinfo[0]";
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=viewarchive">$nav{'165'}</a> $btn{'014'} $boardname~;
					}
				}
			}
			elsif ($action eq "imsend") {
				$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=im">$nav{'102'}</a> $btn{'014'} $btn{'008'}~;
			}
			elsif (($action eq "im") && ($info{'from'})) {
					my $read = "\u$nav{'152'}";
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=im">$nav{'102'}</a> $btn{'014'} $read~;
			} else {

# include all the below in an else and breaknavbar once for they all need it:

				breaknavbar();

				if (($action eq "topics") && ($viewcat)) {
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=topics">$nav{'004'}</a> $btn{'014'} $mylinktext[2]~;
				}
				elsif (($action eq "links") && ($cat)) {
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=links">$nav{'005'}</a> $btn{'014'} $mylinktext[2]~;
				}
				elsif ($action eq "linkinfo") {
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=links">$nav{'005'}</a> $btn{'014'} <a
 href="$pageurl/$cgi?action=links&amp;cat=$cat">$mylinktext[2]</a> $btn{'014'} $mylinktext[3]~;
				}
				elsif (($action eq "downloads") && ($cat)) {
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=downloads">$nav{'056'}</a> $btn{'014'} $mylinktext[2]~;
				}
				elsif ($action eq "downloadinfo") {
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=downloads">$nav{'056'}</a> $btn{'014'} <a
 href="$pageurl/$cgi?action=downloads&amp;cat=$cat">$mylinktext[2]</a> $btn{'014'} $mylinktext[3]~;
				}
# im stuff:
				elsif (($action eq "imfolder") || ($action eq "saveim") || ($action eq "messageadmin")) {
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=im">$nav{'102'}</a> $btn{'014'} $mylinktext[2]~;
				}
				elsif ($action eq "im2") {
					my $read = "\u$nav{'152'}";
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=im">$nav{'102'}</a> $btn{'014'} <a
 href="$pageurl/$cgi?action=imfolder">$mylinktext[2]</a> $btn{'014'} $read~;
				}
				elsif ($action eq "im3") {
					my $read = "\u$nav{'152'}";
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=im">$nav{'102'}</a> $btn{'014'} <a
 href="$pageurl/$cgi?action=saveim">$mylinktext[2]</a> $btn{'014'} $read~;
				}
				elsif ($action eq "viewprofile") {
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=memberlist">$nav{'017'}</a> $btn{'014'} $mylinktext[2]~;
				}

# Admin override for log viewers:
				elsif ($action eq "viewsent") {
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} $mylinktext[1]~;
				}
				elsif ($action eq "viewstats") {
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} $mylinktext[1] $btn{'014'} $mylinktext[2]~;
				}
				elsif ($action eq "deview") {
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} $mylinktext[1]~;
				}
				elsif ($action eq "banlog") {
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} $mylinktext[1]~;
				}
# end Admin override for log viewers

# action eq admin:
				elsif (($action eq "admin") && ($op) && ($op ne "siteadmin")) {
					if ((($op =~ /newsletter/) && ($op ne "newsletter")) || ($op eq "editemails")) {
						if ($mylinktext[3]) {
							$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/$cgi?action=admin&amp;op=newsletter">$mnu{'038'}</a> $btn{'014'} $mylinktext[2] $btn{'014'} $mylinktext[3]~;
						}
						elsif ($mylinktext[2]) {
							$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/$cgi?action=admin&amp;op=newsletter">$mnu{'038'}</a> $btn{'014'} $mylinktext[2]~;
						} else {
							$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/$cgi?action=admin&amp;op=newsletter">$mnu{'038'}</a> $btn{'014'} $mylinktext[1]~;
						}
					}
					elsif ($op eq "editpoll") {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/$cgi?action=admin&amp;op=polladmin">$mylinktext[1]</a> $btn{'014'} $mylinktext[2]~;
					}
					elsif ($op eq "modifynews2") {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/$cgi?action=admin&amp;op=modifynews">$mylinktext[1]</a> $btn{'014'} $mylinktext[2]~;
					} else {
						if ($mylinktext[3]) {
							$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} $mylinktext[2] $btn{'014'} $mylinktext[3]~;
						}
						elsif ($mylinktext[2]) {
							$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} $mylinktext[2]~;
						} else {
							$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} $mylinktext[1]~;
						}
					}
				}
# end action eq admin
# in admin folder:
				elsif ($location =~ /\/admin\//) {
					if ($action =~ /editlang|addlang/) {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/admin/language.cgi">$mylinktext[1]</a> $btn{'014'} $mylinktext[2]~;
					}
					elsif ($action =~ /editrecord|addtheme/) {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/admin/themes.cgi">$mylinktext[1]</a> $btn{'014'} $mylinktext[2]~;
					}
					elsif (($action eq "editbanner") || ($action eq "addbanner")) { # Admin override for banners
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/admin/banners.cgi">$banner{'015'}</a> $btn{'014'} $mylinktext[2]~;
					}
					elsif ($action =~ /edithlp|addhlp/) {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/admin/help.cgi">$mylinktext[1]</a> $btn{'014'} $mylinktext[2]~;
					}
					elsif ($action =~ /^(editdlcat|adddlcat)$/) {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/admin/downloadadmin.cgi">$mylinktext[1]</a> $btn{'014'} $mylinktext[2]~;
					}
					elsif ($action =~ /^(editlncat|addlncat)$/) {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/admin/linksadmin.cgi">$mylinktext[1]</a> $btn{'014'} $mylinktext[2]~;
					}
					elsif ($action eq "editlblk" || $action eq "addlblk") {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/admin/blockleft.cgi">$mylinktext[1]</a> $btn{'014'} $mylinktext[2]~;
					}
					elsif ($action eq "editrblk" || $action eq "addrblk") {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/admin/blockright.cgi">$mylinktext[1]</a> $btn{'014'} $mylinktext[2]~;
					}
					elsif ($action eq "edittblk" || $action eq "addtblk") {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/admin/blocktop.cgi">$mylinktext[1]</a> $btn{'014'} $mylinktext[2]~;
					}
					elsif ($action eq "editbtmblk" || $action eq "addbtmblk") {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/admin/blockbottom.cgi">$mylinktext[1]</a> $btn{'014'} $mylinktext[2]~;
					}
					elsif ($location =~ /\/showhtml\.cgi/) {
						if ($action eq "Add") {
							$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/admin/showhtml.cgi">$mnu{'046'}</a> $btn{'014'} $nav{'030'}~;
						}
						elsif ($action eq "Edit") {
							$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} <a
 href="$pageurl/admin/showhtml.cgi">$mnu{'046'}</a> $btn{'014'} $nav{'139'}~;
						} else {
							$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} $mylinktext[1]~;
						}
					}
					elsif ($location =~ /\/logs\.cgi$/) { # 14 Aug 2006
							$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a> $btn{'014'} $nav{'053'}~;
					} else {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a>~;
						if ($mylinktext[1] !~ /$nav{'042'}/) {
							$navtrail .= qq~ $btn{'014'} $mylinktext[1]~; # added space before btn 014
						}
						if ($mylinktext[2]) {
							$navtrail .= qq~ $btn{'014'} $mylinktext[2]~; # added space before btn 014
						}
						if ($mylinktext[3]) {
							$navtrail .= qq~ $btn{'014'} $mylinktext[3]~; # added space before btn 014
						}
					}
				} # end admin section
# end in admin folder

				elsif ($location =~ /\/modmanager\.cgi/) {
					$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=admin">$nav{'042'}</a>~;
					$navtrail .= qq~ $btn{'014'} $mylinktext[1]~;
######################
				} else { # If we get here we're using the $navbar call to work it out 
					&breaknavlink;
					&fixlinks;

					if ($mylinktext[6]) {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=$mylink[1]">$mylinktext[1]</a> $btn{'014'} <a
 href="$cgi?action=$mylink[2]">$mylinktext[2]</a> $btn{'014'} <a
 href="$cgi?action=$mylink[3]">$mylinktext[3]</a> $btn{'014'} <a
 href="$cgi?action=$mylink[4]">$mylinktext[4]</a> $btn{'014'} <a
 href="$cgi?action=$mylink[5]">$mylinktext[5]</a> $btn{'014'} $mylinktext[6]~;
					}
					elsif ($mylinktext[5]) {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=$mylink[1]">$mylinktext[1]</a> $btn{'014'} <a
 href="$cgi?action=$mylink[2]">$mylinktext[2]</a> $btn{'014'} <a
 href="$cgi?action=$mylink[3]">$mylinktext[3]</a> $btn{'014'} <a
 href="$cgi?action=$mylink[4]">$mylinktext[4]</a> $btn{'014'} $mylinktext[5]~;
					}
					elsif ($mylinktext[4]) {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=$mylink[1]">$mylinktext[1]</a> $btn{'014'} <a
 href="$cgi?action=$mylink[2]">$mylinktext[2]</a> $btn{'014'} <a
 href="$cgi?action=$mylink[3]">$mylinktext[3]</a> $btn{'014'} $mylinktext[4]~;
					}
					elsif ($mylinktext[3]) {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=$mylink[1]">$mylinktext[1]</a> $btn{'014'} <a
 href="$cgi?action=$mylink[2]">$mylinktext[2]</a> $btn{'014'} $mylinktext[3]~;
					}
					elsif ($mylinktext[2]) {
						$navtrail = qq~$btn{'014'} <a
 href="$pageurl/$cgi?action=$mylink[1]">$mylinktext[1]</a> $btn{'014'} $mylinktext[2]~;
					}
					elsif ($mylinktext[1]) {
						$navtrail = qq~$btn{'014'} $mylinktext[1]~;
					}
				} # end getting the $mylink[]
			} # end breaknavbar

			print qq~<a href="$pageurl/$cgi">$nav{'002'}</a> $navtrail~;

		} else { # end if to do any of the above
			print qq~<a href="$pageurl/$cgi">$nav{'002'}</a> $navbar~;
		}

	} else { # if no $navbar, assume this is the front page
		print qq~$nav{'002'}~;
	}

}

#################
sub breaknavbar {
#################

	my $mynavbar = "$navbar";
	$mynavbar =~ s/ /&nbsp;/g; # keeps word phrases together

	@mylinktext = split(/$btn{'014'}/, $mynavbar);

}

##################
sub breaknavlink {
##################

	my $mynavbarlink = "$navbar";
	$mynavbarlink =~ s/ |&nbsp;//g; # remove spaces
	$mynavbarlink = "\L$mynavbarlink";

	@mylink = split(/$btn{'014'}/,$mynavbarlink);

}

##############
sub fixlinks {
##############
# This is using the $navbar call but changing any language errors

	for $fix (@mylink) {
		$fix =~ s/$nav{'004'}/topics/i;
		if ($gal{'001'}) { # fix by drive_c
			$fix =~ s/$gal{'001'}/gallery/i; 
		}
	}

}

if (-e "$user_lib/breadcrumb.pl") {require "$user_lib/breadcrumb.pl"}

1;