###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# forum_subs.pl                                                               #
# v0.9.9.3.4                                                                  #
# subroutines for use by forums - moved here from forum_display.pl by:        #
# Jos (www.bantychick.com) for WebAPP v0.9.9.3                                #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified: 2005 by Jos                                                 #
# Modified: 16 May, 1 Aug 2006 by Jos                                         #
###############################################################################
###############################################################################

############
sub jumpto {
############

	@jumptofiles = read_database("$boardsdir/cats.txt");

	foreach $jumpfile (@jumptofiles) {
		$jumpfile =~ s/[\n\r]//g;

		@jumpinfo = read_database("$boardsdir/$jumpfile.cat");

		$jumpinfo[1] =~ s/[\n\r]//g;
		if ($jumpinfo[1] ne "") {
			if ($userrank ne "$root" && $userrank ne "$jumpinfo[1]") { next; }
		}

		$jumptoboard = "$jumpinfo[0]";
		foreach $jumptoboard (@jumpinfo) {
			if ($jumptoboard ne "$jumpinfo[0]" && $jumptoboard ne "$jumpinfo[1]") {
				$jumptoboard =~ s/[\n\r]//g;

				open(FILE, "$boardsdir/$jumptoboard.dat") || error("$err{'001'} $boardsdir/$jumptoboard.dat");
				hold(FILE);
				chomp(@jumpoptions = <FILE>);
				release(FILE);
				close(FILE);
				$selecthtml .= qq~<option value="$jumptoboard">$jumpoptions[0]</option>~;
			}
		}
	}

}

#################
sub smilieblock {
#################

	if ($enable_smile eq "1") {
		print qq~<tr>
<td class="formstextnormal">$msg{'533'}</td>
<td valign="middle"><a href="javascript:addCode('[smile]')"><img src="$imagesurl/forum/buttons/smile.gif" border="0" title="$msg{'512'}" alt="$msg{'512'}"></a>
<a href="javascript:addCode('[grin]')"><img src="$imagesurl/forum/buttons/grin.gif" border="0" title="$msg{'505'}" alt="$msg{'505'}"></a>
<a href="javascript:addCode('[cool]')"><img src="$imagesurl/forum/buttons/cool.gif" border="0" title="$msg{'500'}" alt="$msg{'500'}"></a>
<a href="javascript:addCode('[oops]')"><img src="$imagesurl/forum/buttons/oops.gif" border="0" title="$msg{'510'}" alt="$msg{'510'}"></a>
<a href="javascript:addCode('[lol]')"><img src="$imagesurl/forum/buttons/lol.gif" border="0" title="$msg{'507'}" alt="$msg{'507'}"></a>
<a href="javascript:addCode('[mad]')"><img src="$imagesurl/forum/buttons/mad.gif" border="0" title="$msg{'508'}" alt="$msg{'508'}"></a>
<a href="javascript:addCode('[cry]')"><img src="$imagesurl/forum/buttons/cry.gif" border="0" title="$msg{'501'}" alt="$msg{'501'}"></a>
<a href="javascript:addCode('[bounce]')"><img src="$imagesurl/forum/buttons/bounce.gif" border="0" title="$msg{'506'}" alt="$msg{'506'}"></a>
<a href="javascript:addCode('[nonsense]')"><img src="$imagesurl/forum/buttons/nonsense.gif" border="0" title="$msg{'509'}" alt="$msg{'509'}"></a>
<a href="javascript:addCode('[dancing-banana]')"><img src="$imagesurl/forum/buttons/dancing-banana.gif" border="0" title="$msg{'695'}" alt="$msg{'695'}"></a>
<a href="javascript:addCode('[question]')"><img src="$imagesurl/forum/buttons/question.gif" border="0" title="$msg{'713'}" alt="$msg{'713'}"></a>
<br>
<a href="javascript:addCode('[wink]')"><img src="$imagesurl/forum/buttons/wink.gif" border="0" title="$msg{'514'}" alt="$msg{'514'}"></a>
<a href="javascript:addCode('[rolleyes]')"><img src="$imagesurl/forum/buttons/rolleyes.gif" border="0" title="$msg{'511'}" alt="$msg{'511'}"></a>
<a href="javascript:addCode('[tongue]')"><img src="$imagesurl/forum/buttons/tongue.gif" border="0" title="$msg{'513'}" alt="$msg{'513'}"></a>
<a href="javascript:addCode('[confused]')"><img src="$imagesurl/forum/buttons/confused.gif" border="0" title="$msg{'499'}" alt="$msg{'499'}"></a>
<a href="javascript:addCode('[eek]')"><img src="$imagesurl/forum/buttons/eek.gif" border="0" title="$msg{'502'}" alt="$msg{'502'}"></a>
<a href="javascript:addCode('[frown]')"><img src="$imagesurl/forum/buttons/frown.gif" border="0" title="$msg{'504'}" alt="$msg{'504'}"></a>
<a href="javascript:addCode('[evil]')"><img src="$imagesurl/forum/buttons/evil.gif" border="0" title="$msg{'503'}" alt="$msg{'503'}"></a>
<a href="javascript:addCode('[bones]')"><img src="$imagesurl/forum/buttons/bones.gif" border="0" title="$msg{'498'}" alt="$msg{'498'}"></a>
<a href="javascript:addCode('[ninja]')"><img src="$imagesurl/forum/buttons/ninja.gif" border="0" title="$msg{'515'}" alt="$msg{'515'}"></a>
<a href="javascript:addCode('[llama-banana]')"><img src="$imagesurl/forum/buttons/llama-banana.gif" border="0" title="$msg{'696'}" alt="$msg{'696'}"></a>
<a href="javascript:addCode('[tarzan]')"><img src="$imagesurl/forum/buttons/tarzan.gif" border="0" title="$msg{'714'}" alt="$msg{'714'}"></a></td>
</tr>
~;
	}

}

#################
sub show_legend {
#################

	if ($username ne "$anonuser") {

		open(FILE, "$memberdir/$username.pref") || error("$err{'010'}");
		hold(FILE);
		chomp(@preferences = <FILE>);
		release(FILE);
		close(FILE);

		if ($preferences[7] == 1 || $preferences[7] eq "" ) {
			legend();
		}

	} else {
		legend();
	}

}

############
sub legend {
############

	print qq~<tr>
<td>&nbsp;</td>
<td valign="top"><br>
<div class="menutable">&nbsp;$msg{'516'}</div>
<div class="menubordercolor" style="padding: 1px">
<table border="0" cellpadding="3" cellspacing="0" width="100%" border="0" class="menubackcolor">
<tr>
<td colspan="2" align="center"><b><u>$msg{'116'}</u></b></td>
</tr>
<tr>
<td width="50%" align="left">&nbsp;<img src="$imagesurl/forum/xx.gif" border="0" alt="$msg{'517'}">&nbsp;&nbsp;$msg{'517'}.<br>
&nbsp;<img src="$imagesurl/forum/thumbup.gif" border="0" alt="$msg{'518'}">&nbsp;&nbsp;$msg{'518'}.<br>
&nbsp;<img src="$imagesurl/forum/thumbdown.gif" border="0" alt="$msg{'519'}">&nbsp;&nbsp;$msg{'519'}.<br></td>
<td width="50%" align="left">&nbsp;<img src="$imagesurl/forum/exclamation.gif" border="0" alt="$msg{'520'}">&nbsp;&nbsp;$msg{'520'}<br>
&nbsp;<img src="$imagesurl/forum/question.gif" border="0" alt="$msg{'521'}">&nbsp;&nbsp;$msg{'521'}.<br>
&nbsp;<img src="$imagesurl/forum/lamp.gif" border="0" alt="$msg{'522'}">&nbsp;&nbsp;$msg{'522'}.</td>
</tr>
~;

	if ($enable_ubbc eq "1") {
		print qq~<tr>
<td colspan="2" align="center"><center><b><u>$msg{'156'}</u></b></center></td>
</tr>
<tr>
<td width="50%" align="left">&nbsp;<img src="$imagesurl/forum/buttons/bold.gif" alt="$msg{'117'}" border="0">&nbsp;&nbsp;$msg{'523'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/italicize.gif" alt="$msg{'118'}" border="0">&nbsp;&nbsp;$msg{'524'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/underline.gif" alt="$msg{'119'}" border="0">&nbsp;&nbsp;$msg{'525'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/small.gif" alt="$msg{'729'}" border="0">&nbsp;&nbsp;$msg{'715'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/big.gif" alt="$msg{'730'}" border="0">&nbsp;&nbsp;$msg{'731'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/sub.gif" alt="$msg{'544'}" border="0">&nbsp;&nbsp;$msg{'544'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/sup.gif" alt="$msg{'545'}" border="0">&nbsp;&nbsp;$msg{'545'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/strike.gif" alt="$msg{'546'}" border="0">&nbsp;&nbsp;$msg{'546'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/pre.gif" alt="$msg{'547'}" border="0">&nbsp;&nbsp;$msg{'547'}.</td>
<td width="50%" align="left">&nbsp;<img src="$imagesurl/forum/buttons/left.gif" alt="$msg{'548'}" border="0">&nbsp;&nbsp;$msg{'548'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/center.gif" alt="$msg{'120'}" border="0">&nbsp;&nbsp;$msg{'526'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/right.gif" alt="$msg{'549'}" border="0">&nbsp;&nbsp;$msg{'549'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/list.gif" alt="$msg{'125'}" border="0">&nbsp;&nbsp;$msg{'532'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/email2.gif" alt="$msg{'122'}" border="0">&nbsp;&nbsp;$msg{'529'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/img.gif" alt="$msg{'171'}" border="0">&nbsp;&nbsp;$msg{'528'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/url.gif" alt="$msg{'121'}" border="0">&nbsp;&nbsp;$msg{'527'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/quote2.gif" alt="$msg{'124'}" border="0">&nbsp;&nbsp;$msg{'531'}.<br>
&nbsp;<img src="$imagesurl/forum/buttons/code.gif" alt="$msg{'123'}" border="0">&nbsp;&nbsp;$msg{'530'}.</td>
</tr>
~;
	}

	print qq~</table>
</div>
<br></td>
</tr>
~;

}

#################
sub checkfornew {
#################
# used in gallery.pl and forum.pl
# modified to pass results back to subs where used - Aug 2006 by Jos

	my ($date1, $date2) = @_;
	my $new = "";

	my ($number1, $number2, $number3, $number4) = (0, 0, 0, 0);
	my ($month, $day, $year, $hour, $min);

	my ($tmonth, $tday, $tyear) = (split(/[\/ ]/, $date))[0..2];
	my $todaysdate = ($tyear*365)+($tmonth*30)+$tday;
	if ($date1) {
		($month, $day, $year, $hour, $min) = (split(/\/| - |\:/, $date1))[0..4];
		$number1 = ($year*365)+($month*30)+$day; # Log Date
		$number3 = ($hour*60)+$min; # Log Time
	}
	($month, $day, $year, $hour, $min) = (split(/\/| - |\:/, $date2))[0..4];
	$number2 = ($year*365)+($month*30)+$day; # Post date
	$number4 = ($hour*60)+$min; # Post Time

	if (($number1 == $number2) && ($number3 < $number4)) {
			$new = 1;
	}
	# if log date is less than post date
	if ($number1 < $number2) {
		# difference equals today's date minus post date
		$datedifference = $todaysdate-$number2;
		# if the difference is the max log days setting or less
		if ($datedifference <= $max_log_days_old) {
			$new = 1;
		}
	}
	return($new);
}

################
sub symbol_alt {
################

	local ($field) = @_;

	if ($field eq "xx") {$symbolalt = "$msg{'517'}";}
	if ($field eq "thumbup") {$symbolalt = "$msg{'518'}";}
	if ($field eq "thumbdown") {$symbolalt = "$msg{'519'}";}
	if ($field eq "exclamation") {$symbolalt = "$msg{'520'}";}
	if ($field eq "question") {$symbolalt = "$msg{'521'}";}
	if ($field eq "lamp") {$symbolalt = "$msg{'522'}";}

}

#############
sub logread {
#############

	# Time allowed between posts
	$tbp = 3;

	# getting times for the log

	my $currenttime = time();

	# Check the log
	open(LOG, "$datadir/forum/readlog.log") || open(LOG, ">$datadir/forum/readlog.log");
	hold(LOG);
	chomp(my @data = <LOG>);
	close(LOG);

	foreach my $data(@data) {

		$data =~ s/[\n\r]//g;
		my ($yourip, $loggedtime) = split(/\|/, $data);

		# if your IP is logged then we will check the time it was logged
		if ($ENV{REMOTE_ADDR} eq "$yourip") {
			my $checktime = $currenttime - $loggedtime;

			#if your ip was logged less the $tbp seconds ago cut it out
			if ($checktime <= "$tbp") {
				$navbar = "$btn{'014'} $err{'041'} "; # Slow down Simba
				print_top();

				print qq~$err{'039'} $tbp $err{'040'}...  $err{'041'}...~; # Too many displays in a $tbp second period... Slow down Simba...
				print_bottom();
				exit;
			} else {

				# if your ip was more then $tbp seconds, you maybe messed up, we'll fix it.

				# removing your IP from the log
				open(FILE, ">$datadir/forum/readlog.log");
				hold(FILE);

				foreach $data (@data) {
					$data =~ s/[\n\r]//g;
					my ($yourip, $loggedtime) = split(/\|/, $data);
					if ($ENV{REMOTE_ADDR} ne "$yourip" && $checktime <= "$tbp") {
						print FILE "$data\n";
					}
				}
				print FILE "$ENV{REMOTE_ADDR}|$currenttime\n"; # moved here to do once

				release(FILE);
				close(FILE);
			}
		}
	}

}

if (-e "$user_lib/forum_subs.pl") {require "$user_lib/forum_subs.pl"} 

1; # return true