###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# memberlist.pl                                                               #
# v0.9.9.3.4                                                                  #
# Search User function by: Klaus                                              #
# Speed Update by: Carter                                                     #
# Max Members per Page setting by: Aron Shiewitz (2xlnt.com)                  #
# Column for Last Visited by: Jos Brown (www.bantychick.com)                  #
# Search User Paging by: Jos                                                  #
# CSS Update by: my2cents (classicchat.net)                                   #
# Member Since User Display Date by: sebb                                     #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified: 2005 by Jos Brown ("bantychick")                            #
# Modified: 13 Apr 2006 by my2cents                                           #
# Modified: 17 May, 7 Aug 2006 by Jos                                         #
###############################################################################
###############################################################################

###########
sub mlist {
###########

	if ($username eq "$anonuser") { error("$err{'011'}"); }
	if ($userrank ne "$root") {
		if ($hidememlist eq "1") { error("$err{'011'}"); }
	}
	my @sortedmembers = ();

	if (!$maxmembersdisplay) { $maxmembersdisplay = $maxmessagedisplay; }

	# Reading the Member's Names in the memberlist file
	my @memberlist = chomp_database("$memberdir/memberlist.dat");

	my $thelatestmember = $memberlist[$#memberlist];

	# Getting info about the newest member here
	my @lmsettings = chomp_database("$memberdir/$thelatestmember.dat");

	my $tlmname = $lmsettings[1];

	my $count = @memberlist; # number of valid member.dat files, used to show total members

	my @membergroups = chomp_database("$memberdir/membergroups.dat");

# Giving us a blank slate to find the start of the members
# also used for reset start for display of cut set (see below where arrays are split out again)
	my $gotomember = 0;

# ----------------------------------------- No sorting ------------------------------------	

	my $start = 0; # start set to zero in no sorting only
	if ($info{'start'}) { $start = $info{'start'}; }

	if (!defined $info{'sort'}) {
	
		my $startcounting = 0; # blank slate to count to the max to show
		foreach my $member (@memberlist) {
			$gotomember++;

			# More my stuff to speed this up!
			if ($start < "$gotomember" && $startcounting < "$maxmembersdisplay") {

				# test for missing or corrupt membername.dat files (original fix for memberlist, by Jos)
				my @members;
				if (-e "$memberdir/$member.dat") {
					$startcounting++; # count only if member file
					@members = chomp_database("$memberdir/$member.dat");
				} else { 
					next;
				}
				if ((@members == 0) || ($members[1] =~ /^$/)) { # filter out blank files or blank realname
					$startcounting--;
					next;
				}
				# end membername.dat files test

				my $searchname = lc $members[1];
				my $posts = $members[6]+$members[11]+$members[12];

				my ($memberinfo, $rank);
				if ($members[7]) { # for Moderators and Administrators
					$memberinfo = "$members[7]"; # add actual rank
					if ($memberinfo eq "$root") { $rank = 1; } # $rank is a reverse sort variable
					elsif ($memberinfo eq "$boardmoderator") { $rank = 2; }

					elsif ($memberinfo eq "$membergroups[2]") { $rank = 9; }
					elsif ($memberinfo eq "$membergroups[3]") { $rank = 8; }
					elsif ($memberinfo eq "$membergroups[4]") { $rank = 7; }
					elsif ($memberinfo eq "$membergroups[5]") { $rank = 6; }
					elsif ($memberinfo eq "$membergroups[6]") { $rank = 5; }
					elsif ($memberinfo eq "$membergroups[7]") { $rank = 4; }
					elsif ($memberinfo eq "$membergroups[8]") { $rank = 3; }
					else { $rank = 9; }
				} else {
					if ($posts > 1500) { $memberinfo = "$membergroups[8]"; $rank = 3; }
					elsif ($posts > 1000) { $memberinfo = "$membergroups[7]"; $rank = 4; }
					elsif ($posts > 500) { $memberinfo = "$membergroups[6]"; $rank = 5; }
					elsif ($posts > 250) { $memberinfo = "$membergroups[5]"; $rank = 6; }
					elsif ($posts > 100) { $memberinfo = "$membergroups[4]"; $rank = 7; }
					elsif ($posts > 25) { $memberinfo = "$membergroups[3]"; $rank = 8; } # allows sort rank for admins and mods
					else { $memberinfo = "$membergroups[2]"; $rank = 9; }
				}
				# replaced email with last online - Jos:
				my $lastvisited = readlog("Last_Visited","$member");
				if ($lastvisited eq "") {
					$lastvisited = $members[10];
				}
				push (@sortedmembers, join ("\|", "$searchname|$members[1]|$lastvisited|$members[10]|$members[8]|$memberinfo|$rank|$posts|$members[14]|$member\n"));
			} # end counting

			# test for missing or corrupt membername.dat files (original fix for memberlist, by Jos)
			if (-e "$memberdir/$member.dat") {
				@members = chomp_database("$memberdir/$member.dat");
			} else { 
				$count--; # subtract from total member count if no member.dat file
			}
			if ((@members == 0) || ($members[1] =~ /^$/)) { # filter out blank files or blank realname
				$count--;
				next;
			}
			# end membername.dat files test

		} # end foreach member
	} else {
# -------------------------------------- End No sorting ---------------------------------

# ----------------------------------------- Sorting -------------------------------------	

		my @allmembers = ();
		foreach my $member(@memberlist) {

			# test for missing or corrupt membername.dat files (original fix for memberlist, by Jos)
			my @members;
			if (-e "$memberdir/$member.dat") {
				@members = chomp_database("$memberdir/$member.dat");
			} else { 
				$count--; # subtract from count if no member.dat file
				next;
			}
			if ((@members == 0) || ($members[1] =~ /^$/)) { # filter out blank files or blank realname
				$count--;
				next;
			}
			# end membername.dat files test

			my $searchname = lc $members[1];
			my $posts = $members[6]+$members[11]+$members[12];

			# set date for sort:
			my $sortdate = $members[10];
			if ($sortdate !~ / - /) {
				$sortdate = 0;
			} else {
				my ($chkmonth, $chkday, $chkyear, $chkhour, $chkmin, $chksec) = split(/\/| - |\:/, $sortdate);
				$chkyear = (2000+$chkyear);
				$sortdate = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";
			}

			my ($memberinfo, $rank);
			if ($members[7]) { # for Moderators and Administrators
				$memberinfo = "$members[7]"; # add actual rank
				if ($memberinfo eq "$root") { $rank = 1; } # $rank is a reverse sort variable
				elsif ($memberinfo eq "$boardmoderator") { $rank = 2; }

				elsif ($memberinfo eq "$membergroups[2]") { $rank = 9; }
				elsif ($memberinfo eq "$membergroups[3]") { $rank = 8; }
				elsif ($memberinfo eq "$membergroups[4]") { $rank = 7; }
				elsif ($memberinfo eq "$membergroups[5]") { $rank = 6; }
				elsif ($memberinfo eq "$membergroups[6]") { $rank = 5; }
				elsif ($memberinfo eq "$membergroups[7]") { $rank = 4; }
				elsif ($memberinfo eq "$membergroups[8]") { $rank = 3; }
				else { $rank = 9; }
	 		} else {
				if ($posts > 1500) { $memberinfo = "$membergroups[8]"; $rank = 3; }
				elsif ($posts > 1000) { $memberinfo = "$membergroups[7]"; $rank = 4; }
				elsif ($posts > 500) { $memberinfo = "$membergroups[6]"; $rank = 5; }
				elsif ($posts > 250) { $memberinfo = "$membergroups[5]"; $rank = 6; }
				elsif ($posts > 100) { $memberinfo = "$membergroups[4]"; $rank = 7; }
				elsif ($posts > 25) { $memberinfo = "$membergroups[3]"; $rank = 8; } # allows sort rank for admins and mods
				else { $memberinfo = "$membergroups[2]"; $rank = 9; }
			}
			# replaced email with last online - Jos:
			$lastvisited = readlog("Last_Visited","$member");
			if ($lastvisited eq "") {
				$lastvisited = $members[10];
			}
			# set last visited date for sort:
			my $lastvisit = $lastvisited;
			my ($chkmonth, $chkday, $chkyear, $chkhour, $chkmin, $chksec) = split(/\/| - |\:/, $lastvisit);
			$chkyear = (2000+$chkyear);
			$lastvisit = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";

			push (@allmembers, join ("\|", "$searchname|$members[1]|$lastvisited|$members[10]|$members[8]|$memberinfo|$rank|$posts|$members[14]|$member|$sortdate|$lastvisit\n"));
		}

		# this is still in if defined sorted now after the adjustments:
		for (0..$#allmembers) {
			@fields = split(/\|/, $allmembers[$_]);
			for $i (0..$#fields) {
				$data[$_][$i] = $fields[$i];
			}
		}
		if ($info{'sort'} == 0) {
			@sorted = sort { $a->[0] cmp $b->[0] } @data; # username
		}
		# replaced email with last online - Jos:
		elsif ($info{'sort'} == 1) { # date
			@sorted = sort { $a->[10] <=> $b->[10] } @data; # compressed join date
		}
		elsif ($info{'sort'} == 2) { # last visited date
			@sorted = sort { $b->[11] <=> $a->[11] } @data; # compressed last visited date
		}
		elsif ($info{'sort'} == 3) {
			@sorted = sort { $b->[4] cmp $a->[4] } @data; # if ICQ, put at top
		}
		elsif ($info{'sort'} == 4) {
			@sorted = sort { $a->[6] <=> $b->[6] } @data; # now by sorting rank
		}
		elsif ($info{'sort'} == 5) {
			@sorted = sort { $b->[7] <=> $a->[7] } @data; # by total posts + articles + comments
		}
		elsif ($info{'sort'} == 6) {
			@sorted = sort { $b->[8] cmp $a->[8] } @data; # by status - if status, put at top
		} else {
			@sorted = @data;
		}
		for (@sorted) {
			$sortedrow = join ("|", @$_);
			push (@sortedmembers, $sortedrow);
		}
	}
# ----------------------------------------- End Sorting ------------------------------------	

	$navbar = "$btn{'014'} $nav{'019'}";
	print_top();

	# show list of who's on with link to profiles:
	my $users = "";

	my @entries = read_database("$datadir/log.dat");

	foreach my $curentry (@entries) {
		$curentry =~ s/[\n\r]//g;
		my ($name, $value) = split(/\|/, $curentry);
		if ($name !~ /\./) {
			my @msettings = chomp_database("$memberdir/$name.dat");
			$users = qq~$users <a href="$pageurl/$cgi?action=viewprofile&amp;username=$name">$msettings[1]</a>\n~;
		}
	}

	print qq~<table border="0" width="100%" cellspacing="1">
<tr>
<td valign="top">$msg{'028'} <a href="$pageurl/$cgi?action=viewprofile&amp;username=$thelatestmember">$tlmname</a><br>
$msg{'029'} $count<br>
$msg{'030'} $users</td>
</tr>
</table>
<br>
<form method="POST" action="$pageurl/$cgi?action=searchuser">
$msg{'006'}<INPUT TYPE=RADIO NAME="searchtype" VALUE="searchuserid" CHECKED>
$msg{'013'}<INPUT TYPE=RADIO NAME="searchtype" VALUE="searchusername">
~;

	if (!($hidemail eq "1" || $hidemail eq "")) {
		print qq~$msg{'007'}<INPUT TYPE=RADIO NAME="searchtype" VALUE="searchemail">~;
	}

	print qq~<input type="text" name="membersearch" size="16" class="textinput">
<input type="submit" value="$btn{'001'}" class="button">
</form>
<br>
<table width="100%" class="titlebg" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<table width="100%" border="0" cellspacing="1" cellpadding="2">
<tr>
<td class="windowbg"><a href="$pageurl/$cgi?action=memberlist&amp;sort=0"><b>$msg{'013'}</b></a></td>
<td class="windowbg"><a href="$pageurl/$cgi?action=memberlist&amp;sort=1"><b>$msg{'027'}</b></a></td>
<td class="windowbg"><a href="$pageurl/$cgi?action=memberlist&amp;sort=2"><b>$msg{'535'}</b></a></td>
<td class="windowbg"><a href="$pageurl/$cgi?action=memberlist&amp;sort=3"><b>$msg{'016'}</b></a></td>
<td class="windowbg"><a href="$pageurl/$cgi?action=memberlist&amp;sort=4"><b>$msg{'024'}</b></a></td>
<td class="windowbg"><a href="$pageurl/$cgi?action=memberlist&amp;sort=5"><b>$msg{'031'}</b></a></td>
<td class="windowbg"><a href="$pageurl/$cgi?action=memberlist&amp;sort=6"><b>$msg{'011'}</b></a></td>
</tr>
~;

	my $pagesetting;
	if ($gotomember) { # if no sorting was done, start splitting at beginning of array
		$pagesetting = $start; # reset start for display of cut set (see below where arrays are split out again)
		$start = 0;
	}

	my $cnt = 0;
	my $second = "windowbg3";
	for ($i = $start; $i < @sortedmembers; $i++) {
		if ($second eq "windowbg2") { $second="windowbg3"; }
		else { $second="windowbg2"; }
		# replaced email with last online - Jos
		my ($mname, $lastvisited, $msince, $micq, $mrank, $mposts, $mfunct, $musername) = (split(/\|/, $sortedmembers[$i]))[1..5,7..9]; # unsorted does not have the last field (sortdate)
		$cnt++;
		my $icq = "";
		if ($micq ne "") {
			$icq = qq~<a href="http://www.icq.com/$micq" target="_blank"><img src="http://wwp.icq.com/scripts/online.dll?icq=$micq&amp;img=5" alt="$micq" border="0"></a>~;
		}

		if ($musername eq "") { next; }

		if($msince ne "forever"){ 
			$msince = user_date($msince);
		}
		$lastvisited = user_date($lastvisited);

		print qq~<tr>
<td class="$second"><a href="$pageurl/$cgi?action=viewprofile&amp;username=$musername">$mname</a></td>
~;

		print qq~<td class="$second">$msince</td>
<td class="$second">$lastvisited</td>
<td class="$second">$icq</td>
<td class="$second">$mrank</td>
<td class="$second">$mposts</td>
<td class="$second">$mfunct</td>
</tr>
~;
		if ($cnt >= $maxmembersdisplay) { $i = $count; }
	}

	print qq~</table>
</td>
</tr>
</table>
<br>
~;

	# set page variable not to include sort if no sort:
	my $sortvar = "";

	if ($gotomember) { # if no sorting was done, reset start for paging
		$start = $pagesetting;
	} else {
		$sortvar = qq~&amp;sort=$info{'sort'}~;
	}

	print "<b>$msg{'039'}</b> ";
	$cnt = 0;
	while (($cnt*$maxmembersdisplay) < $count) {
		my $view = $cnt+1;
		my $offset = ($cnt*$maxmembersdisplay);
		if ($start == $offset) { print qq~[$view] ~; }
		elsif ($offset == 0) {
			print qq~<a
 href="$pageurl/$cgi?action=memberlist$sortvar">$view</a> ~;
		} else {
			print qq~<a
 href="$pageurl/$cgi?action=memberlist$sortvar&amp;start=$offset">$view</a> ~;
		}
		$cnt++;
	}

	print qq~<br>
<br>
~;

	print_bottom();
	exit;

}

################
sub searchuser {
################
# Thank you Klaus

	if ($username eq "$anonuser") { error("$err{'011'}"); }
	if ($userrank ne "$root") {
		if ($hidememlist eq "1") { error("$err{'011'}"); } # filter search user view by URL
	}
	undef @allmembers;

	if (!$maxmembersdisplay) { $maxmembersdisplay = $maxmessagedisplay; }

	open(FILE, "$memberdir/memberlist.dat");
	hold(FILE);
	chomp(@memberlist = <FILE>);
	release(FILE);
	close(FILE);

	$thelatestmember = $memberlist[$#memberlist];

	open(FILE, "$memberdir/$thelatestmember.dat");
	hold(FILE);
	chomp(@lmsettings = <FILE>);
	release(FILE);
	close(FILE);

	$tlmname = $lmsettings[1];

	$count = @memberlist; # number of valid member.dat files, used to show total members

	# for paging:
	if (!$input{'membersearch'}) { $input{'membersearch'} = $info{'membersearch'} || ''; }
	if (!$input{'searchtype'}) { $input{'searchtype'} = $info{'searchtype'} || ''; }

	open(FILE, "$memberdir/membergroups.dat");
	hold(FILE);
	@membergroups = <FILE>;
	release(FILE);
	close(FILE);

	$id = 0;

	foreach $member (@memberlist) {
		if (open(FILE, "$memberdir/$member.dat")) {
			hold(FILE);
			chomp(@members = <FILE>);
			release(FILE);
			close(FILE);
		} else { 
			$count--; # subtract from count if no member.dat file
			next;
		}
		if ((@members == 0) || ($members[1] =~ /^$/)) { # filter out blank files or blank realname
			$count--;
			next;
		}
		$id++;
		if ((($input{'searchtype'} eq "searchuserid") && (grep(/$input{'membersearch'}/i, lc($member)))) 
			|| (($input{'searchtype'} eq "searchusername") && (grep(/$input{'membersearch'}/i, lc($members[1])))) 
			|| (($input{'searchtype'} eq "searchemail") && (grep(/$input{'membersearch'}/i, lc($members[2]))))) {
			$searchname = lc $members[1];
			$posts = $members[6]+$members[11]+$members[12];

			# sorting by date:
			($chkmonth, $chkday, $chkyear, $chkhour, $chkmin, $chksec) = split(/\/| - |\:/, $members[10]);
			$chkyear = (2000+$chkyear);
			my $sortdate = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";
			$sortdate =~ s/forever/0/;

			if ($members[7] ne "") {
				$memberinfo = "$members[7]"; # add actual rank
				if ($memberinfo eq "$root") { $rank = 1; } # $rank is a reverse sort variable
				if ($memberinfo eq "$boardmoderator") { $rank = 2; }
	 		} else { # for Moderators and Administrators
				if ($posts > 1500) { $memberinfo = "$membergroups[8]"; $rank = 3; }
				elsif ($posts > 1000) { $memberinfo = "$membergroups[7]"; $rank = 4; }
				elsif ($posts > 500) { $memberinfo = "$membergroups[6]"; $rank = 5; }
				elsif ($posts > 250) { $memberinfo = "$membergroups[5]"; $rank = 6; }
				elsif ($posts > 100) { $memberinfo = "$membergroups[4]"; $rank = 7; }
				elsif ($posts > 25) { $memberinfo = "$membergroups[3]"; $rank = 8; } # allows sort rank for admins and mods
				else { $memberinfo = "$membergroups[2]"; $rank = 9; }
			}
			push (@allmembers, join ("\|", "$searchname|$members[1]|$members[2]|$members[10]|$members[8]|$memberinfo|$rank|$posts|$members[14]|$member|$id|$sortdate\n"));
		}
	}

	for (0..$#allmembers) {
		@fields = split(/\|/, $allmembers[$_]);
		for $i (0..$#fields) {
			$data[$_][$i] = $fields[$i];
		}
	}

	if (!defined $info{'sort'}) { $info{'sort'} = 0 }
	if ($info{'sort'} eq "0") {
		@sorted = sort { $a->[0] cmp $b->[0] } @data; # searched name 
	}
	elsif ($info{'sort'} == 1) {
		@sorted = sort { $a->[2] cmp $b->[2] } @data; # email 
	}
	elsif ($info{'sort'} == 2) { # date
		@sorted = sort { $a->[11] <=> $b->[11] } @data; # by compressed join date
	}
	elsif ($info{'sort'} == 3) {
		@sorted = sort { $b->[4] <=> $a->[4] } @data; # if ICQ, put at top
	}
	elsif ($info{'sort'} == 4) {
		@sorted = sort { $a->[6] <=> $b->[6] } @data; # by sorting rank
	}
	elsif ($info{'sort'} == 5) {
		@sorted = sort { $b->[7] <=> $a->[7] } @data; # by total posts + articles + comments
	}
	elsif ($info{'sort'} == 6) {
		@sorted = sort { $b->[8] cmp $a->[8] } @data; # by status - if status, put at top
	}
	else {
		@sorted = sort { $a->[0] cmp $b->[0] } @data; # searched name 
	}
	for (@sorted) { 
		$sortedrow = join ("|", @$_);
		push (@sortedmembers, $sortedrow);
	}

	$navbar = "$btn{'014'} $nav{'019'}";
	print_top();

	$users = "";

	open(FILE, "$datadir/log.dat");
	hold(FILE);
	@entries = <FILE>;
	release(FILE);
	close(FILE);
	
	foreach $curentry (@entries) {
		$curentry =~ s/[\n\r]//g;
		($name, $value) = split(/\|/, $curentry);
		if ($name !~ /\./) {
			open(FILE, "$memberdir/$name.dat");
			hold(FILE);
			chomp(@msettings = <FILE>);
			release(FILE);
			close(FILE);

			$users = qq~$users <a href="$pageurl/$cgi?action=viewprofile&amp;username=$name">$msettings[1]</a>\n~;
		}
	}

	print qq~<table border="0" width="100%" cellspacing="1">
<tr>
<td valign="top">$msg{'028'} <a href="$pageurl/$cgi?action=viewprofile&amp;username=$thelatestmember">$tlmname</a><br>
$msg{'029'} $count<br>
$msg{'030'} $users</td>
</tr>
</table>
<br>
<form method="POST" action="$pageurl/$cgi?action=searchuser">
$msg{'006'}<INPUT TYPE=RADIO NAME="searchtype" VALUE="searchuserid" CHECKED>
$msg{'013'}<INPUT TYPE=RADIO NAME="searchtype" VALUE="searchusername">
~;

	if (!($hidemail eq "1" || $hidemail eq "")) {
		print qq~$msg{'007'}<INPUT TYPE=RADIO NAME="searchtype" VALUE="searchemail">~; 
	}

	print qq~<input type="text" name="membersearch" size="16" class="textinput">
<input type="submit" value="$btn{'001'}" class="button">
</form>
<br>
<table width="100%" class="titlebg" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<table width="100%" border="0" cellspacing="1" cellpadding="2">
<tr>
~;
	print qq~<td class="windowbg"><a href="$pageurl/$cgi?action=searchuser&amp;membersearch=$input{'membersearch'}&amp;searchtype=$input{'searchtype'}&amp;sort=0"><b>$msg{'013'}</b></a></td>
<td class="windowbg"><a href="$pageurl/$cgi?action=searchuser&amp;membersearch=$input{'membersearch'}&amp;searchtype=$input{'searchtype'}&amp;sort=1"><b>$msg{'007'}</b></a></td>
<td class="windowbg"><a href="$pageurl/$cgi?action=searchuser&amp;membersearch=$input{'membersearch'}&amp;searchtype=$input{'searchtype'}&amp;sort=2"><b>$msg{'027'}</b></a></td>
<td class="windowbg"><a href="$pageurl/$cgi?action=searchuser&amp;membersearch=$input{'membersearch'}&amp;searchtype=$input{'searchtype'}&amp;sort=3"><b>$msg{'016'}</b></a></td>
<td class="windowbg"><a href="$pageurl/$cgi?action=searchuser&amp;membersearch=$input{'membersearch'}&amp;searchtype=$input{'searchtype'}&amp;sort=4"><b>$msg{'024'}</b></a></td>
<td class="windowbg"><a href="$pageurl/$cgi?action=searchuser&amp;membersearch=$input{'membersearch'}&amp;searchtype=$input{'searchtype'}&amp;sort=5"><b>$msg{'031'}</b></a></td>
<td class="windowbg"><a href="$pageurl/$cgi?action=searchuser&amp;membersearch=$input{'membersearch'}&amp;searchtype=$input{'searchtype'}&amp;sort=6"><b>$msg{'011'}</b></a></td>
</tr>
~;

	$start = $info{'start'} || 0;

	$count = 0;
	$second = "windowbg3";
	for ($i = $start; $i < @sortedmembers; $i++) {
		$count++;
		if ($second eq "windowbg2") { $second="windowbg3"; }
		else { $second="windowbg2"; }
		my ($mname, $memail, $msince, $micq, $mrank, $mposts, $mfunct, $musername) = (split(/\|/, $sortedmembers[$i]))[1..5,7..9];
		if ($musername eq "") { next; }
		$icq = "";
		if ($micq ne "") {
			$icq = qq~<a href="http://www.icq.com/$micq" target="_blank"><img src="http://wwp.icq.com/scripts/online.dll?icq=$micq&amp;img=5" alt="$micq" border="0"></a>~;
		}

		print qq~<tr>
<td class="$second"><a href="$pageurl/$cgi?action=viewprofile&amp;username=$musername">$mname</a></td>
~;
		if ($hidemail eq "1" || $hidemail eq "") {
			print qq~<td class="$second"><a
 href="$pageurl/$cgi?action=anonemail&sendto=$musername">$msg{'007'} $mname</a></td>
~;
		} else {
			print qq~<td class="$second"><a
 href="mailto:$memail">$memail</a></td>
~;
		}
		print qq~<td class="$second">$msince</td>
<td class="$second">$icq</td>
<td class="$second">$mrank</td>
<td class="$second">$mposts</td>
<td class="$second">$mfunct</td>
</tr>
~;
		if ($count >= $maxmembersdisplay) { $i = @allmembers; }
	}

	print qq~</table>
</td>
</tr>
</table>
<br>
<b>$msg{'039'}</b> ~;

	$nummembers = @allmembers;
	$count = 0;
	while (($count*$maxmembersdisplay) < $nummembers) {
		$view = $count+1;
		$offset = ($count*$maxmembersdisplay);
		if ($start == $offset) { print qq~[$view] ~; }
		elsif ($offset == 0) {
			print qq~<a
 href="$pageurl/$cgi?action=searchuser&amp;membersearch=$input{'membersearch'}&amp;searchtype=$input{'searchtype'}&amp;sort=$info{'sort'}">$view</a> ~;
		} else {
			print qq~<a
 href="$pageurl/$cgi?action=searchuser&amp;membersearch=$input{'membersearch'}&amp;searchtype=$input{'searchtype'}&amp;sort=$info{'sort'}&amp;start=$offset">$view</a> ~;
		}
		$count++;
	}

	print qq~<br>
<br>
~;

	print_bottom();
	exit;

}

if (-e "$user_lib/memberlist.pl") {require "$user_lib/memberlist.pl"}

1; # return true