###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# poll.pl                                                  	              #
# v0.9.9.3.4                                                                  #
# Vote All Polls by: Jos Brown (www.bantychick.com)                           #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified: Dec 16 2005                                                 #
# Modified: 16 May, 23 May, 14 Aug, 15 Aug, 16 Aug 2006 by Jos                #
###############################################################################
###############################################################################

##########
sub poll {
##########

	if (!defined &boxtop) { # old themes compatibility
		print qq~<tr>
<td align="center">~;
	}

	my @polls = read_database("$datadir/polls/polls.txt");

	if (@polls == 0) {
		print qq~<div class="pollquestion" align="center">$msg{'153'}</div>~;
	} else {
		my ($pollid, $pollname) = split(/\|/, $polls[0]);
		my $pollidq = $pollid . '_q';

		print qq~<div class="poll">
<div class="pollquestion">$pollname</div>
<form action="$pageurl/$cgi?action=pollit" method="post">
<input type="hidden" name="id" value="$pollid">
<input type="hidden" name="submitted" value="1">
<div style="text-align: left">
~;

		my @data = chomp_database("$datadir/polls/$pollidq.dat");

		for ($i = 0; $i < @data; $i++) {
			print qq~<div class="poll"><input type="radio" name="answer" value="$i">$data[$i]</div>
~;
		}

		print qq~</div>
<input type="submit" class="votebutton" value="$btn{'002'}"></form>
<a href="$pageurl/$cgi?action=pollit2&amp;id=$pollid" class="polllink">$nav{'013'}</a><br>
<a href="$pageurl/$cgi?action=pollit3&amp;id=$pollid#morepolls" class="polllink">$xtr{'002'}</a></div>
~;

	}

	if (!defined &boxbottom) { # old themes compatibility
		print qq~</td>
</tr>
~;
	}

}

############
sub pollit {
############

	# Get remote host if server does not:
	unless ($ENV{REMOTE_HOST}) {
		my $ip_num = pack("C4", split(/\./, $ENV{REMOTE_ADDR}));

		if (gethostbyaddr($ip_num, 2)) {
			$ENV{REMOTE_HOST} = scalar gethostbyaddr($ip_num, 2);
		}
		$ENV{REMOTE_HOST} = $ENV{REMOTE_ADDR} unless $ENV{REMOTE_HOST};
	}

	if (($multiplevoting eq "0") || ($multiplevoting eq "")) {
		check_ip();
	}

	if ($input{'answer'} eq "") { error("$err{'019'}"); }

	open(FILE, "$datadir/polls/polls.txt") || error("$err{'001'} $datadir/polls/polls.txt");
	hold(FILE);
	@polls = <FILE>;
	release(FILE);
	close(FILE);

	if ($input{'id'} =~ /(\$+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

	open(FILE, "$datadir/polls/$input{'id'}_a.dat") || error("$err{'001'} $datadir/polls/$input{'id'}_a.dat");
	hold(FILE);
	chomp(@data = <FILE>);
	release(FILE);
	close(FILE);

	open(FILE, ">$datadir/polls/$input{'id'}_a.dat") || error("$err{'016'} $datadir/polls/$input{'id'}_a.dat");
	hold(FILE);
	for ($i = 0; $i < @data; $i++) {
		if ($i == $input{'answer'}) {
			$count = $data[$i] + 1;
			print FILE "$count\n";
		}
		else { print FILE "$data[$i]\n"; }
	}
	release(FILE);
	close(FILE);

	open(LOG, ">>$datadir/polls/$input{'id'}_ip.dat") || error("$err{'001'} $datadir/polls/$input{'id'}_ip.dat");
	hold(LOG);
	print LOG "$ENV{'REMOTE_ADDR'}|$ENV{'REMOTE_HOST'}\n";
	release(LOG);
	close(LOG);

	print "Location: $cgi?action=pollit2&id=$input{'id'}\n\n";

}

#############
sub pollit2 {
#############

	open(FILE, "$datadir/polls/polls.txt") || error("$err{'001'} $datadir/polls/polls.txt");
	hold(FILE);
	@polls = <FILE>;
	release(FILE);
	close(FILE);

	foreach $line (@polls) {
		($pollid, $pollname) = split(/\|/, $line);
		if ($pollid eq $info{'id'}) { $polltitle = $pollname; }
	}

	if ($info{'id'} =~ /(\$+|\?+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

	open(FILE, "$datadir/polls/$info{'id'}_q.dat") || error("$err{'001'} $datadir/polls/$info{'id'}_q.dat!");
	hold(FILE);
	chomp(@questions = <FILE>);
	release(FILE);
	close(FILE);

	if ($info{'id'} =~ /(\$+|\?+|\|+|\(+|\)+|\[+|\]+|\{+|\}+|\^+|\*+|\.+|\<)/) { print_top();  print "What are you doing Stan?"; print_bottom(); exit; }

	open(FILE, "$datadir/polls/$info{'id'}_a.dat") || error("$err{'001'} $datadir/polls/$info{'id'}_a.dat!");
	hold(FILE);
	chomp(@answers = <FILE>);
	release(FILE);
	close(FILE);

	if (open(FILE, "$datadir/polls/$info{'id'}_c.dat")) { # warning fix not in core code
		hold(FILE);
		chomp(@comments = <FILE>);
		release(FILE);
		close(FILE);
	}

	$totalvotes = 0;
	for ($x = 0; $x < @answers; $x++) {
		$totalvotes = $totalvotes + $answers[$x];
	}

	$navbar = "$btn{'014'} $nav{'013'}";
	print_top();

	print qq~<BR>
<table align="center" cellpadding="0" cellspacing="0" border="0">
<tr>
<td colspan="2" align="center"><b>$msg{'064'} $polltitle</b><br><br></td>
</tr>
~;
	for ($i = 0; $i < @answers; $i++) {
		if ($totalvotes ne 0) {
			$pixels = int((($answers[$i]/$totalvotes) * 100)/2);
			$procent = ($answers[$i]/$totalvotes) * 100;
			$c = int(10*($procent*10 - int($procent*10)));
			$b = int(10*($procent - int($procent)));
			$a = int($procent);
			if ($c >= 5) { $b++ }
		} else {
			$a = 0;
			$b = 0;
			$pixels = 0;
		}
		$procent = $a.".".$b;

		print qq~<tr>
<td>$questions[$i]:</td>
<td><img src="$imagesurl/leftbar.gif" width="7" height="14" alt=""><img
 src="$imagesurl/mainbar.gif" width="$pixels" height="14" alt=""><img
 src="$imagesurl/rightbar.gif" width="7" height="14" alt="">&nbsp;&nbsp;$answers[$i]&nbsp;($procent%)</td>
</tr>
~;
	}

	print qq~<tr>
<td colspan="2" align="center"><br><br>$msg{'065'} $totalvotes</td>
</tr>
</table>
<br>
<table border="0" cellpadding="1" cellspacing="3" width="100%">
<tr>
<td colspan="2" align="center"
 class="commenttitleback">$msg{'617'} &quot; $polltitle &quot;</td>
</tr>~;

	if (@comments) {
		for ($a = 0; $a < @comments; $a++) {
			@item = split (/\|/, $comments[$a]);
			display_date($item[2]); $item[2] = $user_display_date;
			$message = $item[3];
			$message = censor_it($message);
			if ($enable_ubbc) { doubbc(); }
			if ($enable_smile) { dosmilies(); }

			print qq~<tr><td class="commentsubtitleback" valign="top" colspan="2"> &nbsp;$msg{'110'} $item[2] $msg{'042'} ~;

			if ($username ne $anonuser) {
				print qq~<a href="$pageurl/$cgi?action=imsend&amp;to=$item[0]">$item[1]</a>~;
			} else {
				print qq~<b>$item[1]</b>~;
			}
			if ($username eq "admin") {
				print qq~&nbsp;&nbsp;-&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=editpollcomment&id=$info{'id'}&num=$a">[Edit]</a>&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=removepollcomment&id=$info{'id'}&num=$a">[Remove]</a>~;
			}

 			if ($userrank eq "$root" && $editpoll eq "1" && $username ne "admin") {
				print qq~&nbsp;&nbsp;-&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=editpollcomment&id=$info{'id'}&num=$a">[Edit]</a>&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=removepollcomment&id=$info{'id'}&num=$a">[Remove]</a>~;
			}

			print qq~</td>
</tr>
<tr>
<td valign="top" colspan="2">$message<br><br></td>
</tr>
~;
		}

		print qq~<tr>
<td colspan="2" align="center" class="newssubtitle">$msg{'159'}~;
		if ($username eq $anonuser) {
			print qq~<br><br>$msg{'611'}~;
		}

		print qq~<br><br></td></tr>~;
	} else {
		print qq~<tr>
<td align="center" colspan="2">$msg{'043'}<br><br></td>
</tr>
~;
	}

	print qq~</table>~;

	if ($username ne $anonuser) {
		print qq~<form action="$pageurl/$cgi?action=commentpoll" method="post">
<table border="0" cellpadding="1" cellspacing="3" width="100%">
<tr>
<td colspan="2" align="center" class="commenttitleback">$msg{'618'} &quot; $polltitle&quot;</td>
</tr>
<tr>
<td class="formstextnormal" valign="top">$msg{'023'}</td><td><textarea name="message" rows="5" cols="40"></textarea></td>
</tr>
<tr>
<td colspan="2" align="center">
<input type="hidden" value="$info{'id'}" name="id">
<input type="hidden" name="rname" value="$realname">
<input type="hidden" name="uname" value="$username">
<input type="submit" class="button" value="$btn{'012'}">&nbsp;&nbsp;<input type="reset" class="button" value="$btn{'009'}"></td>
</tr>
</table>
</form>
<br>
~;
	}

	if (@polls > 1) {
		print qq~<div align="center"><table
 border="0" cellpadding="1" cellspacing="3" width="80%">
<tr>
<td colspan="2" align="center" class="commenttitleback"><b>$msg{'150'}</b></td>
</tr>
~;

		foreach $line(@polls) {
			($pollid, $pollname) = split(/\|/, $line);
			if ($pollid ne $info{'id'}) {
				print qq~<tr>
<td width="70%" class="forumwindow3">&nbsp;$pollname</td>
<td width="30%" class="forumwindow1">&nbsp;<a href="$pageurl/$cgi?action=pollit3&id=$pollid">$msg{'647'}</a></td>
</tr>
~;

			}
		}

		print qq~</table>
</div>
<br>
<br>
~;
	}

	print_bottom();
	exit;

}

#############
sub pollit3 {
#############

	if ($info{'id'} !~ /^\d*#?\w*$/) { &data_error; }

	my @polls = read_database("$datadir/polls/polls.txt");

	foreach $line(@polls) {
		($pollid, $polltitle) = split(/\|/, $line);
		if ($pollid eq $info{'id'}) {
			last;
		}
	}

	my @questions = chomp_database("$datadir/polls/$info{'id'}_q.dat");

	my @answers = chomp_database("$datadir/polls/$info{'id'}_a.dat");
	
	if (open(FILE, "$datadir/polls/$info{'id'}_c.dat")) {
		holdr(FILE);
		chomp(@comments = <FILE>);
		close(FILE);
	}

	my $totalvotes = 0;
	for ($x = 0; $x < @answers; $x++) {
		$totalvotes += $answers[$x];	
	}
	
	$navbar = "$btn{'014'} $nav{'041'} $info{'id'}";
	print_top();

	print qq~<div style="text-align:center"><div style="width:160px">
<br>
~;

	print qq~<div class="menutable">&nbsp;$btn{'002'}</div>
<div class="menubordercolor" style="padding: 1px;">
<div class="menubackcolor">
<div class="pollquestion">$polltitle</div>
<form action="$pageurl/$cgi?action=pollit" method="post"><table
 align="center" cellpadding="1" cellspacing="0">~;

	for ($i = 0; $i < @questions; $i++) {
		print qq~<tr><td valign="top"><input
 type="radio" name="answer" value="$i"></td>
<td align="left" valign="middle" class="poll" style="text-align: left">$questions[$i]</td>
</tr>
~;
	}

	print qq~<tr><td align="center" colspan="2"><input
 type="submit" class="votebutton"
 value="$btn{'002'}"></td></tr></table>
<!-- input type="hidden" name="id" value="$pollid" -->
<input type="hidden" name="id" value="$info{'id'}">
<input type="hidden" name="submitted" value="1"></form>~;

	print qq~</div></div></div>
</div>
~;

	print qq~<br>
<table align="center" cellpadding="0" cellspacing="0" border="0">
<tr>
<td colspan="2" align="center"><b>$msg{'749'} &quot; $polltitle&quot;</b><br><br></td>
</tr>
~;
	for ($i = 0; $i < @answers; $i++) {
		if ($totalvotes ne 0) {
			$pixels = int((($answers[$i]/$totalvotes) * 100)/2);
			$procent = ($answers[$i]/$totalvotes) * 100;
			$c = int(10*($procent*10 - int($procent*10)));
			$b = int(10*($procent - int($procent)));
			$a = int($procent);
			if ($c >= 5) { $b++ }
		} else { 
			$a = 0; 
			$b = 0;
		}
		$procent = $a.".".$b;

		print qq~<tr>
<td>$questions[$i]:</td>
<td><img src="$imagesurl/leftbar.gif" width="7" height="14" alt=""><img
 src="$imagesurl/mainbar.gif" width="$pixels" height="14" alt=""><img
 src="$imagesurl/rightbar.gif" width="7" height="14" alt="">&nbsp;&nbsp;$answers[$i]&nbsp;($procent%)</td>
</tr>
~;
	}

	print qq~<tr>
<td colspan="2" align="center"><br><br>$msg{'065'} $totalvotes</td>
</tr>
</table>
<br>
<table border="0" cellpadding="1" cellspacing="3" width="100%">
<tr>
<td colspan="2" align="center" class="commenttitleback">$msg{'617'} &quot; $polltitle&quot;</td>
</tr>
~;

	if (@comments) {
		for ($a = 0; $a < @comments; $a++) {
			@item = split (/\|/, $comments[$a]);
			display_date($item[2]); $item[2] = $user_display_date;
			$message = $item[3];
			$message = censor_it($message);
			if ($enable_ubbc) { doubbc(); }
			if ($enable_smile) { dosmilies(); }
			
			print qq~<tr><td class="commentsubtitleback" valign="top" colspan="2"> &nbsp;$msg{'110'} $item[2] $msg{'042'} ~;

			if ($username ne $anonuser) {
				print qq~<a
 href="$pageurl/$cgi?action=imsend&amp;to=$item[0]">$item[1]</a>~;
			} else {
				print qq~<b>$item[1]</b>~;
			}

			if ($username eq "admin") {
				print qq~&nbsp;&nbsp;-&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=editpollcomment&id=$info{'id'}&num=$a">[Edit]</a>
&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=removepollcomment&id=$info{'id'}&num=$a">[Remove]</a>~;
			}

			if ($userrank eq "$root" && $editpoll eq "1" && $username ne "admin") { #-w Feb 6 2004
				print qq~&nbsp;&nbsp;-&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=editpollcomment&id=$info{'id'}&num=$a">[Edit]</a>
&nbsp;&nbsp;<a
 href="$pageurl/$cgi?action=removepollcomment&id=$info{'id'}&num=$a">[Remove]</a>~;
			}

			print qq~</td>
</tr>
<tr>
<td valign="top" colspan="2">$message<br><br></td>
</tr>~;
		}

		print qq~<tr><td colspan="2" align="center"
 class="newssubtitle">$msg{'159'}~;

		if ($username eq $anonuser) {
			print qq~<br><br>$msg{'611'}~;
		}

		print qq~<br><br></td></tr>~;
	} else {
		print qq~<tr>
<td align="center" colspan="2">$msg{'043'}<br><br></td>
</tr>
~; 
	}

	print qq~</table>
~;

	if ($username ne $anonuser) {
		print qq~<form action="$pageurl/$cgi?action=commentpoll" method="post">
<table border="0" cellpadding="1" cellspacing="3" width="100%">
<tr>
<td colspan="2" align="center" class="commenttitleback"> $msg{'618'} &quot; $polltitle&quot;</td>
</tr>
<tr>
<td class="formstextnormal" valign="top">$msg{'023'}</td><td><textarea
 name="message" rows="5" cols="40"></textarea></td>
</tr>
<tr>
<td colspan="2" align="center">
<input type="hidden" value="$info{'id'}" name="id">
<input type="hidden" name="rname" value="$realname">
<input type="hidden" name="uname" value="$username">
<input type="submit" class="button" value="$btn{'012'}">&nbsp;&nbsp;<input
 type="reset" class="button" value="$btn{'009'}"></td>
</tr>
</table></form><br>
~;
	}

	if (@polls > 1) {
		print qq~<a name="morepolls"></a><div align="center"><table
 border="0" cellpadding="1" cellspacing="3" width="80%">
<tr>
<td colspan="2" align="center" class="commenttitleback"><b>$msg{'150'}</b></td>
</tr>
~;

		foreach $line (@polls) {
			@item = split(/\|/, $line);
			if ($item[0] ne $info{'id'}) {
				print qq~<tr>
<td width="70%" class="forumwindow3">&nbsp;$item[1]</td>
<td width="30%" class="forumwindow1">&nbsp;<a
 href="$pageurl/$cgi?action=pollit3&id=$item[0]">$msg{'647'}</a></td>
</tr>
~;
			}
		}
		print qq~</table>
</div>
<br>
<br>
~;
	}

	print_bottom();
	exit;

}

##############
sub check_ip {
##############

	open(FILE, "$datadir/polls/polls.txt") || error("$err{'001'} $datadir/polls/polls.txt");
	hold(FILE);
	@polls = <FILE>;
	release(FILE);
	close(FILE);

	($id[0], $name[0]) = split(/\|/, $polls[0]);
	$usersip = $ENV{'REMOTE_ADDR'};

	open('LOG', "$datadir/polls/$input{'id'}_ip.dat") || error("$err{'001'} $datadir/polls/$id[0]_ip.dat");
	hold(LOG);
	@entries = <LOG>;
	release(LOG);
	close(LOG);

	foreach $curentry (@entries) {
		$curentry =~ s/\n//g;
		$curentry =~ s/\r//g;
		($ip, $host) = split(/\|/, $curentry);
		if ($usersip eq "$ip") { error("$err{'020'}") }
	}
}

#################
sub commentpoll {
#################
	if($username eq "$anonuser") { error("noguests"); }

	error("$err{'015'}") unless ($input{'message'});

	open(FILE, "$datadir/polls/$input{'id'}_c.dat");
	hold(FILE);
	@datas = <FILE>;
	release(FILE);
	close(FILE);

	$message = htmlescape($input{'message'});

	open(FILE, ">$datadir/polls/$input{'id'}_c.dat");
	hold(FILE);
	print FILE "$input{'uname'}|$input{'rname'}|$date|$message\n";
	print FILE @datas;
	release(FILE);
	close(FILE);

	print "Location: $pageurl/$cgi?action=pollit2&id=$input{'id'}\n\n";
}

#################
sub removepollcomment {
#################
	if ($userrank ne "$root") {error("$err{'011'}");}
	if ($username ne "admin" &&  $userrank eq "$root" && $editpoll ne "1") { error("$err{'011'}"); }

	open(FILE, "$datadir/polls/$info{'id'}_c.dat");
	hold(FILE);
	chomp(@datas = <FILE>);
	release(FILE);
	close(FILE);

	open(FILE, ">$datadir/polls/$info{'id'}_c.dat");
	hold(FILE);
	for ($a = 0; $a < @datas; $a++) {
	@item = split (/\|/, $datas[$a]);
	if ($a ne $info{'num'}) {
	print FILE "$item[0]|$item[1]|$item[2]|$item[3]\n";}
	}
	release(FILE);
	close(FILE);

	print "Location: $pageurl/$cgi?action=pollit2&id=$info{'id'}\n\n";
}

#################
sub editpollcomment {
#################
	if ($userrank ne "$root") {error("$err{'011'}");}
	if ($username ne "admin" &&  $userrank eq "$root" && $editpoll ne "1") { error("$err{'011'}"); }

	open(FILE, "$datadir/polls/$info{'id'}_c.dat");
	hold(FILE);
	chomp(@datas = <FILE>);
	release(FILE);
	close(FILE);

	for ($a = 0; $a < @datas; $a++) {
	@citem = split (/\|/, $datas[$a]);
	if ($a eq $info{'num'}) {
	$message = htmltotext($citem[3]);
	$navbar = "$btn{'014'} $nav{'035'}";
	print_top();
	print qq~<table border="0" cellpadding="1" cellspacing="3" width="100%">
	<form action="$pageurl/$cgi?action=editpollcomment2" method="post">
	<tr>
			<td class="formstextnormal" valign="top">$msg{'023'}</td><td><textarea name="message" rows="5" cols="40">$message</textarea></td>
	</tr>
	<tr>
			<td colspan="2">
			<input type="hidden" value="$info{'id'}" name="id">
			<input type="hidden" value="$info{'num'}" name="num">
			<input type="hidden" name="rname" value="$citem[1]">
			<input type="hidden" name="uname" value="$citem[0]">
			<input type="hidden" name="cdate" value="$citem[2]">
			<input type="submit" class="button" value="$btn{'030'}"><input type="reset" class="button" value="$btn{'009'}"></td>
	</tr>
	</form>
	</table>~;

	print_bottom();
	exit;}
	}


}

#################
sub editpollcomment2 {
#################
	if ($userrank ne "$root") {error("$err{'011'}");}
	if ($username ne "admin" &&  $userrank eq "$root" && $editpoll ne "1") { error("$err{'011'}"); }

	error("$err{'015'}") unless ($input{'message'});

	open(FILE, "$datadir/polls/$input{'id'}_c.dat");
	hold(FILE);
	chomp(@datas = <FILE>);
	release(FILE);
	close(FILE);

	$message = htmlescape($input{'message'});

	open(FILE, ">$datadir/polls/$input{'id'}_c.dat");
	hold(FILE);
	for ($a = 0; $a < @datas; $a++) {
	@citem = split (/\|/, $datas[$a]);
		 if ($a eq $input{'num'}) {
		 print FILE "$input{'uname'}|$input{'rname'}|$input{'cdate'}|$message\n";
		 } else {
		 print FILE "$citem[0]|$citem[1]|$citem[2]|$citem[3]\n";
		 }
	}
	release(FILE);
	close(FILE);

	print "Location: $pageurl/$cgi?action=pollit2&id=$input{'id'}\n\n";
}

if (-e "$user_lib/poll.pl") {require "$user_lib/poll.pl"}

1; # return true