###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# recommend.pl                                                                #
# v0.9.9.3.4                                                                  #
# CAPTCHA visual verification by: Shaka_Flex                                  #
# CAPTCHA integration by: Mossad                                              #
# Security and Spam Filters by: On (www.mlapp.org)                            #
# Language Tags and HTML/code Fixes by: Jos Brown (www.bantychick.com)        #
# Mail::RFC822::Address validation by: Jos                                    #
# CSS Update by: my2cents (classicchat.net)                                   #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified: 13 Apr 2006 by my2cents                                           #
# Modified: 17 May 2006 by Jos                                                #
###############################################################################
###############################################################################

###############
sub recommend {
###############

	if ($username ne $anonuser) {
		$membername = "$realname";
		$email = "$realemail";
		$email_show = "$realemail";
		$memname_show = "$realname";
		$memberdescr = ", $msg{'742'} $pagename,";
	} else {
		### CAPTCHA ###		
		my @captcha;
		if (open(CAPTCHA, "$datadir/conf/captcha.cfg")) {
			holdr(CAPTCHA);
			chomp(@captcha = <CAPTCHA>);
			close(CAPTCHA);
		}
		my $allowgrec = $captcha[2] || "yes";

		if ($allowgrec ne "yes") {
			error("noguests");
		} else {
			my $ablevisual = $captcha[0] || "yes";
			if ($ablevisual eq "yes") {
				require "$sourcedir/captcha.pl"; 
				$Imagehtml = get_image();
			} else {
				$Imagehtml = "";
			}

			$membername = "";
			$email = "";
			$email_show = "$pagename";
			$memname_show = "($msg{'060'})";
			$memberdescr = ", $msg{'743'} $pagename,";
		}
	}

	$entermsg = $inf{'012'}; 
	$entermsg =~ s/\n/<br>/g; 

	$navbar = "$btn{'014'} $nav{'008'}"; 
	print_top(); 

	print qq~<form method="post" action="$pageurl/$cgi?action=recommend2"><input
 type="hidden" name="mdesc" value="$memberdescr">
<table border="0" cellspacing="1">
<tr>
<td nowrap><b>$msg{'060'}:</b></td>
<td><input type="text" class="textinput" name="sender_name" size="25" value="$membername"></td>
</tr>
<tr>
<td><b>$msg{'061'}</b></td>
<td><input type="hidden" name="sender_email" value="$email">$email_show</td>
</tr>
<tr>
<td nowrap><b>$msg{'062'}:</b></td>
<td><input type="text" class="textinput" name="recip_name" size="25" value=""></td>
</tr>
<tr>
<td nowrap><b>$msg{'063'}</b></td>
<td><input type="text" class="textinput" name="recip" size="25" value=""></td>
</tr>
<tr>
<td nowrap><b>$nav{'036'}:</b></td>
<td><textarea name="my_message" wrap="virtual" rows="5" cols="35"></textarea></td>
</tr>
<tr>
<td>&nbsp;</td>
<td><b>$msg{'175'}</b>
<br><br>($msg{'062'}),<br><br>$memname_show$memberdescr $entermsg</td>
</tr>
<tr>
<td align="center" colspan="2">~;

	### CAPTCHA ###
	print qq~$Imagehtml~;

	print qq~<input type="submit" value="$btn{'005'}" class="button"></td>
</tr>
</table>
</form>
~;

	print_bottom();
 	exit;

} 

################
sub recommend2 {
################

	### CAPTCHA ###		
	if($username eq $anonuser) {
		my @captcha;
		if (open(CAPTCHA, "$datadir/conf/captcha.cfg")) {
			holdr(CAPTCHA);
			chomp(@captcha = <CAPTCHA>);
			close(CAPTCHA);
		}
		my $allowgrec = $captcha[2] || "yes";

		if ($allowgrec ne "yes") {
			error("noguests");
		} else {
			my $ablevisual = $captcha[0] || "yes";
			if ($ablevisual eq "yes") {
				require "$sourcedir/captcha.pl"; 
				my $secret_images = get_image(1, $input{'security_key'}, $input{'date_captcha'});
				if (!$secret_images) {
					error("$cha{'001'}");
				}
			}
		}
	}

	if (!$input{'sender_name'}) {
		$sender_name = "$anonuser";
	} else {
		$sender_name = $input{'sender_name'};
	}
	if (!$input{'sender_email'}) {
		$sender_email = "$webmaster_email";
	} else {
		$sender_email  = $input{'sender_email'};
	}
	
	if (!$input{'recip'}) { error("$err{'018'}"); }
	if (!$input{'recip_name'}) { error("$err{'017'}"); }
	$recip_email = $input{'recip'};
	$recip_name  = $input{'recip_name'};

	use lib "$sourcedir";
	use Mail::RFC822::Address qw(valid validlist);
	unless(valid($recip_email)) {
		error ("$err{'006'} - <b><font color=red>$recip_email</font></b>");
	}
	
	$memberdescr = $input{'mdesc'};

	$sender_email= clean_tags($sender_email);
	$recip_name= clean_tags($recip_name);
	$recip_email = clean_tags($recip_email);
	$input{'my_message'} = clean_tags($input{'my_message'});

	$subject = "$inf{'010'}: $pagename";
	$message = qq~$recip_name,

	$sender_name$memberdescr $inf{'012'}

	$input{'my_message'}

~;

	sendemail($recip_email, $subject, $message, $sender_email);

	open (LOG,">>$datadir/recommend.log");
	hold(LOG);
	print LOG"$date|$ENV{'REMOTE_ADDR'}|$sender_name|$sender_email|$recip_name|$recip_email\n";
	close(LOG);

	$navbar = "$btn{'014'} $nav{'008'}";
	print_top();

	print qq~$inf{'013'} <b>$recip_name ($recip_email)</b><br>
$inf{'014'}
~; 
	print_bottom();
	exit;

} 

################
sub clean_tags {
################

	local $tag = $_[0];
	$tag =~ s/\&/\&amp;/g;
	$tag=~ s/</\&lt;/g;
	$tag =~ s/>/\&gt;/g;
	$tag =~ s/"/\&quot;/g;
	return $tag;

}

if (-e "$user_lib/recommend.pl") {require "$user_lib/recommend.pl"}

1; # return true