###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# subs.pl                                                                     #
# v0.9.9.3.4                                                                  #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
###############################################################################
###############################################################################

################
sub loadcookie {
################

	if ($input{'rememberme'}) {
	$cookie_expdate = "Thu, 01-Jan-2099 00:00:00 GMT";
	}
	else {
		$cookie_expdate = '';
	}
	if ($ENV{'HTTP_COOKIE'}) {
		foreach (split(/; /,$ENV{'HTTP_COOKIE'})) {
			($cookie, $value) = split(/=/);
			if ($cookie eq $cookieusername) { $username = $value; }
			if ($cookie eq $cookiepassword) { $password = $value; }
			if ($cookie eq $cookieusertheme) { $usertheme = $value; }
			if ($cookie eq $cookieuserlang) { $userlang = $value; }
		}
	}
}

##############
sub loaduser {
##############
# modified for theme/lang chooser by  ("bantychick")

	my $noselector = '';
	if ($info{'theme'}) { # theme chooser
		# stop the spiders, but allow for W3C to check inactive themes:
		if (($ENV{'HTTP_REFERER'}) || ($ENV{'HTTP_USER_AGENT'} =~ /W3C_Validator/)) { # stop the spiders, allow W3C
			$usertheme = $info{'theme'};
			print qq~Set-Cookie: $cookieusertheme=$info{'theme'}; path=/; expires=Thu, 01-Jan-2099 00:00:00 GMT;\n~;
		} else { $noselector = 1; }
	}
	if ($info{'lang'}) { # lang chooser
		if ($ENV{'HTTP_REFERER'}) {
			$userlang = $info{'lang'} . ".lng";
			print qq~Set-Cookie: $cookieuserlang=$userlang; path=/; expires=Thu, 01-Jan-2099 00:00:00 GMT;\n~;
		} else { $noselector = 1; }
	}

	if (!defined $username) { $username = ''; }
	if ($username eq '') {
		$username = $anonuser;

		if (!$usertheme) { # theme chooser
			$usertheme = "$defaulttheme";
		}
		if (!$userlang) { # lang chooser
			$userlang = $language;
		}

		print qq~Set-Cookie: $cookieusername=; path=/; expires=$cookie_expdate\n~;
		print qq~Set-Cookie: $cookiepassword=; path=/; expires=$cookie_expdate\n~;

		if (!$usertheme) { # theme chooser
			print qq~Set-Cookie: $cookieusertheme=; path=/; expires=$cookie_expdate\n~;
		}
		if (!$userlang) { # lang chooser
			print qq~Set-Cookie: $cookieuserlang=; path=/; expires=$cookie_expdate\n~;
		}

		$password = "";
		@settings = ();
		$userrank = "";
		$userstatus = "";
		$realname = "";
		$realemail = "";
		$ENV{'HTTP_COOKIE'} = "";
		$user_check_date = $check_date;
		$user_check_time = $timezone;
	}

	if ($username ne $anonuser) {
		# fix for Delete Member Profile Leaves Cookie - Abywn and 
		if (open(FILE, "$memberdir/$username.dat")) {
			holdr(FILE);
			chomp(@settings = <FILE>);
			close(FILE);
		} else { @settings = (); }

		# security measure by Shaka_Flex:
		if ((@settings == 0) || ($settings[0] ne $password && $action ne "logout")) {
			print qq~Set-Cookie: $cookieusername=; path=/; expires=$cookie_expdate\n~;
			print qq~Set-Cookie: $cookiepassword=; path=/; expires=$cookie_expdate\n~;
			print qq~Set-Cookie: $cookieusertheme=; path=/; expires=$cookie_expdate\n~;
			print qq~Set-Cookie: $cookieuserlang=; path=/; expires=$cookie_expdate\n~;

			$username = $anonuser;
			$password = "";
			$usertheme = "$defaulttheme";
			$userlang = $language;
			@settings = ();
			$userrank = "";
			$userstatus = "";
			$realname = "";
			$realemail = "";
			$ENV{'HTTP_COOKIE'} = "";
			$user_check_date = $check_date;
			$user_check_time = $timezone;
		} else {
			$realname = $settings[1];
			$realemail = $settings[2];
			$userrank = $settings[7];

			if (!$usertheme) { # theme chooser
				$usertheme = $settings[13];
			}

			$userstatus = $settings[14];

			if (!$userlang) { # lang chooser
				$userlang = $settings[15];
			}

			$user_check_date = $settings[25];
			$user_check_time = $settings[26];
			$writedate = $date;
			writelog("Last_Visited");
		}
	}

	# fix for missing theme - Jane, admin set theme for all and no user choose theme - :
	if ((!$usertheme) || (!(-e "$themesdir/$usertheme/theme.pl")) || ($letmemthm ne "1")) {
		$usertheme = "$defaulttheme";
	}
	if ($userlang eq "") { $userlang = $language; }
	&getlanguage; # needed here for admin files, calendar, mods

	if ($noselector) { # theme/lang chooser
		# other main loading subs so stats log error visit:
		logips();
		&ban;
		logvisitors();
		&getver;
		error("$err{'051'}");
	}

}

#################
sub logvisitors {
#################

	if ($username ne $anonuser) {
		$field = $username;
		$fieldcheck = "$ENV{'REMOTE_ADDR'}";
	} else {
		$field = "$ENV{'REMOTE_ADDR'}";
		$fieldcheck = "";
	}

#	$location = $ENV{'REQUEST_URI'}; # changed 24 Aug 2006
	if ($ENV{'REQUEST_URI'}) {
		$location = $ENV{'REQUEST_URI'};
	} else {
		# REQUEST_URI not set by IIS
		$location = $ENV{'SCRIPT_NAME'} . '?' . $ENV{'QUERY_STRING'};
	}
	$location2 = $ENV{'QUERY_STRING'}; # this still being used elsewhere

	if ($ENV{'HTTP_USER_AGENT'} =~ /(google|infoseek|webcrawler|exactseek|galaxybot|nutch|turnitinbot|yandex|yahoo\! slurp|msnbot|ia_archiver|lycos_spider|yahoo\-mmcrawler|scooter\/|slurp\/|gigabot)/i) {
		$robot = $1;
	} else {
		$robot = "";
	}

 	@entries = chomp_database("$datadir/log.dat");

	$c = 0;
	foreach $curentry (@entries) {
		($name, $value) = (split(/\|/, $curentry))[0,1];
		$date1 = "$value";
		$date2 = "$date";
		calctime();

		if (($name ne $field) && ($name ne $fieldcheck) && (($result == 1) || ($result == 0))) {
			$curentries[$c] = "$curentry\n";
			$c++;
		}
	}

	open(LOG, ">$datadir/log.dat");
	hold(LOG);
	print LOG "$field\|$date\|$location\|$robot\n";
	print LOG @curentries;
	close(LOG);

}

################
sub print_main {
################
# defines the welcome message and calls news sub
# which reads from a text file rather than compiling from all the articles
# then prints top x number of news to the front page
# Works together with updated subs:
# printnews and holdr subs here in subs.pl;
# commentnews, and postnews2 in topics.pl;
# verifynews2, modifynews3, and movetopic in admin.pl *)
# - for front page news, as of ver 0.9.9.3 .

	if ($username ne "$anonuser") {
		open(FILE, "$memberdir/$username.pref") || file_error("$err{'010'}"); # User doesn't exist!
		hold(FILE);
		chomp(@preferences = <FILE>);
		close(FILE);

		# welcome message member
		if ((!defined $preferences[3]) || ($preferences[3] == 1)) {
			@lines = chomp_database("$datadir/welcomemsgm.txt");
		}
	} else {
		@lines = chomp_database("$datadir/welcomemsg.txt");
	}

	$message = $lines[1];

	if ($enable_ubbc) {
		doubbctopic();
	}
	if ($enable_smile) {
		dosmilies();
	}

	$welcometitle = showhtml("$lines[0]");
	$welcomebody = showhtml("$message");

	$welcome = qq~<p class="texttitle">$welcometitle</p>
$welcomebody
~;

	require "$sourcedir/topics.pl";
	topnews();

	exit;

}

###############
sub print_top {
###############

	if (!$scriptver) { &getver; } # check for version to support mods
	require "$sourcedir/plugins.pl";
	require "$themesdir/$usertheme/theme.pl";
	require "$themesdir/$usertheme/header.pl";

}

##################
sub print_bottom {
##################

	require "$themesdir/$usertheme/footer.pl";

}

##################
sub print_poll {
##################

	require "$themesdir/$usertheme/pollfooter.pl";

}

######################
sub latestforumposts {
######################

	if (!$userrank) { $userrank = "none"; }
	if (!$userstatus) { $userstatus = "none"; } # these for multiple status on board

	%myforumdata = ();

	my @fcats = chomp_database("$boardsdir/cats.txt");

	foreach my $fcat(@fcats) {
		my @fcatinfo = read_database("$boardsdir/$fcat.cat");

		chomp($fcatinfo[1]);

		if ($fcatinfo[1]) {
			if (($fcatinfo[1] !~ /\b$userrank\b|\b$userstatus\b/i) && ($userrank ne "$root")) { # for multiple status on board
				next;
			}
		}

		foreach my $selboard (@fcatinfo[2 .. $#fcatinfo]) {
			chomp($selboard);
			# check for blank lines in cat file:
			if (!$selboard) { next; }
			my @fposts = read_database("$boardsdir/$selboard.txt");
			# set to max msg like forums:
			for ($f = 0; $f < @fposts && $f < $maxmessagedisplay; $f++) {
				my ($fpnum, $fptitle, $fpdate) = (split(/\|/, $fposts[$f]))[0,1,5];
				my $lfptitle = censor_it($fptitle);

				my @fptposts;
				if (-e "$messagedir/$fpnum.txt") {
					@fptposts = chomp_database("$messagedir/$fpnum.txt");
				} else {
					next;
				}

				if (!@fptposts) { next; }

				my $fpnummessages = @fptposts;
				my $c = 0;
				my $strt;
				my $fppages = '';
				if ($fpnummessages > $maxmessagedisplay) {
					while (($c*$maxmessagedisplay) < $fpnummessages) {
						my $viewc = $c+1;
						$strt = ($c*$maxmessagedisplay);
						$fppages = qq~$fppages <a
 href="$pageurl/$cgi?action=forum&amp;board=$selboard&amp;op=display&amp;num=$fpnum&amp;start=$strt"
 class="forumlink">$viewc</a> ~;
						$c++;
					}
					$fppages =~ s/\n$//g;
					$fppages = qq~( <img
 src="$imagesurl/forum/multipage.gif" alt=""> $fppages )~;
				} else {
					$strt = 0;
				}

				my ($fptposter, $fpmessage) = (split(/\|/, $fptposts[$#fptposts]))[1,7];
				my $fptuser = $fptposter;

				$fpmessage = htmltotext($fpmessage); # strip tags in highlight
				$fpmessage = censor_it($fpmessage); # censor mouseovers
				$fpmessage =~ s/\[[^\]]+\]//g; # trim ubbc tags

				if (length($fpmessage) > 100) {
					$fpmessage = substr($fpmessage, 0, 100);
					$fpmessage =~ s/(.*)\s.*/$1/s; # trim to last whole word
					$fpmessage .= "..."; # add ellipsis
				}

				display_date($fpdate); $rjtdate = $user_display_date; # jane
				my $myforumlink = qq~<a
 href="$pageurl/$cgi?action=forum&amp;board=$selboard&amp;op=display&amp;num=$fpnum&amp;start=$strt#$#fptposts"
 class="forumlink" title="$fpmessage">$lfptitle</a> - ($rjtdate) $msg{'042'} $fptuser $fppages~;

				my ($chkdate, $chktime) = split(/ - /, $fpdate);
				my ($chkmonth, $chkday, $chkyear) = split(/\//, $chkdate);
				my ($chkhour, $chkmin, $chksec) = split (/:/, $chktime);
				$chkyear += 2000;

				my $sortedentry = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";
				$myforumdata{$sortedentry} = $myforumlink;
			}
			# added for stickies - 
			my @fstickies = read_database("$boardsdir/$selboard.sticky");
			# set to max msg like forums:
			for ($f = 0; $f < @fstickies && $f < $maxmessagedisplay; $f++) {
				my ($fpnum, $fptitle, $fpdate) = (split(/\|/, $fstickies[$f]))[0,1,5];
				my $lfptitle = censor_it($fptitle);

				my @fptposts;

				if (-e "$messagedir/$fpnum.txt") {
					@fptposts = chomp_database("$messagedir/$fpnum.txt");
				} else {
					next;
				}

				if (!@fptposts) { next; }

				my $fpnummessages = @fptposts;
				my $c = 0;
				my $strt;
				my $fppages = '';
				if ($fpnummessages > $maxmessagedisplay) {
					while (($c*$maxmessagedisplay) < $fpnummessages) {
						my $viewc = $c+1;
						$strt = ($c*$maxmessagedisplay);
						$fppages = qq~$fppages <a
 href="$pageurl/$cgi?action=forum&amp;board=$selboard&amp;op=displaysticky&amp;num=$fpnum&amp;start=$strt"
 class="forumlink">$viewc</a> ~;
						$c++;
					}
					$fppages =~ s/\n$//g;
					$fppages = qq~( <img
 src="$imagesurl/forum/multipage.gif" alt=""> $fppages )~;
				} else {
					$strt = 0;
				}

				my ($fptposter, $fpmessage) = (split(/\|/, $fptposts[$#fptposts]))[1,7];
				my $fptuser = $fptposter;

				$fpmessage = htmltotext($fpmessage); # strip tags in highlight
				$fpmessage = censor_it($fpmessage); # censor mouseovers
				$fpmessage =~ s/\[[^\]]+\]//g; # trim ubbc tags

				if (length($fpmessage) > 100) {
					$fpmessage = substr($fpmessage, 0, 100);
					$fpmessage =~ s/(.*)\s.*/$1/s; # trim to last whole word
					$fpmessage .= "..."; # add ellipsis
				}

				display_date($fpdate); $rjtdate = $user_display_date; # jane
				my $myforumlink = qq~<a
 href="$pageurl/$cgi?action=forum&amp;board=$selboard&amp;op=displaysticky&amp;num=$fpnum&amp;start=$strt#$#fptposts"
 class="forumlink" title="$fpmessage">$lfptitle</a> - ($rjtdate) $msg{'042'} $fptuser $fppages~;

				my ($chkdate, $chktime) = split(/ - /, $fpdate);
				my ($chkmonth, $chkday, $chkyear) = split(/\//, $chkdate);
				my ($chkhour, $chkmin, $chksec) = split (/:/, $chktime);
				$chkyear += 2000;

				my $sortedentry = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";
				$myforumdata{$sortedentry} = $myforumlink;
			}
		}
	}

	@myforumnum = sort { $b <=> $a } keys %myforumdata;

}

### WHO'S ON: ###
################
sub userstatus { 
################
# sub originally customized by Anton, extended and redesigned by 

	if (!defined &boxtop) { # old themes compatibility
		print qq~<tr><td>~;
	}

 	@wholist = chomp_database("$datadir/log.dat");

	$botsnum = 0;
	$bots = ""; 
	$guests = 0; 
	$users = 0; 
	$omlink = "";

	# from Anton (modified):
	foreach $wholine(@wholist) { 
		($whoson, $robot) = (split(/\|/, $wholine))[0,3]; 

		if ($whoson !~ /\./) {
			$users++;
			if ($username ne "$anonuser") {
			 	@whoset = chomp_database("$memberdir/$whoson.dat");

				$omlink .= qq~<a
 href="$pageurl/$cgi?action=imsend&amp;to=$whoson"><img
 src="$imagesurl/chat.gif" alt="$msg{'109'} $whoset[1]" border="0"></a> <a
 href="$pageurl/$cgi?action=viewprofile&amp;username=$whoson"><img
 src="$imagesurl/profile.gif" alt="$msg{'051'} $whoset[1]" border="0"></a>~;

				if ($whoset[7] eq $root) { 
					$omlink .= qq~ <span
 class="highlight">*</span><span
 class="mouseoveroff" title="$msg{'430'}"~;
				}
				elsif ($whoset[7] eq $boardmoderator) {
					$omlink .= qq~ <span
 style="color: #FF9933; font-weight: bold">*</span><span
 class="mouseoveroff" title="$msg{'099'}"~; 
				} else {
					$omlink .= qq~ <span
 class="mouseoveroff" title="$msg{'728'}"~;
				}

				$omlink .= qq~ onmouseover="this.className='mouseover';"
 onmouseout="this.className='mouseoveroff';">$whoset[1]</span><br>~; 

				@whoset=();
			}
		} else {
			if ($robot) {
				if ($robot =~ /(google|webcrawler|nutch|turnitinbot|yandex)/i) {
					$botsnum++; 
					$bots .= qq~$1<br>~;
				}
				elsif ($robot =~ /yahoo\! slurp|slurp\//i) {
					$botsnum++; 
					$bots .= qq~Yahoo!<br>~; 
				}
				elsif ($robot =~ /msnbot/i) {
					$botsnum++; 
					$bots .= qq~MSN<br>~; 
				}
				elsif ($robot =~ /ia_archiver/i) {
					$botsnum++; 
					$bots .= qq~Alexa<br>~; 
				}
				elsif ($robot =~ /scooter\//i) {
					$botsnum++; 
					$bots .= qq~Alta Vista<br>~; 
				}
				elsif ($robot =~ /galaxybot/i) {
					$botsnum++; 
					$bots .= qq~Galaxy<br>~; 
				}
				elsif ($robot =~ /exactseek/i) {
					$botsnum++; 
					$bots .= qq~ExactSeek<br>~; 
				}
				elsif ($robot =~ /infoseek/i) {
					$botsnum++; 
					$bots .= qq~Go<br>~; 
				}
				elsif ($robot =~ /gigabot/i) {
					$botsnum++; 
					$bots .= qq~BigByte<br>~; 
				}
				elsif ($robot =~ /lycos_spider/i) {
					$botsnum++; 
					$bots .= qq~Lycos<br>~;
				}
				elsif ($robot =~ /yahoo\-mmcrawler/i) {
					$botsnum++; 
					$bots .= qq~Overture<br>~; 
				} # compliments of Anton - extra bots added by 
			} else { 
				$guests++; 
			}
		}
	}

	# begin most online
 	$oldcount = chomp_datatext("$memberdir/mostonline.cnt");

	$newcount = $guests + $users; 

	if ($newcount > $oldcount) { 
		open(CNT, ">$memberdir/mostonline.cnt"); 
		hold(CNT); 
		print CNT "$newcount"; 
		close(CNT);
		$mostonline = $newcount; 
	} else { 
		$mostonline = $oldcount;
	} 

	# begin registered members
 	@memberlist = chomp_database("$memberdir/memberlist.dat");

	$mbrcount = @memberlist;
	$thelatestmember = $memberlist[$#memberlist];
	# get latest member's real name:
	my @lmrealname = chomp_database("$memberdir/$thelatestmember.dat");

	# begin printing HTML
	print qq~<div align="center" class="whocat">~;

	# number of guests, number of members
	if ($username eq "$anonuser") {
		print qq~$users $msg{'745'}<br>
$guests $msg{'746'}<br>
$botsnum $msg{'747'}~;
		if ($botsnum > 0) { 
			print qq~:<br>
$bots~;
		} else {
			print qq~<br>~;
		}

		print qq~$msg{'748'}<br>~;
	} else {
		print qq~<a href="$pageurl/$cgi?action=who"
 class="whomenu">$users</a> $msg{'745'}<br>
$guests $msg{'746'}<br>
$botsnum $msg{'747'}~;
		if ($botsnum > 0) { 
			print qq~:<br>
$bots~;
		} else {
			print qq~<br>~;
		}

		print qq~</div><hr>$omlink<div align="center" class="whocat">~;

# when "my" added here, modify imalert also
		# fix for: if welcome IM to new member is turned off, there is no $username.msg - 
		if (open(IM, "$memberdir/$username.msg")) {
			holdr(IM); 
			chomp(@immessages = <IM>);
			close(IM); 
		} 

		$newimnow = 0;

		if (@immessages) {
			foreach $imline (@immessages) { 
				($instmchecked) = (split(/\|/,$imline))[5];
				if (!$instmchecked) {
					++$newimnow;
				}
			}

			$mnum = @immessages; 

			if ($mnum >= 0) { 
	 			@preferences = chomp_database("$memberdir/$username.pref");

				if ($preferences[0] == 1 || $preferences[0] eq "" ) {
					if ($preferences[6] < $mnum) {
						imalert();
					}
				}

				if ($username ne "admin") {
					$preferences[4] = "";
					$preferences[5] = "";
				}
				open(FILE, ">$memberdir/$username.pref") || file_error("$err{'010'}");
				hold(FILE);
				print FILE "$preferences[0]\n";
				print FILE "$preferences[1]\n";
				print FILE "$preferences[2]\n";
				print FILE "$preferences[3]\n";
				print FILE "$preferences[4]\n";
				print FILE "$preferences[5]\n";
				print FILE "$mnum\n";
				print FILE "$preferences[7]\n";
				close(FILE);
			}
		}

		print qq~<hr>
~;

	}

	# most on
	if ($dispmost eq "1") {
		print qq~$msg{'345'}$mostonline<br>~;
	}  

	# registered members
	print qq~$msg{'029'} $mbrcount<br>~;

	# newest member
	print qq~<div style="margin-top:3px">$msg{'028'}~;

	if ($username ne "$anonuser") {
		# print latest member's real name:
		print qq~ <a href="$pageurl/$cgi?action=viewprofile&amp;username=$thelatestmember"
 class="whomenu">$lmrealname[1]</a>~;

		print qq~<hr>
$realname, $msg{'342'}:<br>
<div align="center"><a href="$pageurl/$cgi?action=im"
 class="whomenu">$newimnow</a> $msg{'744'}</div>~;

	} else {
		print qq~ $lmrealname[1]~;
	}

	print qq~</div></div>~;

	if (!defined &boxbottom) { # old themes compatibility
		print qq~</td></tr>~;
	}

}

#############
sub readlog {
#############

	local ($field, $readuser) = @_;

	if (!defined $readuser) { $readuser = ""; }

	if ($readuser eq "") { $readuser = $username; }
	if ($readuser ne "$anonuser") {
		if (-e "$memberdir/$readuser.log") { # log exists after login or forum activity
			@entries = read_database("$memberdir/$readuser.log");

			foreach $curentry (@entries) {
				$curentry =~ s/[\n\r]//g;
				($name, $value) = split(/\|/, $curentry);
				if ($name eq "$field") { return "$value"; }
			}
		} else { return ""; }
	}
}

##############
sub writelog {
##############

	local($field) = @_;
	if ($username ne "$anonuser") {
		if (open(LOG, "<$memberdir/$username.log")) {
			hold(LOG);
			@entries = <LOG>;
			close(LOG);
		} else {
			@entries = ();
		}

		open(LOG, ">$memberdir/$username.log");
		hold(LOG);
		print LOG "$field|$writedate\n";
		foreach $curentry (@entries) {
			$curentry =~ s/[\n\r]//g;
			($name, $value) = split(/\|/, $curentry);
			$date1 = "$value";
			$date2 = "$date";
			calcdifference();
			if ($name ne "$field" && $result <= $max_log_days_old) { print LOG "$curentry\n"; }
		}
		close(LOG);
	}

}

############
sub logips {
############
# changes for new stats system where stats are cached
# by 
# Needs updated getdate sub in this subs.pl, and accompanying
# updated subs parse_log in stats.pl, viewstats in logs.cgi

	my @skip = ('127.0.0.1'); # skips localhost
	my $check = 0;

	if (@skip) {
		foreach $ips (@skip) {
			if ($ENV{'REMOTE_ADDR'} =~ /$ips/) {
				$check = 1;
				last;
			}
		}
	}

	# if not in skip list and time between logging has non-zero value:
	if (($check == 0) && ($ip_time)) {
		my $this_time = time(); # now in seconds since epoch

		open(FILE,"$logdir/ip.log");
		holdr(FILE);
		my @lines = <FILE>;
		close(FILE);

		open(FILE,">$logdir/ip.log");
		hold(FILE);
		foreach $visitor (@lines) {
			# check against global variable $ip_time
			($ip_addr,$time_stamp) = split(/\|/, $visitor); # IP and visit time in seconds since epoch
			if ($this_time < $time_stamp + (60*$ip_time)) {
				if ($ip_addr eq $ENV{'REMOTE_ADDR'}) { $check = 1; }
				# print others
				else { print FILE "$ip_addr|$time_stamp"; }
			}
		}
		# print this visitor
		print FILE "$ENV{'REMOTE_ADDR'}|$this_time\n";
		close(FILE);
	}
	# if it still proves a "new" visitor:
	if ($check == 0) { 
		if ($ENV{'REMOTE_HOST'}) { $host = $ENV{'REMOTE_HOST'}; }
		else {
			$ip_address = $ENV{'REMOTE_ADDR'};
			@numbers = split(/\./, $ip_address);
			$ip_number = pack("C4", @numbers);
			$host = (gethostbyaddr($ip_number, 2))[0];
		}
		if (! $host) { $host = "$ENV{'REMOTE_ADDR'}"; }

		if ($ENV{'HTTP_REFERER'}) {
			$referer = "$ENV{'HTTP_REFERER'}";
			if ($referer !~ /https?:\/\/.*\.[a-z]{2,4}\//i) { $referer = "-"; }
		}
		else { $referer = "-"; }

		if (! $ENV{'HTTP_USER_AGENT'}) { $ENV{'HTTP_USER_AGENT'} = "-" }
		if (! $ENV{HTTP_ACCEPT_LANGUAGE}) { $ENV{HTTP_ACCEPT_LANGUAGE} = "-"; } 
		if (! $ENV{SCRIPT_NAME}) { $ENV{SCRIPT_NAME} = "-"; } 
		if (! $ENV{QUERY_STRING}) { $ENV{QUERY_STRING} = ""; } 

		foreach ($host, $ENV{'HTTP_USER_AGENT'}, $referer, $ENV{QUERY_STRING}) {
			s/\|/&#124;/sg;
			s/\015|\012//sg;
		}

		open(DATA, ">>$logdir/stats.dat");
		hold(DATA);
		print DATA "$logdate|$host|$ENV{'HTTP_USER_AGENT'}|$referer|$ENV{HTTP_ACCEPT_LANGUAGE}|$ENV{SCRIPT_NAME}|$ENV{QUERY_STRING}|$ENV{'REMOTE_ADDR'}|$username\n";
		close (DATA);
	}

}

################
sub htmlescape {
################
# saves original post doing this: $message = htmlescape($input{'message'});
# for posting from admin/blockleft.cgi, admin/blockright.cgi, admin.pl,
# downloads.pl, forum_admin.pl, forum_display.pl, instantmessage.pl, links.pl,
# newsletter.pl, poll.pl, subs.pl, forum_post.pl, topics.pl

	my $text = shift;

	$text =~ s/&/&amp;/g;
	$text =~ s/"/&quot;/g;
	$text =~ s/  / \&nbsp;/g;
	$text =~ s/</&lt;/g;
	$text =~ s/>/&gt;/g;
	$text =~ s/\t/&nbsp;&nbsp;&nbsp;/g;
	$text =~ s/\cM//g;
	$text =~ s/\n/<br>/g;
	$text =~ s/\|/<pipe>/g;

	return $text;
}

################
sub htmltotext {
################
# this is all of what it does to the message part of the postnumber text file
# before it edits a post, also used for printing form input values
# for posting from admin/blockleft.cgi, admin/blockright.cgi, admin.pl,
# downloads.pl, forum_admin.pl, instantmessage.pl, links.pl, newsletter.pl,
# poll.pl, subs.pl, forum_post.pl, topics.pl

	my $html = shift;

	$html =~ s~<br>~\n~gi;
	$html =~ s~<pipe>~&#124;~g; # anton - moved up to fix pipe problem in <p -
	$html =~ s~<\/*(blockquote|ul|li|p)[^<>]*>~\n\n~gi;
	$html =~ s~<a href=\"*([^\s<>\"]+)\"*[^>]*>([\s\S]+?)<\/a>~$2 (link: $1)~gi;
	$html =~ s~<[^>]+>~~g;
	$html =~ s~\"~&quot;~g;
	$html =~ s/ \&nbsp;/  /g;

	return $html;

}

##############
sub showhtml {
##############

	my $text = shift;

	if ($allow_html == 1) {

		$text =~ s/&amp;/&/g;
		$text =~ s/&quot;/"/g;
		$text =~ s/ \&nbsp;/  /g;
		$text =~ s/&lt;/</g;
		$text =~ s/&gt;/>/g;
		$text =~ s/ \&nbsp; \&nbsp; \&nbsp;/\t/g;
		$text =~ s/\n/<br>/g;
		$text =~ s/<pipe>/\|/g;
		$text =~ s~(\<|&lt;?)(.*?)color=([\w#]+)(\>|&gt;?)(.*?)(\<|&lt;?)/color(\>|&gt;?)~<font color="$2">$3</font>~isg;
		$text =~ s~(\<|&lt;?)hr(\>|&gt;?)~<hr size="1">~g;
		$text =~ s~([^\w\"\=\[\]]|\A|[\n\b])\\*(\w+://[^<>\s\n\"\]\[]+)~$1<a href="$2" target="_blank">$2</a>~isg; # make links from ://
		$text =~ s~([^\f\"\=\[\]]|\A|[\n\b])\\*(\f+://[^<>\s\n\"\]\[]+)~$1<a href="$2" target="_blank">$2</a>~isg;
		# remove double links made in welcome message - :
		$text =~ s~<a [^>]+>(<a [^>]+>[^<]+</a>)</a>~$1~isg;
		$text =~ s~([^\"\=\[\]/\:]|\A|[\n\b])\\*(ftp\.[^<>\s\n\]\[]+)~$1<a href="ftp://$2" target="_blank">$2</a>~isg;
	}

	$text =~ s/<s(?!(pan|up|ub|mall))/&lt;s/ig; # allow span, sup, sub, small tags in articles
	$text =~ s/<j/&lt;j/ig;

	return $text;

}

############
sub doubbc {
############

	$message =~ s{\[code\](.+?)\[/code\](?!('\)))}{ # Anton and 
	my $tmp = $1;
	$tmp =~ s~scrypt~script~g;
	$tmp =~ s~yframe~iframe~g;
	$tmp =~ s~myta~meta~g;
	$tmp =~ s~\{~&#123;~g;
	$tmp =~ s~\}~&#125;~g;
	$tmp =~ s~\[~&#91;~g;
	$tmp =~ s~\]~&#93;~g;
	$tmp =~ s~\:~&#58;~g;
	$tmp =~ s~\)~&#41;~g;
	$tmp =~ s~\(~&#40;~g;
	$tmp = qq~<br><div class="forumtextbold">$msg{'684'}</div><div class="codepost"><code>$tmp</code></div><br>~;
	}exisog; # Anton to here

	$message =~ s~\[\[~\{\{~g;
	$message =~ s~\]\]~\}\}~g;
	$message =~ s~\n\[~\[~g;
	$message =~ s~\]\n~\]~g;

	$message =~ s~\<br\>~ <br>~g;
	$message =~ s~<pipe>~&#124;~g;
	$message =~ s~\[hr\]\n~<hr size="1">~g;
	$message =~ s~\[hr\]~<hr size="1">~g;

	$message =~ s~\[b\]~<b>~isg;
	$message =~ s~\[\/b\]~</b>~isg;

	$message =~ s~\[i\]~<i>~isg;
	$message =~ s~\[\/i\]~</i>~isg;

	$message =~ s~\[u\]~<u>~isg;
	$message =~ s~\[\/u\]~</u>~isg;

	$message =~ s~(\[img\])(.*?)(view-source:|script:|mocha:|mailto:|about:|shell:)(.*?)(\[\/img\])~\[<font color=red>$err{'043'}<\/font>\]~isg; #anton
	$message =~ s~\[url[^\]]*?\][^\[]*?script:[^\[]*?\[\/url\]~\[<font color=red>$err{'043'}<\/font>\]~isg; # filter for Shaka_Flex trick:

	if ($imageicons eq "1") {
		$message =~ s~\[img\](.+?)\[\/img\]~<a href="$1" target="_blank"><img src="$1" width="50" height="50" alt="" border="0"></a>~isg;
		}
	if ($imageicons ne "1") {
		$message =~ s~\[img\](.+?)\[\/img\]~<img src="$1" alt="" border="0">~isg;
		}

	$message =~ s~\[color=(\S+?)\]~<font color="$1">~isg;
	$message =~ s~\[\/color\]~</font>~isg;
	$message =~ s~\[quote=\s*(\w+\+?)\](.+?)\s*\[/quote\]~<blockquote><b>$1 $msg{'685'}</b><hr><cite>$2</cite><hr></blockquote>~isg;
	$message =~ s~\[quote\]<br>(.+?)<br>\[\/quote\]~<blockquote><hr><cite>$1</cite><hr></blockquote>~isg;
	$message =~ s~\[quote\](.+?)\[\/quote\]~<blockquote><hr><cite>$1</cite><hr></blockquote>~isg;
	$message =~ s~\[fixed\]~<font face="Courier New">~isg;
	$message =~ s~\[\/fixed\]~</font>~isg;
	$message =~ s~\[sup\]~<sup>~isg;
	$message =~ s~\[\/sup\]~</sup>~isg;
	$message =~ s~\[strike\]~<strike>~isg;
	$message =~ s~\[\/strike\]~</strike>~isg;
	$message =~ s~\[sub\]~<sub>~isg;
	$message =~ s~\[\/sub\]~</sub>~isg;
	$message =~ s~\[left\]~<div align="left">~isg;
	$message =~ s~\[\/left\]~</div>~isg;
	$message =~ s~\[center\]~<center>~isg;
	$message =~ s~\[\/center\]~</center>~isg;
	$message =~ s~\[right\]~<div align="right">~isg;
	$message =~ s~\[\/right\]~</div>~isg;
	$message =~ s~\[list\]~<ul>~isg;
	$message =~ s~\[\*\]~<li>~isg;
	$message =~ s~\[\/list\]~</ul>~isg;
	$message =~ s~\[pre\]~<pre>~isg;
	$message =~ s~\[\/pre\]~</pre>~isg;
	$message =~ s~\[small\]~<small>~isg;
	$message =~ s~\[\/small\]~</small>~isg;
	$message =~ s~\[big\]~<big>~isg;
	$message =~ s~\[\/big\]~</big>~isg;
	$message =~ s~\[email\](.+?)\[\/email\]~<a href="mailto:$1">$1</a>~isg;
	$message =~ s~\[url\]www\.\s*(.+?)\s*\[/url\]~<a href="http://www.$1" target="_blank">www.$1</a>~isg;
	$message =~ s~\[url=\s*(\w+\://.+?)\](.+?)\s*\[/url\]~<a href="$1" target="_blank">$2</a>~isg;
	$message =~ s~\[url\]\s*(.+?)\s*\[/url\]~<a href="$1" target="_blank">$1</a>~isg;
	$message =~ s~([^\w\"\=\[\]]|[\n\b]|\A)\\*(\w+://[\w\~\.\;\:\,\$\-\+\!\*\?/\=\&\@\#\%]+[\w\~\.\;\:\$\-\+\!\*\?/\=\&\@\#\%])~$1<a href="$2" target="_blank">$2</a>~isg;
	$message =~ s~\{\{~\[~g;
	$message =~ s~\}\}~\]~g;

	$message =~ s~\[font=(.+?)\]~<font face="$1">~isg; # these for IMX
	$message =~ s~\[\/font\]~</font>~isg;
	$message =~ s~\[size=(.+?)\]~<font size="$1">~isg;
	$message =~ s~\[\/size\]~</font>~isg; 

}

#################
sub doubbctopic {
#################
# used in printpage sub forum_display.pl;
# printtopic, viewnews, postnews2, topnews subs topics.pl;
# and palm pilot

	$message =~ s~\[color=(\S+?)\]~<font color="$1">~isg;
	$message =~ s~\[\/color\]~</font>~isg;

	$message =~ s{\[code\](.+?)\[/code\](?!('\)))}{ # Anton and 
	my $tmp = $1;
	$tmp =~ s~scrypt~script~g;
	$tmp =~ s~yframe~iframe~g;
	$tmp =~ s~myta~meta~g;
	$tmp =~ s~&lt;~&#60;~g;
	$tmp =~ s~&gt;~&#62;~g;
	$tmp =~ s~\[~&#91;~g;
	$tmp =~ s~\]~&#93;~g;
	$tmp =~ s~\:~&#58;~g;
	$tmp =~ s~\)~&#41;~g;
	$tmp =~ s~\(~&#40;~g;
	$tmp = qq~<br><div class="forumtextbold">$msg{'684'}</div><div class="codepost"><code>$tmp</code></div><br>~;
	}exisog; # Anton to here

	$message =~ s/&quot;/"/g;
	$message =~ s/^\s/&nbsp;/; # preserve leading spaces
	$message =~ s/<br>\s/<br>&nbsp;/g; # preserve space beginning of lines
	$message =~ s/&lt;script&gt;/<skript>/g;
	$message =~ s/&lt;\\script&gt;/<\\skript>/g;
	$message =~ s/&lt;javascript&gt;/<javaskript>/g;
	$message =~ s/&lt;\\javascript&gt;/<\\javaskript>/g;
	$message =~ s/&lt;/</g;
	$message =~ s/&gt;/>/g;
	$message =~ s/ \&nbsp; \&nbsp; \&nbsp;/\t/g;
	$message =~ s/\n/<br>/g;
	$message =~ s/\|/<pipe>/g;
	$message =~ s~\[\[~\{\{~g;
	$message =~ s~\]\]~\}\}~g;
	$message =~ s~\n\[~\[~g;
	$message =~ s~\]\n~\]~g;
	$message =~ s~\<br\>~ <br>~g;
	$message =~ s~<pipe>~&#124;~g;
	$message =~ s~\[hr\]\n~<hr size="1">~g;
	$message =~ s~\[hr\]~<hr size="1">~g;
	$message =~ s~\[b\]~<b>~isg;
	$message =~ s~\[\/b\]~</b>~isg;
	$message =~ s~\[i\]~<i>~isg;
	$message =~ s~\[\/i\]~</i>~isg;
	$message =~ s~\[u\]~<u>~isg;
	$message =~ s~\[\/u\]~</u>~isg;

	if ($imageicons eq "1") {
		$message =~ s~\[img\](.+?)\[\/img\]~<a href="$1" target="_blank"><img src="$1" width="50" height="50" alt="" border="0"></a>~isg;
	}
	if ($imageicons ne "1") {
		$message =~ s~\[img\](.+?)\[\/img\]~<img src="$1" alt="" border="0">~isg;
	}

	$message =~ s~\[quote=\s*(\w+\+?)\](.+?)\s*\[/quote\]~<blockquote><b>$1 $msg{'685'}</b><hr width="400" align="left"><cite>$2</cite><hr width="400" align="left"></blockquote>~isg;
	$message =~ s~\[quote\]<br>(.+?)<br>\[\/quote\]~<blockquote><hr width="400" align="left"><cite>$1</cite><hr width="400" align="left"></blockquote>~isg;
	$message =~ s~\[quote\](.+?)\[\/quote\]~<blockquote><hr width="400" align="left"><cite>$1</cite><hr width="400" align="left"></blockquote>~isg;
	$message =~ s~\[fixed\]~<font face="Courier New">~isg;
	$message =~ s~\[\/fixed\]~</font>~isg;
	$message =~ s~\[sup\]~<sup>~isg;
	$message =~ s~\[\/sup\]~</sup>~isg;
	$message =~ s~\[strike\]~<strike>~isg;
	$message =~ s~\[\/strike\]~</strike>~isg;
	$message =~ s~\[sub\]~<sub>~isg;
	$message =~ s~\[\/sub\]~</sub>~isg;
	$message =~ s~\[left\]~<div align="left">~isg;
	$message =~ s~\[\/left\]~</div>~isg;
	$message =~ s~\[center\]~<center>~isg;
	$message =~ s~\[\/center\]~</center>~isg;
	$message =~ s~\[right\]~<div align="right">~isg;
	$message =~ s~\[\/right\]~</div>~isg;
	$message =~ s~\[list\]~<ul>~isg;
	$message =~ s~\[\*\]~<li>~isg;
	$message =~ s~\[\/list\]~</ul>~isg;
	$message =~ s~\[pre\]~<pre>~isg;
	$message =~ s~\[\/pre\]~</pre>~isg;
	$message =~ s~\[small\]~<small>~isg;
	$message =~ s~\[\/small\]~</small>~isg;
	$message =~ s~\[big\]~<big>~isg;
	$message =~ s~\[\/big\]~</big>~isg;
	$message =~ s~\[email\](.+?)\[\/email\]~<a href="mailto:$1">$1</a>~isg;
	$message =~ s~\[url\]www\.\s*(.+?)\s*\[/url\]~<a href="http://www.$1" target="_blank">www.$1</a>~isg;
	$message =~ s~\[url=\s*(\w+\://.+?)\](.+?)\s*\[/url\]~<a href="$1" target="_blank">$2</a>~isg;
	$message =~ s~\[url=\s*(.+?)\]\s*(.+?)\s*\[/url\]~<a href="http://$1" target="_blank">$2</a>~isg;
	$message =~ s~\[url\]\s*(.+?)\s*\[/url\]~<a href="$1" target="_blank">$1</a>~isg;
	$message =~ s~([^\w\"\=\[\]]|[\n\b]|\A)\\*(\w+://[\w\~\.\;\:\,\$\-\+\!\*\?/\=\&\@\#\%]+[\w\~\.\;\:\$\-\+\!\*\?/\=\&\@\#\%])~$1<a href="$2" target="_blank">$2</a>~isg;
	# remove double links made in articles - :
	$message =~ s~<a [^>]+>(<a [^>]+>[^<]+</a>)</a>~$1~isg;
	$message =~ s~\{\{~\[~g;
	$message =~ s~\}\}~\]~g;
	$message =~ s/<s(?!(pan|up|ub|mall))/&lt;s/ig; # allow span, sup, sub, small tags in articles
	$message =~ s/<j/&lt;j/ig;
	$message =~ s/<([^>]* on[^>]*)/&lt;$1/ig; # onload filter - 

}

###############
sub dosmilies {
###############

	$message =~ s~\[\[~\{\{~g;
	$message =~ s~\]\]~\}\}~g;

	$message =~ s~\[bones\]~<img src="$imagesurl/forum/smilies/bones\.gif" alt="">~g;
	$message =~ s~\[bounce\]~<img src="$imagesurl/forum/smilies/bounce\.gif" alt="">~g;
	$message =~ s~\:-\?~<img src="$imagesurl/forum/smilies/confused\.gif" alt="">~g;
	$message =~ s~\[confused\]~<img src="$imagesurl/forum/smilies/confused\.gif" alt="">~g;
	$message =~ s~\Q8)\E~<img src="$imagesurl/forum/smilies/cool\.gif" alt="">~g;
	$message =~ s~\Q8-)\E~<img src="$imagesurl/forum/smilies/cool\.gif" alt="">~g;
	$message =~ s~\[cool\]~<img src="$imagesurl/forum/smilies/cool\.gif" alt="">~g;
	$message =~ s~\[cry\]~<img src="$imagesurl/forum/smilies/cry\.gif" alt="">~g;
	$message =~ s~\:o~<img src="$imagesurl/forum/smilies/eek\.gif" alt="">~g;
	$message =~ s~\:\-o~<img src="$imagesurl/forum/smilies/eek\.gif" alt="">~g;
	$message =~ s~\[eek\]~<img src="$imagesurl/forum/smilies/eek\.gif" alt="">~g;
	$message =~ s~\[evil\]~<img src="$imagesurl/forum/smilies/evil\.gif" alt="">~g;
	$message =~ s~\:\(~<img src="$imagesurl/forum/smilies/frown\.gif" alt="">~g;
	$message =~ s~\:-\(~<img src="$imagesurl/forum/smilies/frown\.gif" alt="">~g;
	$message =~ s~\[frown\]~<img src="$imagesurl/forum/smilies/frown\.gif" alt="">~g;
	$message =~ s~\:D~<img src="$imagesurl/forum/smilies/grin\.gif" alt="">~g;
	$message =~ s~\:-D~<img src="$imagesurl/forum/smilies/grin\.gif" alt="">~g;
	$message =~ s~\[grin\]~<img src="$imagesurl/forum/smilies/grin\.gif" alt="">~g;
	$message =~ s~\[lol\]~<img src="$imagesurl/forum/smilies/lol\.gif" alt="">~g;
	$message =~ s~\:x~<img src="$imagesurl/forum/smilies/mad\.gif" alt="">~g;
	$message =~ s~\:-x~<img src="$imagesurl/forum/smilies/mad\.gif" alt="">~g;
	$message =~ s~\[mad\]~<img src="$imagesurl/forum/smilies/mad\.gif" alt="">~g;
	$message =~ s~\[ninja\]~<img src="$imagesurl/forum/smilies/ninja\.gif" alt="">~g;
	$message =~ s~\[nonsense\]~<img src="$imagesurl/forum/smilies/nonsense\.gif" alt="">~g;
	$message =~ s~\[oops\]~<img src="$imagesurl/forum/smilies/oops\.gif" alt="">~g;
	$message =~ s~\[razz\]~<img src="$imagesurl/forum/smilies/razz\.gif" alt="">~g;
	$message =~ s~\[rolleyes\]~<img src="$imagesurl/forum/smilies/rolleyes\.gif" alt="">~g;
	$message =~ s~\:\)~<img src="$imagesurl/forum/smilies/smile\.gif" alt="">~g;
	$message =~ s~\:-\)~<img src="$imagesurl/forum/smilies/smile\.gif" alt="">~g;
	$message =~ s~\[smile\]~<img src="$imagesurl/forum/smilies/smile\.gif" alt="">~g;
	$message =~ s~\s\:P~<img src="$imagesurl/forum/smilies/tongue\.gif" alt="">~g;
	$message =~ s~\:-P~<img src="$imagesurl/forum/smilies/tongue\.gif" alt="">~g;
	$message =~ s~\[tongue\]~<img src="$imagesurl/forum/smilies/tongue\.gif" alt="">~g;
	$message =~ s~\;-\)~<img src="$imagesurl/forum/smilies/wink\.gif" alt="">~g;
	$message =~ s~\[wink\]~<img src="$imagesurl/forum/smilies/wink\.gif" alt="">~g;
	$message =~ s~\[tarzan\]~<img src="$imagesurl/forum/smilies/tarzan\.gif" alt="">~g;
	$message =~ s~\[dancing\-banana\]~<img src="$imagesurl/forum/smilies/dancing\-banana\.gif" alt="">~g;
	$message =~ s~\[llama\-banana\]~<img src="$imagesurl/forum/smilies/llama\-banana\.gif" alt="">~g;

	$message =~ s~\[question\]~<img src="$imagesurl/forum/smilies/question.gif" alt="">~g;
	$message =~ s~\[qfish\]~<img src="$imagesurl/forum/smilies/question.gif" alt="">~g;
	$message =~ s~\[gfish\]~<img src="$imagesurl/forum/smilies/gfish.gif" alt="">~g;

	$message =~ s~\{\{~\[~g;
	$message =~ s~\}\}~\]~g;

}


############
sub getcgi {
############
	$hack_attack = 0; # begin Abywn's security fix

	if ($ENV{'CONTENT_LENGTH'}) {
		read(STDIN, $input, $ENV{'CONTENT_LENGTH'}); # for form method=post
		@pairs = split(/&/, $input);
		foreach $pair(@pairs) {
			($name, $value) = split(/=/, $pair);
			$name =~ tr/+/ /;
			$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
			$value =~ tr/+/ /;
			$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
			$value =~ s/<(\s*\/*[^>]*)script([^>]*)>/<$1scrypt$2>/ig;
			$value =~ s/<(\s*\/*)[^>]*iframe([^>]*)>/<$1yframe$2>/ig;
			$value =~ s/<(\s*\/*) *meta([^>]*)>/<$1myta$2>/ig;
			$input{$name} = $value;
		}
	}

	if ($ENV{'HTTP_REFERER'}) {
		$checkstring = "$ENV{'HTTP_REFERER'}";
		$checkstring2 = "$pageurl";
		$checkstring2 =~ s/\/\/www\./\/\//ig;
		if (($checkstring !~/$pageurl/i) && ($checkstring !~/$checkstring2/i) && (%input > 0)) {
			%input=();
			$hack_attack = 1;
		}
	} # this block may stop some users from logging in due to antivirus program, privacy program, or browser setting blocking referrer

	if ($ENV{QUERY_STRING}) {
		@vars = split(/&/, $ENV{QUERY_STRING}); # for query string and form method=get
		foreach $var(@vars) {
			($v,$i) = split(/=/, $var, 2);
			if (!defined $i) { $i = ""; }
			$v =~ tr/+/ /;
			$v =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
			$v =~ s/amp;//; # for user agents that leave ampersands encoded in the separator, by scraping source like Fetch API Request

			$i =~ tr/+/ /;
			$i =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;


			if ($i =~ /([\\\$'`"<;!|]|\%00$|\.\.\/|^-)/) { 
				$i =~ s/\\//g; # stop regex error
				$i=~s/$1//g;
				$hack_attack = 1;
			}
		# removed ":"  until after we fix search.pl
			elsif ($i =~/\(|\)|\/n|\/r|\~$/g){ # stop regex error
			$i =~ s/\\//g; 
				$i=~s/$1//g;
				$hack_attack = 1;
			}
				
			$info{$v} = $i;
		}
	}
	$action = $info{'action'};
	$currentboard = $info{'board'};
	$op = $info{'op'};
	$cat = $info{'cat'};
	$viewcat = $info{'viewcat'};
	$num = $info{'num'};
	$id = $info{'id'};

	if ($hack_attack == 1) {
		$error_type = lc($err{'043'});
		#$error_type =~ s/\s+/_/g;
		print "Location: $pageurl/index\.cgi\?action=data_error&type=invalid_character\n";
	}

}

#############
sub getdate {
#############

	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time + 3600*$timeoffset);
	$mon_num = $mon+1;
	$hour = "0$hour" if ($hour < 10);
	$min = "0$min" if ($min < 10);
	$sec = "0$sec" if ($sec < 10);
	$saveyear = ($year % 100); # modulus
	$year = 1900 + $year; # used elsewhere
	$mon_num = "0$mon_num" if ($mon_num < 10);
	$mday = "0$mday" if ($mday < 10);
	$saveyear = "0$saveyear" if ($saveyear < 10);

	my @logmonths = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);

	$date = "$mon_num/$mday/$saveyear - $hour:$min:$sec";
	$logdate = "$mday-$logmonths[$mon]-$saveyear $hour:$min:$sec";

}

################################################################################
# Date/Time and Timezone routines. Added by Floyd with help from Ted. v0.9.8   #
################################################################################

##################
sub display_date {
##################

	my ($convertdatetime) = @_; # ($postdate) for viewnews - sometimes not passed in?

	my ($cnvdate, $cnvtime) = split(/ - /, $convertdatetime);

	if (!$user_check_date) { $user_check_date = $check_date; } # $check_date defined in config.pl, config.dat - american or european

	getTimezones();
	my ($newcnvmonth, $newcnvday, $newcnvyear, $newcnvhour, $newcnvmin, $newcnvsec) = getNewtime($cnvdate, $cnvtime);

	if ($user_check_date eq "american") {
		$user_display_date = "$newcnvmonth/$newcnvday/$newcnvyear $msg{'580'} $newcnvhour:$newcnvmin:$newcnvsec $displaytimezone";
	}
	if ($user_check_date eq "european") {
		$user_display_date = "$newcnvday/$newcnvmonth/$newcnvyear $msg{'580'} $newcnvhour:$newcnvmin:$newcnvsec $displaytimezone";
	}

	return($user_display_date); # $postdatenew = for viewnews

}

###############
sub user_date {
###############


	my ($convertdatetime) = @_;
	my ($cnvdate, $cnvtime) = split(/ - /, $convertdatetime);

	getTimezones();
	my ($newcnvmonth, $newcnvday, $newcnvyear, $newcnvhour, $newcnvmin, $newcnvsec) = getNewtime($cnvdate, $cnvtime);

	my $user_display_date;
	if ($user_check_date eq "american") {
		$user_display_date = "$newcnvmonth/$newcnvday/$newcnvyear";
	}
	elsif ($user_check_date eq "european") {
		$user_display_date = "$newcnvday/$newcnvmonth/$newcnvyear";
	}
	$user_display_date .= " - $newcnvhour:$newcnvmin:$newcnvsec";

	return($user_display_date);

}

##################
sub getTimezones {
##################

	my ($sitetimezone) = @_; # from display_date sub or ($timezone) from forums boardindex sub

	if (!defined $user_check_time) { $user_check_time = ""; }
	if ($user_check_time eq "") { $user_check_time = $timezone; } # $timezone defined in config.pl, config.dat

	if (!defined $sitetimezone) { $sitetimezone = ""; }

	if ($sitetimezone eq $timezone) { $user_check_time = $sitetimezone; } # $user_check_time set in loaduser sub

	@timezones = read_database("$datadir/timezones.dat");

	$displaytimezone = "";

	foreach $zone (@timezones) {
		$zone =~ s/[\n\r]//g;
		@zitem = split(/\|/, $zone);

		if ($zitem[0] eq $user_check_time) {
			if ($zitem[3] eq "") { $displaytimezone = "$zitem[2]"; }
			else { $displaytimezone = "$zitem[3]"; }
		}
	}
}

################
sub getNewtime {
################
# called only from display_date sub

	my ($convertdate, $converttime) = @_;

	my ($cnvhour, $cnvmin, $cnvsec) = split(/:/, $converttime);
	my ($ncnvmonth, $ncnvday, $ncnvyear);
	if ($convertdate ne "") { ($ncnvmonth, $ncnvday, $ncnvyear) = split(/\//, $convertdate); }

	if ($user_check_time eq "") { $user_check_time = $timezone; }

	my $makeyearnumber = ($ncnvyear*365);
	my $makemonthnumber = ($ncnvmonth*30);
	my $makedaynumber = abs($ncnvday);
	my $monthtraversal = 0;
	my $leapyear = 0;

	if ((!($year % 4) && ($year % 100)) || !($year % 400)) { $leapyear = 1; } 

	my $makehournumber = ($cnvhour*60);
	my $makeminutenumber = abs($cnvmin);

	my ($tzoffset1, $tzoffset2) = split(/\./, $user_check_time); # some $timezone's have decimals
	my ($tzoffset3, $tzoffset4) = split(/\./, $timezone);

	if (!defined $tzoffset2) { $tzoffset2 = 0; }

	my $nettzoffset = $tzoffset1 - $tzoffset3;

	$tzoffset1 = ($nettzoffset*60);
	$tzoffset2 = abs($tzoffset2);

	if ($tzoffset2 > 24) {
		if ($tzoffset2 eq 25) { $tzoffset2 = abs(60/4); }
		if ($tzoffset2 eq 50) { $tzoffset2 = abs(60/2); }
		if ($tzoffset2 eq 75) { $tzoffset2 = abs((60/4)*3); }
	} else {
		$tzoffset2 = 0;
	}

	if ($tzoffset1 ne 0) { $makehournumber = $makehournumber+$tzoffset1; }
	if ($tzoffset2 ne 0 && $tzoffset1 > 0) {
		$makeminutenumber = $makeminutenumber+$tzoffset2;
	}
	if ($tzoffset2 ne 0 && $tzoffset1 < 0) {
		$makeminutenumber = $makeminutenumber-$tzoffset2;
	}

	if ($makeminutenumber < 0) {
		$makeminutenumber = $makeminutenumber+60; $makehournumber = $makehournumber-60;
	}
	if ($makeminutenumber > 59) {
		$makeminutenumber = $makeminutenumber-60; $makehournumber = $makehournumber+60;
	}

	if ($makehournumber < 0) {
		$makehournumber = $makehournumber+1440; $makedaynumber = $makedaynumber-1;
	}
	if ($makehournumber > 1439) {
		$makehournumber = $makehournumber-1440; $makedaynumber = $makedaynumber+1;
	}

	if ($makedaynumber < 1) {
		$makedaynumber = 31; $makemonthnumber = $makemonthnumber-30; $monthtraversal = 1;
	}

	if ($makedaynumber > 31) {
		$makedaynumber = 1; $makemonthnumber = $makemonthnumber+30; $monthtraversal = 1;
	}
	# what about Jan 31 late night?
	if ($makemonthnumber == 60) {
		if ($monthtraversal == 1 && $makedaynumber == 31) {
		if ($leapyear eq 1) { $makedaynumber = 29; } else { $makedaynumber = 28; }
		} else {
			if ((($makedaynumber > 29) && ($leapyear == 1))
			|| (($makedaynumber > 28) && ($leapyear == 0))) {
				$makedaynumber = 1; $makemonthnumber = 90;
			}
		}
	}

	# fix for dates like 10/01/05, 07:49:57 changing to dates like 09/31/05 at 23:49 PST 
	if (($makemonthnumber =~ /^(270|120|180|330)$/) && ($monthtraversal == 1) && ($makedaynumber == 31)) { 
      		$makedaynumber = 30; 
	}
	# later found this commented out of 0.9.9 from 0.9.8:
	# if ($makemonthnumber eq 120 or $makemonthnumber eq 180 or $makemonthnumber eq 270 or $makemonthnumber eq 330 && $monthtraversal eq 1) {$makedaynumber = 30;}

	if ($makedaynumber eq 31 && $makemonthnumber eq 0 && $monthtraversal eq 1) {
		$makeyearnumber = $makeyearnumber-365; $makemonthnumber = 360;
	}
	if ($makedaynumber eq 1 && $makemonthnumber eq 390 && $monthtraversal eq 1) {
		$makeyearnumber = $makeyearnumber+365; $makemonthnumber = 30;
	}

	if ($makeyearnumber > 36135) { $makeyearnumber = 0; } # > 99 years
	if ($makeyearnumber < 0) { $makeyearnumber = 36135; }

	my $newcnvyear;
	if ($makeyearnumber ne 0) { $newcnvyear = ($makeyearnumber/365);
	} else { $newcnvyear = 0; }

	my $newcnvmonth = ($makemonthnumber/30);
	my $newcnvday = $makedaynumber;
	my $newcnvhour = ($makehournumber/60);
	my $newcnvmin = $makeminutenumber;
	my $newcnvsec = $cnvsec;

	if ($newcnvyear < 10) { $newcnvyear = "0$newcnvyear"; }
	if ($newcnvmonth < 10) { $newcnvmonth = "0$newcnvmonth"; }
	if ($newcnvday < 10) { $newcnvday = "0$newcnvday"; }

	if ($newcnvhour < 10) { $newcnvhour = "0$newcnvhour"; }
	if ($newcnvmin < 10) { $newcnvmin = "0$newcnvmin"; }

	return($newcnvmonth, $newcnvday, $newcnvyear, $newcnvhour, $newcnvmin, $newcnvsec);

}

################################################################################
# End of new Date/Time and Timezone routines.                                  #
################################################################################

####################
sub calcdifference {
####################

	if($date1) {
		($dates, undef) = split(/ /, $date1);
		($cdmonth, $cdday, $cdyear) = split(/\//, $dates);
		$number1 = ($cdyear*365)+($cdmonth*30)+$cdday;
	} else {
		$number1 = 0;
	}
	($dates, undef) = split(/ /, $date2);
	($cdmonth, $cdday, $cdyear) = split(/\//, $dates);
	$number2 = ($cdyear*365)+($cdmonth*30)+$cdday;
	$result = $number2-$number1;

}

##############
sub calctime {
##############

	(undef, $times) = split(/ - /, $date1);
	($cthour, $ctmin, undef) = split(/:/, $times);
	$number1 = ($cthour*60)+$ctmin;
	(undef, $times) = split(/ - /, $date2);
	($cthour, $ctmin, undef) = split(/:/, $times);
	$number2 = ($cthour*60)+$ctmin;
	$result = $number2-$number1;

}

#########
sub ban { 
#########

#Opening the ban list and the bans log files   
   open (BANLOG, ">>$datadir/banned/ban_log.dat") || warn "Cannot open file: $!"; 
	open (BANNED, "$datadir/banned/banned_ip.txt") || warn "Cannot open $ban_list file: $!"; 
	hold (BANLOG); 
	hold (BANNED); 

	while (<BANNED>) { 
		chomp; 
		#if ($ENV{REMOTE_ADDR} =~ /^$_/) { # allow partial IP bans  Not nice to steal codes i, and besides its called domain ban.
    if ($_ eq  $ENV{REMOTE_ADDR} || $remotehost =~ /\.$_$/ || $ENV{REMOTE_ADDR} =~ /^$_/ ) { 
#If the visitor is banned do this: 
			print "Content-type: text/html\n\n"; 

#Bye bye baby you are banned! 
			print "$date $msg{'475'} $ENV{REMOTE_ADDR}<br>";

			if (! $ENV{REMOTE_HOST}) { $ENV{REMOTE_HOST} = "-"; }
			if (! $ENV{QUERY_STRING}) { $ENV{QUERY_STRING} = "-"; }
			if (! $ENV{'HTTP_REFERER'}) { $ENV{'HTTP_REFERER'} = "-"; }
			if (!defined $realname) { $realname = ''; }
			if (!defined $ENV{HTTP_CONNECTION}) { $ENV{HTTP_CONNECTION} = ''; }
#Update the ban log file: 
			print BANLOG "$date|$$|$username|$realname|$userrank|$ENV{REMOTE_ADDR}|$ENV{REMOTE_HOST}|$ENV{REMOTE_PORT}|$ENV{HTTP_CONNECTION}|$ENV{SCRIPT_NAME}|$ENV{QUERY_STRING}|$ENV{SERVER_PROTOCOL}|$ENV{'HTTP_REFERER'}|$ENV{SCRIPT_NAME}|$ENV{HTTP_ACCEPT_LANGUAGE}\n"; 
			print "$msg{'477'}";
    
#Send BAN ALERT to admin: 
#			$msgid = time; 
#			$imsubj = "BAN ALERT [BANNED_IP] $ENV{REMOTE_ADDR} "; 
#			$formatmsg = "<br><b>$msg{'214'}:</b> $date<br><br> <b>Banned ip:</b> $ENV{REMOTE_ADDR}<br><br> <b>$mnu{'036'}:</b> $scripturl/index.cgi?action=admin&op=deletebannedip&=$ENV{REMOTE_ADDR}<br><br><b>$mnu{'025'}:</b> $scripturl/index.cgi?action=admin&op=editbanip<br><br>"; 
#			open (FILE, "$memberdir/admin.msg") || error("$err{'001'} $memberdir/admin.msg"); 
#			hold(FILE); @imessages = <FILE>; 
#			release(FILE); 
#			close (FILE); 
#			open (FILE, ">$memberdir/admin.msg") || error("$err{'001'} $memberdir/admin.msg"); 
#			hold(FILE); 
#			print FILE "$anonuser|$imsubj|$date|$formatmsg|$msgid\n"; 

#			foreach $curm (@imessages) { print FILE "$curm"; } 
#			release(FILE); 
#			close(FILE); 
             
			exit; 
		} 
	} 
   close BANLOG; 
   close BANNED; 

}

###########
sub error {
###########

	my ($e, $e1, $e2) = @_;
      
	if ($e eq "noguests") { require "$sourcedir/user.pl"; register("$err{'029'}"); }
	elsif ($e eq "nopassmatch") { require "$sourcedir/user.pl"; register("$err{'012'}", "$e1", "$e2"); }
	elsif ($e eq "nousername") { require "$sourcedir/user.pl"; register("$err{'003'}", "$e1", "$e2"); }
	elsif ($e eq "invalidusername") { require "$sourcedir/user.pl"; register("$err{'004'}", "$e1", "$e2"); }
	elsif ($e eq "noemail") { require "$sourcedir/user.pl"; register("$err{'005'}", "$e1", "$e2"); }
	elsif ($e eq "invalidemail") { require "$sourcedir/user.pl"; register("$err{'030'}", "$e1", "$e2"); }
	elsif ($e eq "existsusername") { require "$sourcedir/user.pl"; register("$err{'007'}", "$e1", "$e2"); }
	else { 
		# fix for missing theme or language when error called before loaduser completes - 
		if (!$usertheme) {
			$usertheme = $settings[13] || $defaulttheme;
		}
		if (!$userlang) {
			$userlang = $settings[15] || $language;
			&getlanguage;
		}

		if ($userrank ne $root) { $e =~ s/\/[^\.]*\///ig } # remove path

		$navbar = "$btn{'014'} $nav{'001'}";
		print_top();

		print qq~<p><b>$msg{'001'}</b><br>$e</p>
~;

		print_bottom();
		exit;
	}

}

#########
sub ver {
#########

	$navbar = "$btn{'014'} Version";
	print_top();

	print qq~<div style="text-align: center">
<div style="text-align: center; width: 80%; margin-left: auto; margin-right: auto"><br>
<hr><br>
<b>Powered by <a href="http://www.web-app.net/cgi-bin/index.cgi"
 target="_blank">$scriptname</a> v$scriptver</b><br>
<br>
<hr>
<br>
~;

	my @contributors = read_database("$datadir/contributors.txt");

	my $contriblist = "@contributors";
	$contriblist =~ s/!!!imagesurl!!!/$imagesurl/sg;

	print $contriblist;

	print qq~<a href="http://www.web-app.net/cgi-bin/index.cgi" target="_blank"><img
 src="$imagesurl/web-app-net.gif" width="80" height="15" border="0"
 alt="$scriptname"></a><br>
<small>EST May 25 2006<br>
Copyright $year : $scriptname Network</small><br>
<br>
<br>
</div>
</div>
~;

	print_bottom();
	exit;

}

#########
sub die {
#########
	local($e) = @_;
	print qq~<p>
<b>$msg{'001'}</b><br>
$e
~;
die $error;
}

##########
sub hold {
##########
	local($file) = @_;
	if ($use_flock eq "1") { flock($file, $LOCK_EX); }
}

#############
sub release {
#############
# Commented out rather than removing all calls to it.
# Using unlocks the file before it is closed.
# Chance of another process writing to that file in 
# split second between when it is unlocked and closed.
# Closing the file automatically unlocks the file.
# Better not to use an explicit unlock.
#
#	local($file) = @_;
#	if ($use_flock eq "1") { flock($file, $LOCK_UN); }
}

#############
sub imalert {
############# 
# hack by Rick to read IM file, modified by  ("bantychick")

# next line will become necessary if someone puts a "my" on @immessages in sub userstatus
#	@immessages = chomp_database("$memberdir/$username.msg");
	# who sent the most recent message? 
	my ($fromwho, $thesubject, $thisno) = (split(/\|/, $immessages[0]))[0,1,4];

	print qq~<script>

var alertmessage="$msg{'478'}"

//Alert only once per browser session (0=no, 1=yes)

var once_per_session=0

function get_cookie(Name) {
  var search = Name + "="
  var returnvalue = "";
  if (document.cookie.length > 0) {
    offset = document.cookie.indexOf(search)
    if (offset != -1) { // if cookie exists
      offset += search.length
      // set index of beginning of value
      end = document.cookie.indexOf(";", offset);
      // set index of end of cookie value
      if (end == -1)
         end = document.cookie.length;
      returnvalue=unescape(document.cookie.substring(offset, end))
      }
   }
  return returnvalue;
}

function alertornot(){
if (get_cookie('alerted')==''){
loadalert()
document.cookie="alerted=yes"
}
}

// im alert hack from rick
function loadalert(){ 
new_im=confirm("You have a new instant message from $fromwho.\\n\\n Subject: $thesubject\\n\\n Click OK to view it, or cancel to hide this prompt."); 
if (new_im==true) { 
window.location="$scripturl/$cgi?action=im&from=$fromwho&messageid=$thisno"; 
}
}

if (once_per_session==0)
loadalert()
else
alertornot()

</script>

~;

}

###############
sub sendemail {
###############
# used in admin.pl, emailer.pl, newsletter.pl, notify.pl, recommend.pl, user.pl,
# topics.pl, calendar/index.cgi

	my ($to, $subject, $message, $from) = @_;

	if ($from) { $webmaster_email = $from; }
	$to =~ s/[ \t]+/, /g;
	$webmaster_email =~ s/.*<([^\s]*?)>/$1/;
	$message =~ s/^\./\.\./gm;
	$message =~ s/\r\n/\n/g;
	$message =~ s/\n/\r\n/g;
	$smtp_server =~ s/^\s+//g;
	$smtp_server =~ s/\s+$//g;

 	if ($mailtype == 1) {
		($x, $x, $x, $x, $here) = gethostbyname($null);
		($x, $x, $x, $x, $there) = gethostbyname($smtp_server);
		$thisserver = pack('S n a4 x8', 2, 0, $here);
		$remoteserver = pack('S n a4 x8', 2, 25, $there);
		(!(socket(S, 2, 1, 6))) && (error("Connect error! socket"));
		(!(bind(S, $thisserver))) && (error("Connect error! bind"));
		(!(connect(S, $remoteserver))) && (error("!! connection to $smtp_server has failed!"));

		my ($oldfh) = select(S);
		$| = 1;
		select($oldfh);

		$_ = <S>;
		($_ !~ /^220/) && (error("Sending Email: data in Connect error - 220"));

		print S "HELO $smtp_server\r\n";
		$_ = <S>;
		($_ !~ /^250/) && (error("Sending Email: data in Connect error - 250"));

		print S "MAIL FROM:<$webmaster_email>\n";
		$_ = <S>;
		($_ !~ /^250/) && (error("Sending Email: 'From' address not valid"));

		print S "RCPT TO:<$to>\n";
		$_ = <S>;
		($_ !~ /^250/) && (error("Sending Email: 'Recipient' address not valid"));

		print S "DATA\n";
		$_ = <S>;
		($_ !~ /^354/) && (error("Sending Email: Message send failed - 354"));
	}

	if ($mailtype == 0) {
		open(S,"| $mailprogram -t") || error("$err{'008'}");
	}

	print S "To: $to\n";
	print S "From: $webmaster_email\n";
	print S "Subject: $subject\n\n";
	print S "$message";
	print S "\n.\n";

	if ($mailtype == 1) {
		$_ = <S>;
		($_ !~ /^250/) && (error("Sending Email: Message send failed - try again - 250"));
		print S "QUIT\r\n";
	}

	close(S);
	return(1);
}

#################
sub getlanguage {
#################

	@lang = chomp_database("$langdir/languages.dat");

	if ($userlang) {
		foreach $line (@lang) {
			@item = split(/\|/, $line);
			if ($item[1] eq $userlang) {
				if ($item[2] ne "0") {
					$getuserlang = $item[1];
					$langgfx = $item[3];
					last;
				} else {
					$getuserlang = $language;
					($langgfx, undef) = split(/\./,$getuserlang);
				}
			}
		} #abwyn
	}

	if (!$getuserlang) {
		$getuserlang = $language;
	}
	if (!$langgfx) {
		$getuserlang = $language;
		($langgfx, undef) = split(/\./,$getuserlang);
	}

	eval {
		require "$langdir/$getuserlang";

		if ($IIS != 2) {
			if ($IIS == 0) {
				if ($ENV{'SERVER_SOFTWARE'} =~ m!IIS!) { $IIS = 1; }
			}
			if (($IIS) && ($0 =~ m!(.*)(\\|\/)!)) { chdir($1); }
			if ($IIS == 1) { print "HTTP/1.0 200 OK\n"; }
		}
	};

	if ($@) { language_fail(); }

	# Abwyn's show language tags addition
	if ($info{'showlanguage'}) {
		@languagetags = qw(banner help err msg btn mnu nav inf xtr);
		foreach  $languagetag (@languagetags) {
			foreach $navelement ('001' .. '999' ) {
				if ($$languagetag{$navelement}) {
					$${languagetag}{$navelement} = qq~/-$$languagetag{$navelement} $languagetag\{\'$navelement\'\}-/~;
				}
			}
		}
	}

}

###################
sub language_fail {
###################

eval {
	require "$lang";
};
if ($@) {
print "Content-type: text/html\n\n";
print qq~<h1>Language File Error:</h1>
Execution of <b>$scriptname</b> has been aborted due a compilation error:<br>
<pre>$@</pre>
<p>If this problem persists, please contact the webmaster and inform him about date and time you've received this error.</p>
~;
	exit;
}

}

##################
sub check_access {
##################
# used in admin/ : banners.cgi, downloadadmin.cgi, help.cgi, linksadmin.cgi, logs.cgi,
# blockleft.cgi, blockright.cgi - also used in: admin.pl, downloads.pl, links.pl,
# stats.pl, subs.pl, and modmanager.cgi

	$access_granted = 0;

	if ($username ne "admin") {

		my ($actrequest) = @_;
		if (!defined $actrequest) { $actrequest = ""; }
		# Are YOU actually allowed to be here at all!
		if ($actrequest eq "siteadmin") {
			if ($username ne "$article_imrecip") {
				if ($userrank ne "$root") { error("$err{'011'}"); }
			}
		}
		# Are YOU actually allowed to see the link
		if ($actrequest eq "siteadminlink") {
			if ($username ne "$article_imrecip") {
				$adminlinkprinted = 0;
				if ($userrank eq "$root") {
					$adminlinkprinted = 1;
					menuitem("admin\&amp\;op=siteadmin", "$nav{'042'}");
				}
			}
			if ($username eq "$article_imrecip") {
				if ($adminlinkprinted ne 1) { menuitem("admin\&amp\;op=siteadmin", "$nav{'042'}"); }
			}
		}

		# Site Admin Section
		if ($actrequest eq "editwelc" && $editwelc eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}
		if ($actrequest eq "editabout" && $editabout eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}
		if ($actrequest eq "editim" && $editim eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}
		if ($actrequest eq "editbanner" && $editbanner eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}
		if ($actrequest eq "editfaq" && $editfaq eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}
		if ($actrequest eq "editdown" && $editdown eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}
		if ($actrequest eq "editlink" && $editlink eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}
		if ($actrequest eq "modadmin" && $modadmin eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}

		# Forum Admin Section
		if ($actrequest eq "editcats" && $editcats eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}
		if ($actrequest eq "editboards" && $editboards eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}
		if ($actrequest eq "editcensor" && $editcensor eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}

		# Poll Admin Section
		if ($actrequest eq "editpoll" && $editpoll eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}

		# News Admin Section
		if ($actrequest eq "pubnews" && $pubnews eq 1) {
			if ($username ne "$article_imrecip") {
				if ($userrank eq "$root") { $access_granted = 1; }
			} else { $access_granted = 1; }
		}
		if ($actrequest eq "editnews" && $editnews eq 1) {
			if ($username ne "$article_imrecip") {
				if ($userrank eq "$root") { $access_granted = 1; }
			} else { $access_granted = 1; }
		}
		if ($actrequest eq "edittops" && $edittops eq 1) {
			if ($username ne "$article_imrecip") {
				if ($userrank eq "$root") { $access_granted = 1; }
			} else { $access_granted = 1; }
		}

		# Block Admin Section
		if ($actrequest eq "editlblk" && $editlblk eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}
		if ($actrequest eq "editrblk" && $editrblk eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}
		if ($actrequest eq "edittblk" && $edittblk eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}
		if ($actrequest eq "editbtmblk" && $editbtmblk eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}

		# Module Admin Section
		if ($actrequest eq "editcal" && $editcal eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}
		if ($actrequest eq "editnl" && $editnl eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}

		# Security Admin Section
		if ($actrequest eq "editip" && $editip eq 1) {
			if ($userrank eq "$root") { $access_granted = 1; }
		}
	}

	if ($username eq "admin") { $access_granted = 1; }

}

###############
sub censor_it {
###############
# Use: $text_to_censor = censor_it($text_to_censor);
##################

	my ($texttocensor)=@_;
	@censored = chomp_database("$boardsdir/censor.txt");

	foreach $censor (@censored) {
		($word, $censored) = split(/\=/, $censor);
		$texttocensor =~ s/\b$word\b/$censored/gi;
	}
	return $texttocensor;

}

###################
sub read_database {
###################
# Use: @array = read_database("path_to_file/filename_to_read");
###################

	my ($filetoread) = @_;
	my @readfile = ();

	open(DATABASE, "<$filetoread") || file_error("$err{'001'} $filetoread");
	holdr(DATABASE); # nonexclusive read lock
	@readfile = <DATABASE>;
	close(DATABASE);

	return @readfile;

}

####################
sub chomp_database {
####################
# Use: @array = chomp_database("path_to_file/filename_to_read");
###################

	my ($filetochomp) = @_;
	my @chompedfile = ();

	open(DATABASE, "<$filetochomp") || file_error("$err{'001'} $filetochomp");
	holdr(DATABASE); # nonexclusive read lock
	chomp(@chompedfile = <DATABASE>);
	close(DATABASE);

	return @chompedfile;

}

####################
sub chomp_datatext {
####################
# Use: $variable = chomp_datatext("path_to_file/filename_to_read");
###################

	my ($filetochomp) = @_;
	my $chompedtext = "";

	open(DATABASE, "<$filetochomp") || file_error("$err{'001'} $filetochomp");
	holdr(DATABASE); # nonexclusive read lock
	chomp($chompedtext = <DATABASE>);
	close(DATABASE);

	return $chompedtext;

}

################
sub data_error {
################
# set IMs on data error to off by default until admin setting can be made

	my $adminmsg = 0; # set to 1 for admin IM about hack attempts, 0 for no IM

	if ($ENV{'HTTP_REFERER'}) {
		$linkpage = "$ENV{'HTTP_REFERER'}";
	} else {
		$linkpage = "unknown";
	}

	# print data error log
	my $activity = $location2;
	$activity =~ s/\|/&#124;/g;

	open(DELOG, ">>$logdir/data_error.log") || error("Cannot open data_error.log"); 
	hold(DELOG);
	print DELOG "$date|$username|$ENV{'REMOTE_ADDR'}|$ENV{SERVER_NAME}$location?$activity|$linkpage\n";
	close(DELOG);

	if ($adminmsg) {
		$imsubj = "$err{'044'}";
		$formatmsg = qq~$err{'045'}
$msg{'006'} $username
$msg{'225'}: $ENV{'REMOTE_ADDR'}
$err{'046'} http://$ENV{SERVER_NAME}$location?$location2
$err{'047'} $linkpage~;
		$msgid = time;

		$formatmsg = htmlescape($formatmsg);

		@imessages = read_database("$memberdir/admin.msg");

		open(FILE, ">$memberdir/admin.msg");
		hold(FILE);
		print FILE "$anonuser|$imsubj|$date|$formatmsg|$msgid\n";
		foreach $curm(@imessages) { print FILE "$curm"; }
		close(FILE);
	}

	$navbar = " $btn{'014'} $err{'044'}";
	print_top();

	print qq~<BR>
<p class="texttitle">$err{'048'}</p>
<br>
<br>
~;

	print_bottom();
	exit;

}

###########
sub holdr {
###########
# for non-exclusive read locks

	local($file) = @_;
	if ($use_flock eq "1") { flock($file, "1"); } # LOCK_SH, read lock

}

############
sub getver {
############

$scriptver = chomp_datatext("$datadir/ver.txt");

}

########################## new subs after WebAPP 0.9.9.3.2 #######################

################
sub file_error {
################
# for errors happening mid-page

	my ($e) = @_;
      
	if ($userrank ne $root) { $e =~ s/\/[^\.]*\///ig } # removes path

	print qq~<p>$e</p>~;

}

################
sub front_date {
################
# for nice front page dates
# @shortmos are in lng file

	my ($wholetime) = @_; # ($postdate) for viewnews

	my ($twodate, $posttime) = split(/ - /, $wholetime);
	my ($mm, $dd, $yy) = split(/\//, $twodate);

	if (!$user_check_date) { $user_check_date = $check_date; } # $check_date defined in config.pl, config.dat - american or european

	&getTimezones;
	my ($newcnvmonth, $newcnvday, $newcnvyear, $newcnvhour, $newcnvmin) = getNewtime($twodate, $posttime);
	$newcnvmonth -= 1;
	$newcnvday =~ s/^0//;
	$newcnvyear += 2000;
	$newcnvhour =~ s/^0//;

	if ($user_check_date eq "american") {
		$frontdate = "$shortmos[$newcnvmonth] $newcnvday $newcnvyear";
	}
	if ($user_check_date eq "european") {
		$frontdate = "$newcnvday $shortmos[$newcnvmonth] $newcnvyear";
	}

	$fronttime = "$newcnvhour:$newcnvmin <small>$displaytimezone</small>";

}

#################
sub boxhead_div {
#################
# by  Brown (www.bantychick.com)
# For converting the old boxheader/boxfooter tables to divs.
# Define a boxtop and boxbottom sub in theme.pl or anywhere
# and this will use those. Otherwise this will parse the
# boxheader and boxfooter subs and apply the style to a div.

	($title) = @_;

	if (defined &boxtop) {
		&boxtop;
	} else {
		require B::Deparse;

		my $deparser = B::Deparse->new();
		$boxheaddiv = $deparser->coderef2text(\&boxheader);

		if ($boxheaddiv =~ /<table/i) {
			$boxheaddiv =~ s/^\{.*print\s+(qq\[|")//s;
			$boxheaddiv =~ s/\]?;\s*\}$//s;
			$boxheaddiv =~ s/\\n/\n/gs;
			$boxheaddiv =~ s/\$(\w+)/$$1/gs;

			$hasclass = '';

			if ($boxheaddiv =~ /(<table [^>]*(cellpadding|cellspacing|class)=[^ >]+[^>]*>)\s?$/is) {
				my $styling = $1;
				my $padding = 0;
				$styling =~ s/ border=[^ >]*//i;
				$styling =~ s/ width=[^ >]*//i;
				if ($styling =~ /cellpadding="?([\d])*/i) {
					$padding += $1;
					$styling =~ s/ cellpadding=[^ >]*//i;
				}
				if ($styling =~ /cellspacing="?([\d])*/i) {
					$padding += $1;
					$styling =~ s/ cellspacing=[^ >]*//i;
				}
				if ($padding) {
					$padding .= "px";
					$padding = " style=\"padding: $padding\"";
				} else {
					$padding = "";
				}
				$styling =~ s/table/div$padding/i;

				$boxheaddiv =~ s/<table([^>])*>\s*$/$styling/is;
				$hasclass = 1;
			} else {
				$boxheaddiv =~ s/<table[^>]*>\s*$//is;
			}

			$boxheaddiv =~ s/\$(themesurl|usertheme)/$$1/gs;

			print "$boxheaddiv";
			$dobottom = 1;
		} else {
			boxheader("$title");
		}
	}
}

#################
sub boxfoot_div {
#################
# by  Brown (www.bantychick.com)

	if (defined &boxbottom) {
		&boxbottom;
	} else {
		if ($dobottom) {
			require B::Deparse;
			my $deparser = B::Deparse->new();
			$boxfootdiv = $deparser->coderef2text(\&boxfooter);
       
			$boxfootdiv =~ s/^\{\s*print\s+(qq\[|")//s;
			$boxfootdiv =~ s/(\]|");\s*\}$//s;
			$boxfootdiv =~ s/\\n/\n/gs;

			if ($hasclass) {
				$boxfootdiv =~ s/.*?<\/table>/<\/div>/is; # for other stuff before /table
			} else {
				$boxfootdiv =~ s/.*?<\/table>//is;
			}

			$boxfootdiv =~ s/\$(themesurl|usertheme)/$$1/gs;

			print "$boxfootdiv";
		} else {
			&boxfooter;
		}
	}

}

######################
sub themelangchooser {
######################
# by  Brown (www.bantychick.com)

	# stop search engines from seeing this (doesn't work for FAST):
	if ($ENV{'HTTP_USER_AGENT'} !~ /(google|infoseek|webcrawler|exactseek|galaxybot|nutch|turnitinbot|yandex|yahoo\! slurp|msnbot|ia_archiver|lycos_spider|yahoo\-mmcrawler|scooter\/|slurp\/|gigabot|FAST|findlinks)/i) {
		my ($themedrop, $langdrop) = &themelangstuff;

		if ($themedrop || $langdrop) {
			boxhead_div("$thm{'012'}");

			print qq~<dl style="margin: 0">
~;
			if ($themedrop) {
				print qq~<dt class="cat"><a href="#" class="menu"
 OnClick="return toggle('theme')">$msg{'161'}</a></dt>
$themedrop
~;
			}
			if ($langdrop) {
				print qq~<dt class="cat"><a href="#" class="menu"
 OnClick="return toggle('lang')">$msg{'412'}</a></dt>
$langdrop
~;
			}
			print qq~</dl>
~;
			&boxfoot_div;
		}
	}

}

####################
sub themelangstuff {
####################
# by 
# separated from themelangchooser for optional use outside of a side block

	my ($themedrop, $langdrop) = ();
	my $qs = "";
	if ($location2) {
		$qs = $location2;
		$qs =~ s/&?(theme|lang)=.*//;
		$qs .= '&';
	}
	if ($letmemthm) {
		$themedrop = qq~<dd id="theme" style="display:none">~;

		open(FILE, "$themesdir/themes.dat" );
		holdr(FILE);
		@themes = <FILE>;
		close(FILE);

		foreach my $line(@themes) {
			$line =~ s/[\n\r]//g;
			my @item = split(/\|/, $line);
			if ($item[2] ne "0") {
				$themedrop .= qq~<a href="$pageurl/$cgi?$qs~ . qq~theme=$item[1]">$item[0]</a><br>
~;
			}
		}

		$themedrop .= qq~</dd>~;

		if ($qs) {
			$themedrop =~ s/\?&/\?/g;
			$themedrop =~ s/&/&amp;/g;
		}
	}

	if ($letmemlng eq "1") {
		$langdrop = qq~<dd id="lang" style="display:none">~;

		open(FILE, "$langdir/languages.dat" );
		holdr(FILE);
		@lang = <FILE>;
		close(FILE);

		foreach $line (@lang) {
			$line =~ s/[\n\r]//g;
			my @item = split(/\|/, $line);
			if ($item[2] ne "0") {
				$item[1] =~ s/\.lng//;
				$langdrop .= qq~<a href="$pageurl/$cgi?$qs~ . qq~lang=$item[1]">$item[0]</a><br>
~;
			}
		}
		$langdrop .= qq~</dd>~;

		if ($qs) {
			$langdrop =~ s/\?&/\?/g;
			$langdrop =~ s/&/&amp;/g;
		}
	}

	return ($themedrop, $langdrop);

}
################
sub clean_tags {
################

	local $tag = $_[0];
	$tag =~ s/\&/\&amp;/g;
	$tag=~ s/</\&lt;/g;
	$tag =~ s/>/\&gt;/g;
	$tag =~ s/"/\&quot;/g;
	return $tag;

}

if (-e "$user_lib/subs.pl") {require "$user_lib/subs.pl"}

1; # return true