###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# header.pl                                                                   #
# Prints the top, left column, and start for center column of each page.      #
# v0.9.9.3.4                                                                  #
# Based on Old WebAPP v0.9.9.6 Standard Theme                                 #
# Language Charset tags by: John-Gr (www.coinsmania.gr)                       #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified:                                                                   #
###############################################################################
###############################################################################

print "Content-type: text/html\n\n";
print qq~<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
 "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=$charset{'001'}">
<meta http-equiv="Content-Language" content="$charset{'002'}">
<meta http-equiv="expires" content="0">
<meta name="Generator" content="$scriptname $scriptver">
<title>$pagetitle</title>
~;

if ($navbar && ($navbar !~ /\S/)) { # print xml alternate front page only ($navbar is space)
	print qq~<link href="$baseurl/webapp.xml" rel="alternate" type="application/rss+xml" title="$pagetitle">
~;
}

print qq~<link rel="stylesheet" href="$themesurl/$usertheme/style.css" type="text/css">
~;

# broadcastmessage(); # moved to pollfooter.pl for js fix
 
print qq~<script language="javascript" src="$baseurl/webapp.js"
 type="text/javascript"></script>
</head>
<body>
<table class="pagetable">
<tr>
<td>~;

logo_block();

print qq~</td>
</tr>
<tr>
<td height="21">~;

&top_menu;

print qq~</td>
</tr>
</table>
~;

checkforbanner();

print qq~<table class="pagetable">
<tr>
<td valign="top" width="150"><table width="150">
~;

&themelangchooser;

&main_menu;

&left_top_plugins;

&search_block;

&mysite_block;

&status_block;

&left_bottom_plugins;

&leftblock_block;

print qq~</table></td>
<td valign="top" width="100%"><table width="100%">
<tr>
<td width="100%">~;

nav_bar();

1; # return true